/* ASLASSIN.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void aslassassin();
void aslassassinmot(int term);
void aslassassinbene();
void aslassassinskills(int skills);

extern int asl_spec_duty(int need_nbr);
extern int asl_surv(int need_nbr, int upp_type, int upp_val);
extern int reenlist(int need_nbr);
extern int aslmotrolls();
extern void addskill(int skill, int skl_val);
extern int asl_mot();
extern char getche_mot();
extern int asl_cash();
extern int asl_beneroll();
extern void bumpedu();
extern void bumpsoc();
extern void independ();
extern int aslpicktable();
extern int d6();
extern int aslsklroll();
extern void physicl(int skl_val);
extern void aslmentl(int skl_val);
extern void aslmc(int skl_val);
extern void aslinbrn(int skl_val);
extern void aslvhcl(int skl_val);
extern void aslenv(int skl_val);
extern void aslinterp(int skl_val);
extern void aslspace(int skl_val);
extern void land();
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_lopsg();
extern void mot_midpsg();

#include "chargen.h"

void aslassassin()
{
  int  skills, newterm;
  
  addskill(INDEPENDENCE, 1);
  aslmc(1);
  newterm = 0;
  while (newterm != 1) {
    skills = asl_spec_duty(4);
    newterm = asl_surv(9, intl, 9);
    if (newterm == 0) skills += 3;
    if (skills != 0) aslassassinskills(skills);
    printf("That competes this term!\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  aslassassinmot(aslmotrolls());
  if (sex == 1 && soc > 9) addskill(LEADER, 1);
}


void aslassassinmot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = asl_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      roll = asl_cash();
      cash--;
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 500; break;
        case 2: amt = 1000; break;
        case 3: amt = 5000; break;
        case 4: amt = 10000; break;
        case 5: amt = 20000; break;
        case 6: amt = 50000; break;
        default: amt = 200000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        term--;
        aslassassinbene();
    }
  }
  while (term > 0) {
    aslassassinbene();
    term--;
  }
}


void aslassassinbene()
{
  int roll;

  roll = asl_beneroll();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpedu(); break;
    case 3: mot_weapon(); break;
    case 4: mot_weapon(); break;
    case 5: addskill(INDEPENDENCE, 1); break;
    case 6: mot_midpsg(); break;
    case 7: bumpsoc(); break;
    case 8: land(); break;
  }
}


void aslassassinskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = aslpicktable();
    roll = d6();
    roll = aslsklroll(roll);
    if (table == 1) {
      switch (roll) {
        case 1: independ(1); break;
        case 2: physicl(1); break;
        case 3: physicl(1); break;
        case 4: aslmc(1); break;
        case 5: aslmentl(1); break;
        case 6: break;
      }
    }
    if (table == 2) {
      switch (roll) {
        case 1: independ(1); break;
        case 2: aslmc(1); break;
        case 3: aslvhcl(1); break;
        case 4: aslinbrn(1); break;
        case 5: aslinterp(1); break;
        case 6: break;
      }
    }
    if (table == 3) {
      switch (roll) {
        case 1: independ(1); break;
        case 2: aslenv(1); break;
        case 3: aslvhcl(1); break;
        case 4: aslmc(1); break;
        case 5: aslinbrn(1); break;
        case 6: break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: independ(1); break;
        case 2: aslvhcl(1); break;
        case 3: aslspace(1); break;
        case 4: aslmc(1); break;
        case 5: aslinbrn(1); break;
        case 6: break;
      }
    }
    skills--;
  }
}

