/* ASLCARER.C is part of the MegaTraveller (C) character generation */
/* program. It is used to select the Aslan characters career. */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "chargen.h"

void careers();
void getcareer();
void aslpickcareer();
void asldraft();
void aslrandcareer();
void asltrymilitary();
void gotmiltry();
void asltrymiloff();
void asltryspacer();
void gotspace();
void asltryspacoff();
void asltrymgmt();
void asltryartist();
void asltrypirate();
void asltrymedic();
void asltrybelter();
void asltrywander();
void asltryscient();
void asltryenvoy();
void asltryflyer();
void asltrytechy();
void asltrymariner();
void asltryteacher();
void asltryassassin();
void asltryoutcast();
int rop();
int aslpicktable();
void land();
void corp();
void altcareertbl();
/*void schools();*/

extern void cascades();
extern void background();
extern void dfltech();
extern void dfltcareer();
extern void aslmiloff();
extern void aslmilitary();
extern void aslspaceoff();
extern void aslspacer();
extern void aslflyer();
extern void aslmariner();
extern void aslmedic();
extern void aslenvoy();
extern void aslscient();
extern void aslbelter();
extern void aslpirate();
extern void aslmgmt();
extern void aslartist();
extern void aslwander();
extern void asltechy();
extern void aslteacher();
extern void aslassassin();
extern void asloutcast();
extern char getche_y_n();
extern void prntupp();
extern int getsel_bigint();
extern int d3();
extern int d4();
extern int d6();
extern int d12();
extern void gotpirate();
extern void gotscient();
extern void gotflyer();
extern void gotbelter();
extern int getsel_int(int min, int max);

void careers()
{
  cascades();
  dfltech();
  background();
  if (careernbr == 0) getcareer();
  printf("Career = %s (%d)\n", career, careernbr);
  dfltcareer();
  switch (careernbr) {
    case ARMY: {
      if (rankeo == 'O') aslmiloff();
      else aslmilitary();
      }
      break;
    case NAVY: {
      if (rankeo == 'O') aslspaceoff();
      else aslspacer();
      }
      break;
    case FLYER: aslflyer(); break;
    case SAILOR: aslmariner(); break;
    case DOCTOR: aslmedic(); break;
    case DIPLOMAT: aslenvoy(); break;
    case SCIENTIST: aslscient(); break;
    case BELTER: aslbelter(); break;
    case PIRATE: aslpirate(); break;
    case MANAGEMENT: aslmgmt(); break;
    case ARTIST: aslartist(); break;
    case WANDERER: aslwander(); break;
    case TECHY: asltechy(); break;
    case TEACHER: aslteacher(); break;
    case ASSASSIN: aslassassin(); break;
    case OUTCAST: asloutcast(); break;
    default: printf("\nCareer unknown\n");
  }
}


void getcareer()
{
  int choice;

  age = 14;
  appearent_age = age;
  printf("Career selection can be random or you can try to pick your\n");
  printf("characters career. Do you want to try to pick your characters\n");
  printf("career?");
  choice = getche_y_n();
  printf("\n");
  if (choice == 'Y' || choice == 'y') {
    aslpickcareer();
  } else {
      aslrandcareer();
  }
}


void aslpickcareer()
{
	int choice;

	km_land = 0;
	prntupp();
	printf("\nWhat career do you want? Remember, if you fail\n");
	printf("your enlistment, you will become a pirate or an outcast.\n\n");
	printf("   1. pick one at random\n");
	if (tech >= 4)
	{
		printf("   2. space (roll 8)\n   3. space officer (roll ");
		if (sex == 2)
			printf("10");
		else
			printf("11");
		printf(")\n");
	}
	if (tech >= 3)
	{
		printf("   4. military (roll 7)\n   5. military officer (roll ");
		if (sex == 2)
			printf("9");
		else
			printf("10");
		printf(")\n");
	}
	if (sex == 2 && pop >= POPMID && law >= LAWLO)
		printf("   6. management (rol 8)\n");
	printf("   7. artist (roll ");
	if (sex == 2)
		printf("9");
	else
		printf("12");
	printf(")\n");
	if (tech >= TLEARSTEL)
		printf("   8. pirate (roll 8)\n");
	if (sex == 2 && tech >= TLPRESTEL)
		printf("   9. scientist (roll 6)\n");
	if (sex == 1 && tech >= TLIND && soc >= 9)
		printf("   10. envoy (roll 11)\n");
	if (sex == 2 && tech >= TLIND)
		printf("   11. medic (roll 9)\n");
	if (sex == 1 && tech >= TLIND && atmos >= ATMTHN && pop >= POPMID)
		printf("   12. flyer (roll 11)\n");
	if (sex == 2 && tech >= TLEARSTEL)
		printf("   13. belter (roll 8)\n");
	if (sex == 1 && tech >= TLEARSTEL)
		printf("   14. wanderer (roll 8)\n");
	if (sex == 2 && tech >= TLIND)
		printf("   15. technician (roll 7)\n");
	if (sex == 1 && hydro >= HYDWET)
		printf("   16. mariner (roll 11)\n");
	if (sex == 1)
		printf("   17. teacher (roll 9)\n");
	if (sex == 1 && tech >= TLIND)
		printf("   18. assassin (roll 11)\n");
	printf("   19. outcast (automatic)\n");
	choice = getsel_bigint(1, 19);
	if (((choice == 2 || choice == 3) && tech < TLEARSTEL)
		|| ((choice == 4 || choice == 5) && tech < TLPRESTEL)
		|| (choice == 6 && (pop < 2 || sex != 2 || law < LAWLO)) 
		|| (choice == 8 && tech < TLIND) || (choice == 9 && (tech < TLPRESTEL || sex != 2)) 
		|| (choice == 10 && (soc < 9 || sex != 1 || tech < TLIND)) 
		|| (choice == 11 && (tech < TLIND || sex != 2)) 
		|| (choice == 12 && (atmos < ATMTHN || sex != 1 || tech < TLIND || pop < POPMID)) 
		|| (choice == 13 && (tech < TLEARSTEL || sex != 2)) 
		|| (choice == 14 && (sex != 1 || tech < TLEARSTEL)) 
		|| (choice == 15 && (tech < TLIND || sex != 2)) 
		|| (choice == 16 && (hydro < HYDWET || sex != 1)) 
		|| (choice == 17 && sex != 1) || (choice == 18 && (sex != 1 || tech < 2))) {
		printf("Please enter a valid number - try again.\n");
		aslpickcareer();
		return;
	}
	switch (choice)
	{
		case 1: aslrandcareer(); break;
		case 2: asltryspacer(); break;
		case 3: asltryspacoff(); break;
		case 4: asltrymilitary(); break;
		case 5: asltrymiloff(); break;
		case 6: asltrymgmt(); break;
		case 7: asltryartist(); break;
		case 8: asltrypirate(); break;
		case 9: asltryscient(); break;
		case 10: asltryenvoy(); break;
		case 11: asltrymedic(); break;
		case 12: asltryflyer(); break;
		case 13: asltrybelter(); break;
		case 14: asltrywander(); break;
		case 15: asltrytechy(); break;
		case 16: asltrymariner(); break;
		case 17: asltryteacher(); break;
		case 18: asltryassassin(); break;
		case 19: asltryoutcast(); break;
	}
	if (careernbr == 0) asldraft();
	return;
}


void asldraft()
{
  soc = 2;
  asltrypirate();
  if (careernbr == 0) asltryoutcast();
  return;
}


void aslrandcareer()
{
  int  roll;

  roll = d3();
  if (roll == 1) {
    roll = d6();
    if ((roll == 1) && (tech >= 4)) asltryspacer();
    else {
      if ((roll == 2) && (tech >= 4)) asltryspacoff();
      else {
        if ((roll == 3) && (tech >= 3)) asltrymilitary();
        else {
	  if ((roll == 4) && (tech >= 3)) asltrymiloff();
          else {
            if ((roll == 5) && (sex == 2 && pop >= 2 && law >= 2)) asltrymgmt();
            else {
              if (roll == 6) asltryartist();
            }
          }
        }
      }
    }
  } else {
    if (roll == 2) {
      roll = d6();
      if ((roll == 1) && (tech >= 4)) asltrypirate();
      else {
        if ((roll == 2) && (tech >= 3) && (sex == 2)) asltryscient();
        else {
          if ((roll == 3) && (tech >= 2) && (law >= 2) && (sex == 1)) asltryenvoy();
          else {
            if ((roll == 4) && (tech >= 2) && (sex == 2)) asltrymedic();
            else {
              if (roll == 5 && tech >= 2 && sex == 1 && atmos >= 2
                && pop >= 2) asltryflyer();
              else {
                if (roll == 6 && tech >= 3 && sex == 2) asltrybelter();
              }
	    }
          }
        }
      }
    } else {
      roll = d6();
      if ((roll == 1) && (tech >= 4) && (sex == 1)) asltrywander();
      else {
        if ((roll == 2) && (tech >= 2) && (sex == 2)) asltrytechy();
        else {
          if ((roll == 3) && (hydro >= 3) && (sex == 1)) asltrymariner();
          else {
            if (roll == 4 && sex == 1) asltryteacher();
	    else {
              if ((roll == 5) && (tech >= 2) && (sex == 1)) asltryassassin();
              else {
                if (roll == 6) asltryoutcast();
              }
            }
          }
        }
      }
    }
  }
  if (careernbr == 0) aslrandcareer();
}


void asltrymilitary()
{
  int  enlist;

  enlist = d12() + rop();
  if (enlist >= 7) gotmiltry();
}


void gotmiltry()
{
  strncpy(career,"Military",9);
  careernbr = ARMY;
}


void asltrymiloff()
{
  int  enlist;

  enlist = d12() + rop();
  if ((enlist >= 9 && sex == 2) || enlist >= 10) {
    gotmiltry();
    rank = 1;
    rankeo = 'O';
  }
}


void asltryspacer()
{
  int  enlist;

  enlist = d12() + rop();
  if (enlist >= 8) gotspace();
}


void gotspace()
{
  strncpy(career,"Space",6);
  careernbr = NAVY;
}


void asltryspacoff()
{
  int  enlist;

  enlist = d12() + rop();
  if ((enlist >= 10 && sex == 2) || enlist >= 11) {
    gotspace();
    rank = 1;
    rankeo = 'O';
  }
}


void asltrymgmt()
{
  int  enlist;

  enlist = d12() + rop();
  if (enlist >= 8) {
    strncpy(career,"Management",11);
    careernbr = MANAGEMENT;
  }
}


void asltryartist()
{
  int  enlist;

  enlist = d12() + rop();
  if ((enlist >= 9 && sex == 2) || enlist >= 12) {
    strncpy(career,"Artist",7);
    careernbr = ARTIST;
  }
}


void asltrypirate()
{
  int  enlist;

  enlist = d12();
  if (enlist >= 8) gotpirate();
}


void asltryscient()
{
  int  enlist;

  enlist = d12();
  if (enlist >= 6) gotscient();
}


void asltryenvoy()
{
  int  enlist;

  enlist = d12() + rop();
  if (enlist >= 11) {
    strncpy(career,"Envoy",6);
    careernbr = DIPLOMAT;
  }
  return;
}


void asltrymedic()
{
  int  enlist;

  enlist = d12() + rop();
  if (enlist >= 9) {
    strncpy(career,"Medic",6);
    careernbr = DOCTOR;
  }
  return;
}


void asltryflyer()
{
  int  enlist;

  enlist = d12() + rop();
  if (enlist >= 11) gotflyer();
}


void asltrybelter()
{
  int  enlist;

  enlist = d12();
  if (enlist >= 8) gotbelter();
}


void asltrywander()
{
  int  enlist;

  enlist = d12() + rop();
  if (enlist >= 8) {
    strncpy(career,"Wanderer",9);
    careernbr = WANDERER;
  }
}


void asltrytechy()
{
  int  enlist;

  enlist = d12() + rop();
  if (enlist >= 7) {
    strncpy(career,"Technician",11);
    careernbr = TECHY;
  }
}


void asltrymariner()
{
  int  enlist;

  enlist = d12() + rop();
  if (enlist >= 11) {
    strncpy(career,"Mariner",8);
    careernbr = SAILOR;
  }
}


void asltryteacher()
{
  int  enlist;

  enlist = d12() + rop();
  if (enlist >= 9) {
    strncpy(career,"Teacher",8);
    careernbr = TEACHER;
  }
}


void asltryassassin()
{
  int  enlist;

  enlist = d12() + rop();
  if (enlist >= 11) {
    strncpy(career,"Assassin",9);
    careernbr = ASSASSIN;
  }
}


void asltryoutcast()
{
  strncpy(career,"Outcast",8);
  careernbr = OUTCAST;
}


int rop()
{
  int ropnbr, roll;

  roll = d12();
  ropnbr = 0;
  if (sex == 1) {
    if (str > roll) ropnbr++;
    if (dex > roll) ropnbr++;
    if (end > roll) ropnbr++;
  }
  if (intl > roll) {
    if (sex == 1) ropnbr++;
    else ropnbr += 2;
  }
  if (edu > roll) {
    if (sex == 1) ropnbr++;
    else ropnbr += 2;
  }
  if (soc > roll) {
    if (sex == 1) ropnbr++;
    else ropnbr += 2;
  }
  printf("Rite of passage. Roll = %d & RoP = %d\n", roll, ropnbr);
  return ropnbr;
}


int aslpicktable()
{
  int choice;

  if (pick > 2) {
    if (careernbr <= NAVY || careernbr == ARTIST || careernbr == MANAGEMENT) {
      return (d3());
    } else {
      return (d4());
    }
  }
  printf("\nWhich table do you wish to take your new skill on?\n\n");
  printf("   1. personal development table\n   2. service skills table\n");
  if (careernbr <= NAVY || careernbr == BUREAUCRAT || careernbr == MANAGEMENT) {
    if (sex == 2) printf("   3. female service skills table\n");
    else printf("   3. male service skills table\n");
  } else {
    printf("   3. second service skills table\n");
    printf("   4. experience table\n\n");
  }
  choice = getsel_int(1, 4);
  if ((careernbr <= NAVY || careernbr == ARTIST || careernbr == MANAGEMENT)
    && choice == 4) {
      printf("Please enter a valid number - try again.\n");
      return aslpicktable();
  }
  return choice;
}


void land()
{
  int worth, i;

  worth = 1;
  i = soc - 8;
  while (i >= 1) {
    worth = worth * 10;
    i--;
  }
  printf("land holding of %d square km ", worth);
  km_land += worth;
  printf("for a total of %d square km.\n", km_land);
}


void corp()
{
  int roll;

  roll = d12() + d12() - 3;
  if (blue_blood == 0) printf("You received a corporation");
  else printf("Your corporation is now");
  blue_blood += roll;
  printf(" worth %d MCr.\n", blue_blood);
}


void altcareertbl()
{
}


/*
void schools()
{
}*/
