/* ASLENVOY.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void aslenvoy();
void aslenvoymot(int term);
void aslenvoybene();
void aslenvoyskills(int skills);

extern int asl_spec_duty(int need_nbr);
extern int asl_surv(int need_nbr, int upp_type, int upp_val);
extern int reenlist(int need_nbr);
extern int aslmotrolls();
extern void addskill(int skill, int skl_val);
extern int asl_mot();
extern char getche_mot();
extern int asl_cash();
extern int asl_beneroll();
extern void bumpintl();
extern void bumpedu();
extern void bumpsoc();
extern void bumpend();
extern void bumpdex();
extern void independ();
extern int aslpicktable();
extern int d6();
extern int aslsklroll();
extern void aslmc();
extern void land();
extern void aslmentl(int skl_val);
extern void aslecon(int skl_val);
extern void aslinbrn(int skl_val);
extern void aslgc(int skl_val);
extern void asltechl(int skl_val);
extern void aslenv(int skl_val);
extern void aslvhcl(int skl_val);
extern void aslinterp(int skl_val);
extern int find_skl(int skill);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_nada();
extern void mot_ship();

#include "chargen.h"

void aslenvoy()
{
  int  skills, newterm;
  
  asltechl(1);
  newterm = 0;
  while (newterm != 1) {
    skills = asl_spec_duty(6);
    newterm = asl_surv(6, find_skl(TOLERANCE), 0);
    if (newterm == 0) skills += 3;
    if (skills != 0) aslenvoyskills(skills);
    printf("That competes this term!\n");
    if (newterm == 0) newterm = reenlist(8);
  }
  aslenvoymot(aslmotrolls());
  if (sex == 1 && soc >= 9) addskill(LEADER, 1);
}


void aslenvoymot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = asl_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      roll = asl_cash();
      cash--;
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: break;
        case 2: break;
        case 3: break;
        case 4: amt = 5000; break;
        case 5: amt = 5000; break;
        case 6: amt = 10000; break;
        default: amt = 20000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        term--;
        aslenvoybene();
    }
  }
  while (term > 0)
  {
    aslenvoybene();
    term--;
  }
}


void aslenvoybene()
{
  int roll;

  roll = asl_beneroll();
  switch (roll)
  {
	case 1: mot_nada(); break;
	case 2: mot_nada(); break;
	case 3: bumpintl(); break;
    case 4: bumpedu(); bumpedu(); break;
    case 5: addskill(INDEPENDENCE, 1); break;
    case 6: mot_weapon(); break;
    case 7: mot_ship(); break;
    case 8: land(); break;
  }
}


void aslenvoyskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = aslpicktable();
    roll = d6();
    roll = aslsklroll(roll);
    if (table == 1) {
      switch (roll) {
        case 1: independ(1); break;
        case 2: aslmc(1); break;
        case 3: bumpdex(); break;
        case 4: bumpend(); break;
        case 5: aslecon(1); break;
      }
    }
    if (table == 2) {
      switch (roll) {
        case 1: aslmentl(1); break;
        case 2: aslmc(1); break;
        case 3: aslinterp(1); break;
        case 4: aslinterp(1); break;
        case 5: aslenv(1); break;
      }
    }
    if (table == 3) {
      switch (roll) {
        case 1: aslinterp(1); break;
        case 2: aslinterp(1); break;
        case 3: addskill(TOLERANCE, 1); break;
        case 4: addskill(TOLERANCE, 1); break;
        case 5: aslgc(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: aslinbrn(1); break;
        case 2: aslvhcl(1); break;
        case 3: aslmc(1); break;
        case 4: aslinterp(1); break;
        case 5: bumpsoc(); break;
      }
    }
    skills--;
  }
}

