/* ASLMEDIC.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void aslmedic();
void aslmedicmot(int term);
void aslmedicbene();
void aslmedicskills(int skills);

extern int asl_spec_duty(int need_nbr);
extern int asl_surv(int need_nbr, int upp_type, int upp_val);
extern int reenlist(int need_nbr);
extern int aslmotrolls();
extern void addskill(int skill, int skl_val);
extern int asl_mot();
extern char getche_mot();
extern int asl_cash();
extern int asl_beneroll();
extern void bumpedu();
extern void bumpdex();
extern void bumpend();
extern int aslpicktable();
extern int d6();
extern int d12();
extern int aslsklroll();
extern void physicl(int skl_val);
extern void aslmentl(int skl_val);
extern void sci(int skl_val);
extern void asltechl(int skl_val);
extern void aslvhcl(int skl_val);
extern void aslacad(int skl_val);
extern void aslinterp(int skl_val);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_midpsg();
extern void mot_lopsg();
extern void mot_medkit();

#include "chargen.h"

void aslmedic()
{
  int  skills, newterm;
  
  addskill(MEDICAL, 1);
  newterm = 0;
  while (newterm != 1) {
    skills = asl_spec_duty(4);
    newterm = asl_surv(6, intl, 8);
    if (newterm == 0) skills += 3;
    if (skills != 0) aslmedicskills(skills);
    printf("That competes this term!\n");
    if (newterm == 0) newterm = reenlist(4);
  }
  aslmedicmot(aslmotrolls());
}


void aslmedicmot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = asl_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      roll = asl_cash();
      cash--;
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 5000; break;
        case 2: amt = 10000; break;
        case 3: amt = 10000; break;
        case 4: amt = 10000; break;
        case 5: amt = 20000; break;
        case 6: amt = 40000; break;
        default: amt = 70000; break;
      }
	  mot_cash(amt);
    }
	else
	{
      term--;
      aslmedicbene();
    }
  }
  while (term > 0)
  {
    aslmedicbene();
    term--;
  }
}


void aslmedicbene()
{
  int roll;

  roll = asl_beneroll();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpedu(); break;
    case 3: bumpedu(); break;
    case 4: mot_weapon(); break;
    case 5: mot_medkit(); break;
    case 6: addskill(INDEPENDENCE, 1); break;
    default: mot_midpsg(); break;
  }
}


void aslmedicskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = aslpicktable();
    roll = d6();
    roll = aslsklroll(roll);
    if (table == 1) {
      switch (roll) {
        case 1: break;
        case 2: physicl(1); break;
        case 3: bumpdex(); break;
        case 4: bumpend(); break;
        case 5: aslmentl(1); break;
        case 6: aslmentl(1); break;
      }
    }
    if (table == 2) {
      switch (roll) {
        case 1: break;
        case 2: asltechl(1); break;
        case 3: asltechl(1); break;
        case 4: addskill(MEDICAL, 1); break;
        case 5: aslacad(1); break;
        case 6: aslinterp(1); break;
      }
    }
    if (table == 3) {
      switch (roll) {
        case 1: break;
        case 2: addskill(MEDICAL, 1); break;
        case 3: sci(1); break;
        case 4: addskill(MEDICAL, 1); break;
        case 5: asltechl(1); break;
        case 6: aslacad(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: break;
        case 2: aslacad(1); break;
        case 3: aslacad(1); break;
        case 4: asltechl(1); break;
        case 5: aslvhcl(1); break;
        case 6: aslinterp(1); break;
      }
    }
    skills--;
  }
}

