/* ASLSCINT.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void aslscient();
void aslscientmot(int term);
void aslscientbene();
void aslscientskills(int skills);

extern int asl_spec_duty(int need_nbr);
extern int asl_surv(int need_nbr, int upp_type, int upp_val);
extern int reenlist(int need_nbr);
extern int aslmotrolls();
extern void addskill(int skill, int skl_val);
extern int asl_mot();
extern char getche_mot();
extern int asl_cash();
extern int asl_beneroll();
extern void bumpedu();
extern void bumpsoc();
extern void bumpdex();
extern void aslmc(int skl_val);
extern int aslpicktable();
extern int d6();
extern int aslsklroll();
extern void physicl(int skl_val);
extern void aslmentl(int skl_val);
extern void aslacad(int skl_val);
extern void aslinbrn(int skl_val);
extern void aslst(int skl_val);
extern void asltechl(int skl_val);
extern void aslinterp(int skl_val);
extern void aslvhcl(int skl_val);
extern void sci(int skl_val);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_midpsg();
extern void mot_ship();
extern void mot_lopsg();

#include "chargen.h"

void aslscient()
{
  int  skills, newterm;
  
  asltechl(1);
  newterm = 0;
  while (newterm != 1) {
    skills = asl_spec_duty(4);
    newterm = asl_surv(5, end, 9);
    if (newterm == 0) {
      if (terms == 1) skills += 3;
      else skills += 2;
    }
    if (skills != 0) aslscientskills(skills);
    printf("That competes this term!\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  aslscientmot(aslmotrolls());
}


void aslscientmot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = asl_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      roll = asl_cash();
      cash--;
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 1000; break;
        case 2: amt = 5000; break;
        case 3: amt = 5000; break;
        case 4: amt = 10000; break;
        case 5: amt = 20000; break;
        case 6: amt = 40000; break;
        default: amt = 70000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        term--;
        aslscientbene();
    }
  }
  while (term > 0)
  {
    aslscientbene();
    term--;
  }
}


void aslscientbene()
{
  int roll;

  roll = asl_beneroll();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpedu(); break;
    case 3: mot_midpsg(); break;
    case 4: mot_weapon(); break;
    case 5: addskill(INDEPENDENCE, 1); break;
    case 6: bumpsoc(); break;
    default: mot_ship(); break;
  }
}


void aslscientskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = aslpicktable();
    roll = d6();
    roll = aslsklroll(roll);
    if (table == 1) {
      switch (roll) {
        case 1: break;
        case 2: physicl(1); break;
        case 3: bumpdex(); break;
        case 4: aslmc(1); break;
        case 5: aslmentl(1); break;
        case 6: aslmentl(1); break;
      }
    }
    if (table == 2) {
      switch (roll) {
        case 1: break;
        case 2: asltechl(1); break;
        case 3: sci(1); break;
        case 4: addskill(COMPUTER, 1); break;
        case 5: aslacad(1); break;
        case 6: aslvhcl(1); break;
      }
    }
    if (table == 3) {
      switch (roll) {
        case 1: break;
        case 2: asltechl(1); break;
        case 3: sci(1); break;
        case 4: sci(1); break;
        case 5: asltechl(1); break;
        case 6: aslacad(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: break;
        case 2: sci(1); break;
        case 3: aslst(1); break;
        case 4: aslmentl(1); break;
        case 5: aslinterp(1); break;
        case 6: aslinbrn(1); break;
      }
    }
    skills--;
  }
}


