/* ASLWANDR.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void aslwander();
void aslwandermot(int term);
void aslwanderbene();
void aslwanderskills(int skills);

extern int asl_spec_duty(int need_nbr);
extern int asl_surv(int need_nbr, int upp_type, int upp_val);
extern int reenlist(int need_nbr);
extern int aslmotrolls();
extern void addskill(int skill, int skl_val);
extern int asl_mot();
extern char getche_mot();
extern int asl_cash();
extern int asl_beneroll();
extern void land();
extern void bumpedu();
extern void bumpintl();
extern void asltechl(int skl_val);
extern void bumpdex();
extern void independ();
extern int aslpicktable();
extern int d6();
extern int aslsklroll();
extern void physicl(int skl_val);
extern void aslmc(int skl_val);
extern void aslgc(int skl_val);
extern void aslspace(int skl_val);
extern void aslvhcl(int skl_val);
extern void aslsc(int skl_val);
extern void aslexplore(int skl_val);
extern void aslenv(int skl_val);
extern void asltechl(int skl_val);
extern void aslinterp(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_ship();

#include "chargen.h"

void aslwander()
{
  int  skills, newterm;
  
  addskill(PILOT, 1);
  newterm = 0;
  while (newterm != 1) {
    skills = asl_spec_duty(5);
    newterm = asl_surv(9, intl, 8);
    if (newterm == 0) {
      if (terms == 1) skills += 3;
      else skills += 2;
    }
    if (skills != 0) aslwanderskills(skills);
    printf("That competes this term!\n");
    if (newterm == 0) newterm = reenlist(5);
  }
  aslwandermot(aslmotrolls());
  if (sex == 1 && soc >= 9) addskill(LEADER, 1);
}


void aslwandermot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = asl_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      roll = asl_cash();
      cash--;
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: break;
        case 2: break;
        case 3: break;
        case 4: amt = 2000; break;
        case 5: amt = 5000; break;
        case 6: amt = 10000; break;
        default: amt = 200000; break;
      }
    } 
	else 
	{
      term--;
      aslwanderbene();
    }
  }
  while (term > 0)
  {
    aslwanderbene();
    term--;
  }
}


void aslwanderbene()
{
  int roll;

  roll = asl_beneroll();
  switch (roll)
  {
    case 2: mot_lopsg(); break;
    case 3: bumpintl(); break;
    case 4: bumpedu(); bumpedu(); break;
    case 5: addskill(INDEPENDENCE, 1); break;
    case 6: addskill(TOLERANCE, 1); break;
    case 7: mot_ship(); break;
    case 8: land(); break;
  }
}


void aslwanderskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = aslpicktable();
    roll = d6();
    roll = aslsklroll(roll);
    if (table == 1) {
      switch (roll) {
        case 1: independ(1); break;
        case 2: physicl(1); break;
        case 3: bumpdex(); break;
        case 4: aslmc(1); break;
        case 5: aslgc(1); break;
      }
    }
    if (table == 2) {
      switch (roll) {
        case 1: independ(1); break;
        case 2: aslvhcl(1); break;
        case 3: aslsc(1); break;
        case 4: aslspace(1); break;
        case 5: aslmc(1); break;
      }
    }
    if (table == 3) {
      switch (roll) {
        case 1: aslspace(1); break;
        case 2: aslvhcl(1); break;
        case 3: aslgc(1); break;
        case 4: aslexplore(1); break;
        case 5: aslinterp(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: aslsc(1); break;
        case 2: aslvhcl(1); break;
        case 3: asltechl(1); break;
        case 4: aslinterp(1); break;
        case 5: aslenv(1); break;
      }
    }
    skills--;
  }
}

