/* Academy.C establishes the characters pre-career choices */

#include <stdio.h>
#include <string.h>

/*
#ifndef APPLE_CC
#include <conio.h>
#endif
*/

int mil_acad();
int air_acad();
int nav_acad();
void picknav();
int merch_acad();
void pickdept();

extern void honors();
extern int bp_adj();
extern int bp_skill1(int roll, int need_nbr);
extern void gotarmy();
extern void gotflyer();
extern void gotnavy();
extern void gotmarines();
extern void gotmerch();
extern int d6();
extern int d12();
extern int getsel_int(int min, int max);
extern void addskill(int skill, int skl_val);
extern void bumpedu();
extern void techl(int skl_val);
extern void join_mega();
extern void join_sector();
extern void deck();
extern void mer_engr();
extern void purser();
extern void mer_admin();
extern void sales();
extern void bp_add(int amt);
extern void prntacceptedu(char accepted[], char schoolname[]);
extern void prntgraduateedu(char graduated[], char schoolname[]);

#include "chargen.h"

extern int  mer_acd, mil_acd, nav_acd, air_acd;


int mil_acad()
{
	int roll;
	char name[18];

	strncpy(name, "Military Academy", 17);
	roll = d12();
	if (str >= 10)
		roll += 2;
	if (roll < 10 && brownie_points > 0)
		roll = bp_adj(roll, 10);
	if (roll < 10)
	{
		prntacceptedu("not ", name);
		return NOTACCEPTED;
	}
	prntacceptedu("", name);
	gotarmy();
	roll = d12();
	if (edu >= 8 || (race == ITHKLUR && edu >= 6))
		roll += 2;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 9);
	if (roll < 9)
	{
		prntgraduateedu("not ", name);
		age++;
		appearent_age++;
		return 0;
	}
	prntgraduateedu("", name);
	col = 4;
	rankeo = 'O';
	rank = 1;
	roll = d6() - 3;
	if (intl >= 9)
		roll++;
	if (roll < 1)
		roll = 1;
	while (roll > 0)
	{	 
		bumpedu();
		roll--;
	}
	age += 4;
	appearent_age = age;
	bp_add(2);
	addskill(CMBTRIFLMAN, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(ADMIN, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(TACTICS, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(LEADER, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(HEAVYWEAP, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(FORWARDOBS, 1);
	roll = bp_skill1(d6(), 4);
	if ((roll >= 4 && race != ITHKLUR) || (roll >= 6 && race == ITHKLUR))
		addskill(COMPUTER, 1);
	roll = d12();
	if (intl >= 9)
		roll++;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 9);
	if (roll >= 9)
		honors();
	return 1;
}


int air_acad()
{
	int roll;
	char name[13];

	if (race == ITHKLUR)
		strncpy(name, "Flight Academy", 15);
	else
		strncpy(name, "Air Academy", 12);
	roll = d12();
	if (dex >= 9)
		roll += 2;
	if (roll < 10 && brownie_points > 0)
		roll = bp_adj(roll, 10);
	if (roll < 10)
	{
		prntacceptedu("not ", name);
		return NOTACCEPTED;
	}
	prntacceptedu("", name);
	gotflyer();
	roll = d12();
	if (intl >= 8)
		roll += 2;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 9);
	if (roll < 9)
	{
		prntgraduateedu("not ", name);
	    age++;
		appearent_age++;
		return 0;
	}
	prntgraduateedu("", name);
	col = 6;
	rankeo = 'O';
	rank = 1;
	age = 22;
	appearent_age = age;
	bp_add(2);
	roll = d6() - 3;
	if (intl >= 9)
		roll++;
	if (roll < 1)
		roll = 1;
	while (roll > 0)
	{	 
		bumpedu();
		roll--;
	}
	addskill(SURVIVAL, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(ADMIN, 1);
	roll = bp_skill1(d6(), 4);
	if ((roll >= 4 && race != ITHKLUR) || (race == ITHKLUR && roll >=6))
		addskill(NAVIGATION, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(LEADER, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		techl(1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 6)
		addskill(PROPAIR, 1);
	roll = d12();
	if (intl >= 9)
		roll++;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 9);
	if (roll >= 9)
		honors();
	return 1;
}


int nav_acad()
{
	int roll;
	char name[15];

	strncpy(name, "Naval Academy", 14);
	roll = d12();
	if (soc >= 10)
		roll += 2;
	if (roll < 10 && brownie_points > 0)
		roll = bp_adj(roll, 10);
	if (roll < 10)
	{
		prntacceptedu("not ", name);
		return NOTACCEPTED;
	}
	prntacceptedu("", name);
	picknav();
	roll = d12();
	if (edu >= 8 || (race == ITHKLUR && edu >= 6))
		roll = roll + 2;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 9);
	if (roll < 9)
	{
		prntgraduateedu("not ", name);
	    age++;
		appearent_age++;
		return 0;
	}
	prntgraduateedu("", name);
	col = 5;
	bp_add(2);
	rankeo = 'O';
	rank = 1;
	age = 22;
	appearent_age = age;
	roll = d6() - 3;
	if (roll < 1)
		roll = 1;
	if (intl >= 9)
		roll++;
	while (roll > 0)
	{ 
		bumpedu();
	    roll--;
	}
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(VACCSUIT, 1);
	roll = bp_skill1(d6(), 4);
	if ((roll >= 4 && race != ITHKLUR) || (race == ITHKLUR && roll >= 6))
		addskill(NAVIGATION, 1);
	roll = bp_skill1(d6(), 4);
	if ((roll >= 4 && race != ITHKLUR) || (race == ITHKLUR && roll >= 6))
	{
		addskill(ENGINEERING, 1);
		roll = bp_skill1(d6(), 4);
		if ((roll >= 4 && race != ITHKLUR) || (race == ITHKLUR && roll >= 5))
			addskill(NAVALARCH, 1);
	}
	roll = d12();
	if (intl >= 9)
		roll++;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 9);
	if (roll >= 9)
		honors();
	return 1;
}


void picknav()
{
	int  choice;

	printf("Which branch do you wish to serve in?\n\n");
	printf("   1. navy\n   2. marines\n");
	choice = getsel_int(1, 2);
	if (choice == 1)
	{
		line = 1;
		gotnavy();
	} 
	else
		gotmarines();
}


int merch_acad()
{
	int roll;
	char name[18];

	strncpy(name, "Merchant Academy", 17);
	join_mega();
	if (line == 0)
		join_sector();
	if (line == 0)
	{
		printf("You were not accepted into a megacorp or sector wide line,\n");
		printf("so, you may not attend the %s.\n", name);
		return NOTACCEPTED;
	}
	gotmerch();
	roll = d12();
	if (edu >= 10)
		roll += 2;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 9);
	if (roll < 9)
	{
		prntacceptedu("not ", name);
		return NOTACCEPTED;
	}
	prntacceptedu("", name);
	roll = d12();
	if (intl >= 8)
		roll += 2;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 9);
	if (roll < 9)
	{
		prntgraduateedu("not ", name);
	    age++;
		appearent_age++;
		return 0;
	}
	prntgraduateedu("", name);
	col = 3;
	bp_add(2);
	rankeo = 'O';
	rank = 1;
	age = 22;
	appearent_age = age;
	roll = d6() - 3;
	if (intl >= 9)
		roll++;
	if (roll < 1)
		roll = 1;
	while (roll > 0)
	{ 
		bumpedu();
		roll--;
	}
	pickdept();  
	roll = d12();
	if (intl >= 9)
		roll++;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 9);
	if (roll >= 9)
		honors();
	if (race == VILANI)
		careernbr = ARTIST;
	return 1;
}


void pickdept()
{
	int  choice;

	printf("Pick your department.\n\n   1. deck\n   2. engineering\n");
	printf("   3. purser\n   4. administrative\n   5. sales\n");
	choice = getsel_int(1, 5);
	branch = choice;
	switch (branch)
	{
		case 1: deck(); break;
		case 2: mer_engr(); break;
		case 3: purser(); break;
	    case 4: mer_admin(); break;
		default: sales(); break;
	}
}
