/* BACKGRND.C establishes the characters background skills */

#include <stdio.h>
#include <stdlib.h>

/*
#ifndef APPLE_CC
#include <conio.h>
#endif
*/

void background();
int pickbg();
void bg(int amount);
int finearts();
void bgskills();
int bgatmos();
int bgtech();
int bgsocsci();
int bgother();
int getfinearts();
int swfinearts(int choice);
int getbgatmos();
int swbgatmos(int choice);
int getbg();
int swbg(int choice);
int getbgtech();
int swbgtech(int choice);
int getbgsocsci();
int swbgsocsci(int choice);
int getbgother();
int swbgother(int choice);

extern int d5();
extern int pickvhcl(int skl_val);
extern int getvhcl(int skl_val);
extern int getsel_int(int min, int max);
extern void addskill(int skill, int skl_val);
extern char getche_y_n();
extern void anykey();
extern int pickaw();
extern int pickpc();
extern int pickanim();
extern int pickgc();
extern int getaw();
extern int getpc();
extern int getanim();
extern int getgc();
extern void dispskil(int sequ, int skill);
extern int d6();
extern int d7();

#include "chargen.h"


void background()
{
	char choice;

	printf("\nDo you want to use background skills?");
	choice = getche_y_n();
	if (choice == 'y' || choice == 'Y')
		bgskills();
	return;
}


void bgskills()
{
	int bgskl, bglevel;

	printf("\nHow many back ground skills do you want? (up to 4)");
	bgskl = getsel_int(1, 4);
	if (race == ITHKLUR && bgskl > 2)
	{
		bgskl = 2;
		printf("Ithklur characters get only half of the normal background skills (%d).\n", bgskl);
	}
	printf("\nWhat level of background skills do you want? (0 or 1)");
	bglevel = getsel_int(0, 1);
	while (bgskl > 0)
	{
		bg(bglevel);
		bgskl--;
	}
	return;
}


void bg(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getbg();
	else
		skill = pickbg();
	if (skill > 0)
		addskill(skill, amount);
}


int getbg()
{
	int  choice;

	choice = d5();
	return swbg(choice);
}


int swbg(int choice)
{
	switch (choice)
	{
		case 1: return getfinearts();
	    case 2: return getbgatmos();
		case 3: return getbgtech();
	    case 4: return getbgsocsci();
		case 5: return getbgother();  
	}
	return -1;
}


int pickbg()
{
	int choice, val;

	printf("Pick an area where you want background skills.\n");
	printf("\n   1. fine arts\n   2. atmosphere related\n   3. technology related\n");
	printf("   4. social or science\n   5. other\n");
	choice = getsel_int(1, 5);
	switch (choice)
	{
		case 1: val = finearts(); break;
		case 2: val = bgatmos(); break;
		case 3: val = bgtech(); break;
		case 4: val = bgsocsci(); break;
		case 5: val = bgother(); break;
	}
	if (val <= 0)
		val = pickbg();
	return(val);
}


int finearts()
{
	int choice, val;

	if (pick == 2 || pick == 4)
		return getfinearts();
	printf("Pick a skill in the fine arts area.\n");
	printf("\n   1. none\n");
	dispskil(2, ACTING);
	dispskil(3, DANCE);
	dispskil(4, DISGUISE);
	dispskil(5, MUSIC);
	dispskil(6, ARTS);
	dispskil(7, SONG);
	choice = getsel_int(1, 7);
	if (choice > 1)
		val = swfinearts(choice - 1);
	else
		return 0;
	return(val);
}


int getfinearts()
{
	int  choice;

	if (race == HIVER) // hivers like disguise
		choice = 3;
	else
	{
		choice = d6();
		if (race == ITHKLUR)
		{
			if (choice != 2 && choice != 5) // ithklur like dance & arts
				choice = d6();
			if (choice == 3) // ithklur dislike disguise
				choice = d6();
		}

	}
	return swfinearts(choice);
}


int swfinearts(int choice)
{
	int val;
	
	switch (choice)
	{
		case 1: val = ACTING; break;
		case 2: val = DANCE; break;
		case 3: val = DISGUISE; break;
		case 4: val = MUSIC; break;
		case 5: val = ARTS; break;
		case 6: val = SONG; break;
	}
	return val;
}


int bgatmos()
{
	int choice, val, max;

	if (pick == 2 || pick == 4)
		return getbgatmos();
	printf("Pick a skill in the atmosphere related area.\n");
	printf("\n   1. none\n");
	if (atmos <= ATMVAC)
	{
		dispskil(2, VACCSUIT);
		max = 2;
	}
	else
	{
		dispskil(2, PROPAIR);
		max = 2;
		if (atmos <= ATMDEN)
		{
			dispskil(3, SURVIVAL);
			dispskil(4, HUNTING);
			max = 4;
			if (hydro >= HYDDRY)
			{
				dispskil(5, FARMING);
				dispskil(6, SWIMMING);
				max = 6;
			}
			if (hydro >= HYDWET)
			{
				dispskil(7, SMALLBOAT);
				max = 7;
			}
		}
	}
	if (race == KKREE || race == JONKEREEN)
	{
		dispskil(8, ENCLOSURE);
		max = 8;
	}
	choice = getsel_int(1, max);
	if (choice > 1)
		val = swbgatmos(choice - 1);
	else
		return 0;
	return (val);
}


int getbgatmos()
{
	int  choice;

	if (race == KKREE || race == JONKEREEN)
		choice = d7();
	else
		choice = d6();
	if (race == ITHKLUR)
	{
		if (choice != 2 && choice != 3) //ithklur like survival & hunting
			choice = d6();
		if (choice == 4) // ithklur dislike farming
			choice = d6();
	}
	if (atmos <= ATMVAC || atmos > ATMDEN)
		choice = 1;
	else
		if (hydro < HYDWET && choice == 6)
			choice = 1;
		else
			if (hydro < HYDDRY && (choice == 4 || choice == 5))
				choice -= 2;
	return swbgatmos(choice);
}


int swbgatmos(int choice)
{
	int val;
	
	switch (choice)
	{
		case 1: 
			{
				if (atmos <= ATMVAC)
					val = VACCSUIT;
				else
					val = PROPAIR;
				break;
			}
		case 2: val = SURVIVAL; break;
		case 3: val = HUNTING; break;
		case 4: val = FARMING; break;
		case 5: val = SWIMMING; break;
		case 6: val = SMALLBOAT; break;
		case 7: val = ENCLOSURE; break;
	}
	return val;
}


int bgtech()
{
	int choice, val;

	if (tech < TLIND && (col % 10) == 1)
	{
		printf("You have no technology related options.\n");
		anykey();
		return 0;
	}
	if (pick == 2 || pick == 4)
		return getbgtech();
	printf("Pick a skill in the technology related area.\n");
	printf("\n   1. none\n");
	dispskil(2, ELECTRONICS);
	dispskil(3, MECHANICAL);
	dispskil(4, VEHICLE);
	dispskil(5, COMPUTER);
	dispskil(6, VACCSUIT);
	choice = getsel_int(1, 6);
	if (choice <= 1)
		val = 0;
	else
		val = swbgtech(choice - 1);
	return (val);
}


int getbgtech()
{
	int  choice;

	choice = d5();
	if (race == HIVER && choice != 1 && choice != 4) // hivers like elec. & comp.
		choice = d5();
	if (race == ITHKLUR && choice == 4) // ithklur dislike computers
		choice = d5();
	return swbgtech(choice);
}


int swbgtech(int choice)
{
	int val;
	
	switch (choice)
	{
		case 1: val = ELECTRONICS; break;
		case 2: val = MECHANICAL; break;
		case 3:
			{
				if (pick == 2 || pick == 4)
					val = getvhcl(1);
				else
					val = pickvhcl(1);
				break;
			}
		case 4: val = COMPUTER; break;
		case 5: val = VACCSUIT; break;
	}
	return val;
}


int bgsocsci()
{
	int choice, val, max;

	if (pick == 2 || pick == 4)
	{
		choice = d5() + 1;
		if (race == ITHKLUR)
		{
			if (choice != 2 && choice != 5) // ithklur prefer hist. & Bio.
				choice = d5() + 1;
			if (choice == 6) // ithklur dislike chem.
				choice = d5() + 1;
		}
	}
	else
	{
		printf("Pick a skill in the social/science area.\n");
		printf("\n   1. none\n");
		dispskil(2, HISTORY);
		dispskil(3, LINGUISTICS);
		dispskil(4, RESEARCH);
		dispskil(5, BIOLOGY);
		dispskil(6, CHEMISTRY);
		max = 6;
		if (race == LLELLEWYLOLY || race == ASLAN)
		{
			dispskil(7, TOLERANCE);
			max = 7;
		}
		choice = getsel_int(1, max);
	}
	if (choice <= 1)
		val = 0;
	else
		val = swbgsocsci(choice - 1);
	return (val);
}


int getbgsocsci()
{
	int  choice;

	if (race == LLELLEWYLOLY || race == ASLAN)
		choice = d6(); // allow tolerance
	else
		choice = d5();
	if (race == ITHKLUR)
	{
		if (choice != 1 && choice != 4) // ithklur prefer hist. & bio.
			choice = d5();
		if (choice == 5) // ithklur don't like chemistry
			choice = d5();
	}
	return swbgtech(choice);
}


int swbgsocsci(int choice)
{
	int val;
	
	switch (choice)
	{
		case 1: val = HISTORY; break;
		case 2: val = LINGUISTICS; break;
		case 3: val = RESEARCH; break;
		case 4: val = BIOLOGY; break;
		case 5: val = CHEMISTRY; break;
		case 6: val = TOLERANCE; break;
	}
	return val;
}


int bgother()
{
	int choice, val, max;

	if (pick == 2 || pick == 4)
		return getbgother();
	printf("Pick a skill in the miscellaneous area.\n");
	printf("\n   1. none\n");
	dispskil(2, ARCHAICWEAP);
	dispskil(3, PERSONALCMBT);
	dispskil(4, ANIMALS);
	dispskil(5, STEALTH);
	dispskil(6, GUNCMBT);
	max = 6;
	if (pop >= POPMID && race != NEWT)
	{
		dispskil(7, STREETWISE);
		max = 7;
	}
	choice = getsel_int(1, max);
	if (choice <= 1)
		val = 0;
	else
		val = swbgother(choice - 1);
	return (val);
}


int getbgother()
{
	int  choice;

	if (pop >= POPMID && race != NEWT)
		choice = d6(); // allow streetwise
	else
		choice = d5();
	if (race == HIVER && (choice < 3 || choice == 5)) // hivers like amin. & stealth
		choice = d6();
	if (race == ITHKLUR && (choice == 4 || choice == 6)) // ithklur like fighting
		choice = d6();
	return swbgother(choice);
}


int swbgother(int choice)
{
	int val;
	
	switch (choice)
	{
		case 1:
			{
				if (pick == 2 || pick == 4)
					val = getaw();
				else
					val = pickaw();
				break;
			}
		case 2:
			{
				if (pick == 2 || pick == 4)
					val = getpc();
				else
					val = pickpc();
				break;
			}
		case 3:
			{
				if (pick == 2 || pick == 4)
					val = getanim();
				else
					val = pickanim();
				break;
			}
		case 4: val = STEALTH; break;
		case 5:
			{
				if (pick == 2 || pick == 4)
					val = getgc();
				else
					val = pickgc();
				break;
			}
		case 6: val = STREETWISE; break;
	}
	return (val);
}
