/* CGINIT.C is a MegaTraveller (c) aid for character generation */

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <ctype.h>
#include <stdarg.h>
#include <string.h>
#include <unistd.h>



/*
#ifndef APPLE_CC
#include <dos.h>
#include <process.h>
#endif
*/

int welcome(int ac, char **av);
int doit();
int again();
void initvars();
int d2();
int d3();
int d4();
int d5();
int d6();
int d7();
int d8();
int d9();
int d10();
int d11();
int d12();
int d18();
int d12plus();
int TeePrint(char * fmt);

extern void clrscr();
extern void anykey();
extern void upp();
extern void homesys();
extern void prntchar();
extern void careers();
extern char getche_y_n();

/* personality related characteristics */

int   str, dex, end, intl, edu, soc, psi, age, appearent_age;
int   race, terms, anagathics, sex, blue_blood, prevterms;

/* muster related variables */

int   gambler, kit, kitval, tas, hipsg, midpsg, lopsg;
int   ship, weapons, brownie_points;
long  credits, km_land;

/* career relatied variables */

int   careernbr, rank, branch, line, medic, drafted, assignment;
int   col, otc, med_sch, flt_sch, tech_acd, law_sch;
int   skil, surv, promo, decor, mcuf, mcg, seh, cmbt, cmd;
int   alt_career, grad_sch, major, purple, prevcareernbr, prevrank;
char  rankeo, career[21], office[20], prevrankeo, prevcareer[21];
char  prevoffice[20], alt_careername[21], disp_duty[15];
char  skill_tbl_name[21];
int   skill_table[6], special_duty[46];

/* home planet related variables */

int   atmos, hydro, pop, law, tech, size, gov;
char  starport, size_descr[9], atmos_descr[9], hydro_descr[13];
char  pop_descr[9], law_descr[9], tech_descr[16], uwp[26];
char  gov_descr[18];

/* skill related variables */

int   totalskill, skillcount, maxskill, pick, spec_skill;
int   skillcode[100], skillrating[100], psigames, zhomedal[11];
char  skill[20];

int telepath, clair, telekin, aware, teleport, psispecial, psi_interest;

FILE *outfl;

int welcome(int ac, char **av)
{
	clrscr();
	if (ac > 1)
		return atoi(av[1]);
	printf("Welcome to MTCG version 1.18.1, a MegaTraveller (c)\n");
	printf("character generation program written by Greg Svenson.\n\n");
	printf("This is a public domain program.\n\n");
	printf("Traveller and MegaTraveller are registered trademarks of Far Future\n");
	printf("Enterprises. Portions of this material are Copyright 1977-2005 by\n");
	printf("Far Future Enterprises.\n\n");
	anykey();
	return 0;
}


int doit()
{
	clrscr();
	srand((unsigned)time(NULL));
	initvars();
//	if ((outfl = fopen("mtcg.txt","wt")) == (FILE *) 0)
//	{
//		fprintf(stderr,"Failed to Open output file: mtcg.txt (%d)\n", errno);
//		exit (-1);
//	}
	upp();
	homesys();
	careers();
	prntchar();
//	printf("Your character's history was saved in file mtcg.txt\n");
//	fclose(outfl);
	return (again());
}


int again()
{
	char choice;

	anykey();
	clrscr();
	printf("\nDo you want to generate another character?");
	choice = getche_y_n();
	if (choice == 'Y' || choice == 'y')
	execl("mtcg", "mtcg", "0", NULL);
	return 0;
}


void initvars()
{
	int  i;

	blue_blood = 0;
	str = 0;
	dex = 0;
	end = 0;
	intl = 0;
	edu = 0;
	soc = 0;
	psi = 0;
	sex = 0;
	age = 18;
	appearent_age = age;
	terms = 0;
	prevterms = 0;
	anagathics = 0;

/* muster related variables */

	gambler = 0;
	kit = 0;
	kitval = 0;
	tas = 0;
	hipsg = 0;
	midpsg = 0;
	lopsg = 0;
	ship = 0;
	weapons = 0;
	credits = 0;
	km_land = 0;
	brownie_points = 0;

/* career relatied variables */

	careernbr = 0;
	prevcareernbr = careernbr;
	branch = 0;
	line = 0;
	medic = 0;
	drafted = 0;
	col = 0;
	otc = 0;
	med_sch = 0;
	flt_sch = 0;
	skil = 0;
	surv = 0;
	promo = 0;
	decor = 0;
	mcuf = 0;
	mcg = 0;
	seh = 0;
	purple = 0;
	cmbt = 0;
	cmd = 0;
	alt_career = 0;
	alt_careername[0] = '\0';
	grad_sch = 0;
	tech_acd = 0;
	law_sch = 0;
	major = 0;
	rankeo = 'E';
	rank = 0;
	prevrank = rank;
	prevrankeo = '\0';
	prevcareer[0] = '\0';
	prevoffice[0] = '\0';
	disp_duty[0] = '\0';
	assignment = 0;
	for (i = 0; i < 45; i++)
		special_duty[i] = 0;

/* home planet related variables */

	atmos = 0;
	hydro = 0;
	pop = 0;
	law = 0;
	gov = 0;
	tech = 0;
	size = 0;
	starport = ' ';
	for (i = 0; i < 26; i++)
		uwp[i] = '\0';

/* skill related variables */

	totalskill = 0;
	skillcount = 0;
	pick = 0;
	spec_skill = 0;
	psigames = 0;
	psi_interest = 0;
	for (i = 1; i < 12; i++)
		zhomedal[i] = 0;
	maxskill = 100;
	for (i = 0; i < maxskill; i++)
		skillcode [i] = skillrating [i] = 0;
}


int d2()
{
	int nbr;
	nbr = (rand() % 2) + 1;
	return(nbr);
}


int d3()
{
	int nbr;
	nbr = (rand() % 3) + 1;
	return(nbr);
}


int d4()
{
	int nbr;
	nbr = (rand() % 4) + 1;
	return(nbr);
}


int d5()
{
	int nbr;
	nbr = (rand() % 5) + 1;
	return(nbr);
}


int d6()
{
	int nbr;
	nbr = (rand() % 6) + 1;
	return(nbr);
}


int d7()
{
	int nbr;
	nbr = (rand() % 7) + 1;
	return(nbr);
}


int d8()
{
	int nbr;
	nbr = (rand() % 8) + 1;
	return(nbr);
}


int d9()
{
	int nbr;
	nbr = (rand() % 9) + 1;
	return(nbr);
}


int d10()
{
	int nbr;
	nbr = (rand() % 10) + 1;
	return(nbr);
}


int d11()
{
	int nbr;
	nbr = (rand() % 11) + 1;
	return(nbr);
}


int d12()
{
	int nbr;
	nbr = d6() + d6();
	return(nbr);
}


int d12plus()
{
	int  nbr, d1, d2, d3;
	d1 = d6();
	d2 = d6();
	d3 = d6();
	if (d1 < d2)
	{
		nbr = d1;
		d1 = d2;
		d2 = nbr;
	}
	if (d2 < d3)
	{
		nbr = d2;
		d2 = d3;
		d3 = nbr;
	}
	nbr = d1 + d2;
	return(nbr);
}


int d18()
{
	int nbr;
	nbr = d6() + d6() + d6();
	return(nbr);
}


int TeePrint(char * fmt)
{
	va_list argptr;
	int cnt;
	char buffer[256];

	//va_start(argptr, fmt);
	cnt = vsprintf(buffer, fmt, argptr);
	//va_end(argptr);
	printf("%s",buffer);
	fprintf(outfl,"%s",buffer);
	fflush(outfl);
	return(cnt);
}
