/* DRODRONE.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void drodrone();
void drodrnmot(int term);
void drodrnskills(int skills);
void drodrn_pdt(int roll);
void drodrn_sst(int roll);

extern int d6();
extern int basic_surv(int need_nbr, int upp, int upp_val);
extern int basic_spec_duty(int roll);
extern int dro_dist(int need_nbr, int upp, int upp_val);
extern int reenlist(int need_nbr);
extern int basic_bene();
extern void bumpsense();
extern void bumpdex();
extern void bumpintl();
extern int dropicktable();
extern void crosstrain();
extern void psionics();
extern void addskill(int skill, int skl_val);
extern void mot_weapon();
extern void mot_midpsg();
extern void mot_lopsg();
extern void mot_kit();

#include "chargen.h"

void drodrone()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    if (terms == 1) drodrn_pdt(d6());
    newterm = basic_surv(5, edu, 5);
    skills = 0;
    if (newterm == 0) {
	  skills = basic_spec_duty(5) + 1;
      skills += dro_dist(7, intl, 4);
    }
    if (skills != 0) drodrnskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(0);
  }
  terms = terms - anagathics;
  drodrnmot(terms);
}


void drodrnmot(int term)
{
  int  roll;
  
  while (term > 0)
  {
    term--;
    roll = basic_bene();
    switch (roll)
	{
      case 1: bumpsense(); bumpsense(); break;
      case 2: bumpdex(); break;
      case 3: mot_weapon(); break;
      case 4: mot_lopsg(); break;
      case 5: mot_midpsg(); break;
      default: mot_kit(); break;
    }
  }
}


void drodrnskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = dropicktable();
    roll = d6();
    if (table == 1) {
      drodrn_pdt(roll);
    }
    if (table == 2) {
      drodrn_sst(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: crosstrain(1); break;
        case 2: addskill(APPEAL, 1); break;
		case 3: addskill(COMPUTER, 1); break;
        case 4: addskill(ADMIN, 1); break;
        case 5: addskill(LIAISON, 1); break;
        case 6: crosstrain(1); break;
      }
    }
    if (table == 4) {
      if (alt_career < 0) {
        switch (roll) {
          case 1: addskill(INSTRUCTION, 1); break;
          case 2: addskill(INSTRUCTION, 1); break;
          case 3: addskill(LIAISON, 1); break;
          case 4: addskill(STEWARD, 1); break;
	  case 5: addskill(HANDYMAN, 1); break;
          case 6: addskill(MEDICAL, 1); break;
        }
      } else {
        if (alt_career == 0) {
          switch (roll) {
            case 1: addskill(LIAISON, 1); break;
            case 2: addskill(APPEAL, 1); break;
            case 3: addskill(INSTRUCTION, 1); break;
            case 4: addskill(PREDICTION, 1); break;
            case 5: addskill(APPEAL, 1); break;
            case 6: bumpsense(); bumpsense(); break;
          }
	} else {
          switch (roll) {
            case 1: addskill(MEDICAL, 1); break;
            case 2: addskill(ADMIN, 1); break;
            case 3: addskill(ADMIN, 1); break;
            case 4: bumpintl(); break;
            case 5: addskill(ADMIN, 1); break;
            case 6: crosstrain(1); break;
          }
        }
      }
    }
    skills--;
  }
}


void drodrn_pdt(int roll)
{
  switch (roll) {
    case 1: addskill(INSTRUCTION, 1); break;
    case 2: addskill(INSTRUCTION, 1); break;
    case 3: addskill(LIAISON, 1); break;
    case 4: addskill(STEWARD, 1); break;
    case 5: bumpsense();bumpsense(); break;
    case 6: psionics(1); break;
  }
}


void drodrn_sst(int roll)
{
  switch (roll) {
    case 1: addskill(HANDYMAN, 1); break;
    case 2: addskill(APPEAL, 1); break;
    case 3: addskill(ADMIN, 1); break;
    case 4: addskill(LIAISON, 1); break;
    case 5: bumpsense(); bumpsense(); break;
    case 6: addskill(FLYING, 1); break;
  }
}

