/* DROSPORT.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>


void drosport();
void drosprt_sst(int roll);
void drosprtmot(int term);
void drosprtskills(int skills);
void drosprt_pdt(int roll);

extern int d6();
extern int basic_surv(int need_nbr, int upp, int upp_val);
extern int dro_dist(int need_nbr, int upp, int upp_val);
extern int reenlist(int need_nbr);
extern int basic_bene();
extern int basic_spec_duty(int roll);
extern void bumpsense();
extern void bumpintl();
extern int dropicktable();
extern void crosstrain();
extern void bumpstr();
extern void spac(int skl_val);
extern void vc(int skl_val);
extern void vhcl(int skl_val);
extern void droweapon(int skl_val);
extern void addskill(int skill, int skl_val);
extern void mot_weapon();
extern void mot_ship();
extern void mot_kit();

#include "chargen.h"


void drosport()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    if (terms == 1) drosprt_pdt(d6());
    newterm = basic_surv(6, edu, 1);
    skills = 0;
    if (newterm == 0) {
	  skills = basic_spec_duty(4) + 1;
      skills += dro_dist(9, intl, 5);
    }
    if (skills != 0) drosprtskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(0);
  }
  terms = terms - anagathics;
  drosprtmot(terms);
}


void drosprtmot(int term)
{
  int  roll;
  
  while (term > 0)
  {
    term--;
    roll = basic_bene();
    switch (roll)
	{
      case 1: bumpintl(); bumpintl(); break;
      case 2: bumpstr(); bumpstr(); break;
      case 3: mot_weapon(); break;
      case 4: mot_weapon(); break;
      case 5: mot_kit(); break;
      default: mot_ship(); break;
    }
  }
}


void drosprtskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = dropicktable();
    roll = d6();
    if (table == 1) {
      drosprt_pdt(roll);
    }
    if (table == 2) {
      drosprt_sst(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: crosstrain(1); break;
        case 2: addskill(APPEAL, 1); break;
        case 3: addskill(HANDYMAN, 1); break;
        case 4: addskill(LEADER, 1); break;
        case 5: addskill(LIAISON, 1); break;
        case 6: crosstrain(1); break;
      }
    }
    if (table == 4) {
      if (alt_career < 0) {
        switch (roll) {
          case 1: vc(1); break;
          case 2: spac(1); break;
          case 3: vhcl(1); break;
          case 4: droweapon(1); break;
          case 5: addskill(SURVIVAL, 1); break;
          case 6: addskill(INTERROGATE, 1); break;
        }
      } else {
        if (alt_career == 0) {
          switch (roll) {
            case 1: addskill(LIAISON, 1); break;
            case 2: addskill(APPEAL, 1); break;
            case 3: addskill(INSTRUCTION, 1); break;
            case 4: addskill(PREDICTION, 1); break;
            case 5: addskill(INTERROGATE, 1); break;
            case 6: addskill(LEADER, 1); break;
          }
        } else {
          switch (roll) {
            case 1: addskill(MEDICAL, 1); break;
            case 2: addskill(HUNTING, 1); break;
            case 3: addskill(PROSPECTING, 1); break;
            case 4: vc(1); break;
            case 5: addskill(DEMOLITIONS, 1); break;
            case 6: crosstrain(1); break;
          }
        }
      }
    }
    skills--;
  }
}


void drosprt_pdt(int roll)
{
  switch (roll) {
    case 1: vc(1); break;
    case 2: spac(1); break;
    case 3: vhcl(1); break;
    case 4: droweapon(1); break;
    case 5: bumpsense(); break;
    case 6: bumpintl(); break;
  }
}


void drosprt_sst(int roll)
{
  switch (roll) {
    case 1: addskill(UNARMEDCMBT, 1); break;
    case 2: droweapon(2); break;
    case 3: vhcl(1); break;
    case 4: vhcl(1); break;
    case 5: addskill(FLYING, 1); break;
    case 6: addskill(FLYING, 1); break;
  }
}

