/* DROWORKR.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>


void droworker();
void drowrkrskills(int skills);
void drowrkr_pdt(int roll);
void drowrkr_sst(int roll);

extern int d6();
extern int basic_surv(int need_nbr, int upp, int upp_val);
extern int dro_dist(int need_nbr, int upp, int upp_val);
extern int reenlist(int need_nbr);
extern int basic_bene();
extern int basic_spec_duty(int roll);
extern void bumpsense();
extern void bumpdex();
extern void bumpend();
extern void bumpintl();
extern int dropicktable();
extern void crosstrain();
extern void bumpstr();
extern void addskill(int skill, int skl_val);

#include "chargen.h"


void droworker()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    if (terms == 1) drowrkr_pdt(d6());
    newterm = basic_surv(5, end, 5);
    skills = 0;
    if (newterm == 0) {
	  skills = basic_spec_duty(6) + 1;
      skills += dro_dist(10, edu, 5);
    }
    if (skills != 0) drowrkrskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(0);
  }
  terms = terms - anagathics;
}


void drowrkrskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = dropicktable();
    roll = d6();
    if (table == 1) {
      drowrkr_pdt(roll);
    }
    if (table == 2) {
      drowrkr_sst(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: addskill(STEWARD, 1); break;
        case 2: addskill(STEWARD, 1); break;
        case 3: bumpstr(); break;
        case 4: bumpend(); break;
        case 5: addskill(HANDYMAN, 1); break;
        case 6: crosstrain(1); break;
      }
    }
    if (table == 4) {
      if (alt_career < 0) {
        switch (roll) {
          case 1: bumpstr(); bumpstr(); break;
          case 2: bumpstr(); break;
          case 3: bumpend(); bumpend(); break;
          case 4: bumpend(); break;
          case 5: addskill(MECHANICAL, 1); break;
          case 6: addskill(MECHANICAL, 1); break;
        }
      } else {
        if (alt_career > 0) {
          switch (roll) {
            case 1: bumpdex(); bumpdex(); break;
            case 2: bumpdex(); bumpdex(); break;
            case 3: addskill(MECHANICAL, 1); break;
            case 4: addskill(ELECTRONICS, 1); break;
            case 5: addskill(GRAVITICS, 1); break;
            case 6: addskill(DEMOLITIONS, 1); break;
          }
        } else {
          switch (roll) {
            case 1: bumpstr(); bumpstr(); break;
            case 2: bumpstr(); break;
            case 3: bumpend(); bumpend(); break;
            case 4: bumpend(); break;
            case 5: bumpdex(); bumpdex(); break;
            case 6: bumpdex(); break;
          }
        }
      }
    }
    skills--;
  }
}


void drowrkr_pdt(int roll)
{
  switch (roll) {
    case 1: bumpstr(); bumpstr(); break;
    case 2: bumpstr(); break;
    case 3: bumpend(); bumpend(); break;
    case 4: bumpend(); break;
    case 5: bumpintl(); break;
    case 6: bumpend(); break;
  }
}


void drowrkr_sst(int roll)
{
  switch (roll) {
    case 1: bumpstr(); break;
    case 2: bumpdex(); break;
    case 3: bumpend(); break;
    case 4: bumpintl(); break;
    case 5: bumpsense(); break;
    case 6: addskill(UNARMEDCMBT, 1); break;
  }
}

