/* HivEdu.C establishes the Hiver characters pre-career choices */

#include <stdio.h>
#include <string.h>

/*
#ifndef UNIX
#include <conio.h>
#endif
*/

void hivprecareer();
void hivmakeprecar();
int hivtechedu();
int hivtechskills();
int hivmiledu();
int hivmileduskills();
int hivgenedu();
void hivgeneduskills(int years);
void hivmedadv();
void hivmedsch();
void hivadvedu();

extern int piusocsci();
extern void honors();
extern void prntschooltype();
extern int pickmajor();
extern int hardsci();
extern int pickecon();
extern int pickvhcl();
extern int picktech();
extern int pickacad(int amount);
extern int pickst();
extern int pickint();
extern void background();
extern void prntupp();
extern int bp_adj();
extern int d6();
extern int d12();
extern int getsel_int(int min, int max);
extern void addskill(int skill, int skl_val);
extern int pickinterp();
extern void bumpdex();
extern void bumpedu();
extern void dispskil(int sequ, int skl_val);
extern void bp_add(int amt);
extern void gotdoc();
extern int chk_skl(int skill, int value);
extern void prntacceptedu(char accepted[], char schoolname[]);
extern void prntgraduateedu(char graduated[], char schoolname[]);

#include "chargen.h"

signed int  tech_sch, univ, mer_acd, mil_acd, nav_acd, air_acd;

void hivprecareer()
{
	tech_sch = 0;
	univ = tech_sch;
	mer_acd = tech_sch;
	mil_acd = tech_sch;
	nav_acd = tech_sch;
	air_acd = tech_sch;
	background();
	hivmakeprecar();
}


void hivmakeprecar()
{
	int choice, max;

	if (tech_sch == NOTACCEPTED && mil_acd == NOTACCEPTED && univ == NOTACCEPTED)
		return;
	prntupp();
	max = 1;
	printf("You have the following pre-career options:\n\n");
	printf("   1. none\n");
	if (tech_sch > NOTACCEPTED)
	{
		printf("   2. technical");
		prntschooltype();
		printf("7, edu 8+) based on Aliens of the Rim\n");
		max = 2;
	}
	if (mil_acd > NOTACCEPTED)
	{
		printf("   3. military");
		prntschooltype();
		printf("7, edu 8+)\n");
		max = 3;
	}
	if (univ > NOTACCEPTED && edu >= 5)
	{
		printf("   4. general");
		prntschooltype();
		printf("9, edu 9+) based on Aliens of the Rim\n");
		max = 4;
	}
	choice = getsel_int(1, max);
	if (choice == 1)
		return;
	if (choice == 2)
	{
		if ((tech_sch = hivtechedu()) < 0)
		{
			hivmakeprecar();
			return;
		}
	}
	if (choice == 3)
	{
		if ((mil_acd = hivmiledu()) < 0)
		{
			hivmakeprecar();
			return;
		}
	}
	if (choice == 4)
	{
		if ((univ = hivgenedu()) < 0)
		{
			hivmakeprecar();
			return;
		}
	}
}


int hivtechedu()
{
	int roll, skills, years, retval;
	char name[20];

	strncpy(name, "Technical Education", 20);
	roll = d12();
	if (edu >= 8)
		roll++;
	if (roll < 7)
	{
		prntacceptedu("not ", name);
	    return NOTACCEPTED;
	}
	prntacceptedu("", name);
	roll = d12();
	retval = 0;
	if (intl >= 7)
		roll += 2;
	if (roll < 7)
	{
		years = (d6() + 1) / 2;
		age += years;
	    appearent_age += years;
		prntgraduateedu("not ", name);
		printf("After studying %d years.\n", years);
	    skills = (d12() - 9 + years) % 2;
		while (skills > 0)
		{
			roll = hivtechskills();
			if (roll != 0)
			{
				addskill(roll, 1);
				skills--;
			}
		}
		return 0;
	}
	prntgraduateedu("", name);
	col = 1;
	retval = GRADUATED;
	bumpedu();
	bumpdex();
	addskill(COMPUTER, 1);
	skills = 1;
	if (intl >= 9)
		skills++;
	roll = d12();
	if (intl >= 9)
		roll++;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 10);
	if (roll >= 9)
	{
		honors();
		retval = HONORS;
		skills++;
	}
	age += 4;
	appearent_age += 4;
	bp_add(1);
	while (skills >= 0)
	{
		roll = hivtechskills();
	    if (roll > 0)
		{
			addskill(roll, 1);
			skills--;
		}
	}
	hivmedadv();
	return retval;
}


int hivtechskills()
{
	int choice, val;
 
	printf("You need to pick your field of study in technical education.\n");
	dispskil(1, ECONOMIC);
	dispskil(2, COMPUTER);
	dispskil(3, ARTISAN);
	dispskil(4, SPACTECH);
	dispskil(5, TECHNICAL);
	dispskil(6, ACADEMIC);
	choice = getsel_int(1, 6);
	switch (choice)
	{
		case 1: val = pickecon(); break;
	    case 2: val = COMPUTER; break;
		case 3: val = ARTISAN; break;
	    case 4: val = pickst(); break;
		case 5: val = picktech(); break;
		case 6: val = pickacad(1); break;
	}
	if (val < 0)
		val = hivtechskills();
	return (val);
}


int hivgenedu()
{
	int roll, years, retval;
	char name[18];

	strncpy(name, "General Education", 18);
	roll = d12();
	if (edu >= 9)
		roll += 2;
	if (roll < 9)
	{
		prntacceptedu("not ", name);
	    return NOTACCEPTED;
	}
	prntacceptedu("", name);
	roll = d12();
	if (intl >= 8)
		roll += 2;
	if (roll < 7)
	{
		years = (d6() + 1) / 2;
	    age += years;
		appearent_age += years;
		prntgraduateedu("not ", name);
		printf("After studying %d years.\n", years);
		hivgeneduskills((years+1) / 2);
	    roll = (d6() - 5 + years) / 2;
		while (roll > 0)
		{ 
			bumpedu(); 
			roll--; 
		}
		return 0;
	}
	prntgraduateedu("", name);
	years = 4;
	col = 2;
	retval = GRADUATED;
	roll = d6() - 2;
	if (roll < 1)
		roll = 1;
	if (intl >= 9)
		roll++;
	while (roll > 0)
	{
		bumpedu(); 
		roll--; 
	}
	roll = d12();
	if (intl >= 10)
		roll++;
	if (roll < 10 && brownie_points > 0)
		roll = bp_adj(roll, 10);
	if (roll >= 10)
	{
		honors();
		retval = HONORS;
	}
	age += years;
	appearent_age += years;
	bp_add(1);
	hivgeneduskills(years);
	hivmedadv();
	return retval;
}


void hivgeneduskills(int years)
{
	int choice, skills;

	printf("What method do you wish to use for general education skills?\n");
	printf("   1. Scientists (Challenge #29)\n   2. TNE (use education)\n");
	printf("   3. house A (1 per year)\n   4. house B (1/2 education)\n");
	choice = getsel_int(1, 4);
	switch (choice)
	{
		case 1:
		{
			skills = d6() - 3;
			if (skills < 1)
				skills = 1;
			if (intl >= 9)
				skills++;
			if (col >= 10)
				skills++;
			skills = skills * years / 4;
			break;
		}
		case 2: skills = edu * years / 4; break;
		case 3: skills = years; break;
		case 4: skills = (edu / 2) * years / 4; break;
	}
	while (skills > 0)
	{
		addskill(pickmajor(), 1);
		skills--;
	}
}


int hivmiledu()
{
	int roll, skills, years, retval;
	char name[19];

	strncpy(name, "Military Education", 19);
	roll = d12();
	if (edu >= 8)
		roll++;
	if (roll < 7)
	{
		prntacceptedu("not ", name);
		return NOTACCEPTED;
	}
	retval = 0;
	prntacceptedu("", name);
	roll = d12();
	if (intl >= 7)
		roll += 2;
	if (roll < 7)
	{
		years = (d6() + 1) / 2;
		age += years;
		appearent_age += years;
		prntgraduateedu("not ", name);
		printf("After studying %d years.\n", years);
		skills = (d12() - 9 + years) % 2;
		while (skills > 0)
		{
			roll = hivmileduskills();
			if (roll != 0)
			{
				addskill(roll, 1);
				skills--;
			}
		}
		return retval;
	}
	prntgraduateedu("", name);
	col = 4;
	retval = GRADUATED;
	bumpedu();
	skills = d6() - 3;
	if (skills < 1)
		skills = 1;
	if (intl >= 9)
		skills++;
	roll = d12();
	if (intl >= 9)
		roll++;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 10);
	if (roll >= 9)
	{
		honors();
		retval = HONORS;
		skills++;
	}
	age += 4;
	appearent_age += 4;
	bp_add(1);
	while (skills >= 0)
	{
		roll = hivmileduskills();
		if (roll != 0)
		{
			addskill(roll, 1);
			skills--;
		}
	}
	return retval;
}


int hivmileduskills()
{
	int choice, val;
 
	printf("You need to pick your field of study at military education.\n\n");
	dispskil(1, SPACTECH);
	dispskil(2, TECHNICAL);
	dispskil(3, INTERPERS);
	printf("   4. Social Sciences *\n");
	choice = getsel_int(1, 4);
	switch (choice)
	{
		case 1: val = pickst(); break;
		case 2: val = picktech(); break;
	    case 3: val = pickint(); break;
		case 4: val = piusocsci(); break;
	}
	if (val <= 0)
		val = hivmileduskills();
	return (val);
}


void hivmedadv()
{
	int choice, max;

	if (grad_sch == NOTACCEPTED && med_sch == NOTACCEPTED)
		return;
	printf("You have the following advanced education options.\n\n");
	printf("   1. none\n");
	max = 1;
	if (grad_sch > NOTACCEPTED)
	{
		printf("   2. advanced education (roll 6, edu 8)\n");
		max = 2;
	}
	if (med_sch > NOTACCEPTED && (col > 10 
		|| (chk_skl(BIOLOGY, 1) > 0 && chk_skl(CHEMISTRY, 1) > 0)))
	{
		printf("   3. medical/biological education (roll 9, edu 8)\n");
		max = 3;
	}
	if (max == 1)
		return;
	choice = getsel_int(1, max);
	if (choice == 1)
		return;
	if (choice == 2)
	{
		hivadvedu();
		if (grad_sch == NOTACCEPTED)
			hivmedadv();
	}
	if ((col > 10 || (chk_skl(BIOLOGY, 1) > 0 && chk_skl(CHEMISTRY, 1) > 0))
		&& choice == 3)
	{
		hivmedsch();
		if (med_sch == NOTACCEPTED)
			hivmedadv();
	}
}


void hivmedsch()
{
	int roll, years;
	char name[29];

	strncpy(name, "Medical/Biological Education", 29);
	roll = d12();
	if (edu >= 8)
		roll += 2;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 9);
	if (roll >= 9)
	{
		prntacceptedu("", name);
	    roll = d12();
		if (edu > 8)
			roll += 2;
		if (roll < 8 && brownie_points > 0)
			roll = bp_adj(roll, 8);
		if (roll < 8)
		{
			years = (d6() + 1) / 2;
			if (years <= 0) years = 1;
			age += years;
			appearent_age += years;
			prntgraduateedu("not ", name);
			addskill(MEDICAL, (years - 1));
		}
		else
		{
			prntgraduateedu("", name);
			med_sch = GRADUATED;
			if (careernbr == 0)
			{
				gotdoc();
				printf("Your career is %s\n", career);
			}
			bp_add(2);
			bumpedu();
			addskill(MEDICAL, 3);
			addskill(ADMIN, 1);
			med_sch = GRADUATED;
			roll = d12();
			if (edu >= 11)
				roll++;
			if (roll < 11 && brownie_points > 0)
				roll = bp_adj(roll, 11);
			if (roll >= 11)
			{
			    honors();
				med_sch = HONORS;
				addskill(MEDICAL, 1);
				addskill(COMPUTER, 1);
			}
			age += 4;
			appearent_age += 4;
		}
	}	
	else
	{
		prntacceptedu("not ", name);
		med_sch = NOTACCEPTED;
	}
}


void hivadvedu()
{
	int roll, years;
	char name[19];

	strncpy(name, "Advanced Education", 19);
	roll = d12();
	if (edu >= 8)
		roll = roll + 2;
	if (roll < 6 && brownie_points > 0)
		roll = bp_adj(roll, 6);
	if (roll >= 6)
	{
		prntacceptedu("", name);
		roll = d12();
	    if (edu > 8)
			roll += 2;
		if (roll < 8 && brownie_points > 0)
			roll = bp_adj(roll, 8);
		if (roll < 8)
		{
			years = (d6() + 1) / 2;
			age += years;
			appearent_age += years;
			prntgraduateedu("not ", name);
			years--;
			while (years > 0)
			{
				addskill(pickmajor(), 1);
				years--;
			}
		}
		else
		{
			prntgraduateedu("", name);
			bp_add(2);
			bumpedu();
			major = pickmajor();
			addskill(major, 3);
			addskill(pickmajor(), 1);
			grad_sch = GRADUATED;
			age += 4;
			appearent_age += 4;
			roll = d12();
			if (edu >= 11)
				roll++;
			if (roll < 11 && brownie_points > 0)
				roll = bp_adj(roll, 11);
			if (roll >= 11)
			{
				honors();
				addskill(major, 1);
				addskill(pickmajor(), 1);
				grad_sch = HONORS;
			}
		}
	}
	else
	{
		prntacceptedu("not ", name);
		grad_sch = NOTACCEPTED;
	}
}
