/* HIVMANIP.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

int hivmanipulator();
int hiv_stsfctn(int needs, int mod, int mod_needs);
void manipmot(int term);
void manipskills(int skills);

extern int basic_surv(int neednbr, int upp, int upp_val);
extern int basic_spec_duty(int roll);
extern int picktable();
extern int d6();
extern int d12();
extern char getche_mot();
extern void bumpintl();
extern void bumpdex();
extern void bumpstr();
extern void bumpedu();
extern void bumpsoc();
extern void addskill(int skill, int skl_val);
extern void vhcl(int val);
extern void weapon(int val);
extern void mot_cash(int amt);
extern void mot_ship();
extern void mot_midpsg();
extern void mot_hipsg();
extern void mot_weapon();

#include "chargen.h"

int hivmanipulator()
{
	int  skills, newterm;
  
	newterm = basic_surv(5, intl, 10);
	if (newterm == 0)
	{
		skills = basic_spec_duty(4) + 1;
		if (terms == 1)
			skills++;
		if (blue_blood == 1)
			skills++;
		skills += hiv_stsfctn(6, intl, 10);
	}
	if (skills != 0)
		manipskills(skills);
	printf("That competes this term!\n");
	manipmot(1);
	return newterm;
}


int hiv_stsfctn(int needs, int mod, int mod_needs)
/* returns the number of skills gained for satisfaction, saves satisfaction
   level in variable km_land */
{
	int roll;

	roll = d12();
	if (mod >= mod_needs)
		roll++;
	if (roll >= needs)
	{
		km_land++;
		printf("You got satisfaction! (%d)\n", km_land);
		return 1;
	}
	printf("You did not get satisfaction (%d).\n", km_land);
	return 0;
}


void manipmot(int term)
{
  int  roll, choice, amt;
  
  choice = getche_mot();
  roll = d6();
  if (choice == 'C' || choice == 'c')
  {
    amt = 0;
    switch (roll)
	{
      case 1: amt = 10000; break;
      case 2: amt = 10000; break;
      case 3: amt = 10000; break;
      case 4: amt = 50000; break;
      case 5: amt = 50000; break;
      case 6: amt = 50000; break;
    }
	mot_cash(amt);
  } 
  else
  {
      switch (roll)
	  {
        case 1: bumpintl(); break;
        case 2: bumpintl(); break;
        case 3: mot_weapon(); break;
        case 4: mot_midpsg(); break;
        case 5: mot_hipsg(); break;
        case 6: mot_ship(); break;
      }
  }
}


void manipskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = picktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: bumpstr(); break;
        case 2: bumpdex(); break;
        case 3: bumpintl(); break;
        case 4: bumpedu(); break;
        case 5: bumpsoc(); break;
        case 6: addskill(MANIPULATION, 1); break;
      }
    }
    if (table == 2) {
      switch (roll) {
        case 1: vhcl(1); break;
        case 2: addskill(FORGERY, 1); break;
        case 3: addskill(BRIBERY, 1); break;
        case 4: addskill(STREETWISE, 1); break;
        case 5: addskill(PILOT, 1); break;
        case 6: addskill(MANIPULATION, 1); break;
      }
    }
    if (table == 3) {
      switch (roll) {
        case 1: addskill(TACTICS, 1); break;
        case 2: addskill(COMPUTER, 1); break;
        case 3: addskill(MANIPULATION, 1); break;
        case 4: vhcl(1); break;
        case 5: weapon(1); break;
        case 6: addskill(HANDYMAN, 1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: addskill(MEDICAL, 1); break;
        case 2: addskill(ADMIN, 1); break;
        case 3: addskill(LIAISON, 1); break;
        case 4: addskill(MANIPULATION, 1); break;
        case 5: addskill(LEADER, 1); break;
        case 6: addskill(MANIPULATION, 1); break;
      }
    }
    skills--;
  }
}

