/* HIVMERCH.C develops Hiver merchant prince character's personal history */

#include <stdio.h>

void hivmerchant();
long mer_cash();
void merchantbene();
int  mer_asgn();
void adj_by_branch();
int  small_asgn(int roll);
int  free_asgn();
void adj_deck();
void adj_engr();
void adj_purs();
void adj_adm();
void adj_sales();
void mer_route();
void mer_charter();
void mer_explore();
void mer_speculate();
void mer_bonus();

extern int basic_cash();
extern int mer_get_branch();
extern int mer_doterms();
extern int merchantmot();
extern int d6();
extern int d12();
extern int basic_bene();
extern void bumpintl();
extern int mer_set_branch();
extern void bumpedu();
extern void bumpsoc();
extern int chk_skl(int skill, int skl_val);
extern int find_skl(int skill);
extern int bp_spcl_duty(int roll);
extern int ask_adj_asgn(int roll);
extern void mot_cash(int amt);
extern void mot_ship();
extern void mot_tas();
extern void mot_midpsg();
extern void mot_hipsg();
extern void mot_lopsg();
extern void mot_weapon();

#include "chargen.h"

extern int mer_anag, mer_cross[7], position;

void hivmerchant()
{
  int i;

  for (i = 1; i <= 6; i++)
  {
    mer_cross[i] = 0;
  }
  mer_get_branch();
  while (mer_doterms() == 0);
  if (line == 6 && rankeo == 'O' && rank >= 6) ship++;
  terms -= anagathics;
  merchantmot(terms);
}


long mer_cash()
{
  int roll;
  long cr;

  roll = basic_cash();
  if (line == 3)
  {
    switch (roll)
	{
      case 1: cr = 1000; break;
      case 2: cr = 5000; break;
      case 3: cr = 10000; break;
      case 4: cr = 20000; break;
      case 5: cr = 40000; break;
      case 6: cr = 40000; break;
      case 7: cr = 100000; break;
    }
  }
  else
  {
    switch (roll)
	{
      case 1: cr = 1000; break;
      case 2: cr = 5000; break;
      case 3: cr = 10000; break;
      case 4: cr = 20000; break;
      case 5: cr = 30000; break;
      case 6: cr = 40000; break;
      case 7: cr = 50000; break;
    }
  }
  return (cr);
}


void merchantbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1:
		{
		if (line <= 2) mot_hipsg();
		else
			if (line <= 5) mot_midpsg();
			else mot_lopsg();
		}
		break;
    case 2: bumpintl(); if (line == 1) bumpintl(); break;
    case 3: bumpedu(); if (line <= 2) bumpedu(); break;
    case 4: mot_weapon(); break;
    case 5:
		{
		if (line <= 2) mot_hipsg();
		else
			if (line <= 5) mot_midpsg();
			else mot_weapon();
		}
		break;
    case 6:
		{
		if (line == 1) mot_tas();
		else
			if (line <= 3) mot_hipsg();
			else mot_midpsg();
		}
		break;
    case 7: if (line == 1) bumpsoc(); else mot_ship(); break;
  }
}


int mer_asgn()
{
  int roll, asgnmt;

  if (line == 6) return free_asgn();
  roll = d12();
  if (edu <= 6) roll--;
  if (rankeo == 'O' && rank >= 4) roll++;
  if (soc <= 10) roll--;
  if (rankeo != 'O' && col >= 1) roll++;
  if (pick == 1)
	  roll = ask_adj_asgn(roll);
  else
	  if (pick == 4)
		  roll = bp_spcl_duty(roll);
  if (line >= 3) return small_asgn(roll);
  if (roll <= 2)
  {
    line++;
    printf("You were transfered down.\n");
    return mer_asgn();
  }
  if (roll <= 8)
  {
    mer_route();
    asgnmt = 1;
  }
  if (roll == 9)
  {
    mer_charter();
    asgnmt = 2;
  }
  if (roll == 10)
  {
    mer_speculate();
    asgnmt = 4;
  }
  if (roll == 11)
  {
    mer_explore();
    asgnmt = 3;
  }
  if (roll >= 12)
  {
    surv = skil = decor = 0;
    asgnmt = 5;
  }
  adj_by_branch();
  return asgnmt;
}


void adj_by_branch()
{
  switch (branch) {
    case 1: adj_deck(); break;
    case 2: adj_engr(); break;
    case 3: adj_purs(); break;
    case 4: adj_adm(); break;
    case 5: adj_sales(); break;
  }
}


int small_asgn(int roll)
{
  int asgnmt;

  if (roll <= 2)
  {
    line++;
    printf("You were transfered down.\n");
    if (line == 6)
	{ 
      branch = 6;
      if (rankeo == 'O' && rank == 0) rank++;
    }
    return mer_asgn();
  }
  if (roll <= 6) {
    mer_route();
    asgnmt = 1;
  }
  if (roll == 7) {
    mer_charter();
    asgnmt = 2;
  }
  if (roll == 8 || roll == 9) {
    mer_speculate();
    asgnmt = 4;
  }
  if (roll == 10 || roll == 11) {
    mer_explore();
    asgnmt = 3;
  }
  if (roll == 12) {
    surv = 0;
    skil = 0;
    decor = 0;
    asgnmt = 5;
  }
  if (roll >= 13) {
    line--;
    printf("You were transfered up.\n");
    return mer_asgn();
  }
  adj_by_branch();
  return asgnmt;
}


int free_asgn()
{
  int roll, asgnmt, qual;

  roll = d12();
  if (soc <= 5) roll++;
  if (pick == 1)
	  roll = ask_adj_asgn(roll);
  else
	  if (pick == 4 && (roll == 3 || roll == 6 || roll == 8)
		  && brownie_points > 3)
	  {
		  roll--;
		  brownie_points--;
		  printf("You used 1 brownie point to get a better assignment.\n");
	  }
  if (roll <= 2)
  {
    line--;
    printf("You were transfered up.\n");
    branch = mer_set_branch();
    return mer_asgn();
  }
  if (roll == 3 || roll == 5 || roll == 7)
  {
    mer_route();
    asgnmt = 1;
  }
  if (roll == 9)
  {
    mer_charter();
    asgnmt = 2;
  }
  if (roll == 10)
  {
    mer_speculate();
    asgnmt = 4;
  }
  if (roll == 4 || roll == 11)
  {
    mer_explore();
    asgnmt = 3;
  }
  if (roll == 6 || roll == 8)
  {
    if (rankeo == 'O' && rank >= 6) return free_asgn();
    asgnmt = 8;
    printf("You found no business.\n");
    surv = 3;
    skil = 3;
    decor = 0;
  }
  if (roll == 12)
  {
    surv = 6;
    skil = 5;
    decor = 6;
    asgnmt = 6;
    printf("You were smuggling.\n");
  }
  if (roll == 13)
  {
    surv = 7;
    skil = 4;
    decor = 5;
    asgnmt = 7;
    printf("You were engaged in piracy.\n");
  }
  qual = chk_skl(PILOT, 2);
  if (qual != 0 && surv != 0) surv--;
  qual = chk_skl(TRADER, 2);
  if (qual != 0 && decor != 0) decor--;
  return asgnmt;
}


void adj_deck()
{
  int qual;

  qual = chk_skl(NAVIGATION, 2);
  if (qual == 0) qual = chk_skl(PILOT, 2);
  if (qual == 0) qual = chk_skl(LEGAL, 2);
  if (qual == 0) qual = chk_skl(ADMIN, 2);
  if (qual == 0) qual = chk_skl(LEADER, 2);
  if (qual == 0) qual = chk_skl(SHIPBOAT, 2);
  if (qual != 0 && surv != 0) surv--;
}


void adj_engr()
{
  int qual;

  qual = chk_skl(ENGINEERING, 2);
  if (qual == 0) qual = chk_skl(MECHANICAL, 2);
  if (qual == 0) qual = chk_skl(ELECTRONICS, 2);
  if (qual == 0) qual = chk_skl(ADMIN, 2);
  if (qual == 0) qual = chk_skl(GRAVITICS, 2);
  if (qual != 0 && surv != 0) surv--;
}


void adj_purs()
{
  int qual;

  qual = find_skl(STEWARD);
  if (qual != 0 && decor != 0) decor -= qual;
}


void adj_adm()
{
  int qual;

  qual = chk_skl(ADMIN, 2);
  if (qual == 0) qual = chk_skl(STREETWISE, 2);
  if (qual == 0) qual = chk_skl(BRIBERY, 2);
  if (qual == 0) qual = chk_skl(LIAISON, 2);
  if (qual != 0 && skil != 0) skil--;
}


void adj_sales()
{
  int qual;

  qual = chk_skl(TRADER, 2);
  if (qual == 0) qual = chk_skl(BROKER, 2);
  if (qual != 0 && decor != 0) decor--;
}


void mer_route()
{
  switch (branch) {
    case 1: skil = 7; surv = 0; decor = 0; break;
    case 2: skil = 7; surv = 0; decor = 0; break;
    case 3: skil = 6; surv = 0; decor = 0; break;
    case 4: skil = 6; surv = 0; decor = 0; break;
    case 5: skil = 7; surv = 0; decor = 13; break;
    default: skil = 7; surv = 3; decor = 11; break;
  }
  printf("You got a route assignment.\n");
}


void mer_charter()
{
  switch (branch) {
    case 1: skil = 7; surv = 3; decor = 0; break;
    case 2: skil = 6; surv = 0; decor = 0; break;
    case 3: skil = 5; surv = 0; decor = 0; break;
    case 4: skil = 5; surv = 0; decor = 0; break;
    case 5: skil = 7; surv = 0; decor = 14; break;
    default: skil = 6; surv = 4; decor = 10; break;
  }
  printf("You got a charter assignment.\n");
}


void mer_explore()
{
  switch (branch) {
    case 1: skil = 5; surv = 4; decor = 11; break;
    case 2: skil = 5; surv = 4; decor = 12; break;
    case 3: skil = 8; surv = 3; decor = 12; break;
    case 4: skil = 8; surv = 3; decor = 12; break;
    case 5: skil = 5; surv = 4; decor = 10; break;
    default: skil = 5; surv = 5; decor = 8; break;
  }
  printf("You got a exploratory assignment.\n");
}


void mer_speculate()
{
  switch (branch) {
    case 1: skil = 6; surv = 3; decor = 12; break;
    case 2: skil = 6; surv = 3; decor = 11; break;
    case 3: skil = 7; surv = 0; decor = 11; break;
    case 4: skil = 7; surv = 3; decor = 11; break;
    case 5: skil = 5; surv = 3; decor = 9; break;
    default: skil = 5; surv = 5; decor = 7; break;
  }
  printf("You got a speculative assignment.\n");
}


void mer_bonus()
{
  int roll;
  long bonus;

  roll = d12();
  if (roll >= decor) {
    bonus = (mer_cash()) / 2;
    printf("You received a %ld credit bonus on this assignment.\n",
      bonus);
    credits += bonus;
  }
}


