/* HIVPRINT.C is part of the MEGATRAVELER (c) character generation
  program written by Greg Svenson. It prints out the resulting character. */

#include <stdio.h>

void printhim();
void pension();
void getbranch();
void getrankp();
void ithgetrank();
void armyrank();
void hivdocrank();
void armyrank();
void navyrank();
void merchrank();
void merdeck();
void merpur();
void meradm();
void mersales();
void merengr();
void flyerrank();
void facilrank();
void guardrank();
void explorank();
void seekerank();
void tetrarank();
void prntstuf();

extern void prntskil(int end);
extern void prntupp();
extern void anykey();
extern void clrscr();
extern void prntrace();
extern void prntsex();
extern void prntblueblood();
extern void prtsch();
extern void prtgrad();
extern void prntpath(int path);
extern void getline();
extern void discover();
extern void awards();
extern void loan();
extern void disp_special_duty();
extern int d12();

#include "chargen.h"

void printhim()  
{
	if (seh > 0)
	{
		if ((rankeo == 'E' && rank < 9) 
			|| (careernbr != NAVY && rankeo == 'O' && rank < 10)
			|| (careernbr == NAVY && rankeo == 'O' && line == 1 && rank < 10)
			|| (careernbr == NAVY && rankeo == 'O' && line == 2 && rank < 8)
			|| (careernbr == NAVY && rankeo == 'O' && line == 3 && rank < 7)
			&& careernbr != MANIPULATOR && race == HIVER)
			rank++;
	}
	printf("Here is a review of your characters skills.\n");
	prntupp();
	prntskil(1);
	anykey();
	clrscr();
	printf("                         Character Description\n");
	printf("\nName: _________________________ ");
	printf("    ");
	prntrace();
	printf(" ");
	prntsex();
	if (blue_blood != 0)
		prntblueblood();
	if (uwp[0] != '\0') printf(" UWP=%s", uwp);
	printf("\n");
	printf(" str dex end int edu ");
	if (race == HIVER)
		printf("cur");
	else
		printf("soc");
	printf(" Home World: star port = %c\n", starport);
	printf("  %2d  %2d  %2d  %2d  %2d  %2d            ", 
		str, dex, end, intl, edu, soc);
	printf("      size = %s\n", size_descr);
	printf("         age: %2d                    ", age);
	printf("atmosphere = %s\n", atmos_descr);
	printf("apparent age: %2d                    ", appearent_age);
	printf("     hydro = %s\n", hydro_descr);
	printf("                                    ");
	printf("population = %s\n", pop_descr);              
	prtsch();
	printf("      law = %s\n", law_descr);
	prtgrad();
	printf("  tech lvl = %s\n", tech_descr);
	if (race == ITHKLUR)
	{
		printf("Path: ");
		prntpath(blue_blood % 10);
		printf("\n");
	}
	printf("Career: %s", career);
	if (line != 0)
		getline();
	if (branch != 0)
		getbranch();
	if (medic != 0 && careernbr != DOCTOR)
		printf(" medic");
	if (((rank != 0 || careernbr == MERCHANT)
		&& (careernbr != MANIPULATOR) && race == HIVER)
		|| race == ITHKLUR)
	{
		printf("\n");
		getrankp();
	}
	if (terms >= 5)
		pension();
	if (careernbr == MANIPULATOR || careernbr == SCIENTIST)
		discover();
	else
		if (careernbr <= NAVY)
			awards();
	disp_special_duty();
	printf("\nSkills:\n");
	prntskil(2);
	printf("\nProperty:               Credits: %ld", credits);
	prntstuf();
}


void pension()
{
	printf("     Pension: %d", (terms * 2000));
}


void getbranch()
{
	printf(" %s ", office);
	if (careernbr <= 3)
		printf("branch");
	else
		printf("office");
}


void getrankp()
{
	if (careernbr == MANIPULATOR || (careernbr == DOCTOR && race == HIVER))
	{
		rank = (terms / 2) + 1;
		if (col > 0)
			rankeo = 'O';
		if (med_sch > 0 || grad_sch > 0)
			rank++;
	}
	printf("  Rank: %c%d ", rankeo, rank);
	if (race == ITHKLUR)
	{
		ithgetrank();
		return;
	}
	switch (careernbr)
	{
		case ARMY: armyrank(); break;
		case NAVY: navyrank(); break;
		case DOCTOR: hivdocrank(); break;
		case SCIENTIST: break;
		case MANIPULATOR: break;
		case MERCHANT: merchrank(); break;
		case EXPLORER: break;
		case STORYTELLER: break;
		case TECHY: break;
		case PARTY: break;
		default: printf("rank?"); break;
	}
}


void hivdocrank()
{
	if (rankeo == 'O')
		printf("Doctor");
	else
		printf("Technician");
}


void armyrank()
{
	if (rankeo == 'E')
	{
		switch (rank)
		{
			case 1: printf("Privite"); break;
			case 2: printf("Lance Corporal"); break;
			case 3: printf("Corporal"); break;
			case 4: printf("Lance Sargent"); break;
			case 5: printf("Sargent"); break;
			case 6: printf("Gunnery Sargent"); break;
			case 7: printf("Leading Sargent"); break;
			case 8: printf("First Sargent"); break;
			case 9: printf("Sargent Major"); break;
			default: printf("rank?"); break;
		}
	}
	else
	{
		switch (rank)
		{
			case 1: printf("2nd Lieutenant"); break;
			case 2: printf("1st Lieutenant"); break;
			case 3: printf("Captain"); break;
			case 4: printf("Major"); break;
			case 5: printf("Lieutenant Colonel"); break;
			case 6: printf("Colonel"); break;
			case 7: printf("Brigadier General"); break;
			case 8: printf("Major General"); break;
			case 9: printf("Lieutenant General"); break;
			case 10: printf("General"); break;
			default: printf("rank?"); break;
		}
	}
}


void navyrank()
{
	if (rankeo == 'E')
	{
		switch (rank)
		{
			case 1: printf("Recruit"); break;
			case 2: printf("Apprentice"); break;
			case 3: printf("Spacehand"); break;
			case 4: printf("Petty Officer 3rd Class"); break;
			case 5: printf("Petty Officer 2nd Class"); break;
			case 6: printf("Petty Officer 1st Class"); break;
			case 7: printf("Chief Petty Officer"); break;
			case 8: printf("Senior Chief Petty Officer"); break;
			case 9: printf("Master Chief Petty Officer"); break;
			default: printf("rank?"); break;
		}
	}
	else
	{
		switch (rank)
		{
			case 1: printf("Ensign"); break;
			case 2: printf("Sublieutenant"); break;
			case 3: printf("Lieutenant"); break;
			case 4: printf("Lieutenant Commander"); break;
			case 5: printf("Commander"); break;
			case 6: printf("Captain"); break;
			case 7: printf("Commodore"); break;
			case 8: printf("Fleet Admiral"); break;
			case 9: printf("Sector Admiral"); break;
			case 10: printf("Grand Admiral"); break;
			default: printf("rank?"); break;
		}
	}
}


void merchrank()
{
	if (rankeo == 'E')
		printf("Enlisted");
	else
	{
		switch (branch)
		{
			case 1: merdeck(); break;
			case 2: merengr(); break;
			case 3: merpur(); break;
			case 4: meradm(); break;
			case 5: mersales(); break;
		}
	}
}


void merdeck()
{
	switch (rank)
	{
		case 0: printf("Apprentice"); break;
		case 1: printf("4th Officer"); break;
		case 2: printf("3rd Officer"); break;
		case 3: printf("2nd Officer"); break;
		case 4: printf("1st Officer"); break;
		case 5: printf("Captain"); break;
		case 6: printf("Senior Captain"); break;
		case 7: printf("Line Commodore"); break;
	}
}


void merengr()
{
	switch (rank)
	{
		case 0: printf("Asst Drive Hand"); break;
		case 1: printf("Drive Hand"); break;
		case 2: printf("Asst Engineer"); break;
		case 3: printf("Engineer"); break;
		case 4: printf("Chief Engineer"); break;
		default: merdeck(); break;
	}
}


void merpur()
{
	if (medic == 0)
	{
		switch (rank)
		{
			case 0: printf("Steward"); break;
			case 1: printf("Junior Purser"); break;
			case 2: printf("Assistant Purser"); break;
			case 3: printf("Purser"); break;
			case 4: printf("Chief Purser"); break;
			default: merdeck(); break;
		}
	}
	else
	{
		switch (rank)
		{
			case 0: printf("Steward"); break;
			case 1: printf("Junior Purser"); break;
			case 2: printf("Assistant Medic"); break;
			case 3: printf("Medic"); break;
			case 4: printf("Chief Purser"); break;
			default: merdeck(); break;
		}
	}
}


void meradm()
{
	switch (rank)
	{
		case 0: printf("Clerk"); break;
		case 1: printf("Asst Manager"); break;
		case 2: printf("Manager"); break;
		case 3: printf("Asst Station Head"); break;
		case 4: printf("Station Head"); break;
		default: merdeck(); break;
	}
}


void mersales()
{
	switch (rank)
	{
		case 0: printf("Apprentice"); break;
		case 1: printf("Clerk"); break;
		case 2: printf("Asst Broker"); break;
		case 3: printf("Broker"); break;
		case 4: printf("Senior Broker"); break;
		default: merdeck(); break;
	}
}


void ithgetrank()
{
	if (rankeo == 'E')
		printf("Elemetary");
	else
		switch (blue_blood % 10)
		{
		case 1: facilrank(); break;
		case 2: guardrank(); break;
		case 3: explorank(); break;
		case 4: seekerank(); break;
		default: tetrarank(); break;
		}
}


void facilrank()
{
	switch (rank)
	{
		case 1: printf("Enlightened Builder"); break;
		case 2: printf("Ethical Builder"); break;
		case 3: printf("Balanced Maker"); break;
		case 4: printf("Resolute Maker"); break;
		case 5: printf("Restorer of Harmony"); break;
		case 6: printf("Timekeeper"); break;
		case 7: printf("Tranquil Creator"); break;
		default: printf("Serene Creator"); break;
	}
}


void guardrank()
{
	switch (rank)
	{
		case 1: printf("Aroused Warrior"); break;
		case 2: printf("Illuminated Warrior"); break;
		case 3: printf("Balanced Warrior"); break;
		case 4: printf("Resolute Spirit"); break;
		case 5: printf("Calm Defender"); break;
		case 6: printf("Patient Warrior"); break;
		case 7: printf("Watchful Warrior"); break;
		default: printf("Exposer of Deceit"); break;
	}
}


void explorank()
{
	switch (rank)
	{
		case 1: printf("Tenderfoot"); break;
		case 2: printf("Ethical Scout"); break;
		case 3: printf("Balanced Voyager"); break;
		case 4: printf("Resolute Traveller"); break;
		case 5: printf("Temperate Journeyer"); break;
		case 6: printf("Composed Wayfarer"); break;
		case 7: printf("Tranquil Explorer"); break;
		default: printf("Serene Discover"); break;
	}
}


void seekerank()
{
	switch (rank)
	{
		case 1: printf("Enlightened Searcher"); break;
		case 2: printf("Ethical Seeker"); break;
		case 3: printf("Balanced Seeker"); break;
		case 4: printf("Resolute Delver"); break;
		case 5: printf("Temperate Aspirant"); break;
		case 6: printf("Composed Inquisitor"); break;
		case 7: printf("Tranquil Inquisitor"); break;
		default: printf("Keeper of Dreams"); break;
	}
}


void tetrarank()
{
	switch (rank)
	{
		case 1: printf("Pilgrim"); break;
		case 2: printf("Wounded Pilgrim"); break;
		case 3: printf("Determined Pilgrim"); break;
		case 4: printf("Indefatigable Pilgrim"); break;
		case 5: printf("Seer of Miracles"); break;
		case 6: printf("Defender of Dreams"); break;
		case 7: printf("Believer of Impossibiities"); break;
		default: printf("Blissful Warrior"); break;
	}
}


void prntstuf()
{
	printf("\n");
	if (ship > 0)
	{
		if (careernbr == MANIPULATOR || careernbr == SCIENTIST)
			printf("Lab Ship");
		if (careernbr == LEADER || careernbr == DIPLOMAT)
			printf("Yacht");
		if (careernbr == EXPLORER)
			printf("Scout");
		if (careernbr == MERCHANT)
			printf("Free Trader");
		loan();
	}
	if (kit > 0)
	{
		if (careernbr == DOCTOR)
			printf("Medical Kit");
		else
			if (careernbr == TECHY)
				printf("Technical Tools");
			else
				if (careernbr == SCIENTIST)
					printf("Scientific Equipment");
				else
					printf("Voucher");
		if (kitval > 0) 
			printf(" (value %d)", kitval);
		else
			if (kit > 1)
				printf("x%d", kit);
		printf(", ");
	}
	if (weapons > 0)
	{
		printf("Weapon");
		if (weapons > 1)
			printf("x%d", weapons);
		printf(", ");
	}
	printf("\n");
	if (tas > 0)
		printf("Travellers Aid Society, ");
	if (hipsg > 0)
	{
		printf("High Passage");
		if (hipsg > 1)
			printf("x%d", hipsg);
		printf(", ");
	}
	if (midpsg > 0)
	{
		printf("Middle Passage");
		if (midpsg > 1)
			printf("x%d", midpsg);
		printf(", ");
	}
	if (lopsg > 0)
	{
		printf("Low Passage");
		if (lopsg > 1)
			printf("x%d", lopsg);
		printf(", ");
	}
}

	