/* HivSci.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "chargen.h"

int hivsci();
void hivscimot();

extern int sci_do_year();
extern int anag();
extern int basic_cash();
extern int basic_bene();
extern char getche_mot();
extern int reenlist(int need_nbr);
extern void bumpsoc();
extern int hiv_stsfctn(int need_nbr, int mod, int mod_need);
extern void sci_gen_skl();
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_hipsg();
extern void mot_weapon();
extern void mot_midpsg();
extern void mot_ship();

extern int  sci_anag, duty;
extern int assignment;

int hivsci()
{
	int survival;
  
	assignment = 0;
	duty = 0;
	survival = 0;
	do
	{
		survival = sci_do_year();
	} while (((age % 4) != 2) && (survival == 0));
	if (hiv_stsfctn(8, intl, 5) > 0)
		sci_gen_skl();
	if (survival != 0)
		return 1;
	sci_anag = anag();
	hivscimot();
	return 0;
}


void hivscimot()
{
	int  roll, amt;
	char choice;
  
	choice = getche_mot();
	if (choice == 'C' || choice == 'c')
	{
		roll = basic_cash();
		amt = 0;
		switch (roll)
		{
		case 1: amt = 1000; break;
        case 2: amt = 2000; break;
	    case 3: amt = 5000; break;
		case 4: amt = 10000; break;
        case 5: amt = 20000; break;
	    case 6: amt = 30000; break;
		case 7: amt = 40000; break;
		}
		mot_cash(amt);
	}
	else
	{
		roll = basic_bene();
		switch (roll)
		{
		case 1: mot_lopsg(); break;
	    case 2: mot_midpsg(); break;
		case 3: bumpsoc(); break;
	    case 4: mot_weapon(); break;
	    case 5: mot_hipsg(); break;
		case 6: mot_ship(); break;
		case 7: mot_ship(); break;
		}
	}
}
