/* ITHATHLT.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

int ithathlete();
void ithathletemot(int term);
void ithathletebene();
void ithathleteskills(int skills);
void miscskills(int amount);
int getas(int amount);
int swas(int choice, int amount);

extern int ith_comm(int need_nbr, int skill1, int skill2, int skl_val);
extern int ith_promo(int need_nbr, int skill1, int skill2, int skl_val);
extern int basic_spec_duty(int need_nbr);
extern int basic_surv(int need_nbr, int upp_type, int upp_val);
extern int reenlist(int need_nbr);
extern void addskill(int skill, int skl_val);
extern int basic_mot();
extern char getche_mot();
extern int basic_cash();
extern int basic_bene();
extern void bumpend();
extern void bumpstr();
extern void bumpsoc();
extern void bumpdex();
extern int picktable();
extern int d6();
extern void physicl(int skl_val);
extern void archaic(int skl_val);
extern void econ(int skl_val);
extern void inbrn(int skl_val);
extern void vhcl(int skl_val);
extern void gc(int skl_val);
extern void pc(int skl_val);
extern void vc(int skl_val);
extern void techl(int skl_val);
extern void arts(int skl_val);
extern void spac(int skl_val);
extern void env(int skl_val);
extern void interp(int skl_val);
extern void mot_cash(int amt);
extern void mot_tas();
extern void mot_weapon();
extern void mot_hipsg();
extern void mot_midpsg();

#include "chargen.h"

int ithathlete()
{
	int     skills, newterm;
  
	newterm = 0;
	skills = basic_spec_duty(7);
	newterm = basic_surv(6, intl, 8);
	if (newterm == 0)
	{
		skills++;
		if (rankeo == 'E')
			skills += ith_comm(11, str, intl, 14);
		else
			skills += ith_promo(13, str, intl, 14);
	}
	if (skills != 0)
		ithathleteskills(skills);
	ithathletemot(1);
	return newterm;
}


void ithathletemot(int term)
{
	int  cash, roll, amt;
	char choice;
  
	cash = basic_mot();
	while ((term > 0) && (cash > 0))
	{
		choice = getche_mot();
		if (choice == 'C' || choice == 'c')
		{
			roll = basic_cash();
			cash--;
			amt = 0;
			switch (roll)
			{
			case 1: amt = 5000; break;
			case 2: amt = 10000; break;
			case 3: amt = 20000; break;
			case 4: amt = 30000; break;
			case 5: amt = 40000; break;
			case 6: amt = 50000; break;
			default: amt = 100000; break;
			}
			mot_cash(amt);
		}
		else
		{
			ithathletebene();
		}
		term--;
	}
	while (term > 0)
	{
		ithathletebene();
		term--;
	}
}


void ithathletebene()
{
	int roll;

	roll = basic_bene();
	switch (roll)
	{
	case 1: mot_midpsg(); break;
	case 2: bumpend(); break;
	case 3: bumpdex(); break;
	case 4: mot_weapon(); break;
	case 5: mot_hipsg(); break;
	case 6: bumpsoc(); break;
	case 7: mot_tas(); break;
	}
}


void ithathleteskills(int skills)
{
	int  table, roll;

	while (skills > 0)
	{
		table = picktable();
		roll = d6();
		if (table == 1)
		{
			switch (roll)
			{
			case 1: addskill(BRAWLING, 1); break;
			case 2: physicl(1); break;
			case 3: bumpdex(); break;
			case 4: bumpend(); break;
			case 5: bumpstr(); break;
			case 6: vc(1); break;
			}
		}
		if (table == 2)
		{
			switch (roll)
			{
			case 1: pc(1); break;
			case 2: pc(1); break;
			case 3: bumpstr(); break;
			case 4: bumpdex(); break;
			case 5: bumpend(); break;
			case 6: archaic(1); break;
			}
		}
		if (table == 3)
		{
			switch (roll)
			{
			case 1: miscskills(1); break;
			case 2: econ(1); break;
			case 3: inbrn(1); break;
			case 4: addskill(ACTING, 1); break;
			case 5: interp(1); break;
			case 6: addskill(RECRUITING, 1); break;
			}
		}
		if (table == 4)
		{
			switch (roll)
			{
			case 1: bumpsoc(); break;
			case 2: techl(1); break;
			case 3: gc(1); break;
			case 4: env(1); break;
			case 5: vhcl(1); break;
			case 6: spac(1); break;
			}
		}
		skills--;
	}
}


void miscskills(int amount)
{
	int  skill;

	skill = getas(amount);
	addskill(skill, amount);
}


int getas(int amount)
{
	int  choice;

	choice = d6();
	return swas(choice, amount);
}


int swas(int choice, int amount)
{
	switch (choice)
	{
		case 1: return STEALTH;
	    case 2: return LEADER;
		case 3: return STREETWISE;  
	    case 4: return EARLYFIREARMS;
		case 5: archaic(amount); return 0;
		default: return GRAVBELT;
	}
}