/* ITHCARER.C is part of the MegaTraveller (C) character generation */
/* program. It is used each term to select the ithklur characters career. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void ithgetcareer();
void ithcareer();
void facistdraft();
void ithdraft();
int ithdoterm();
void ithpickcareer();
void pickfacil();
void pickguard();
void pickexplr();
void pickseekr();
void pickfacist();
void gotphalangist();
void gotmanager();
void gotmechanic();
void gotmerch();
void gotwettrader();
void gotphilos();
void ithgetpath();
void prntpath(int path);
int ith_comm(int neednbr, int modifier1, int modifier2, int mod_needs);
int ith_promo(int neednbr, int modifier1, int modifier2, int mod_needs);
void ithtryarmy();
void ithtrycop();
void ithtrydoc();
void ithtrydiplomat();
void ithtrybureaucrat();
void ithtryscientist();
void ithtrynavy();
void ithtryflyer();
void ithtrysailor();
void ithtrymanager();
void ithtrytechy();
void ithtrymechanic();
void ithtrystriker();
void ithtryexplorer();
void ithtrywettrader();
void ithtryathlete();
void ithtryhunter();
void ithtrybelter();
void ithtryphilos();
void facildraft();
void guarddraft();
void explorerdraft();
void seekerdraft();

extern void gotarmy();
extern void gotcop();
extern void gotdoc();
extern void gotbureaucrat();
extern void gotnavy();
extern void gotflyer();
extern void gotsailor();
extern void gotdiplomat();
extern void gotscient();
extern void gottechy();
extern void gotmarines();
extern void gotrogue();
extern void gotscouts();
extern void gothunter();
extern void gotbelter();
extern void failed();
extern void cascades();
extern void dfltech();
extern void IthEdu();
extern void dfltcareer();
extern char getche_y_n();
extern int d12();
extern int d4();
extern int d5();
extern int d6();
extern int reenlist();
extern int getsel_int(int min, int max);
extern int getsel_bigint(int min, int max);
extern void addskill(int skill, int skl_val);
extern int ithmerc_doterms();
extern int nv_doterms();
extern int ithbelter();
extern int ithcop();
extern int ithbureaucrat();
extern int ithdoc();
extern int ithdplmt();
extern int ithexplorer();
extern int ithflyer();
extern int ithhunter();
extern int ithmanager();
extern int ithmerch();
extern int ithsailor();
extern int ithtechy();
extern int ithscient();
extern int ithmerchseaman();
extern int ithphilosopher();
extern int ithmachanic();
extern int ithathlete();
extern int ithphilangist();
extern void trymerchant();
extern int bp_adj(int roll, int neednbr);
extern void getrank();

#include "chargen.h"

int facilitator, guardian, seeker, explorer;

void ithgetcareer()
{
	int choice;

	ithgetpath();
	IthEdu();
	printf("Career selection can be random or you can try to pick your\n");
	printf("characters career. Do you want to try to pick your characters\n");
	printf("career?");
	choice = getche_y_n();
	printf("\n");
	if (choice == 'Y' || choice == 'y')
		ithpickcareer();
	else
		ithdraft();
}


void ithcareer()
{
	int newterm;

	newterm = 0;
	while (newterm == 0)
		newterm = ithdoterm();
}


int ithdoterm()
{
	int newterm, choice, cont;

	newterm = 0;
	if (terms > 0)
	{
		if (careernbr == 0)
		{
			printf("Do you wish to continue your pregaming career?");
			choice = getche_y_n();
			if (choice == 'N' || choice == 'n')
				return 1;
			ithpickcareer();
			dfltcareer();
		}
	}
	switch (careernbr)
	{
		case ARMY: newterm = ithmerc_doterms(); cont = 4; break;
		case NAVY: newterm = nv_doterms(); cont = 4; break;
//		case STRIKER: newterm = ithmerc_doterms(); cont = 4; break;
		case FLYER: newterm = ithflyer(); cont = 6; break;
		case SAILOR: newterm = ithsailor(); cont = 6; break;
		case COP: newterm = ithcop(); cont = 6; break;
		case DOCTOR: newterm = ithdoc(); cont = 4; break;
		case DIPLOMAT: newterm = ithdplmt(); cont = 5; break;
		case BUREAUCRAT: newterm = ithbureaucrat(); cont = 4; break;
		case SCIENTIST: newterm = ithscient(); cont = 5; break;
		case MERCHANT: newterm = ithmerch(); cont = 4; break;
		case BELTER: newterm = ithbelter(); cont = 6; break;
//		case MERCHSEAMAN: newterm = ithmerchseaman(); cont = 5; break;
//		case ATHLETE: newterm = ithathlete(); cont = 7; break;
		case HUNTER: newterm = ithhunter(); cont = 5; break;
		case MANAGEMENT: newterm = ithmanager(); cont = 6; break;
		case EXPLORER: newterm = ithexplorer(); cont = 6; break;
//		case PHILOSOPHER: newterm = ithphilosopher(); cont = 4; break;
		case TECHY: newterm = ithtechy(); cont = 5; break;
//		case PHALANGIST: newterm = ithphilangist(); cont = 4; break;
//		case MACHINIST: newterm = ithmachanic(); cont = 4; break;
		default: newterm = 1; printf("unknown Ithklur career %d", careernbr); break;
	}
	printf("That completes this term!\n");
	if (newterm == 0)
		choice = reenlist(cont);
	else
		choice = 1;
	if (choice != 0)
		careernbr = 0;
	return newterm;
}


void ithpickcareer()
{
	if (careernbr != 0)
		return;
	switch (blue_blood % 10)
	{
		case 1: pickfacil(); break;
		case 2: pickguard(); break;
		case 3: pickexplr(); break;
		case 4: pickseekr(); break;
		case 5: pickfacist(); break;
		case 6: gotphalangist(); break;
	}
	if (careernbr == 0)
	{
		printf("You failed your enlistment\n");
		ithdraft();
	}
}


void pickfacil()
{
	int choice, max;

	printf("\nWhat career do you want? Remember, if you fail\n");
	printf("your enlistment, you will be drafted.\n\n");
	printf("   1. pick one at random\n");
	printf("   2. mechanic (roll 5, Dex 7+)\n");
	max = 2;
	if (end >= 6 && tech >= TLIND)
	{
		printf("   3. ground support - support (roll 5, End 6+)\n");
		max = 3;
	}
	if (edu >= 5 && law >= LAWMOD)
	{
		printf("   4. bureaucrat (roll 5, Str 8+)\n");
		max = 4;
	}
	if ((col > 0 || tech_sch > 0) && tech >= TLPRESTEL)
	{
		printf("   5. technician (roll 8, Dex 8+)\n");
		max = 5;
	}
	if (intl >= 7 && str >= 8)
	{
		printf("   6. security (roll 6, Dex 10+)\n");
		max = 6;
	}
	if ((str >= 7 || dex >= 7) && pop >= POPMID && atmos >= ATMTHN)
	{
		printf("   7. flyer (roll 6, Dex 9+)\n");
		max = 7;
	}
	if (intl >= 8 || edu >= 6)
	{
		printf("   8. navy (roll 8, Edu 6+)\n");
		max = 8;
	}
	if ((intl >= 8 || edu >= 4) && pop >= POPMID && hydro >= HYDWET)
	{
		printf("   9. wet navy (roll 6, Str 8+)\n");
		max = 9;
	}
	if (col > 0)
	{
		printf("   10. manager (roll 7, Int 7+)\n");
		max = 10;
	}
	choice = getsel_bigint(1, max);
	switch (choice)
	{
		case 1: ithdraft(); break;
	    case 2: ithtrymechanic(); break;
		case 3: ithtryarmy(); break;
	    case 4: ithtrybureaucrat(); break;
		case 5: ithtrytechy(); break;
	    case 6: ithtrycop(); break;
		case 7: ithtryflyer(); break;
	    case 8: ithtrynavy(); break;
		case 9: ithtrysailor(); break;
	    case 10: ithtrymanager(); break;
		default: printf("Invalid selection (%d)! Try again.\n", choice);
	}
}


void facildraft()
{
	int  roll;

	roll = d4();
	switch (roll)
	{
		case 1: gotmechanic(); break;
		case 2: gotarmy(); break;
		case 3: gotflyer(); 
		case 4: line = 1; gotnavy(); break;
	}
}


void ithtryarmy()
{
	int  enlist;

	enlist = d12();
	if (dex >= 5)
		enlist++;
	if (end >= 6)
		enlist += 2;
	if (enlist < 5 && brownie_points > 0)
		enlist = bp_adj(enlist, 5);
	if (enlist >= 5)
		gotarmy();
	else
		failed();
}


void ithtrycop()
{
	int  enlist;

	enlist = d12();
	if (intl >= 7)
		enlist++;
	if (dex >= 10)
		enlist += 2;
	if (enlist < 6 && brownie_points > 0)
		enlist = bp_adj(enlist, 6);
	if (enlist >= 6)
		gotcop();
	else
		failed();
}


void ithtrybureaucrat()
{
	int  enlist;

	enlist = d12();
	if (edu >= 8)
		enlist++;
	if (str >= 8)
		enlist += 2;
	if (enlist < 5 && brownie_points > 0)
		enlist = bp_adj(enlist, 5);
	if (enlist >= 5)
		gotbureaucrat();
	else
		failed();
}


void ithtrynavy()
{
	int  enlist;

	enlist = d12();
	if (intl >= 8)
		enlist++;
	if (edu >= 6)
		enlist += 2;
	if (enlist < 8 && brownie_points > 0)
		enlist = bp_adj(enlist, 8);
	if (enlist >= 8)
	{
		line = 1;
		gotnavy();
		return;
	}
	failed();
}


void ithtryflyer()
{
	int  enlist;

	enlist = d12();
	if (str >= 7)
		enlist++;
	if (dex >= 9)
		enlist += 2;
	if (enlist < 6 && brownie_points > 0)
		enlist = bp_adj(enlist, 6);
	if (enlist >= 6)
		gotflyer();
	else
		failed();
}


void ithtrysailor()
{
	int  enlist;

	enlist = d12();
	if (end >= 10)
		enlist++;
	if (str >= 8)
		enlist += 2;
	if (enlist < 6 && brownie_points > 0)
		enlist = bp_adj(enlist, 6);
	if (enlist >= 6)
		gotsailor();
	else
		failed();
}


void ithtrymanager()
{
	int roll;

	roll = d12() + 1;
	if (soc >= 7)
		roll++;
	if (intl >= 7)
		roll += 2;
	if (roll >= 7)
		gotmanager();
	else
		failed();
}


void ithtrymechanic()
{
	int roll;

	roll = d12() + 1;
	if (str >= 7)
		roll++;
	if (dex >= 7)
		roll += 2;
	if (roll >= 5)
		gotmechanic();
	else
		failed();
}


void ithtrytechy()
{
	int  enlist;

	enlist = d12();
	if (dex >= 8)
		enlist += 2;
	if (intl >= 8)
		enlist++;
	if (enlist < 8 && brownie_points > 0)
		enlist = bp_adj(enlist, 5);
	if (enlist >= 8)
		gottechy();
	else
		failed();
}


void pickguard()
{
	int choice, max;

	printf("\nWhat career do you want? Remember, if you fail\n");
	printf("your enlistment, you will be drafted.\n\n");
	printf("   1. pick one at random\n");
	printf("   2. athlete (roll 9, End 7+)\n");
	printf("   3. hunter (roll 9, End 9+)\n");
	max = 3;
	if (tech >= TLIND)
	{
		printf("   4. ground troops (roll 5, End 6+)\n");
		max = 4;
	}
	if (tech >= TLPRESTEL)
	{
		printf("   5. strike force (roll 9, Str 8+)\n");
		max = 5;
	}
	choice = getsel_int(1, max);
	switch (choice)
	{
		case 1: ithdraft(); break;
		case 2: ithtryathlete(); break;
		case 3: ithtryhunter(); break;
		case 4: ithtryarmy(); break;
		case 5: ithtrystriker(); break;
	}
}


void guarddraft()
{
	gotarmy();
}


void ithtrystriker()
{
	int  enlist;

	enlist = d12();
	if (intl >= 8)
		enlist++;
	if (str >= 8)
		enlist += 2;
	if (enlist < 9 && brownie_points > 0)
		enlist = bp_adj(enlist, 9);
	if (enlist >= 9)
		gotmarines();
	else
		failed();
}


void ithtryathlete()
{
	int  enlist;

	enlist = d12();
	if (soc <= 8)
		enlist++;
	if (end >= 7)
		enlist += 2;
	if (enlist < 9 && brownie_points > 0)
		enlist = bp_adj(enlist, 9);
	if (enlist >= 9)
		gotrogue();
	else
		failed();
}


void ithtryhunter()
{
	int  enlist;

	enlist = d12();
	if (dex >= 10)
		enlist++;
	if (end >= 9)
		enlist += 2;
	if (enlist < 9 && brownie_points > 0)
		enlist = bp_adj(enlist, 9);
	if (enlist >= 9)
		gothunter();
	else
		failed();
}


void pickexplr()
{
	int choice, max;

	printf("\nWhat career do you want? Remember, if you fail\n");
	printf("your enlistment, you will be drafted.\n\n");
	printf("   1. pick one at random\n");
	max = 1;
	if (pop >= POPMID && hydro >= HYDWET && (end >= 6 || str >= 8))
	{
		printf("   2. wet trader (roll 6, Str 8+)\n");
		max = 2;
	}
	if (tech >= TLPRESTEL && dex >= 6)
	{
		printf("   3. belter (roll 8, Int 6+)\n");
		max = 3;
	}
	if (tech >= TLEARSTEL)
	{
		if (intl >= 7 || str >= 8)
		{
			printf("   4. explorer (roll 7, Strt 8+)\n");
			max = 4;
		}
		if (intl >= 7)
		{
			printf("   5. trader (based on line)\n");
			max = 5;
		}
	}
	choice = getsel_int(1, max);
	switch (choice)
	{
		case 1: explorerdraft(); break;
		case 2: ithtrywettrader(); break;
		case 3: ithtrybelter(); break;
		case 4: ithtryexplorer(); break;
		case 5: trymerchant(); break;
	}
//	if (careernbr == MERCHANT || MERCHSEAMAN)
	if (careernbr == MERCHANT)
		addskill(TRADER, 1);
}


void explorerdraft()
{
	line = 6;
	gotmerch();
	addskill(TRADER, 1);
}


void ithtryexplorer()
{
	int  enlist;

	enlist = d12();
	if (intl >= 6)
		enlist++;
	if (str >= 8)
		enlist += 2;
	if (enlist < 7 && brownie_points > 0)
		enlist = bp_adj(enlist, 7);
	if (enlist < 7)
	{
		failed();
		return;
	}
	gotscouts();
}


void ithtrybelter()
{
	int  enlist;

	enlist = d12();
	if (dex >= 9)
		enlist++;
	if (intl >= 6)
		enlist += 2;
	if (enlist < 8 && brownie_points > 0)
		enlist = bp_adj(enlist, 8);
	if (enlist < 8)
	{
		failed();
		return;
	}
	gotbelter();
}


void ithtrywettrader()
{
	int  enlist;

	enlist = d12();
	if (end >= 10)
		enlist++;
	if (str >= 8)
		enlist += 2;
	if (enlist < 6 && brownie_points > 0)
		enlist = bp_adj(enlist, 6);
	if (enlist >= 6)
		gotwettrader();
	else
		failed();
}


void pickseekr()
{
	int choice, max;

	printf("\nWhat career do you want? Remember, if you fail\n");
	printf("your enlistment, you will be drafted.\n\n");
	printf("   1. pick one at random\n");
	max = 1;
	if (intl >= 7)
	{
		printf("   2. scientist (roll 6, Edu 10+)\n");
		printf("   3. philosopher (roll 7, Edu 8+)\n");
		max = 3;
		if (pop >= POPMID)
		{
			printf("   4. diplomat (roll 7, Soc 9+)\n");
			max = 4;
		}
	}
	if (dex >= 6)
	{
		printf("   5. medicine (roll 9, Dex 9+)\n");
		max = 5;
	}
	choice = getsel_int(1, max);
	switch (choice)
	{
		case 1: seekerdraft(); break;
		case 2: ithtryscientist(); break;
		case 3: ithtryphilos(); break;
		case 4: ithtrydiplomat(); break;
		case 5: ithtrydoc(); break;
	}
}


void seekerdraft()
{
	gotphilos();
}


void ithtrydoc()
{
	int  enlist;

	enlist = d12();
	if (med_sch > 0)
		enlist += 7;
	if (intl >= 8)
		enlist++;
	if (dex >= 9)
		enlist += 2;
	if (enlist < 9 && brownie_points > 0)
		enlist = bp_adj(enlist, 9);
	if (enlist >= 9)
		gotdoc();
	else
		failed();
}


void ithtrydiplomat()
{
	int  enlist;

	enlist = d12();
	if (edu >= 8)
		enlist++;
	if (soc >= 9)
		enlist += 2;
	if (enlist < 7 && brownie_points > 0)
		enlist = bp_adj(enlist, 7);
	if (enlist >= 7)
		gotdiplomat();
	else
		failed();
}


void ithtryscientist()
{
	int  enlist;

	enlist = d12();
	if (intl >= 9)
		enlist++;
	if (edu >= 10)
		enlist += 2;
	if (col != HONORS && enlist < 6 && brownie_points > 0)
		enlist = bp_adj(enlist, 6);
	if (col == HONORS || enlist >= 6)
		gotscient();
	else
		failed();
}


void ithtryphilos()
{
	int  enlist;

	enlist = d12();
	if (intl >= 9)
		enlist++;
	if (edu >= 8)
		enlist += 2;
	if (enlist < 7 && brownie_points > 0)
		enlist = bp_adj(enlist, 7);
	if (enlist >= 7)
		gotphilos();
	else
		failed();
}


void pickfacist()
{
	int choice, max, full;

	full = facilitator + guardian + explorer + seeker;
	printf("\nWhat career path do you want? Remember, if you fail\n");
	printf("your enlistment, you will be drafted.\n\n");
	printf("   1. pick one at random\n");
	max = 1;
	if (full == 4 || facilitator == 0)
	{
		printf("   2. facilitator career\n");
		max = 2;
	}
	if (full == 4 || guardian == 0)
	{
		printf("   3. guardian career\n");
		max = 3;
	}
	if (full == 4 || explorer == 0)
	{
		printf("   4. explorer career\n");
		max = 4;
	}
	if (full == 4 || seeker == 0)
	{
		printf("   5. seeker career\n");
		max = 5;
	}
	choice = getsel_int(1, max);
	switch (choice)
	{
		case 1: ithdraft(); break;
		case 2: pickfacil(); facilitator = 1; break;
		case 3: pickguard(); guardian = 1; break;
		case 4: pickexplr(); explorer = 1; break;
		case 5: pickseekr(); seeker = 1; break;
	}
}


void ithgetpath()
{
	int choice, max, tetra;

	facilitator = guardian = seeker = explorer = 0;
	printf("\nWhat path do you want to follow? Remember,\n");
	printf("this will limit your career choices.\n\n");
	printf("   1. pick one at random");
	printf("\n   2. ");
	prntpath(6);
	printf("\n   3. ");
	prntpath(1);
	max = 3;
	tetra = 1;
	if (str >= 6)
	{
		printf("\n   4. ");
		prntpath(2);
		max = 4;
		tetra++;
	}
	if ((pop >= POPMID && hydro >= HYDWET && (end >= 6 || str >= 8))
		|| (tech >= TLPRESTEL && dex >= 6)
		|| (tech >= TLEARSTEL && (intl >= 7 || str >= 8)))
	{
		printf("\n   5. ");
		prntpath(3);
		max = 5;
		tetra++;
	}
	if (intl >= 7)
	{
		printf("\n   6. ");
		prntpath(4);
		max = 6;
		tetra++;
	}
	if (tetra >= 4) // a facist must be able to be in a career for each path
	{
		printf("\n   7. ");
		prntpath(5);
		max = 7;
	}
	printf("\n");
	choice = getsel_int(1, max);
	if (choice == 1)
		choice = d4();
	else
		if (choice == 2)
		{
			choice = 6;
			gotphalangist();
		}
		else
			choice -= 2;
	blue_blood += choice;
	printf("You chose the ");
	prntpath(blue_blood % 10);
	printf(".\n");
}


void prntpath(int path)
{
	switch (path)
	{
		case 1: printf("Facilitator"); break;
		case 2: printf("Guardian"); break;
		case 3: printf("Explorer"); break;
		case 4: printf("Seeker"); break;
		case 5: printf("Tetramerous Way-Fascist"); break;
		case 6: printf("Tetramerous Way-Phalangist"); break;
	}
}


void facistdraft()
{
	int  roll, full;

	full = facilitator + guardian + seeker + explorer;
	roll = 0;
	if (full < 4)
	{
		while (roll == 0)
		{
			if (roll == 0)
				roll = d4();
			if (facilitator == 1 && roll == 1)
				roll = 0;
			if (guardian == 1 && roll == 2)
				roll = 0;
			if (explorer == 1 && roll == 3)
				roll = 0;
			if (seeker == 1 && roll == 4)
				roll = 0;
		}
	}
	switch (roll)
	{
		case 1: facildraft(); break;
		case 2: guarddraft(); break;
		case 3: explorerdraft(); break;
		case 4: seekerdraft(); break;
	}
}


void ithdraft()
{
	int  roll;

	printf("You have been drafted. ");
	roll = blue_blood % 10;
	switch (roll)
	{
		case 1: facildraft(); break;
		case 2: guarddraft(); break;
		case 3: explorerdraft(); break;
		case 4: seekerdraft(); break;
		case 5: facistdraft(); break;
	}
	printf("Your career is %s.\n", career);
}


void gotmanager()
{
	strncpy(career,"Manager",8);
	careernbr = MANAGEMENT;
}


void gotmechanic()
{
	strncpy(career,"Mechanic",9);
//	careernbr = MACHINIST;
}


void gotphalangist()
{
	strncpy(career,"Phalangist",11);
//	careernbr = PHALANGIST;
}


void gotwettrader()
{
	strncpy(career,"Wet Trader",11);
//	careernbr = MERCHSEAMAN;
}


void gotphilos()
{
	strncpy(career,"Philosopher",12);
//	careernbr = PHILOSOPHER;
}


int ith_comm(int neednbr, int modifier1, int modifier2, int mod_needs)
{
	int roll, retval;

	retval = 1;
	if (terms == 1 || neednbr == 0)
		retval++;
	if (rankeo == 'E' && drafted == 0 && neednbr > 0)
	{
		roll = d12();
		roll += (modifier1 + modifier2 - mod_needs);
	    printf("Enlightenment requires a %d, your modified roll %d. ", neednbr, roll);
		if (brownie_points > 0 && roll < neednbr)
			roll = bp_adj(roll, neednbr);
	    if (roll >= neednbr)
		{
			printf("You became enlightened!\n");
			rankeo = 'O';
			rank = 1;
			retval++;
			if (roll >= (neednbr + 4))
				retval++;
		}
	}
	drafted = 0;
	return retval;
}


int ith_promo(int neednbr, int modifier1, int modifier2, int mod_needs)
{
	int roll, retval;

	retval = 0;
	if (rankeo == 'O' && (rank < 8))
	{
		roll = d12();
		roll += (modifier1 + modifier2 - mod_needs);
		printf("A promotion requires a %d, you rolled %d.\n", neednbr, roll);
		if (brownie_points > 0 && roll < neednbr)
			roll = bp_adj(roll, neednbr);
		if (roll >= neednbr)
		{
			retval++;
			rank++;
			if (roll >= (neednbr + 4) && rank < 8)
			{
				rank++;
				retval++;
			}
			printf("You received a promotion to ");
			getrank();
//			if ((careernbr == SAILOR || careernbr == MERCHSEAMAN) && rank == 2)
			if (careernbr == SAILOR && rank == 2)
				addskill(LARGEBOAT, 1);
			if (careernbr == COP)
			{
				if (rank == 4)
					addskill(INTERROGATE, 1);
				if (rank == 5)
					addskill(ADMIN, 1);
				if (rank == 6)
					addskill(LIAISON, 1);
			}
		}
	}
	return retval;
}
