/* ITHMCHNC.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>

int ithmachanic();
void ithmachanicmot(int term);
void ithmachanicbene();
void ithmachanicskills(int skills);
void ithmachanic_tbl();

#include "chargen.h"

extern int ith_comm(int need_nbr, int skill1, int skill2, int skl_val);
extern int ith_promo(int need_nbr, int skill1, int skill2, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int d8();
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int picktable();
extern void bumpdex();
extern void bumpsoc();
extern void bumpintl();
extern void bumpedu();
extern void bumpstr();
extern void bumpend();
extern void vhcl(int skl_val);
extern void vc(int skl_val);
extern void mc(int skl_val);
extern void mentl(int skl_val);
extern void econ(int skl_val);
extern void techl(int skl_val);
extern void inbrn(int skl_val);
extern void spac(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_midpsg();
extern void mot_hipsg();
extern void mot_tas();

int ithmachanic()
{
	int skills, newterm;

	newterm = 0;
	skills = basic_spec_duty(6);
	newterm = basic_surv(5, intl, 9);
	if (newterm == 0)
	{
		skills++;
		if (rankeo == 'E')
			skills += ith_comm(10, intl, soc, 13);
		else
			skills += ith_promo(12, intl, soc, 13);
	}
	if (skills != 0) ithmachanicskills(skills);
	ithmachanicmot(1);
	return newterm;
}


void ithmachanicmot(int term)
{
	int  cash, roll, amt;
	char choice;
  
	cash = basic_mot();
	while ((term > 0) && (cash > 0))
	{
		choice = getche_mot();
		if (choice == 'C' || choice == 'c')
		{
			cash--;
			roll = basic_cash();
			term--;
			amt = 0;
			switch (roll)
			{
			case 1: amt = 1000; break;
			case 2: amt = 2000;break;
			case 3: amt = 5000; break;
			case 4: amt = 5000; break;
			case 5: amt = 5000; break;
			case 6: amt = 10000; break;
			case 7: amt = 30000; break;
			}
			mot_cash(amt);
		}
		else
		{
			ithmachanicbene();
			term--;
		}
	}
	while (term > 0)
	{
		ithmachanicbene();
		term--;
	}
}


void ithmachanicbene()
{
	int roll;

	roll = basic_bene();
	switch (roll)
	{
	case 1: bumpsoc(); break;
	case 2: bumpintl(); break;
	case 3: bumpedu(); break;
	case 4: mot_lopsg(); break;
	case 5: mot_midpsg(); break;
	case 6: mot_hipsg(); break;
	case 7: mot_tas(); break;
	}
}


void ithmachanic_tbl()
{
	int roll;

	roll = d6();
	switch (roll)
	{
	case 1: vhcl(1); break;
	case 2: addskill(CAROUSING, 1); break;
	case 3: addskill(HANDYMAN, 1); break;
	case 4: addskill(ELECTRONICS, 1); break;
	case 5: addskill(MECHANICAL, 1); break;
	case 6: addskill(MECHANICAL, 1); break;
	}
}


void ithmachanicskills(int skills)
{
	int  table, roll;

	while (skills > 0)
	{
		table = picktable();
		roll = d6();
		if (table == 1)
		{
			switch (roll)
			{
			case 1: bumpstr(); break;
			case 2: bumpdex(); break;
			case 3: bumpend(); break;
			case 4: addskill(BRAWLING, 1); break;
			case 5: vc(1); break;
			case 6: mentl(1); break;
			}
		}
		if (table == 2)
			ithmachanic_tbl();
		if (table == 3)
		{
			switch (roll)
			{
			case 1: vhcl(1); break;
			case 2: techl(1); break;
			case 3: mc(1); break;
			case 4: econ(1); break;
			case 5: econ(1); break;
			case 6: techl(1); break;
			}
		}
		if (table == 4)
		{
			switch (roll)
			{
			case 1: vc(1); break;
			case 2: mc(1); break;
			case 3: inbrn(1); break;
			case 4: techl(1); break;
			case 5: techl(1); break;
			case 6: spac(1); break;
			}
		}
		skills--;
	}
}
