/* ITHSEAMN.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

int ithmerchseaman();
void ithmerchseamot(int term);
void ithmerchseabene();
void ithmerchseaskills(int skills);
void ithmerchsea_tbl(int roll);

extern int ith_comm(int need_nbr, int skill1, int skill2, int skl_val);
extern int ith_promo(int need_nbr, int skill1, int skill2, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int picktable();
extern void physicl(int skl_val);
extern void bumpdex();
extern void bumpend();
extern void bumpsoc();
extern void bumpedu();
extern void bumpintl();
extern void vc(int skl_val);
extern void special(int skl_val);
extern void vhcl(int skl_val);
extern void techl(int skl_val);
extern void mc(int skl_val);
extern void gc(int skl_val);
extern void interp(int skl_val);
extern void inbrn(int skl_val);
extern void boats(int skl_val);
extern void econ(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_weapon();
extern void mot_hipsg();
extern void mot_tas();

#include "chargen.h"

int ithmerchseaman()
{
	int     skills, newterm;
  
	newterm = 0;
	skills = basic_spec_duty(6);
	newterm = basic_surv(5, end, 8);
	if (newterm == 0)
	{
		skills++;
		if (rankeo == 'E')
			skills += ith_comm(10, intl, end, 13);
		else
			skills += ith_promo(12, intl, end, 13);
	}
	if (skills != 0)
		ithmerchseaskills(skills);
	ithmerchseamot(1);
	return newterm;
}


void ithmerchseamot(int term)
{
	int  cash, roll, amt;
	char choice;
  
	cash = basic_mot();
	while ((term > 0) && (cash > 0))
	{
		choice = getche_mot();
		if (choice == 'C' || choice == 'c')
		{
			cash--;
			roll = basic_cash();
			term--;
			amt = 0;
			switch (roll)
			{
				case 1: amt = 2000; break;
				case 2: amt = 5000; break;
				case 3: amt = 10000; break;
				case 4: amt = 10000; break;
				case 5: amt = 10000; break;
				case 6: amt = 20000; break;
				case 7: amt = 30000; break;
			}
			mot_cash(amt);
		}
		else
		{
			ithmerchseabene();
			term--;
		}
	}
	while (term > 0)
	{
		ithmerchseabene();
		term--;
	}
}


void ithmerchseabene()
{
	int roll;

	roll = basic_bene();
	switch (roll)
	{
		case 1: mot_lopsg(); break;
		case 2: bumpedu(); break;
		case 3: bumpintl(); break;
		case 4: mot_weapon(); break;
		case 5: mot_hipsg(); break;
		case 6: bumpsoc(); break;
		case 7: mot_tas(); break;
	}
}


void ithmerchseaskills(int skills)
{
	int  table, roll;

	while (skills > 0)
	{
		table = picktable();
		roll = d6();
		if (table == 1)
		{
			switch (roll)
			{
				case 1: physicl(1); break;
				case 2: bumpdex(); break;
				case 3: bumpend(); break;
				case 4: vc(1); break;
				case 5: addskill(BRAWLING, 1); break;
				case 6: inbrn(1); break;
			}
		}
		if (table == 2)
			ithmerchsea_tbl(roll);
		if (table == 3)
		{
			switch (roll)
			{
				case 1: addskill(LARGEBOAT, 1); break;
				case 2: addskill(MECHANICAL, 1); break;
				case 3: boats(1); break;
				case 4: econ(1); break;
				case 5: mc(1); break;
				case 6: addskill(HANDYMAN, 1); break;
			}
		}
		if (table == 4)
		{
			switch (roll)
			{
				case 1: addskill(ELECTRONICS, 1); break;
				case 2: vhcl(1); break;
				case 3: vc(1); break;
				case 4: techl(1); break;
				case 5: interp(1); break;
				case 6: inbrn(1); break;
			}
		}
		skills--;
	}
}


void ithmerchsea_tbl(int roll)
{
	if (roll < 1 || roll > 6)
		roll = d6();
	switch (roll)
	{
		case 1: addskill(FORWARDOBS, 1); break;
		case 2: addskill(VACCSUIT, 1); break;
		case 3: gc(1); break;
		case 4: vhcl(1); break;
		case 5: boats(1); break;
		case 6: econ(1); break;
	}
}