/* belter_a.C develops advanced belter character's personal history */

void trybelter();
void pick_assoc();
int try_company();
int try_group();
int try_solo();
void belter();
void bel_line();
int bel_doterms();
int bel_do_year();
long bel_cash();
void belter_a_bene();
void bel_asgn();
void bel_prt_asgnmt();
void bel_outfit();
void bel_xfer_down();
void bel_xfer_up();
void bel_claim();
void bel_search();
void bel_patron();
void bel_mining();
void bel_recruit();
void bel_gen_skill();
int bel_pick_tbl();
void co_life();
void group_life();
void solo_life();
void outfit_tbl();
void recruit_tbl();
void belter_tbl();
void search_tbl();
void mining_tbl();
void claim_tbl();

extern int anag();
extern void adv_aging(int anags);
extern int gotbelter();
extern int survive(int adjust, int roll);
extern int basic_cash();
extern int bp_adj(int need_nbr, int roll);
extern int basic_bene();
extern int d2();
extern int d3();
extern int d6();
extern int d12();
extern char getche_y_n();
extern int getsel_int(int min, int max);
extern void addskill(int skill, int skl_val);
extern int find_skl(int skill);
extern int bp_skill(int roll);
extern int reenlist(int need_nbr);
extern void bp_decor(int need_nbr, int roll);
extern void bumpdex();
extern void bumpstr();
extern void bumpend();
extern void bumpintl();
extern void bumpedu();
extern void bc(int skl_val);
extern void gc(int skl_val);
extern void altcareertbl();
extern void gunner(int skl_val);
extern void zhopsiedu();
extern int ask_adj_asgn(int roll);
extern void mot_midpsg();
extern void mot_hipsg();
extern void mot_weapon();
extern void mot_ship();

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "chargen.h"

int co_years, strike;
int company, group, solo;

void trybelter()
{
  company = 0;
  group = 0;
  solo = 0;
  pick_assoc();
}


void pick_assoc()
{
  int choice, min, max;

  min = 0;
  max = 0;
  printf("Who do you want to associate with?\n");
  if (company == 0)
  {
	  printf("   1. prospecting company (roll 9, dex 9+, int 6+)\n");
	  min = 1;
	  max = 1;
  }
  if (group == 0)
  {
	  printf("   2. informal group (roll 8, dex 9+, int 6+)\n");
	  if (min == 0) min = 2;
	  max = 2;
  }
  if (solo == 0)
  {
	  printf("   3. single-handed (roll 7, dex 9+, int 6+)\n");
	  if (min == 0) min = 3;
	  max = 3;
  }
  if (min == max)
	  choice = min;
  else
	  choice = getsel_int(min, max);
  if (choice == 1)
	  company = try_company();
  if (choice == 2)
	  group = try_group();
  if (choice == 3)
	  solo = try_solo();
  if (careernbr > 0 || (company != 0 && group != 0 && solo != 0))
	  return;
  pick_assoc();
}


int try_company()
{
  int roll;

  roll = d12();
  if (race == DOLPHINS) roll++;
  if (intl >= 6) roll++;
  if (dex >= 9) roll += 2;
  if (roll < 9 || brownie_points > 0) roll = bp_adj(9, roll);
  if (roll < 9) return NOTACCEPTED;
  line = 1;
  gotbelter();
  bel_line();
  return GRADUATED;
}


int try_group()
{
  int roll;

  roll = d12();
  if (race == DOLPHINS) roll++;
  if (intl >= 6) roll++;
  if (dex >= 9) roll += 2;
  if (roll < 8 || brownie_points > 0) roll = bp_adj(8, roll);
  if (roll < 8) return NOTACCEPTED;
  line = 2;
  gotbelter();
  bel_line();
  return GRADUATED;
}

int try_solo()
{
  int roll;

  roll = d12();
  if (race == DOLPHINS) roll++;
  if (intl >= 6) roll++;
  if (dex >= 9) roll += 2;
  if (roll < 7 || brownie_points > 0) roll = bp_adj(7, roll);
  if (roll < 7) return NOTACCEPTED;
  line = 3;
  gotbelter();
  bel_line();
  return GRADUATED;
}

void belter()
{
  int rolls;

  co_years = 0;
  addskill(VACCSUIT, 1);
  while (bel_doterms() == 0);
  terms -= anagathics;
  rolls = terms + (co_years / 4);
  while (rolls > 0)
  {
	  belter_a_bene();
	  rolls--;
  }
}

extern int mer_anag, assignment;

void bel_line()
{
  switch (line)
  {
    case 1: strncpy(office,"Prospecting Co",15); break;
    case 2: strncpy(office,"Informal Group",15); break;
    case 3: strncpy(office,"Single-Handed",14); break; 
    default: strncpy(office,"unknown?",9); break;
  }
  printf("You are part of a %s\n", office);
}

extern int assignment;

int bel_doterms()
{
  int survival;
  
  assignment = 0;
  adv_aging(mer_anag);
  do {
    survival = bel_do_year();
  } while (((age % 4) != 2) && (survival == 0));
  if (survival != 0) return 1;
  if (terms == 2) gc(1);
  if (terms == 4) addskill(NOGRAV, 1);
  if (terms == 6) addskill(LEADER, 1);
  survival = reenlist(0);
  if (survival != 0) return 1; 
  mer_anag = anag();
  return 0;
}


int bel_do_year()
{
  int  roll, adjust;

  age++;
  if (mer_anag == 0) appearent_age++;
  bel_asgn();
  if (line == 1) co_years++;
  if (skil != 0)
  {
    roll = d12();
    if (roll < skil) roll = bp_skill(roll);
    if (roll >= (skil + 4))
	{
      if (spec_skill != 0)
	  {
        printf("Increasing your specialty skill. ");
        addskill(spec_skill, 1);
      }
	  else 
	  {
		bel_gen_skill();
		bel_gen_skill();
      }
    }
	else
	{
      if (roll >= skil) bel_gen_skill();
    }
  }
  if (decor != 0) // strike chance
  {
    if (find_skl(PROSPECTING) >= 0)
		roll = d12() + find_skl(PROSPECTING);
    if (roll < decor && brownie_points > 0)
		bp_decor(decor, roll);
    if (roll >= decor)
		credits += bel_cash();
  }
  roll = d12();
  adjust = 0;
  if (terms > 1) adjust = terms - 1;
  return survive(roll, adjust);
}


long bel_cash()
{
  int roll;
  long cr;

  roll = basic_cash();
  switch (roll)
  {
    case 0: cr = 1000; break;
    case 1: cr = 1000; break;
    case 2: cr = 5000; break;
    case 3: cr = 5000; break;
    case 4: cr = 10000; break;
    case 5: cr = 10000; break;
    case 6: cr = 20000; break;
    default: cr = 50000; break;
  }
  printf("You got %ld credits from a strike.\n", cr);
  return (cr);
}


void belter_a_bene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_midpsg(); break;
    case 2: bumpintl(); break;
    case 3: mot_weapon(); break;
    case 4: mot_weapon(); break;
    case 5: mot_hipsg(); break;
    default: mot_ship(); break;
  }
}


void bel_asgn()
{
  int roll;

  roll = d12();
  if (terms >= 2) roll++;
  if (terms >= 4) roll++;
  if (terms >= 6) roll++;
  if (terms >= 8) roll++;
  if (pick == 1 && brownie_points > 0)
	  roll = ask_adj_asgn(roll);
  else
	  if (pick == 4 && roll == 2 && brownie_points > 0)
	  {
		  roll++;
		  brownie_points--;
		  printf("You used 1 brownie point to avoid a transfer down.\n");
	  }
  if (line == 1)
  {
	if (pick == 4 && roll == 9 && brownie_points > 3)
	{
		roll++;
		brownie_points--;
		printf("You used 1 brownie point to get mining.\n");
	}
	if (pick == 4 && roll == 4 && brownie_points > 3)
	{
		roll--;
		brownie_points--;
		printf("You used 1 brownie point to get mining.\n");
	}
    if (roll <= 2)
		bel_xfer_down();
    else
		if (roll == 3 || roll >= 10)
			bel_mining();
		else
			if (roll >= 7)
				bel_search();
			else
				if (roll == 6)
					bel_outfit();
				else
					bel_recruit();
  }
  else
  {
	if (pick == 4 && roll == 11 && brownie_points > 0)
	{
		roll++;
		brownie_points--;
		printf("You used 1 brownie point to transfer up.\n");
	}
    if (line == 2)
	{
		if (pick == 4 && roll == 4 && brownie_points > 3)
		{
			roll--;
			brownie_points--;
			printf("You used 1 brownie point to stake a claim.\n");
		}
		if (roll <= 2)
			bel_xfer_down();
		else
			if (roll == 3)
				bel_claim();
			else  
				if (roll >= 12)
					bel_xfer_up();
				else
					if (roll >= 9)
						bel_outfit();
					else
						bel_recruit();
	}
    else
	{
		if (pick == 4 && roll == 5 && brownie_points > 3)
		{
			roll--;
			brownie_points--;
			printf("You used 1 brownie point to stake a claim.\n");
		}
		if (roll <= 2)
			bel_patron();
		else
			if (roll <= 4)
				bel_claim();
			else  
				if (roll == 5)
					bel_outfit();
				else
					if (roll <= 9)
						bel_search();
					else
						if (roll <= 11)
							bel_mining();
						else
							bel_xfer_up();
	}
  }
}


void bel_outfit()
{
  assignment = 1;
  surv = 0;
  skil = 8;
  decor = 0;
  printf("You were outfiting.\n");
}


void bel_xfer_down()
{
  line++;
  bel_line();
  printf("You were transfered down to %s.\n", office);
  bel_asgn();
}


void bel_xfer_up()
{
  char resp;

  printf("You have the option to transfer up. Do you want to?");
  resp = getche_y_n();
  if (resp == 'Y' || resp == 'y')
  {
    line--;
    bel_line();
    printf("You were transfered up to %s.\n", office);
  }
  bel_asgn();
}


void bel_prt_asgnmt()
{
  switch (assignment)
  {
    case 1: printf("Outfiting"); break;
    case 2: printf("Recruiting"); break;
    case 3: printf("Claim Jumping"); break;
    case 4: printf("Searching"); break;
    default: printf("Mining"); break;
  }
}


void bel_patron()
{
  printf("You were seeking a new patron.\n");
  assignment = 1;
  surv = 0;
  skil = 8;
  decor = 0;
}


void bel_recruit()
{
  surv = 0;
  skil = 7;
  decor = 0;
  assignment = 2;
  printf("You were recruiting.\n");
}


void bel_claim()
{
  surv = 6;
  skil = 5;
  decor = 6;
  if (line == 3) decor++;
  assignment = 5;
  printf("You were claim jumping.\n");
}


void bel_search()
{
  surv = 4;
  skil = 5;
  decor = 0;
  if (line > 1) skil++;
  if (line > 2) surv++;
  assignment = 3;
  printf("You were searching.\n");
}


void bel_mining()
{
  surv = 3 + line;
  skil = 5;
  if (line > 1) skil++;
  decor = 6 + line;
  assignment = 4;
  printf("You were mining.\n");
}


void bel_gen_skill()
{
  int choice;

  if (pick <= 2)
    choice = bel_pick_tbl();
  else
  {
    if ((race == SOLOMANI && alt_career != 0) || (race == ZHODANI && soc >= 10))
		choice = d3();
    else
		choice = d2();
  }
  if (choice == 1)
  {
    switch (line)
	{
      case 1: co_life(); break;
      case 2: group_life(); break;
      default: solo_life(); break;
    }
  } 
  else
  {
    if (choice == 2)
	{
      switch (assignment)
	  {
        case 1: outfit_tbl(); break;
        case 2: recruit_tbl(); break;
        case 3: claim_tbl(); break;
        case 4: search_tbl(); break;
        default: mining_tbl(); break;
      }
    }
	else 
		if (race == ZHODANI) zhopsiedu();
		else altcareertbl();
  }
}


int bel_pick_tbl()
{
  int choice, max;

  max = 2;
  printf("Which table do you wish to use?\n\n");
  printf("   1. %s life\n   2. ", office);
  bel_prt_asgnmt();
  printf(" table\n");
  if (race == SOLOMANI) {
    if (alt_career == LANDGUARD) printf("   3. home guard army table\n");
    if (alt_career == SPACEGUARD) printf("   3. home guard navy table\n");
	if (alt_career != 0) max = 3;
  }
  if (race == ZHODANI && soc >= 10)
  {
	  printf("   3. Noble/Intendent education\n");
	  max = 3;
  }
  choice = getsel_int(1, max);
  return choice;
}

void co_life()
{
  int roll;

  roll = d6();
  switch (roll) {
    case 1: bumpstr(); break;
    case 2: bumpdex(); break;
    case 3: bumpend(); break;
    case 4: bumpedu(); break;
    case 5: addskill(STREETWISE, 1); break;
    default: addskill(GAMBLING, 1); break;
  }
}


void group_life()
{
  int roll;

  roll = d6();
  switch (roll) {
    case 1: bumpstr(); break;
    case 2: bumpdex(); break;
    case 3: bumpend(); break;
    case 4: addskill(BRAWLING, 1); break;
    case 5: addskill(GAMBLING, 1); break;
    default: bc(1); break;
  }
}


void solo_life()
{
  int roll;

  roll = d6();
  switch (roll) {
    case 1: bumpstr(); break;
    case 2: bumpdex(); break;
    case 3: bumpend(); break;
    case 4: addskill(STREETWISE, 1); break;
    case 5: addskill(GAMBLING, 1); break;
    default: addskill(CAROUSING, 1); break;
  }
}


void outfit_tbl()
{
  int roll;

  roll = d6();
  switch (roll) {
    case 1: addskill(GAMBLING, 1); break;
    case 2: addskill(BRAWLING, 1); break;
    case 3: addskill(RECRUITING, 1); break;
    case 4: addskill(CAROUSING, 1); break;
    case 5: addskill(TRADER, 1); break;
    default: addskill(STREETWISE, 1); break;
  }
}


void recruit_tbl()
{
  int roll;

  roll = d6();
  switch (roll) {
    case 1: addskill(RECRUITING, 1); break;
    case 2: addskill(INTERROGATE, 1); break;
    case 3: addskill(INSTRUCTION, 1); break;
    case 4: addskill(CAROUSING, 1); break;
    case 5: addskill(STREETWISE, 1); break;
    default: addskill(RECRUITING, 1); break;
  }
}


void claim_tbl()
{
  int roll;

  roll = d6();
  switch (roll) {
    case 1: gunner(1); break;
    case 2: addskill(NOGRAV, 1); break;
    case 3: gc(1); break;
    case 4: bc(1); break;
    case 5: addskill(SHIPTAC, 1); break;
    default: addskill(VACCSUIT, 1); break;
  }
}


void belter_tbl()
{
  search_tbl();
}


void search_tbl()
{
  int roll;

  roll = d6();
  switch (roll) {
    case 1: addskill(PROSPECTING, 1); break;
    case 2: addskill(PILOT, 1); break;
    case 3: addskill(SURVEY, 1); break;
    case 4: addskill(ENGINEERING, 1); break;
    case 5: addskill(NAVIGATION, 1); break;
    default: addskill(PROSPECTING, 1); break;
  }
}


void mining_tbl()
{
  int roll;

  roll = d6();
  switch (roll) {
    case 1: bumpstr(); break;
    case 2: bumpend(); break;
    case 3: addskill(DEMOLITIONS, 1); break;
    case 4: addskill(VACCSUIT, 1); break;
    case 5: addskill(SHIPBOAT, 1); break;
    default: addskill(FORWARDOBS, 1); break;
  }
}
