/* CAREER.C is part of the MegaTraveller (C) character generation */
/* program. It is used to select the human characters career. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void careers();
void resolvecareer();
void getcareer();
void pickcareer();
void randomcareer();
void military();
void tryarmy();
void tryguard();
void trynavy();
void trymarines();
void tryscouts();
void tryflyers();
void trysailors();
void tryzhodguard();
void gotzhodguard();
void trydraft();
void government();
void tryparty();
void trydiplomat();
void trybureaucrat();
void tryzhogov();
void gotzhogov();
void tryscientist();
void trycop();
void trydoctor();
void trytechpriest();
void civilian();
void trypirate();
void tryrogue();
void trybarbarian();
void tryhunter();
void trytechy();
void tryentertain();
void tryfarm();
void trywealthy();
void tryjournal();
void tryzprole();
void gotzprole();
void altcareer();
void homeguard();
void solsec_spcl();
void solsecbranch(int brnch);
void solsecalt_career();
void solsecmil();
void solsecgov();
void solsecciv();
void altcareertbl();
extern void failed();
void gotntarronth();
void gotntarronchiia();

extern int d3();
extern int d6();
extern int d7();
extern int d12();
extern char getche_y_n();
extern int getsel_int(int min, int max);
extern int bp_adj(int enlist, int roll);
extern void precareer();
extern void cascades();
extern void dfltech();
extern void dfltcareer();
extern void solarmy();
extern void solnavy();
extern void solmarine();
extern void darnavy();
extern void army();
extern void navy();
extern void marine();
extern void scout();
extern void coacc();
extern void flyer();
extern void sailor();
extern void cop();
extern void doc();
extern void diplomat();
extern void bureaucrat();
extern void scientist();
extern void darnoble();
extern void noble();
extern void solmerch();
extern void merchant();
extern void belter();
extern void pirate();
extern void rogue();
extern void hunter();
extern void barbarian();
extern void solsec();
extern void iris();
extern void geotechy();
extern void solparty();
extern void gotnoble();
extern void gotsolsec();
extern void zhogov();
extern void consularguard();
extern void zhoprole();
extern void tryiris();
extern void trymerchant();
extern void trybelter();
extern void prntupp();
extern void gotarmy();
extern void gotnavy();
extern void gotscouts();
extern void gotflyer();
extern void gotmarines();
extern void gotsailor();
extern void gotbarbarian();
extern void gotparty();
extern void gotcop();
extern void gotdoc();
extern void gotdiplomat();
extern void gotbureaucrat();
extern void gotscient();
extern void gotmerch();
extern void gotpirate();
extern void gotrogue();
extern void gothunter();
extern void gottechy();
extern void gotlawyer();
extern void hmgdarmy();
extern void hmgdnavy();
extern void solarmy_tbl();
extern void solnavy_tbl();
extern void sc_ofc();
extern void solmarine_tbl();
extern void flyer_tbl();
extern void sailor_tbl();
extern void cop_tbl();
extern void doc_tbl();
extern void diplomat_tbl();
extern void bureau_tbl();
extern void solmerch_tbl();
extern void sci_gen_skl();
extern void belter_tbl();
extern void pirate_tbl();
extern void rogue_tbl();
extern void hunter_tbl();
extern void barbrn_tbl();
extern void techy_tbl();
extern void entertain_tbl();
extern void wealthy_tbl();
extern void journal_tbl();
extern void lawyer_tbl();
extern void farm_tbl();
extern void solparty_tbl();
extern void lawyer();
extern void techpriest();
extern void gottechpriest();
extern void farm();
extern void entertain();
extern void gotfarm();
extern void gotentertain();
extern int getsel_bigint(int minval, int maxval);
extern void journal();
extern void wealthy();
extern void gotjournal();
extern void gotwealthy();
extern void hlanssai();
extern void psiinst();

#include "chargen.h"

void careers()
{
	char choice;
	
	cascades();
	dfltech();
	if (race == IMPERIAL && pop >= POPHI && psi == 0)
		psiinst();
	if (race != HLANSSAI && race != LLAMIYA)
		precareer();
	if (careernbr == 0)
		getcareer();
	if (race == SOLOMANI)
		altcareer();
	resolvecareer();
	if (terms < 7)
	{
		printf("Do you want to pursue an additional career?\n");
		choice = getche_y_n();
		if (choice == 'Y' || choice == 'y')
		{
			strcpy(prevcareer, career);
			strcpy(prevoffice, office);
			prevcareernbr = careernbr;
			prevrank = rank;
			prevrankeo = rankeo;
			terms = 0;
			career[0] = '\0';
			office[0] = '\0';
			careernbr = 0;
			branch = 0;
			line = 0;
			pickcareer();
			resolvecareer();
		}
	}
}

void resolvecareer()
{
	printf("Career = %s (%d)\n", career, careernbr);
	dfltcareer();
	switch (careernbr)
	{
		case ARMY:
			{
				if (race == SOLOMANI)
					solarmy();
				else
					army();
				break;
			}
		case NAVY:
			{
				if (race == SOLOMANI)
					solnavy();
				else    
					if (race == DARRIAN)
						darnavy();
					else 
						navy();
				break;
			}
		case MARINE:
			{
				if (race == SOLOMANI)
					solmarine();
				else
					marine();
				break;
			}
		case SCOUT: scout(); break;
		case FLYER:
			{
				if (race == IMPERIAL)
					coacc();
				else
					flyer(); 
				break;
			}
		case SAILOR: sailor(); break;
		case COP: cop(); break;
		case DOCTOR: doc(); break;
		case DIPLOMAT: diplomat(); break;
		case BUREAUCRAT: bureaucrat(); break;
		case SCIENTIST:
			{
				if (race == HLANSSAI)
					hlanssai();
				else
					scientist();
				break;
			}
		case NOBLE:
			{
				if (race == DARRIAN)
					darnoble();
				else
					if (race ==ZHODANI)
						zhogov();
					else
						noble();
				break;
			}
		case MERCHANT:
			{
				if (race == SOLOMANI)
					solmerch();
				else
					merchant();
				break;
			}
		case BELTER: belter(); break;
		case PIRATE: pirate(); break;
		case ROGUE: rogue(); break;
		case HUNTER:
			{
				if (race == HLANSSAI)
					hlanssai();
				else
					hunter();
				break;
			}
		case BARBARIAN: barbarian(); break;
		case IRIS:
			{
	      		if (race == SOLOMANI)
					solsec(); 
				else 
					iris();
				break;
			}
		case ZHOGUARD: consularguard(); break;
		case ENTERTAINER: entertain(); break;
		case TECHNOPRIEST: techpriest(); break;
		case JOURNALIST: journal(); break;
		case TECHY: geotechy(); break;
		case LAWYER: lawyer(); break;
		case WEALTHTRAV: wealthy(); break;
		case PARTY: solparty(); break;
		case ZHOPROLES:
			{
				if (race == ZHODANI)
					zhoprole();
				else
					farm(); 
				break;
			}
		default: printf("\nCareer unknown\n");
	}
}


void getcareer()
{
	int choice;

	printf("Career selection can be random or you can try to pick your\n");
	printf("characters career. Do you want to try to pick your characters\n");
	printf("career?");
	choice = getche_y_n();
	if (choice == 'Y' || choice == 'y' || race == HLANSSAI)
		pickcareer();
	else
		randomcareer();
}


void pickcareer()
{
	int choice, max;

	printf("\nWhat type of career do you want?");
	if (prevcareernbr == 0 && race != HLANSSAI)
	{
		printf(" Remember, if you fail\n");
		printf("your enlistment, you will be drafted into the military.");
	}
	if (race == HLANSSAI)
	{
		max = 2;
		printf("\n\n   1. N'tarronth (technical)\n   2. N'rarronchii'a (hunter)\n");
	}
	else
	{
		printf("\n\n   1. military\n   2. government\n   3. civilian\n   4. draft\n\n");
		max = 4;
	}
	choice = getsel_int(1, max);
	if (race == HLANSSAI)
	{
		if (choice == 1)
			gotntarronth();
		if (choice == 2)
			gotntarronchiia();
		return;
	}
	if (choice == 1)
		military();
	else
		if (choice == 2)
			government();
		else
			if (choice == 3)
				civilian();
			else
				trydraft();
	if (careernbr == 0)
		pickcareer();
	return;
}


void gotntarronth()
{
	careernbr = SCIENTIST;
	strncpy(career,"N'tarronth",11);
}


void gotntarronchiia()
{
	careernbr = HUNTER;
	strncpy(career,"N'tarronchii'a",15);
}


void randomcareer()
{
	int  type, roll;

	type = d3();
	if (type == 1)
	{
		roll = d6();
		switch (roll)
		{
		case 1:
			{
				if (tech >= TLPRESTEL)
					tryarmy();
				break;
			}
		case 2:
			{
				if ((tech >= TLPRESTEL) && race != CAFADI)
					trynavy();
				break;
			}
		case 3:
			{
				if ((tech >= TLPRESTEL) && race != CAFADI)
					trymarines();
				break;
			}
		case 4:
			{
				if (tech >= TLEARSTEL)
					tryscouts();
				break;
			}
		case 5:
			{
				if ((tech >= TLIND) && (pop >= POPMID)
					&& (atmos >= ATMTHN))
					tryflyers();
				break;
			}
		case 6:
			{
				if (race == ZHODANI)
					tryzhodguard();
				else
					if (hydro >= HYDWET)
						trysailors();
				break;
			}
		}
	}
	if (type == 2)
	{
		if (race == SOLOMANI || race == IMPERIAL)
			roll = d7();
		else
			roll = d6();
		switch (roll)
		{
		case 1:
			{
				if (tech >= TLIND)
					trycop();
				break;
			}
		case 2:
			{
				if (tech >= TLIND)
					trydoctor();
				else
					trytechpriest();
				break;
			}
		case 3:
			{
				if ((tech >= TLIND) && (law >= LAWLO))
					trydiplomat();
				break;
			}
		case 4:
			{
				if ((law >= LAWLO) && (pop >= POPMID))
					trybureaucrat();
				break;
			}
		case 5:
			{
				if (tech >= TLPRESTEL)
					tryscientist();
				break;
			}
		case 6:
			{
				if (race == SOLOMANI && soc >= 5)
					tryparty();
				else
				{
					if (race == ZHODANI)
						tryzhogov();
					else
						if (race != JONKEREEN && tech >= TLPRESTEL && soc >= 10)
							gotnoble();
				}
				break;
			}
		case 7:
			{
				if (race == SOLOMANI)
					gotsolsec();
				else
					tryiris();
				break;
			}
		}
	}
	if (type == 3)
	{
		roll = d6();
		switch (roll)
		{
		case 1:
			{
				if (tech >= TLEARSTEL)
					trymerchant();
				break;
			}
		case 2:
			{
				if (tech >= TLEARSTEL)
					trybelter();
				break;
			}
		case 3:
			{
				if (tech >= TLEARSTEL)
					trypirate();
				break;
			}
		case 4:
			{
				if (tech >= TLIND)
					tryrogue();
				break;
			}
		case 5:
			{
				if (atmos >= ATMTHN)
					tryhunter();
				break;
			}
		case 6:
			{
				if (race == JONKEREEN || tech == TLPREIND)
					trybarbarian();
				break;
			}
		}
	}
	if (careernbr == 0 && prevcareernbr == 0)
		trydraft();
}


void military()
{
	int choice, max;

	prntupp();
	max = 6;
	printf("Pick the branch of service you want to serve in.\n\n");
	printf("   0. none\n");
	if (tech >= TLPRESTEL)
	{
		if (race != LLAMIYA)
		{
			printf("   1. army (roll 5, end 6+, dex 5+)\n");
			max = 1;
		}
		if (race != CAFADI)
		{
			printf("   2. navy (roll ");
			max = 2;
			if (race == SOLOMANI)
				printf("7, edu 8");
			else
			printf("8, edu 9");
			printf("+, int 8+)\n");
			if (race != LLAMIYA)
			{
				printf("   3. marines (roll 9, str 8+, int 8+)\n");
				max = 3;
			}
		}
	}
	if (tech >= TLEARSTEL)
	{
		printf("   4. scout (roll 7, str 8+, int 6+)\n");
		max = 4;
	}
	if ((tech >= TLIND) && (pop >= POPMID) && (atmos >= ATMTHN))
	{
		if (race == IMPERIAL)
			printf("   5. COACC (roll 6, dex 9+, str 7+\n");
		else
			printf("   5. flyer (roll 6, dex 9+, str 7+\n");
		max = 5;
	}
	if (hydro >= HYDWET)
	{
		printf("   6. sailor (roll 6, str 8+, end 10+)\n");
		max = 6;
	}
	if (race == ZHODANI)
	{
		printf("   7. Zhodani Consular Guard (roll 14, Soc 10+, Psi 9+, str 7+)\n");
		max = 7;
	}
	printf("\nYou are not able to take any missing careers.");
	choice = getsel_int(0, max);
	switch (choice)
	{
	case 0: return;
	case 1:
		{
			if (tech >= TLPRESTEL)
				tryarmy();
			break;
		}
	case 2:
		{
			if (tech >= TLPRESTEL)
				trynavy();
			break;
		}
	case 3:
		{
			if (tech >= TLPRESTEL)
				trymarines();
			break;
		}
	case 4:
		{
			if (tech >= TLEARSTEL)
				tryscouts();
			break;
		}
	case 5:
		{
			if ((tech >= TLIND) && (pop >= POPMID)
				&& (atmos >= ATMTHN))
				tryflyers();
			break;
		}
	case 6:
		{
			if (hydro >= HYDWET)
				trysailors();
			break;
		}
	case 7:
		{
  			tryzhodguard();
			break;
		}
	default:
		{
			printf("Please enter a valid selection!\n");
			military();
			return;
		}
	}
	if (careernbr == 0 && prevcareernbr == 0)
		trydraft();
	return;
}


void tryzhodguard()
{
	int enlist;

	enlist = d12();
	if (soc >= 10)
		enlist += 3;
	if (psi >= 9)
		enlist += 2;
	if (str >= 7)
		enlist++;
	if (enlist < 14 && brownie_points > 0)
		enlist = bp_adj(enlist, 14);
	if (enlist >= 14)
		gotzhodguard();
	else
		failed();
}


void gotzhodguard()
{
	strncpy(career,"Consular Guard",15);
	careernbr = ZHOGUARD;
}


void tryarmy()
{
	int  enlist;

	enlist = d12();
	if (dex >= 5)
		enlist++;
	if (end >= 6)
		enlist += 2;
	if (race == DOLPHINS)
		enlist -= 2;
	if (race == NEWT)
		enlist--;
	if (enlist < 5 && brownie_points > 0)
		enlist = bp_adj(enlist, 5);
	if (enlist >= 5) 
	{
		gotarmy();
		if (race == ZHODANI)
			tryguard();
	}
	else
		failed();
}


void tryguard()
{
	char choice;
	int  roll;

	printf("You have the option to join the Guards. Do you want to?\n");
	choice = getche_y_n();
	if (choice == 'Y' || choice == 'y')
	{
		roll = d12();
		if (psi >= 9)
			roll++;
		if (str >= 7)
			roll += 2;
		if (roll >= 10)
		{
			printf("You are in the Guards!\n");
			line = 1;
		}
		else
		{
			line = 2;
			printf("You failed to get into the Guards.\n");
		}
	}
	else
		line = 2;
	if (soc >= 10)
	{
		rankeo = 'O';
		rank = 0;
	}
}


void trynavy()
{
	int  enlist;

	enlist = d12();
	if (intl >= 8)
		enlist++;
	if (race == DOLPHINS)
		enlist -= 2;
	if (race == ZHODANI)
		enlist--;
	if (edu >= 9 || (race == SOLOMANI && edu >= 8))
		enlist += 2;
	if (race != SOLOMANI && enlist < 8 && brownie_points > 0)
		enlist = bp_adj(enlist, 8);
	if (race == SOLOMANI && enlist < 7 && brownie_points > 0)
		enlist = bp_adj(enlist, 7);
	if (enlist >= 8 || (race == SOLOMANI && enlist >= 7))
	{
		line = 1;
		gotnavy();
		return;
	}
	if (race == SOLOMANI)
		return;
	enlist = d12();
	if (intl >= 8)
		enlist++;
	if (edu >= 9)
		enlist += 2;
	if (race == ZHODANI)
		enlist--;
	if (enlist < 7 && brownie_points > 0)
		enlist = bp_adj(enlist, 7);
	if (enlist >= 7)
	{
		line = 2;
		gotnavy();
		return;
	}
	enlist = d12();
	if (intl >= 8)
		enlist++;
	if (edu >= 9)
		enlist += 2;
	if (race == ZHODANI)
		enlist--;
	if (enlist < 6 && brownie_points > 0)
		enlist = bp_adj(enlist, 6);
	if (enlist >= 6)
	{
		line = 3;
		gotnavy();
		return;
	}
	failed();
}


void trymarines()
{
	int  enlist;

	enlist = d12();
	if (intl >= 8)
		enlist++;
	if (str >= 8)
		enlist += 2;
	if (race == DOLPHINS)
		enlist -= 2;
	if (race == NEWT)
		enlist -= 3;
	if (enlist < 9 && brownie_points > 0)
		enlist = bp_adj(enlist, 9);
	if (enlist >= 9)
		gotmarines();
	else
		failed();
}


void tryscouts()
{
	int  enlist;

	if (col == 0)
	{
		enlist = d12();
		if (race == DOLPHINS)
			enlist++;
		if (race == NEWT)
			enlist++;
		if (intl >= 6)
			enlist++;
		if (str >= 8)
			enlist += 2;
		if (enlist < 7 && brownie_points > 0)
			enlist = bp_adj(enlist, 7);
		if (enlist < 7)
		{
			failed();
			return;
		}
	}
	gotscouts();
}


void tryflyers()
{
	int  enlist;

	enlist = d12();
	if (race == DOLPHINS)
		enlist -= 2;
	if (str >= 7)
		enlist++;
	if (dex >= 9)
		enlist += 2;
	if (enlist < 6 && brownie_points > 0)
		enlist = bp_adj(enlist, 6);
	if (enlist >= 6)
		gotflyer();
	else
		failed();
}


void trysailors()
{
	int  enlist;

	enlist = d12();
	if (end >= 10) enlist++;
	if (str >= 8) enlist += 2;
	if (enlist < 6 && brownie_points > 0) enlist = bp_adj(enlist, 6);
	if (enlist >= 6)
		gotsailor();
	else
		failed();
}


void trydraft()
{
	int roll;

	printf("\nYou have been drafted!\n");
	if (race == JONKEREEN)
	{
		gotbarbarian();
		return;
	}
	if (race == CAFADI)
	{
		gotarmy();
		return;
	}
	if (race == GEONEE)
	{
		trytechy();
		if (careernbr != 0)
			return;
	}
	roll = d6();
	switch (roll)
	{
    case 1: gotarmy(); break;
    case 2: gotnavy(); line = 1; break;
    case 3:
		{
			if (race == ZHODANI)
				gotzhodguard();
			else
				gotmarines();
			break;
		}
    case 4:
		{
			if (race == ZHODANI)
				gotmerch();
			else
				gotscouts();
			break;
		}
    case 5: 
		{
			if (race == ZHODANI)
				gotzhogov();
			else
				gotflyer();
			break;
		}
    case 6:
		{
			if (race == ZHODANI)
				gotzprole();
			else
				gotsailor();
			break;
		}
  }
  if (race == SOLOMANI && roll > 3)
	  gotparty();
}


void government()
{
	int choice, max;

	prntupp();
	max = 6;
	printf("Pick the type of government career you want.\n\n");
	printf("   0. none\n");
	if (tech >= TLIND)
	{
		printf("   1. law enforcement (roll 6, dex 10+, int 7+)\n");   
		if (race != DOLPHINS)
			printf("   2. doctor (roll 9, dex 9+, int 8+)\n");   
		if (law >= LAWLO)
			printf("   3. diplomat (roll 8, soc 9+, edu 8+)\n");
	}
	else
	{
		printf("   3. technical priesthood (roll 7, soc 10+, edu 7+) TNE\n");
	}
	if ((law >= LAWLO) && (pop >= POPMID))
		printf("   4. bureaucrat (roll 5, str 8+, edu 8+)\n");
	if (tech >= TLPRESTEL)
	{
		printf("   5. scientist (roll 6, edu 10+, int 9+)\n");
		if (race == SOLOMANI)
		{
			if (soc >= 5)
				printf("   6. Solomani Party (roll 3, int 7+, edu 7+)\n");
		}
		else
		{
			if (race == ZHODANI)
				printf("   6. Government (roll 7, soc 10+, edu 8+, int 7+)\n");
			else
				if (race != JONKEREEN && soc >= 10)
					printf("   6. noble (automatic)\n");
		}
	}
	if (race == SOLOMANI)
	{
		printf("   7. Solomani Security (automatic)\n");
		max = 7;
	}
	if (race == IMPERIAL 
		&& ((str >= 5 && dex >= 7 && end >= 5 && intl >= 10 && edu >= 10)     
		|| (str >= 8 && dex >= 9 && end >= 8 && intl >= 8 && edu >= 8)
		&& (soc >= 5 && soc <= 10)))
	{
		printf("   7. IRIS (roll 10) Imperial spy from Challenge mag.\n");
		max = 7;
	}
	printf("\nYou are not able to take any missing careers.");
	choice = getsel_int(0, max);
	switch (choice)
	{
	case 0: return;
	case 1:
		{
			if (tech >= TLIND)
				trycop();
			break;
		}
	case 2:
		{
			if (tech >= TLIND && race != DOLPHINS)
				trydoctor();
			break;
		}
	case 3:
		{
			if (tech >= TLIND)
				trydiplomat();
			else
				trytechpriest();
			break;
		}
	case 4:
		{
			if ((law >= LAWLO) && (pop >= POPMID))
				trybureaucrat();
			break;
		}
	case 5:
		{
			if (tech >= TLPRESTEL)
				tryscientist();
			break;
		}
	case 6:
		{
			if (tech >= TLPRESTEL && soc >= 10 
				&& race != JONKEREEN && race != SOLOMANI && race != ZHODANI)
				gotnoble();
			if (soc >= 5 && race == SOLOMANI)
				tryparty();
			if (race == ZHODANI)
				tryzhogov();
			break;
		}
	case 7:
		{
			if (race == SOLOMANI)
				gotsolsec();
			if (race == IMPERIAL
				&& ((str >= 5 && dex >= 7 && end >= 5 && intl >= 10 && edu >= 10)
				|| (str >= 8 && dex >= 9 && end >= 8 && intl >= 8 && edu >= 8))
				&& (soc >= 5 && soc <= 10))
				tryiris();
			break;
		}
	default:
		{
			printf("Please enter a valid selection!\n");
			government();
			return;
		}
	}
	if (careernbr == 0 && prevcareernbr == 0)
		trydraft();
}


void tryparty()
{
	int roll;

	roll = d12() + 1;
	if (edu >= 7)
		roll++;
	if (intl >= 7)
		roll += 2;
	if (roll >= 3)
		gotparty();
	else
		failed();
}


void trycop()
{
	int  enlist;

	enlist = d12();
	if (race == DOLPHINS)
		enlist -= 2;
	if (intl >= 7)
		enlist++;
	if (dex >= 10)
		enlist += 2;
	if (enlist < 6 && brownie_points > 0)
		enlist = bp_adj(enlist, 6);
	if (enlist >= 6)
		gotcop();
	else
		failed();
}


void trydoctor()
{
	int  enlist;

	enlist = d12();
	if (med_sch > 0)
		enlist += 7;
	if (intl >= 8)
		enlist++;
	if (dex >= 9)
		enlist += 2;
	if (enlist < 9 && brownie_points > 0)
		enlist = bp_adj(enlist, 9);
	if (enlist >= 9)
		gotdoc();
	else
		failed();
}


void trydiplomat()
{
	int  enlist;

	enlist = d12();
	if (edu >= 8)
		enlist++;
	if (soc >= 9)
		enlist += 2;
	if (enlist < 8 && brownie_points > 0)
		enlist = bp_adj(enlist, 8);
	if (enlist >= 8)
		gotdiplomat();
	else
		failed();
}


void trybureaucrat()
{
	int  enlist;

	enlist = d12();
	if (race == DOLPHINS)
		enlist--;
	if (edu >= 8)
		enlist++;
	if (str >= 8)
		enlist += 2;
	if (enlist < 5 && brownie_points > 0)
		enlist = bp_adj(enlist, 5);
	if (enlist >= 5)
		gotbureaucrat();
	else
		failed();
}


void trytechpriest()
{
	int  enlist;

	enlist = d12();
	if (edu >= 7)
		enlist++;
	if (soc >= 10)
		enlist += 2;
	if (enlist < 8 && brownie_points > 0)
		enlist = bp_adj(enlist, 8);
	if (enlist >= 8)
		gottechpriest();
	else
		failed();
}


void tryzhogov()
{
	int  enlist;

	enlist = d12();
	if (intl >= 7)
		enlist++;
	if (edu >= 8)
		enlist += 2;
	if (soc >= 10)
		enlist += 3;
	if (enlist < 7 && brownie_points > 0)
		enlist = bp_adj(enlist, 7);
	if (enlist >= 7)
		gotzhogov();
	else
		failed();
}


void gotzhogov()
{
	careernbr = ZHOGOVT;
	strncpy(career,"Government",11);
}


void tryscientist()
{
	int  enlist;

	enlist = d12();
	if (race == DOLPHINS) enlist++;
	if (intl >= 9) enlist++;
	if (edu >= 10) enlist += 2;
	if (col != HONORS && grad_sch == 0 && enlist < 6 && brownie_points > 0)
		enlist = bp_adj(enlist, 6);
	if (col == HONORS || grad_sch >= GRADUATED || enlist >= 6) gotscient();
	else failed();
}


void civilian()
{
  int choice, max;

  prntupp();
  max = 0;
  printf("Pick the civilian career you want to follow.\n\n");
  printf("   0. none\n");
  if (tech >= TLEARSTEL && race != DOLPHINS)
  {
    printf("   1. merchant (");
	max = 1;
    if (race == SOLOMANI)
		printf("roll 7, str 8+, edu 8+");
    else
		if (race == ZHODANI)
			printf("roll 8, edu 6+, int 6+, str 7+");
		else
			printf("based on line");
    printf(")\n");
  }
  if (tech >= TLEARSTEL)
  {
	  printf("   2. belter (roll 8, int 6+, dex 9+)\n");
	  max = 2;
  }
  if (tech >= TLEARSTEL && race != DOLPHINS && race != NEWT)
  {
	  printf("   3. pirate (roll 7, end 9+, soc 7-)\n");
	  max = 3;
  }
  if (tech >= TLIND && race != NEWT)
  {
	  printf("   4. rogue (roll 6, end 7+, soc 8-)\n");
	  max = 4;
  }
  if (atmos >= ATMTHN && race != DOLPHINS)
  {
	  printf("   5. hunter (roll 9, end 9+, dex 10+)\n");
	  max = 5;
  }
  if (race == JONKEREEN || tech == TLPREIND)
  {
	  printf("   6. barbarian (roll 5, str 10+, end 9+)\n");
	  max = 6;
  }
  if (race == GEONEE)
  {
	  printf("   6. technician (roll 8, dex 8+, int 8+) from Geonee\n");
	  max = 6;
  }
  if (race == ZHODANI && soc < 10)
  {
	  printf("   6. Prole (roll 3, edu 7+, dex 8+) Zhodani peasant\n");
	  max = 6;
  }
  if (race != ZHODANI && race != SOLOMANI && race != DOLPHINS)
  {
	  printf("   7. Entertainer (roll 8, soc 8+, intl 7+) from TNE\n");
	  printf("   8. Farmer (roll 5, end 6+, dex 7+) from TNE\n");
	  max = 8;
	  if (tech >= TLIND)
	  {
		  printf("   9. Journalist (roll 7, edu 10+, int 9+) from TNE\n");
		  max = 9;
	  }
	  if (soc >= 9)
	  {
		  printf("   10. Wealthy Traveller (roll 6, soc 11+, edu 7+) from TNE\n");
		  max = 10;
	  }
	  if (law_sch > 0)
	  {
		  printf("   11. Attorney (automatic) from TNE\n");
		  max = 11;
	  }
  }
  printf("\nYou are not able to take any missing careers.");
  if (max < 10) choice = getsel_int(0, max);
  else choice = getsel_bigint(0, max);
  switch (choice)
  {
  case 0: return;
  case 1:
	  {
		  if (tech >= TLEARSTEL) trymerchant();
		  break;
	  }
  case 2:
	  {
		  if (tech >= TLEARSTEL) trybelter();
		  break;
	  }
  case 3:
	  {
		  if (tech >= TLEARSTEL) trypirate();
		  break;
	  }
  case 4:
	  {
		  if (tech >= TLIND) tryrogue();
		  break;
	  }
  case 5:
	  {
		  if (atmos >= ATMTHN && race != DOLPHINS) tryhunter();
		  break;
	  }
  case 6:
	  {
		  if (race == JONKEREEN || tech == TLPREIND)
			  trybarbarian();
		  if (race == GEONEE)
			  trytechy();
		  if (race == ZHODANI && soc < 10)
			  tryzprole();
		  break;
	  }
  case 7: tryentertain(); break;
  case 8: tryfarm(); break;
  case 9: tryjournal(); break;
  case 10: trywealthy(); break;
  case 11:
	  {
		  if (law_sch > 0) gotlawyer();
		  break;
	  }
  }
  if (careernbr == 0 && prevcareernbr == 0) trydraft();
}


void trypirate()
{
  int  enlist;

  enlist = d12();
  if (soc <= 7) enlist++;
  if (end >= 9) enlist += 2;
  if (enlist < 7 && brownie_points > 0) enlist = bp_adj(enlist, 7);
  if (enlist >= 7)
	  gotpirate();
  else 
	  failed();
}


void tryrogue()
{
  int  enlist;

  enlist = d12();
  if (race == DOLPHINS) enlist--;
  if (soc <= 8) enlist++;
  if (end >= 7) enlist += 2;
  if (enlist < 6 && brownie_points > 0) enlist = bp_adj(enlist, 6);
  if (enlist >= 6)
	  gotrogue();
  else
	  failed();
}


void tryhunter()
{
  int  enlist;

  enlist = d12();
  if (dex >= 10) enlist++;
  if (end >= 9) enlist += 2;
  if (enlist < 9 && brownie_points > 0) enlist = bp_adj(enlist, 9);
  if (enlist >= 9)
	  gothunter();
  else
	  failed();
}


void trybarbarian()
{
  int  enlist;

  enlist = d12();
  if (end >= 9) enlist++;
  if (str >= 10) enlist += 2;
  if (enlist < 5 && brownie_points > 0) enlist = bp_adj(enlist, 5);
  if (enlist >= 5)
	  gotbarbarian();
  else
	  failed();
}


void trytechy()
{
  int  enlist;

  enlist = d12();
  if (dex >= 8) enlist += 2;
  if (intl >= 8) enlist++;
  if (enlist < 8 && brownie_points > 0) enlist = bp_adj(enlist, 5);
  if (enlist >= 8)
	  gottechy();
  else
	  failed();
}


void tryzprole()
{
  int  enlist;

  enlist = d12();
  if (edu >= 7) enlist += 2;
  if (dex >= 8) enlist++;
  if (enlist < 3 && brownie_points > 0) enlist = bp_adj(enlist, 3);
  if (enlist >= 3)
	  gotzprole();
  else
	  failed();
}


void tryentertain()
{
  int  enlist;

  enlist = d12();
  if (soc >= 8) enlist += 2;
  if (intl >= 7) enlist++;
  if (enlist < 8 && brownie_points > 0) enlist = bp_adj(enlist, 8);
  if (enlist >= 8)
	  gotentertain();
  else
	  failed();
}


void tryfarm()
{
  int  enlist;

  enlist = d12();
  if (end >= 6) enlist += 2;
  if (dex >= 7) enlist++;
  if (enlist < 5 && brownie_points > 0) enlist = bp_adj(enlist, 5);
  if (enlist >= 5)
	  gotfarm();
  else
	  failed();
}


void tryjournal()
{
  int  enlist;

  if (col >= 1)
  {
	  gotjournal();
	  return;
  }
  enlist = d12();
  if (edu >= 10) enlist += 2;
  if (intl >= 9) enlist++;
  if (enlist < 7 && brownie_points > 0) enlist = bp_adj(enlist, 7);
  if (enlist >= 7)
	  gotjournal();
  else
	  failed();
}


void trywealthy()
{
  int  enlist;

  enlist = d12();
  if (soc >= 11) enlist += 2;
  if (edu >= 7) enlist++;
  if (enlist < 6 && brownie_points > 0) enlist = bp_adj(enlist, 6);
  if (enlist >= 6)
	  gotwealthy();
  else 
	  failed();
}


void gotzprole()
{
  careernbr = ZHOPROLES;
  strncpy(career,"Prole",6);
}


void altcareer()
{
  if (careernbr == SOLSEC) solsec_spcl();
  else if (careernbr > SAILOR) homeguard();
}


void homeguard()
{
  int choice, max;

  printf("You have the option of joining the Solomani Home Guard.\n");
  printf("Please indicate whether you wish to do so.\n\n");
  printf("   1. do not join the home guard\n   2. join the navy home guard\n");
  max = 2;
  if (careernbr != MERCHANT)
  {
	  printf("   3. join the army home guard\n");
	  max = 3;
  }
  choice = getsel_int(1, max);
  if (choice == 3)
  {
    alt_career = LANDGUARD;
    printf("You are in the army home guard.\n");
    hmgdarmy();
  }
  if (choice == 2)
  {
    alt_career = SPACEGUARD;
    printf("You are in the navy home guard.\n");
    hmgdnavy();
  }
}


void solsec_spcl()
{
  int roll;
  roll = d6();
  if (roll <= 2) branch = 1;
  else
  {
    if (roll <= 4) branch = 2;
    else branch = 3;
  }
  solsecbranch(branch);
  printf("You are a SolSec %s\n", office);
  solsecalt_career();
}


void solsecbranch(int brnch)
{
  switch (brnch) {
    case 1: strncpy(office, "open agent", 11); break;
    case 2: strncpy(office, "secret agent", 13); break;
    case 3: strncpy(office, "monitor", 8); break;
    case 4: strncpy(office, "administrator", 14); break;
    default: strncpy(office, "unknown", 8); break;
  }
}


void solsecalt_career()
{
  int choice;

  if (branch == 1) return;
  printf("Pick the career area where you will work.\n\n");
  printf("   1. military\n   2. government\n   3. civilian\n\n");
  choice = getsel_int(1, 3);
  if (choice == 1) solsecmil();
  if (choice == 2) solsecgov();
  if (choice == 3) solsecciv();
  strcat(career, "(");
  strcat(career, alt_careername);
  strcat(career, ")");
}

extern int duty, assignment;

void solsecmil()
{
  int choice;

  printf("Pick themilitary service you will spy on.\n\n");
  printf("   1. army\n   2. navy\n   3. marines\n   4. scouts\n   5. flyers\n   6. sailors\n");
  choice = getsel_int(1, 6);
  switch (choice)
  {
    case 1:
		{
			alt_career = ARMY;
			strncpy(alt_careername, "army", 5);
			break;
		}
    case 2:
		{
			alt_career = NAVY;
			strncpy(alt_careername, "navy", 5);
			break;
		}
    case 3:
		{
			alt_career = MARINE;
			strncpy(alt_careername, "marines", 8);
			break;
		}
    case 4:
		{
			alt_career = SCOUT;
			strncpy(alt_careername, "scouts", 7);
			break;
		}
    case 5:
		{
			alt_career = FLYER;
			strncpy(alt_careername, "flyers", 7);
			break;
		}
    case 6:
		{
			alt_career = SAILOR;
			strncpy(alt_careername, "sailors", 8);
			break;
		}
  }
}


void solsecgov()
{
  int choice;

  printf("Pick the government service you will spy on.\n\n");
  printf("   1. law enforcement\n   2. medical\n   3. diplomatic\n");
  printf("   4. bureaucratic\n   5. scientific\n   6. solomani party\n");
  choice = getsel_int(1, 6);
  switch (choice) {
    case 1:
		{
			alt_career = COP;
			strncpy(alt_careername, "police", 7);
			break;
		}
    case 2:
		{
			alt_career = DOCTOR;
			strncpy(alt_careername, "medical", 8);
			break;
		}
    case 3:
		{
			alt_career = DIPLOMAT;
			strncpy(alt_careername, "diplomatic", 10);
			break;
		}
    case 4:
		{
			alt_career = BUREAUCRAT;
			strncpy(alt_careername, "bureaucracy", 12);
			break;
		}
    case 5: 
		{
			alt_career = SCIENTIST;
			strncpy(alt_careername, "scientist", 10);
			duty = 2;
			assignment = d6();
			break;
		}
    case 6:
		{
			alt_career = PARTY;
			strncpy(alt_careername, "party", 6);
			break;
		}
  }
}


void solsecciv()
{
  int choice;

  printf("Pick the civilian group you will spy on.\n\n");
  printf("   1. merchants\n   2. belters\n   3. pirates\n");
  printf("   4. rogues\n   5. hunters\n   6. barbarians\n");
  printf("   7. entertainer\n   8. lawyer\n   9. journalist\n");
  choice = getsel_int(1, 9);
  switch (choice)
  {
    case 1:
		{
			alt_career = MERCHANT;
			strncpy(alt_careername, "merchants", 10);
			break;
		}
    case 2:
		{
			alt_career = BELTER;
			strncpy(alt_careername, "belter", 7);
			break;
		}
    case 3:
		{
			alt_career = PIRATE;
			strncpy(alt_careername, "pirates", 8);
			line = 1;
			break;
		}
    case 4:
		{
			alt_career = ROGUE;
			strncpy(alt_careername, "rogues", 7);
			break;
		}
    case 5:
		{
			alt_career = HUNTER;
			strncpy(alt_careername, "hunters", 8);
			break;
		}
    case 6:
		{
			alt_career = BARBARIAN;
			strncpy(alt_careername, "barbarians", 11);
			break;
		}
    case 7:
		{
			alt_career = ENTERTAINER;
			strncpy(alt_careername, "entertainer", 12);
			break;
		}
    case 8:
		{
			alt_career = LAWYER;
			strncpy(alt_careername, "lawyer", 7);
			break;
		}
    case 9:
		{
			alt_career = JOURNALIST;
			strncpy(alt_careername, "journalist", 11);
			break;
		}
  }
}


void altcareertbl()
{
  int roll = d6();

  printf("\nAlt Career Table\n");
  switch (alt_career)
  {
    case ARMY: solarmy_tbl(roll); break;
    case NAVY: solnavy_tbl(roll); break;
    case MARINE: solmarine_tbl(roll); break;
    case SCOUT: sc_ofc(d7()); break;
    case FLYER: flyer_tbl(roll); break;
    case SAILOR: sailor_tbl(roll); break;
    case COP: cop_tbl(roll); break;
    case DOCTOR: doc_tbl(roll); break;
    case DIPLOMAT: diplomat_tbl(roll); break;
    case BUREAUCRAT: bureau_tbl(roll); break;
    case SCIENTIST: sci_gen_skl(); break;
    case MERCHANT: solmerch_tbl(roll); break;
    case BELTER: belter_tbl(roll); break;
    case PIRATE: pirate_tbl(roll); break;
    case ROGUE: rogue_tbl(roll); break;
    case HUNTER: hunter_tbl(roll); break;
    case BARBARIAN: barbrn_tbl(roll); break;
    case LANDGUARD: hmgdarmy(roll); break;
    case SPACEGUARD: hmgdnavy(roll); break;
    case TECHY: techy_tbl(roll); break;
    case ENTERTAINER: entertain_tbl(roll); break;
    case WEALTHTRAV: wealthy_tbl(roll); break;
    case JOURNALIST: journal_tbl(roll); break;
    case LAWYER: lawyer_tbl(roll); break;
    case FARMER: farm_tbl(roll); break;
    case PARTY: solparty_tbl(roll); break;
	default: printf("Bad alt_career %d\n", alt_career);
  }
}
