/* MERCHANT.C develops merchant prince character's personal history */

#include <stdio.h>

void merchant();
long mer_cash();
void merchantbene();
int mer_asgn();
int small_asgn(int roll);
int free_asgn(int roll);
void adj_engr();
void adj_purs();
void adj_adm();
void adj_sales();
void mer_route();
void mer_charter();
void mer_explore();
void mer_speculate();
void mer_bonus();

extern int mer_doterms();
extern int basic_cash();
extern int merchantmot();
extern int basic_bene();
extern int d12();
extern int mer_set_branch();
extern void mer_get_branch();
extern void bumpintl();
extern void bumpedu();
extern int chk_skl(int skill, int skl_val);
extern int bp_spcl_duty(int roll);
extern void mer_spcl_duty();
extern int ask_adj_asgn(int roll);
extern void mot_lopsg();
extern void mot_ship();
extern void mot_weapon();

#include "chargen.h"

extern int mer_anag, mer_cross[7], position;

void merchant()
{
  int i;

  for (i = 1; i <= 6; i++) mer_cross[i] = 0;
  mer_get_branch();
  while (mer_doterms() == 0);
  if (line == 6 && rankeo == 'O' && rank >= 6) ship++;
  terms -= anagathics;
  merchantmot(terms);
}

long mer_cash()
{
  int roll;
  long cr;

  roll = basic_cash();
  switch (roll)
  {
    case 1: cr = 1000; break;
    case 2: cr = 5000; break;
    case 3: cr = 10000; break;
    case 4: cr = 10000; break;
    case 5: cr = 10000; break;
    case 6: cr = 20000; break;
    case 7: cr = 50000; break;
  }
  printf("Got %ld credits.\n", cr);
  return (cr);
}


void merchantbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpintl(); break;
    case 3: mot_weapon(); break;
    case 4: mot_weapon(); break;
    case 5: bumpedu(); bumpedu(); break;
    case 6: mot_lopsg(); break;
    case 7: mot_ship(); break;
  }
}

/* skill tables for merchant characters */

int mer_asgn()
{
  int roll, asgnmt;

  roll = d12();
  if (line == 6) return free_asgn(roll);
  if (edu <= 6) roll--;
  if (rankeo == 'O' && rank >= 4) roll++;
  if (line >= 3) return small_asgn(roll);
  /* increase chances for special duty */
  if (pick == 1 && brownie_points > 0)
	  roll = ask_adj_asgn(roll);
  else
  {
	  if (pick == 4)
		  roll = bp_spcl_duty(roll);
  }
  if (roll <= 2)
  {
    line++;
    printf("You were transfered down.\n");
    return mer_asgn();
  }
  if (roll <= 8)
  {
    mer_route();
    asgnmt = 1;
  }
  if (roll == 9)
  {
    mer_charter();
    asgnmt = 2;
  }
  if (roll == 10)
  {
    mer_speculate();
    asgnmt = 4;
  }
  if (roll == 11)
  {
    mer_explore();
    asgnmt = 3;
  }
  if (roll >= 12)
  {
    surv = skil = decor = 0;
	mer_spcl_duty();
    asgnmt = 5;
  }
  switch (branch)
  {
    case 1: break;
    case 2: adj_engr(); break;
    case 3: adj_purs(); break;
    case 4: adj_adm(); break;
    case 5: adj_sales(); break;
  }
  return asgnmt;
}


int small_asgn(int roll)
{
  int asgnmt;

  /* increase chances for special duty */
  if (pick == 1 && brownie_points > 0)
	  roll = ask_adj_asgn(roll);
  else
  {
	  if (pick == 4)
		  roll = bp_spcl_duty(roll);
  }
  if (roll <= 2)
  {
    line++;
    printf("You were transfered down.\n");
    if (line == 6)
	{ 
      branch = 6;
      if (rankeo == 'O' && rank == 0) rank++;
    }
    return mer_asgn();
  }
  if (roll <= 6)
  {
    mer_route();
    asgnmt = 1;
  }
  if (roll == 7)
  {
    mer_charter();
    asgnmt = 2;
  }
  if (roll == 8 || roll == 9)
  {
    mer_speculate();
    asgnmt = 4;
  }
  if (roll == 10 || roll == 11)
  {
    mer_explore();
    asgnmt = 3;
  }
  if (roll == 12)
  {
    surv = 0;
    skil = 0;
    decor = 0;
    asgnmt = 5;
	mer_spcl_duty();
  }
  if (roll >= 13)
  {
    line--;
    printf("You were transfered up.\n");
    return mer_asgn();
  }
  switch (branch)
  {
    case 1: break;
    case 2: adj_engr(); break;
    case 3: adj_purs(); break;
    case 4: adj_adm(); break;
    case 5: adj_sales(); break;
  }
  return asgnmt;
}


int free_asgn(int roll)
{
  int asgnmt, qual;

  if (soc <= 5) roll++;
  if (pick == 1 && brownie_points > 0)
	  roll = ask_adj_asgn(roll);
  else
  {
	  if (pick == 4)
	  {
		  if (roll == 3 && brownie_points > 3)
		  {
			  roll = 2;
			  brownie_points--;
			  printf("You used 1 brownie point to get transfered up.\n");
		  }
		  if ((roll == 6 || roll == 8) && brownie_points > 3)
		  {
			  roll--;
			  brownie_points--;
			  printf("You used 1 brownie point to get a route assignment.\n");
		  }
	  }
  }
  if (roll <= 2)
  {
    line--;
    printf("You were transfered up.\n");
    branch = mer_set_branch();
    return mer_asgn();
  }
  if (roll == 3 || roll == 5 || roll == 7)
  {
    mer_route();
    asgnmt = 1;
  }
  if (roll == 9)
  {
    mer_charter();
    asgnmt = 2;
  }
  if (roll == 10)
  {
    mer_speculate();
    asgnmt = 4;
  }
  if (roll == 4 || roll == 11)
  {
    mer_explore();
    asgnmt = 3;
  }
  if (roll == 6 || roll == 8)
  {
    if (rankeo == 'O' && rank >= 6) return free_asgn(d12());
    asgnmt = 8;
    printf("You found no business.\n");
    surv = 3;
    skil = 3;
    decor = 0;
  }
  if (roll == 12)
  {
    surv = 6;
    skil = 6;
    decor = 6;
    asgnmt = 6;
    printf("You were smuggling.\n");
  }
  if (roll == 13)
  {
    surv = 7;
    skil = 4;
    decor = 5;
    asgnmt = 7;
    printf("You were engaged in piracy.\n");
  }
  qual = chk_skl(PILOT, 2);
  if (qual != 0 && surv != 0) surv--;
  qual = chk_skl(TRADER, 2);
  if (qual != 0 && decor != 0) decor--;
  return asgnmt;
}


void adj_engr()
{
  int qual;

  qual = chk_skl(ENGINEERING, 2);
  if (qual == 0) qual = chk_skl(MECHANICAL, 2);
  if (qual == 0) qual = chk_skl(ELECTRONICS, 2);
  if (qual == 0) qual = chk_skl(ADMIN, 2);
  if (qual == 0) qual = chk_skl(GRAVITICS, 2);
  if (qual != 0 && surv != 0) surv--;
}


void adj_purs()
{
  int qual;

  qual = chk_skl(STEWARD, 2);
  if (qual != 0 && decor != 0) decor--;
}


void adj_adm()
{
  int qual;

  qual = chk_skl(ADMIN, 2);
  if (qual == 0) qual = chk_skl(STREETWISE, 2);
  if (qual == 0) qual = chk_skl(BRIBERY, 2);
  if (qual == 0) qual = chk_skl(LIAISON, 2);
  if (qual != 0 && surv != 0) surv--;
  if (qual != 0 && skil != 0) skil--;
  if (qual != 0 && decor != 0) decor--;
}


void adj_sales()
{
  int qual;

  qual = chk_skl(PILOT, 2);
  if (qual != 0 && surv != 0) surv--;
  qual = chk_skl(TRADER, 2);
  if (qual == 0) qual = chk_skl(BROKER, 2);
  if (qual != 0 && decor != 0) decor--;
}


void mer_route()
{
  skil = 7;
  surv = 0;
  decor = 0;
  switch (branch)
  {
    case 1: break;
    case 2: break;
    case 3: skil = 6; break;
    case 4: skil = 6; break;
    case 5: break;
    default: surv = 3; decor = 11; break;
  }
  printf("You got a route assignment.\n");
}


void mer_charter()
{
  skil = 6;
  surv = 0;
  decor = 0;
  switch (branch)
  {
    case 1: skil = 7; surv = 3; break;
    case 2: break;
    case 3: skil = 5; break;
    case 4: skil = 5; break;
    case 5: decor = 11; break;
    default: surv = 4; decor = 10; break;
  }
  printf("You got a charter assignment.\n");
}


void mer_explore()
{
  skil = 5;
  surv = 4;
  decor = 12;
  switch (branch)
  {
    case 1: decor = 11; break;
    case 2: break;
    case 3: skil = 8; surv = 3; break;
    case 4: skil = 8; surv = 3; break;
    case 5: decor = 10; break;
    default: surv = 5; decor = 8; break;
  }
  printf("You got a exploratory assignment.\n");
}


void mer_speculate()
{
  skil = 6;
  surv = 3;
  decor = 11;
  switch (branch)
  {
    case 1: decor = 12; break;
    case 2: break;
    case 3: skil = 7; surv = 0; break;
    case 4: skil = 7; break;
    case 5: skil = 5; decor = 8; break;
    default: skil = 5; surv = 5; decor = 7; break;
  }
  printf("You got a speculative assignment.\n");
}


void mer_bonus()
{
  int roll;
  long bonus;

  roll = d12();
  if (roll >= decor)
  {
    bonus = (mer_cash()) / 2;
    printf("You received a %ld credit bonus on this assignment.\n",
      bonus);
    credits += bonus;
  }
}
