/* KREBENNY.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void krebenny();
void merchcash(int roll);
void techcash(int roll);
void govtcash(int roll);
void admincash(int roll);
void merchbene(int roll);
void techbene(int roll);
void govtbene(int roll);
void adminbene(int roll);
int kre_cash();
int kre_bene();
void mot_famskill();
void mot_famguns();
void mot_famtools();
void mot_famarms();

extern char getche_mot();
extern void bumpintl();
extern void bumpedu();
extern void bumpsoc();
extern int d6();
extern int find_skl(int skill);
extern void mot_cash(int amt);
extern void mot_ship();

#include "chargen.h"

void krebenny()
{
  int choice, roll;
  
  choice = getche_mot();
  if (choice == 'C' || choice == 'c')
  {
    roll = kre_cash();
    switch (careernbr)
	{
      case BUREAUCRAT: govtcash(roll); break;
      case MERCHANT: merchcash(roll); break;
      case MANAGEMENT: admincash(roll); break;
      case SCIENTIST: techcash(roll); break;
    }
  }
  else
  {
      roll = kre_cash();
      switch (careernbr)
	  {
        case BUREAUCRAT: govtbene(roll); break;
        case MERCHANT: merchbene(roll); break;
        case MANAGEMENT: adminbene(roll); break;
        case SCIENTIST: techbene(roll); break;
      }
  }
}


void merchcash(int roll)
{
  int amt;

  amt = 0;
  switch (roll)
  {
      case 1: amt = 1000; break;
      case 2: amt = 5000; break;
      case 3: amt = 10000; break;
      case 4: amt = 20000; break;
      case 5: amt = 20000; break;
      case 6: amt = 30000; break;
      case 7: amt = 50000; break;
  }
  mot_cash(amt);
}


void techcash(int roll)
{
  int amt;

  amt = 0;
  switch (roll)
  {
      case 1: amt = 1000; break;
      case 2: amt = 1000; break;
      case 3: amt = 5000; break;
      case 4: amt = 10000; break;
      case 5: amt = 10000; break;
      case 6: amt = 20000; break;
      case 7: amt = 30000; break;
  }
  mot_cash(amt);
}


void govtcash(int roll)
{
  int amt;

  amt = 0;
  switch (roll)
  {
      case 1: amt = 5000; break;
      case 2: amt = 10000; break;
      case 3: amt = 10000; break;
      case 4: amt = 20000; break;
      case 5: amt = 20000; break;
      case 6: amt = 20000; break;
      case 7: amt = 40000; break;
  }
  mot_cash(amt);
}


void admincash(int roll)
{
  int amt;

  amt = 0;
  switch (roll)
  {
      case 1: amt = 5000; break;
      case 2: amt = 10000; break;
      case 3: amt = 10000; break;
      case 4: amt = 10000; break;
      case 5: amt = 20000; break;
      case 6: amt = 20000; break;
      case 7: amt = 50000; break;
  }
  mot_cash(amt);
}


void govtbene(int roll)
{
  switch (roll)
  {
    case 0: mot_famskill(); break;
    case 1: mot_famskill(); break;
    case 2: bumpintl(); break;
    case 3: bumpedu(); break;
    case 4: mot_famguns(); break;
    case 5: mot_famarms(); break;
    case 6: bumpsoc(); bumpsoc(); break;
    case 7: mot_ship(); break;
  }
}


void adminbene(int roll)
{
  switch (roll)
  {
    case 0: mot_famskill(); break;
    case 1: mot_famskill(); break;
    case 2: bumpintl(); break;
    case 3: bumpedu(); break;
    case 4: mot_famguns(); break;
    case 5: mot_famarms(); break;
    case 6: bumpsoc(); break;
    case 7: bumpsoc(); bumpsoc(); break;
  }
}


void techbene(int roll)
{
  switch (roll)
  {
    case 0: mot_famskill(); break;
    case 1: mot_famskill(); break;
    case 2: bumpintl(); break;
    case 3: bumpedu(); break;
    case 4: mot_famguns(); break;
    case 5: mot_famarms(); break;
    case 6: mot_famtools(); break;
    case 7: bumpsoc(); bumpsoc(); break;
  }
}


void merchbene(int roll)
{
  switch (roll)
  {
    case 0: mot_famskill(); break;
    case 1: mot_famskill(); break;
    case 2: bumpintl(); break;
    case 3: bumpedu(); break;
    case 4: mot_famguns(); break;
    case 5: mot_famarms(); break;
    case 6: bumpsoc(); bumpsoc(); break;
    case 7: mot_ship(); break;
  }
}


int kre_cash()
{
  int  roll;

  roll = d6();
  roll += (find_skl(GAMBLING));
  return roll;
}


int kre_bene()
{
  int  roll;

  roll = d6();
  if (alt_career == 1)
  {
     roll--;
  }
  else
  {
     roll++;
  }
  return roll;
}


void mot_famskill()
{
	printf("You got Family Skills.\n");
	lopsg++;
}


void mot_famguns()
{
	printf("You got Family Guns.\n");
	weapons++;
}


void mot_famtools()
{
	printf("You got Family Tools.\n");
	kit++;
}


void mot_famarms()
{
	printf("You got Family Polearms.\n");
	midpsg++;
}
