/* KRECARER.C is part of the MegaTraveller (C) character generation */
/* program. It is used to select the K'kree characters career. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void careers();
void getcareer();
void krepickcareer();
void krerandcareer();
void kresurface();
void krespace();
void kreadmin();
void kretech();
void kretrader();
void kregovt();
void krelaborer();
void kreworker();
int krepicktable();
void altcareertbl();

extern void cascades();
extern void background();
extern void dfltech();
extern void dfltcareer();
extern void kresurf();
extern void krefleet();
extern void kregovern();
extern void kretechy();
extern void kretradr();
extern void kreworkr();
extern void krewife();
extern void kreadm();
extern void krelabor();
extern void girugkagh();
extern char getche_y_n();
extern int d3();
extern int d6();
extern int getsel_int(int min, int max);

#include "chargen.h"

void careers()
{
  cascades();
  dfltech();
  background();
  if (careernbr == 0) getcareer();
  printf("Career = %s (%d)\n", career, careernbr);
  dfltcareer();
  switch (careernbr) {
    case ARMY: kresurf(); break;
    case NAVY: krefleet(); break;
    case BUREAUCRAT: kregovern(); break;
    case SCIENTIST: kretechy();
    case MERCHANT: kretradr(); break;
    case MANAGEMENT: kreadm(); break;
    case WORKER: kreworkr(); break;
    case LABORER:
		{
	      if (sex == 2) krewife(); 
		  else
			  if (race == GIRUGKAGH) girugkagh();
			  else
				  krelabor();
	      break;
		}
    default: printf("\nCareer unknown\n");
  }
}


void getcareer()
{
  int choice;

  age = 20;
  appearent_age = age;
  if (race == GIRUGKAGH)
  {
	  age = age - 2;
	  appearent_age = age;
	  careernbr = LABORER;
	  strncpy(career,"translator",11);
	  terms = d6();
	  printf("\nWhat kind of party will you serve as translator?\n");
	  printf("   1. diplomatic party\n   2. merchant party\n");
	  choice = getsel_int(1, 2);
	  line = choice + 3;
	  return;
  }
  printf("Career selection can be random or you can try to pick your\n");
  printf("characters career. Do you want to try to pick your characters\n");
  printf("career?");
  choice = getche_y_n();
  if (choice == 'Y' || choice == 'y')
  {
	  krepickcareer();
  }
  else
  {
      krerandcareer();
  }
}


void krepickcareer()
{
  int choice;

  if (sex == 2)
  {
    careernbr = 30;
    if (line == 1) strncpy(career,"patriarch's wife",17); 
    else strncpy(career,"wife",5);
    terms = d6();
    return;
  }
  printf("\nWhat career do you want?\n\n");
  printf("   1. pick one at random\n");
  printf("   2. surface warrior\n   3. space warrior\n");
  if (line == 1) printf("   4. government\n   5. administrative\n");
  if (line == 2) printf("   4. trader\n   5. technician\n");
  if (line == 3) printf("   4. laborer\n   5. worker\n");
  choice = getsel_int(1, 5);
  switch (choice)
  {
    case 1: krerandcareer(); break;
    case 2: kresurface(); break;
    case 3: krespace(); break;
    case 4:
		{
	        if (line == 1) kregovt();
		    else
			{
			  if (line == 2) kretrader();
			  else krelaborer();
		    }
		    break;
	    }
    case 5:
		{
	        if (line == 1) kreadmin();
		    else
			{
			  if (line == 2) kretech();
			  else kreworker();
		    }
	        break;
	    }
  }
  if (branch == 2) terms = d6() - 3;
  else terms = d6() + 1;
  if (terms < 1) terms = 1;
  printf("You got %d terms.\n", terms);
}


void krerandcareer()
{
  int  roll;

  roll = rand() % 4;
  if (roll == 0) krespace();
  else
  {
    if (roll == 1) kresurface();
    else
	{
      if (roll == 2)
	  {
        if (line == 1) kregovt();
        else
		{
          if (line == 2) kretech();
          else kreworker();
        }
      }
	  else 
	  {
        if (roll == 3)
		{
          if (line == 1) kreadmin();
          else
		  {
            if (line == 2) kretrader();
            else krelaborer();
          }
        }
      }
    }
  }
}


void kresurface()
{
  strncpy(career,"surface warrior",16);
  careernbr = ARMY;
}


void krespace()
{
  strncpy(career,"space warrior",14);
  careernbr = NAVY;
}


void kretrader()
{
  strncpy(career,"trader",7);
  careernbr = MERCHANT;
}


void kretech()
{
  strncpy(career,"technician",12);
  careernbr = SCIENTIST;
}


void kreadmin()
{
  strncpy(career,"administrative",15);
  careernbr = MANAGEMENT;
}


void kregovt()
{
  strncpy(career,"government",11);
  careernbr = BUREAUCRAT;
}


void krelaborer()
{
  strncpy(career,"laborer",8);
  careernbr = LABORER;
}


void kreworker()
{
  strncpy(career,"worker",8);
  careernbr = WORKER;
}


int krepicktable()
{
  int choice;

  if (pick > 2) return (d3());
  printf("\nWhich table do you wish to take your new skill on?\n\n");
  printf("   1. personal development table\n   2. general skills table\n");
  printf("   3. specialty skills table\n");
  choice = getsel_int(1, 3);
  return choice;
}


void altcareertbl()
{
}