/* KREMERC.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void kresurf();
int kremerc_doterms();
void kremerc_get_branch();
int kremerc_set_branch();
void kremerc_do_initial();
void kremerc_branch(int branch_nbr);
int kremerc_do_year();
void kremerc_branch_tbl(int brnch);
void kremerc_nco();
int kreliferoll();
void kremerc_cmd_off();
void krearmy_life();
void kremerc_inf();
int kremosroll();
void kremerc_arty();
void kremerc_cav();
void kreshipboard_life();
void kremerc_staff_off();
void kremerc_off_life();
void krecivil_grd();
void krebodygrd();
void kremerc_sup();
void kremarine();
void kremerc_spcl_asgn();
void kreenlist_sa(int roll);
void kremerc_attache();
void kremerc_cross_train();
void krespcl_sch();
void kremerc_prot_frcs();
void kremerc_cmdo_sch();
void kremerc_intl_sch();
void kre_cav_sch();
void kremerc_gen_skl();
void kremerc_pick_tbl();
void kremerc_life();
void kreget_skl(int choice);
int kremerc_asgn();
int krearmy_cmd();

extern int anag();
extern int getrank();
extern void gotmarines();
extern int survive(int adjust, int roll);
extern int d2();
extern int d3();
extern int d4();
extern int d6();
extern int d12();
extern int getsel_int(int min, int max);
extern void addskill(int skill, int skl_val);
extern int find_skl(int skill);
extern int chk_skl(int skill, int skl_val);
extern int bp_skill(int roll);
extern int bp_skill1(int roll, int need_nbr);
extern void bp_cmbt();
extern void merc_cmd_col();
extern void merc_staff_col();
extern void kredfltwar();
extern void bumpdex();
extern void bumpstr();
extern void bumpend();
extern void bumpsoc();
extern void bumpintl();
extern void bumpedu();
extern void fag(int skl_val);
extern void gc(int skl_val);
extern void vhcl(int skl_val);
extern void bp_add(int amt);
extern int ask_adj_asgn(int roll);
extern void gotspcldty(int spcldutynbr);

#include "chargen.h"

extern int  aide, nv_anag;

void kresurf()
{
  int term;
  
  aide = 0;
  if (branch == 1) addskill(LEADER, 1);
  kredfltwar();  
  kremerc_get_branch();
  kremerc_do_initial();
  term = terms;
  while (term >= 1)
  {
    term--;
    if (kremerc_doterms() != 0)
		term = 0;
    else 
		if (term > 0)
			nv_anag = anag();
  }
}


extern int nv_promo, assignment, command, combat;

int kremerc_doterms()
{
  int survival;
  
  command = 0;
  combat = 0;
  assignment = 0;
  do {
    survival = kremerc_do_year();
  } while (((age % 6) != 2) && (survival == 0));
  if (survival != 0) return 1;
  drafted = 0;
  bp_add(1);
  return 0;
}


void kremerc_get_branch()
{
  branch = kremerc_set_branch();
  kremerc_branch(branch);
  printf("You were assigned to the %s branch.\n", office);
}


int kremerc_set_branch()
{
  int roll;

  roll = d6();
  if (line == 3) roll--;
  else roll++;
  if (roll == 7) roll = 1;
  if (roll == 5) gotmarines();
  return roll;
}


void kremerc_do_initial()
{
  if (rank == 0) rank++;
  kremerc_branch_tbl(branch);
  kremerc_branch_tbl(branch);
  age++;
  nv_anag = anag();
  if (nv_anag == 0) appearent_age++;
}


void kremerc_branch(int branch_nbr)
{
  switch (branch_nbr) {
    case 0: strncpy(office,"Support",8); break; 
    case 1: strncpy(office,"Infantry",9); break;
    case 2: strncpy(office,"Civil Guard",12); break; 
    case 3: strncpy(office,"Artillery",10); break; 
    case 4: strncpy(office,"Bodyguard",10); break; 
    case 5: strncpy(office,"Marine",7); break; 
    case 6: strncpy(office,"Cavalry",8); break; 
    default: strncpy(office,"unknown?",9); break;
  }
}


int kremerc_do_year()
{
  int   roll;
  
  age++;
  if (nv_anag == 0) appearent_age++;
  command = krearmy_cmd();
  if (command == 2) assignment = 8;
  else assignment = 0;
  assignment = kremerc_asgn();
  if (combat != 0 && command == 1) cmd++;
  if (rank < 12) {
    if (promo != 0) {
      roll = d12();
      if (roll >= promo) {
        printf("You were promoted. ");
        if (rank == 1) rank = soc;
        else
          if (rank >= soc) bumpsoc();
          else rank++;
        if ((line == 2 && rank >= 7) || line == 1) rankeo = 'O';
        getrank();
      }
    }
  }
  if (assignment == 8) kremerc_spcl_asgn();
  if (skil != 0) {
    roll = d12();
    if (roll < skil) roll = bp_skill(roll);
    if (roll >= (skil + 4)) kremerc_gen_skl();
    if (roll >= skil) kremerc_gen_skl();
  }
  roll = d12();
  return survive(roll, 0);
}


void kremerc_branch_tbl(int brnch)
{
  switch (brnch) {
    case 0: kremerc_sup(); break;
    case 1: kremerc_inf(); break;
    case 2: krecivil_grd(); break;
    case 3: kremerc_arty(); break;
    case 4: krebodygrd(); break;
    case 5: kremarine(); break;
    case 6: kremerc_cav(); break;
  }
}


void kremerc_nco()
{
  int  roll;

  roll = kreliferoll();
  switch (roll) {
    case 2: addskill(HEAVYWEAP, 1); break;
    case 3: addskill(MECHANICAL, 1); break;
    case 1: addskill(TACTICS, 1); break;
    case 4: addskill(HEAVYWEAP, 1); break;
    case 5: addskill(ADMIN, 1); break;
    case 7: addskill(RECON, 1); break;
    case 6: addskill(LEADER, 1); break;
    case 8: addskill(INSTRUCTION, 1); break;
    case 9: addskill(TACTICS, 1); break;
  }
}


int kreliferoll()
{
  int roll;

  roll = d6();
  if (line == 1) roll++;
  if (soc >= 7) roll++;
  if (age >= 26) roll += 2;
  return roll;
}


void kremerc_cmd_off()
{
  int  roll;

  roll = kreliferoll();
  switch (roll) {
    case 1: bumpend(); break;
    case 2: gc(1); break;
    case 3: bumpintl(); break;
    case 4: addskill(HEAVYWEAP, 1); break;
    case 5: addskill(LEADER, 1); break;
    case 6: addskill(TACTICS, 1); break;
    case 7: addskill(TACTICS, 1); break;
    case 8: addskill(LEADER, 1); break;
    default: addskill(TOLERANCE, 1); break;
  }
}


void krearmy_life()
{
  int  roll;

  roll = kreliferoll();
  switch (roll) {
        case 1: bumpstr(); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: bumpend(); break;
        case 5: addskill(CLOSECMBT, 1); break;
        case 6: addskill(POLEARM, 1); break;
        case 7: vhcl(1); break;
        case 8: addskill(GAMBLING, 1); break;
        default: bumpsoc(); break;
  }
}


void kremerc_inf()
{
  int  roll;

  roll = kremosroll();
  switch (roll) {
        case 1: addskill(HEAVYWEAP, 1); break;
        case 2: addskill(HEAVYWEAP, 1); break;
        case 3: gc(1); break;
        case 4: gc(1); break;
        case 5: addskill(FORWARDOBS, 1); break;
        case 6: addskill(RECON, 1); break;
        case 7: addskill(TACTICS, 1); break;
  }
}


int kremosroll()
{
  int roll;

  roll = d6();
  if (line == 1) roll++;
  return roll;
}


void kremerc_arty()
{
  int  roll;

  roll = kremosroll();
  switch (roll) {
        case 1: fag(1); break;
        case 2: fag(1); break;
        case 3: vhcl(1); break;
        case 4: addskill(ENCLOSURE, 1); break;
        case 5: addskill(FORWARDOBS, 1); break;
        case 6: addskill(ELECTRONICS, 1); break;
        case 7: addskill(COMPUTER, 1); break;
  }
}


void kremerc_cav()
{
  int  roll;

  roll = kremosroll();
  switch (roll) {
        case 1: addskill(HEAVYWEAP, 1); break;
        case 5: vhcl(1); break;
        case 6: vhcl(1); break;
        case 7: addskill(COMPUTER, 1); break;
        default: addskill(ENCLOSURE, 1); break;
  }
}


void kreshipboard_life()
{
  int  roll;

  roll = kreliferoll();
  switch (roll) {
        case 1: addskill(FORWARDOBS, 1); break;
        case 2: gc(1); break;
        case 3: gc(1); break;
        case 4: addskill(VACCSUIT, 1); break;
        case 5: addskill(VACCSUIT, 1); break;
        case 6: addskill(ENCLOSURE, 1); break;
        case 7: addskill(SHIPBOAT, 1); break;
        case 8: addskill(ENCLOSURE, 1); break;
        default: addskill(NOGRAV, 1); break;
  }
}


void kremerc_staff_off()
{
  int  roll;

  roll = kreliferoll();
  switch (roll) {
        case 1: addskill(MECHANICAL, 1); break;
        default: addskill(HANDYMAN, 1); break;
        case 3: addskill(COMPUTER, 1); break;
        case 4: addskill(ELECTRONICS, 1); break;
        case 5: addskill(TOLERANCE, 1); break;
        case 6: addskill(MEDICAL, 1); break;
        case 7: addskill(INSTRUCTION, 1); break;
        case 8: addskill(ADMIN, 1); break;
  }
}


void kremerc_off_life()
{
  int  roll;

  roll = kreliferoll();
  switch (roll) {
        case 1: bumpstr(); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: bumpintl(); break;
        case 5: addskill(LEADER, 1); break;
        case 6: addskill(ADMIN, 1); break;
        case 7: bumpedu(); break;
        case 8: addskill(TOLERANCE, 1); break;
        default: bumpsoc(); break;
  }
}


void krecivil_grd()
{
  int  roll;

  roll = kremosroll();
  switch (roll) {
        case 1: addskill(POLEARM, 1); break;
        case 3: gc(1); break;
        case 2: addskill(POLEARM, 1); break;
        case 4: addskill(ENCLOSURE, 1); break;
        case 6: addskill(MEDICAL, 1); break;
        case 5: vhcl(1); break;
        case 7: addskill(LEADER, 1); break;
  }
}


void krebodygrd()
{
  int  roll;

  roll = kremosroll();
  switch (roll) {
    case 1: addskill(CLOSECMBT, 1); break;
    case 2: addskill(CLOSECMBT, 1); break;
    case 3: addskill(POLEARM, 1); break;
    case 4: addskill(POLEARM, 1); break;
    default: gc(1); break;
  }
}


void kremerc_sup()
{
  int  roll;

  roll = kremosroll();
  switch (roll) {
        case 1: addskill(MECHANICAL, 1); break;
        case 3: addskill(CMBTENGR, 1); break;
        case 2: addskill(ELECTRONICS, 1); break;
        case 4: addskill(ENCLOSURE, 1); break;
        case 6: addskill(MEDICAL, 1); break;
        case 5: vhcl(1); break;
        case 7: addskill(COMPUTER, 1); break;
  }
}


void kremarine()
{
  int  roll;

  roll = kremosroll();
  switch (roll) {
        case 1: addskill(HEAVYWEAP, 1); break;
        case 2: gc(1); break;
        case 3: addskill(NOGRAV, 1); break;
        case 4: addskill(ENCLOSURE, 1); break;
        case 5: addskill(VACCSUIT, 1); break;
        case 6: addskill(BATTLEDRESS, 1); break;
        case 7: addskill(LEADER, 1); break;
  }
}


void kremerc_spcl_asgn()
{
  int roll;
  
  if (aide != 0) {
    aide = 0;
  }
  roll = d6();
  if (find_skl(ENCLOSURE) >= 1) roll++;
  if (rankeo != 'O')
  {
    kreenlist_sa(roll);
    return;
  }
  if (roll <= 1) kremerc_intl_sch();
  if (roll == 3) merc_cmd_col();
  if (roll == 2) kremerc_cmdo_sch();
  if (roll >= 6) kre_cav_sch();
  if (roll == 5) kremerc_attache();
  if (roll == 4) merc_staff_col();
}


void kreenlist_sa(int roll)
{
  if (roll <= 1) krespcl_sch();
  if (roll == 2) kremerc_cmdo_sch();
  if (roll == 3) kremerc_prot_frcs();
  if (roll == 4) kremerc_cross_train();
  if (roll >= 5) kre_cav_sch();
}


void kremerc_attache()
{
  int roll;

  gotspcldty(ATTACHE);
  roll = d6();
  if (roll >= 6) bumpsoc();
  roll = d6();
  if (roll >= 6) addskill(LIAISON, 1);
  roll = d6();
  if (roll >= 6) addskill(ENCLOSURE, 1);
  roll = d6();
  if (roll >= 6) addskill(TOLERANCE, 1);
  roll = d6();
  if (roll >= 6) addskill(TACTICS, 1);
  roll = d6();
  if (roll >= 6) addskill(ADMIN, 1);
}


void kremerc_cross_train()
{
  printf("You got cross training. Congratulations!\n");
  bp_add(1);
  branch = kremerc_set_branch();
  kremerc_branch(branch);
  printf("Your new assignment is with the %s branch.\n", office);
  kremerc_branch_tbl(branch);
}


void krespcl_sch()
{
  int roll;

  gotspcldty(SPECIALISTSCH);
  roll = d6();
  switch (roll) {
      case 1: vhcl(1); break;
      case 2: addskill(MEDICAL, 1); break;
      case 3: addskill(COMMO, 1); break;
      case 4: addskill(GRAVITICS, 1); break;
      case 5: addskill(MECHANICAL, 1); break;
      case 6: addskill(ELECTRONICS, 1); break;
  }
}


void kremerc_prot_frcs()
{
  int roll;

  gotspcldty(PROTECTEDFORCES);
  roll = bp_skill1(d6(), 3);
  if (roll >= 3) addskill(ENCLOSURE, 1);
  roll = bp_skill1(d6(), 3);
  if (roll >= 3) addskill(VACCSUIT, 1);
  roll = bp_skill1(d6(), 3);
  if (roll >= 3) addskill(NOGRAV, 1);
}


void kremerc_cmdo_sch()
{
  int roll;

  gotspcldty(COMMANDOSCH);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(CLOSECMBT, 1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(DEMOLITIONS, 1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(ENCLOSURE, 1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) gc(1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(SURVIVAL, 1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(INSTRUCTION, 1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(VACCSUIT, 1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(RECON, 1);
}


void kremerc_intl_sch()
{
  int roll;

  gotspcldty(INTELLIGENCESCH);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(FORGERY, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(TOLERANCE, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(BRIBERY, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(STREETWISE, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(INTERROGATE, 1);
}


void kre_cav_sch()
{
  int roll;

  gotspcldty(KRECAVSCH);
  roll = d6();
  if (roll >= 6) addskill(ENCLOSURE, 1);
  branch = 6;
  kremerc_branch(branch);
  printf("Your new assignment is with the %s branch.\n", office);
  if (find_skl(ENCLOSURE) >= 1) {
    kremerc_branch_tbl(branch);
    kremerc_branch_tbl(branch);
  }
}


void kremerc_gen_skl()
{
  int roll;

  if (pick <= 2) {
    kremerc_pick_tbl();
    return;
  }
  if (assignment != 7) {
    if (line == 3 && rank < 7) {
      roll = d2();
    } else {
      roll = d3();
    }
  } else {
    roll = d4();
    if (line == 3 && rank < 7)
      if (roll == 3) roll = 2;
  }
  kreget_skl(roll);
}


void kremerc_life()
{
  if (line == 3) krearmy_life();
  else
    kremerc_off_life();
}


void kremerc_pick_tbl()
{
  int choice;
  printf("\nPlease select the table you wish to use for your new skill.\n\n");
  if (rankeo == 'E') printf("   1. soldiers life\n");   
  else
    if (rankeo == 'O') printf("   1. officers life\n");
  kremerc_branch(branch); 
  printf("   2. The table for %s\n", office); 
  if ((line == 2 && rankeo == 'E') || (line == 3 && rank >= 7)) printf("   3. NCO\n");
  if (rankeo == 'O' && command == 1) printf("   3. Command Officer\n");
  if (rankeo == 'O' && command != 1) printf("   3. Staff Officer\n");
  if (assignment == 7) printf("   4. shipboard life\n");
  choice = getsel_int(1, 4);
  if ((line == 3 && rank < 7 && choice == 3)
    || (assignment != 7 && choice == 4)) {
    printf("Wrong - try again!\n");
    kremerc_pick_tbl();
    return;
  }
  kreget_skl(choice);
}


void kreget_skl(int choice)
{
  switch (choice) {
    case 1: kremerc_life(); break;
    case 2: kremerc_branch_tbl(branch); break;
    case 3: {
      if ((line == 2 && rankeo == 'E') || (line == 3 && soc >= 7)) kremerc_nco();
      else
        if (command == 1) kremerc_cmd_off();
        else
          kremerc_staff_off();
      break;
    }
    case 4: kreshipboard_life(); break;
  }
}


int kremerc_asgn()
{
  int roll, asgnmt;

  combat = 0;
  surv = 0; promo = 0; skil = 0; 
  if (assignment == 8)
  {
	if (d6() > 4) asgnmt = 8;
  }
  else 
  {
    roll = d12();
    if (branch == 4)
		asgnmt = 9;
	else
		if (pick == 1)
			roll = ask_adj_asgn(roll);
    if (branch == 0)
	{
      if (pick == 4 && (roll == 2 || roll == 9 || roll == 11) && brownie_points > 3)
	  {
		  roll++;
		  bp_cmbt();
	  }
      if (pick == 4 && roll == 5 && brownie_points > 3)
	  {
		  roll--;
		  bp_cmbt();
	  }
	  switch (roll)
	  {
        case 2: asgnmt = 5; break;
        case 3: asgnmt = 2; break;
        case 4: asgnmt = 4; break;
        case 9: asgnmt = 1; break;
        case 10: asgnmt = 3; break;
        case 11: asgnmt = 2; break;
        case 12: asgnmt = 3; break;
        default: asgnmt = 6; break;
      }
    }
    if (branch == 3)
	{
      if (pick == 4 && (roll == 3 || roll == 6 || roll == 12)
		  && brownie_points > 3)
	  {
		  roll--;
		  bp_cmbt();
	  }
      if (pick == 4 && roll == 9 && brownie_points > 3)
	  {
		  roll++;
		  bp_cmbt();
	  }
      switch (roll)
	  {
        case 2: asgnmt = 5; break;
        case 3: asgnmt = 1; break;
        case 4: asgnmt = 4; break;
        case 5: asgnmt = 3; break;
        case 6: asgnmt = 6; break;
        case 7: asgnmt = 6; break;
        case 8: asgnmt = 6; break;
        case 9: asgnmt = 1; break;
        case 10: asgnmt = 3; break;
        case 11: asgnmt = 4; break;
        case 12: asgnmt = 1; break;
      }
    }
    if (branch == 1)
	{
      if (pick == 4 && (roll == 6 || roll == 11) && brownie_points > 3)
	  {
		  roll--;
		  bp_cmbt();
	  }
      if (pick == 4 && roll == 9 && brownie_points > 3)
	  {
		  roll++;
		  bp_cmbt();
	  }
      switch (roll)
	  {
        case 2: asgnmt = 5; break;
        case 3: asgnmt = 5; break;
        case 4: asgnmt = 4; break;
        case 5: asgnmt = 4; break;
        case 6: asgnmt = 6; break;
        case 7: asgnmt = 6; break;
        case 8: asgnmt = 6; break;
        case 9: asgnmt = 1; break;
        case 10: asgnmt = 3; break;
        default: asgnmt = 2; break;
      }
    }
    if (branch == 6)
	{
      if (pick == 4 && (roll == 3 || roll == 6 || roll == 11)
		  && brownie_points > 3)
	  {
		  roll--;
		  bp_cmbt();
	  }
      if (pick == 4 && roll == 9 && brownie_points > 3)
	  {
		  roll++;
		  bp_cmbt();
	  }
      switch (roll)
	  {
        case 2: asgnmt = 5; break;
        case 3: asgnmt = 1; break;
        case 4: asgnmt = 4; break;
        case 5: asgnmt = 3; break;
        case 6: asgnmt = 6; break;
        case 7: asgnmt = 6; break;
        case 8: asgnmt = 6; break;
        case 9: asgnmt = 1; break;
        case 10: asgnmt = 3; break;
        case 11: asgnmt = 2; break;
        case 12: asgnmt = 3; break;
      }
    }
    if (branch == 2)
	{
      if (pick == 4 && roll == 11 && brownie_points > 3)
	  {
		  roll++;
		  bp_cmbt();
	  }
      if (pick == 4 && roll == 3 && brownie_points > 3)
	  {
		  roll--;
		  bp_cmbt();
	  }
      switch (roll)
	  {
        case 2: asgnmt = 4; break;
        case 3: asgnmt = 2; break;
        case 4: asgnmt = 2; break;
        case 5: asgnmt = 7; break;
        case 6: asgnmt = 9; break;
        case 7: asgnmt = 6; break;
        case 8: asgnmt = 6; break;
        case 9: asgnmt = 1; break;
        case 10: asgnmt = 2; break;
        case 11: asgnmt = 2; break;
        case 12: asgnmt = 3; break;
      }
    }
    if (branch == 5)
	{
      if (pick == 4 && roll == 9 && brownie_points > 3)
	  {
		  roll++;
		  bp_cmbt();
	  }
      if (pick == 4 && roll == 5 && brownie_points > 3)
	  {
		  roll--;
		  bp_cmbt();
	  }
      switch (roll)
	  {
        case 2: asgnmt = 5; break;
        case 3: asgnmt = 5; break;
        case 4: asgnmt = 4; break;
        case 5: asgnmt = 2; break;
        case 6: asgnmt = 7; break;
        case 7: asgnmt = 6; break;
        case 8: asgnmt = 7; break;
        case 9: asgnmt = 1; break;
        case 10: asgnmt = 4; break;
        case 11: asgnmt = 3; break;
        case 12: asgnmt = 3; break;
      }
    }
    if (branch == 1 || branch == 3 || branch == 6)
	{
      switch (asgnmt)
	  {
        case 1: promo = 18; skil = 6; break;
        case 2: surv = 4; promo = 16; break;
        case 3: surv = 5; promo = 11; skil = 7; break;
        case 4: surv = 5; promo = 12; skil = 8; break;
        case 5: surv = 6; promo = 10; skil = 5; break;
        case 6: promo = 18; break;
      }
      if (line == 1 && surv != 0) surv--;
      if (rank == 1 && promo != 0) promo -= 6;
    }
    if (branch == 5) 
	{
      switch (asgnmt)
	  {
        case 1: promo = 18; skil = 6; break;
        case 2: surv = 4; promo = 16; break;
        case 3: surv = 5; promo = 16; skil = 7; break;
        case 4: surv = 5; promo = 12; skil = 8; break;
        case 5: surv = 6; promo = 11; skil = 5; break;
        case 6: promo = 18; break;
        case 7: surv = 4; promo = 12; skil = 6; break;
      }
      if (line == 1 && surv != 0) surv--;
      if (rank == 1 && promo != 0) promo -= 7;
    }
    if (branch == 0 || branch == 2 || branch == 4) 
	{
      switch (asgnmt)
	  {
        case 1: skil = 8; break;
        case 2: surv = 4; promo = 16; break;
        case 3: surv = 4; promo = 14; skil = 7; break;
        case 4: surv = 5; promo = 14; skil = 7; break;
        case 5: surv = 6; promo = 12; skil = 6; break;
        case 6: promo = 17; break;
        case 7: surv = 4; promo = 12; skil = 6; break;
      }
      if (line == 1 && surv != 0) surv -= 2;
      if (rank == 1 && promo != 0) promo -= 4;
      if (branch == 4 && surv != 0)
	  {
        if ((chk_skl(CLOSECMBT, 2) == 1)
          || (chk_skl(POLEARM, 2) == 1)
          || (chk_skl(HANDGUN, 2) == 1)
          || (chk_skl(LASERWEAP, 2) == 1)
          || (chk_skl(SUBMG, 2) == 1)
          || (chk_skl(CMBTRIFLMAN, 2) == 1))
		  surv--;
      }
    }
    switch (asgnmt)
	{
      case 1: printf("This is training.\n"); break;
      case 2: printf("This is internal security.\n"); break;
      case 3: printf("This is police action.\n"); cmbt++; combat++; break;
      case 4: printf("This is counterinsurgency.\n"); cmbt++; combat++; break;
      case 5: printf("This is a raid.\n"); cmbt++; combat++; break;
      case 6: printf("This is garrison.\n"); break;
      case 7: printf("This is ships troops.\n"); break;
      case 8: printf("This is special duty.\n"); break;
      case 9: printf("This is retinue.\n"); break;
    }
  }
  return asgnmt;
}


int krearmy_cmd()
{
  int  roll;

  if (rankeo == 'E') return 0;
  roll = d6();
  if (edu >= 7) roll++;
  if (soc >= 7) roll--;
  if (roll >= 6) return 2;
  if ((branch == 1 || branch >= 5) && roll <= 3) return 1;
  if ((branch == 3 || branch == 2) && roll <= 2) return 1;
  if (branch == 0 && roll <= 1) return 1;
  return 0;
}


