/* VARADMIN.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void varadmin();
void varadminmot(int term);
void varadminbene();
void varadminskills(int skills);
void varadmin_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int var_success();
extern int basic_cash();
extern int var_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int varpicktable();
extern void bumpdex();
extern void bumpsoc();
extern void bumpedu();
extern void bumpend();
extern void mentl(int skl_val);
extern void mc(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void econ(int skl_val);
extern void acad(int skl_val);
extern void inbrn(int skl_val);
extern void mot_cash(int amt);
extern void mot_midpsg();
extern void mot_lopsg();
extern void mot_hipsg();
extern void mot_voucher();
extern void mot_watch();

#include "chargen.h"

void varadmin()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(6);
    newterm = basic_surv(4, edu, 10);
    if (newterm == 0) {
      skills += basic_comm(6, soc, 9);
      printf("skills=%d\n", skills);
      newterm = var_success(intl, 9, soc, 8, &skills);
      printf("skills=%d\n", skills);
    }
    if (skills != 0) varadminskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(5);
  }
  terms = terms - anagathics;
  varadminmot(terms);
}


void varadminmot(int term)
{

  int  cash, roll, amt;
  char choice;
  
  cash = 3;
  term = var_mot(term);
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: break;
        case 2: break;
        case 3: amt = 10000; break;
        case 4: amt = 10000; break;
        case 5: amt = 40000; break;
        case 6: amt = 40000; break;
        case 7: amt = 80000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        varadminbene();
        term--;
    }
  }
  while (term > 0)
  {
    varadminbene();
    term--;
  }
}


void varadminbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 3: mot_midpsg(); break;
    case 2: mot_watch(); break;
    case 4: mot_voucher(); break;
    case 5: mot_watch(); break;
    case 6: mot_hipsg(); break;
    case 7: bumpsoc(); break;
  }
}


void varadminskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = varpicktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: bumpend(); break;
        case 2: bumpedu(); break;
        case 3: addskill(INFIGHTING, 1); break;
        case 4: bumpdex(); break;
        case 5: inbrn(1); break;
        case 6: mentl(1); break;
      }
    }
    if (table == 2) {
      varadmin_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: addskill(RECRUITING, 1); break;
        case 2: vhcl(1); break;
        case 3: addskill(INTERROGATE, 1); break;
        case 4: addskill(LIAISON, 1); break;
        case 5: acad(1); break;
        case 6: interp(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: addskill(ADMIN, 1); break;
        case 2: addskill(COMPUTER, 1); break;
        case 3: addskill(LEADER, 1); break;
        case 4: econ(1); break;
        case 5: interp(1); break;
        case 6: inbrn(1); break;
      }
    }
    skills--;
  }
}


void varadmin_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: vhcl(1); break;
        case 2: addskill(INFIGHTING, 1); break;
        case 3: mc(1); break;
        case 4: econ(1); break;
        case 5: vhcl(1); break;
        case 6: inbrn(1); break;
      }
}

