/* VARARIST.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void vararistocrat();
void vararistocratmot(int term);
void vararistocratbene();
void vararistocratskills(int skills);
void vararistocrat_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int var_success();
extern int basic_cash();
extern int var_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int varpicktable();
extern void bumpdex();
extern void bumpend();
extern void physicl(int skl_val);
extern void mentl(int skl_val);
extern void spac(int skl_val);
extern void mc(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void spacetech(int skl_val);
extern void acad(int skl_val);
extern void inbrn(int skl_val);
extern void env(int skl_val);
extern void vc(int skl_val);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_ship();
extern void mot_lopsg();
extern void mot_hipsg();

#include "chargen.h"

void vararistocrat()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(4);
    newterm = basic_surv(4, edu, 18);
    if (newterm == 0) {
      skills += basic_comm(6, edu, 9);
      printf("skills=%d\n", skills);
      newterm = var_success(intl, 10, soc, 11, &skills);
      printf("skills=%d\n", skills);
    }
    if (skills != 0) vararistocratskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(3);
  }
  terms = terms - anagathics;
  vararistocratmot(terms);
}


void vararistocratmot(int term)
{

  int  cash, roll, amt;
  char choice;
  
  cash = 3;
  term = var_mot(term);
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 10000; break;
        case 2: amt = 20000; break;
        case 3: amt = 50000; break;
        case 4: amt = 75000; break;
        case 5: amt = 100000; break;
        case 6: amt = 200000; break;
        case 7: amt = 500000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        vararistocratbene();
        term--;
    }
  }
  while (term > 0)
  {
    vararistocratbene();
    term--;
  }
}


void vararistocratbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 3: mot_weapon(); break;
    case 2: mot_hipsg(); break;
    case 4: mot_weapon(); break;
    case 5: mot_hipsg(); mot_hipsg(); break;
    case 6: mot_hipsg(); mot_hipsg(); break;
    case 7: mot_ship(); break;
  }
}


void vararistocratskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = varpicktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: physicl(1); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: vc(1); break;
        case 5: mc(1); break;
        case 6: mentl(1); break;
      }
    }
    if (table == 2) {
      vararistocrat_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: spac(1); break;
        case 2: vhcl(1); break;
        case 3: addskill(SHIPBOAT, 1); break;
        case 4: addskill(NAVIGATION, 1); break;
        case 5: spacetech(1); break;
        case 6: acad(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: addskill(LEADER, 1); break;
        case 2: addskill(LEADER, 1); break;
        case 3: acad(1); break;
        case 4: inbrn(1); break;
        case 5: interp(1); break;
        case 6: inbrn(1); break;
      }
    }
    skills--;
  }
}


void vararistocrat_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: vhcl(1); break;
        case 2: vc(1); break;
        case 3: mc(1); break;
        case 4: bumpdex(); break;
        case 5: env(1); break;
        case 6: acad(1); break;
      }
}

