/* VARBARBR.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void varbarbarian();
void varbarbarianmot(int term);
void varbarbarianbene();
void varbarbarianskills(int skills);
void varbarbarian_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int var_success();
extern int basic_cash();
extern int var_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int varpicktable();
extern void bumpdex();
extern void physicl(int skl_val);
extern void env(int skl_val);
extern void archaic(int skl_val);
extern void mc(int skl_val);
extern void interp(int skl_val);
extern void inbrn(int skl_val);
extern void vc(int skl_val);
extern void bc(int skl_val);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_lopsg();
extern void mot_hipsg();
extern void mot_midpsg();

#include "chargen.h"

void varbarbarian()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(7);
    newterm = basic_surv(6, str, 8);
    if (newterm == 0) {
      skills += basic_comm(6, edu, 9);
      printf("skills=%d\n", skills);
      newterm = var_success(intl, 6, soc, 6, &skills);
      printf("skills=%d\n", skills);
    }
    if (skills != 0) varbarbarianskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  terms = terms - anagathics;
  varbarbarianmot(terms);
}


void varbarbarianmot(int term)
{

  int  cash, roll, amt;
  char choice;
  
  cash = 3;
  term = var_mot(term);
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: break;
        case 2: break;
        case 3: amt = 1000; break;
        case 4: amt = 2000; break;
        case 5: amt = 3000; break;
        case 6: amt = 4000; break;
        case 7: amt = 5000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        varbarbarianbene();
        term--;
    }
  }
  while (term > 0)
  {
    varbarbarianbene();
    term--;
  }
}


void varbarbarianbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 3: mot_weapon(); break;
    case 6: mot_midpsg(); break;
    case 4: mot_weapon(); break;
    case 5: mot_weapon(); break;
    case 2: mot_weapon(); break;
    case 7: mot_hipsg(); break;
  }
}


void varbarbarianskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = varpicktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: physicl(1); break;
        case 2: bumpdex(); break;
        case 3: physicl(1); break;
        case 4: vc(1); break;
        case 5: mc(1); break;
        case 6: physicl(1); break;
      }
    }
    if (table == 2) {
      varbarbarian_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: addskill(HUNTING, 1); break;
        case 2: mc(1); break;
        case 3: vc(1); break;
        case 4: env(1); break;
        case 5: archaic(1); break;
        case 6: env(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: addskill(INTERROGATE,1); break;
        case 2: addskill(MEDICAL, 1); break;
        case 3: addskill(TACTICS, 1); break;
        case 4: interp(1); break;
        case 5: env(1); break;
        case 6: inbrn(1); break;
      }
    }
    skills--;
  }
}


void varbarbarian_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: mc(1); break;
        case 2: addskill(INFIGHTING, 1); break;
        case 3: mc(1); break;
        case 4: archaic(1); break;
        case 5: bc(1); break;
        case 6: env(1); break;
      }
}

