/* VARCORSR.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void varcorsair();
void varcorsairmot(int term);
void varcorsairbene();
void varcorsairskills(int skills);
void varcorsair_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int var_success();
extern int basic_cash();
extern int var_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int varpicktable();
extern void bumpdex();
extern void bumpintl();
extern void bumpsoc();
extern void bumpedu();
extern void bumpend();
extern void physicl(int skl_val);
extern void spacecmbt(int skl_val);
extern void techl(int skl_val);
extern void mc(int skl_val);
extern void vhcl(int skl_val);
extern void spac(int skl_val);
extern void inbrn(int skl_val);
extern void special(int skl_val);
extern void vc(int skl_val);
extern void bc(int skl_val);
extern void gc(int skl_val);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_ship();
extern void mot_lopsg();

#include "chargen.h"

void varcorsair()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(5);
    newterm = basic_surv(6, end, 9);
    if (newterm == 0) {
      skills += basic_comm(8, soc, 7);
      printf("skills=%d\n", skills);
      newterm = var_success(intl, 8, soc, 5, &skills);
      printf("skills=%d\n", skills);
    }
    if (skills != 0) varcorsairskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  terms = terms - anagathics;
  varcorsairmot(terms);
}


void varcorsairmot(int term)
{

  int  cash, roll, amt;
  char choice;
  
  cash = 3;
  term = var_mot(term);
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 1000; break;
        case 2: amt = 1000; break;
        case 3: amt = 10000; break;
        case 4: amt = 10000; break;
        case 5: amt = 30000; break;
        case 6: amt = 30000; break;
        case 7: amt = 50000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        varcorsairbene();
        term--;
    }
  }
  while (term > 0)
  {
    varcorsairbene();
    term--;
  }
}


void varcorsairbene()
{
  int roll;

  roll = basic_bene();
  switch (roll) {
    case 1: mot_lopsg(); break;
    case 3: bumpedu(); bumpedu(); break;
    case 2: bumpintl(); break;
    case 4: mot_weapon(); break;
    case 5: mot_weapon(); break;
    case 6: mot_weapon(); break;
    case 7: mot_ship(); break;
  }
}


void varcorsairskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = varpicktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: physicl(1); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: vc(1); break;
        case 5: mc(1); break;
        case 6: bumpsoc(1); break;
      }
    }
    if (table == 2) {
      varcorsair_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: addskill(NOGRAV, 1); break;
        case 2: spacecmbt(1); break;
        case 3: spac(1); break;
        case 4: spac(1); break;
        case 5: techl(1); break;
        case 6: inbrn(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: spac(1); break;
        case 2: addskill(SHIPTAC, 1); break;
        case 3: bumpsoc(); break;
        case 4: inbrn(1); break;
        case 5: vc(1); break;
        case 6: inbrn(1); break;
      }
    }
    skills--;
  }
}


void varcorsair_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: vhcl(1); break;
        case 2: addskill(VACCSUIT, 1); break;
        case 3: mc(1); break;
        case 4: gc(1); break;
        case 5: bc(1); break;
        case 6: special(1); break;
      }
}

