/* VARHUNTR.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void varhunter();
void varhuntermot(int term);
void varhunterbene();
void varhunterskills(int skills);
void varhunter_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int var_success();
extern int basic_cash();
extern int var_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int varpicktable();
extern void bumpdex();
extern void bumpend();
extern void physicl(int skl_val);
extern void mentl(int skl_val);
extern void techl(int skl_val);
extern void explore(int skl_val);
extern void vhcl(int skl_val);
extern void econ(int skl_val);
extern void acad(int skl_val);
extern void inbrn(int skl_val);
extern void env(int skl_val);
extern void mc(int skl_val);
extern void bc(int skl_val);
extern void spac(int skl_val);
extern void gc(int skl_val);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_ship();
extern void mot_lopsg();
extern void mot_hipsg();
extern void mot_midpsg();

#include "chargen.h"

void varhunter()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(6);
    newterm = basic_surv(6, str, 10);
    if (newterm == 0) {
      skills += 2;
      printf("skills=%d\n", skills);
      newterm = var_success(intl, 6, soc, 6, &skills);
      printf("skills=%d\n", skills);
    }
    if (skills != 0) varhunterskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(5);
  }
  terms = terms - anagathics;
  varhuntermot(terms);
}


void varhuntermot(int term)
{

  int  cash, roll, amt;
  char choice;
  
  cash = 3;
  term = var_mot(term);
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 1000; break;
        case 2: amt = 1000; break;
        case 3: amt = 5000; break;
        case 4: amt = 5000; break;
        case 5: amt = 10000; break;
        case 6: amt = 100000; break;
        case 7: amt = 100000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        varhunterbene();
        term--;
    }
  }
  while (term > 0)
  {
    varhunterbene();
    term--;
  }
}


void varhunterbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: mot_midpsg(); break;
    case 3: mot_hipsg(); break;
    case 4: mot_weapon(); break;
    case 5: mot_weapon(); break;
    case 6: mot_weapon(); break;
    default: mot_ship(); break;
  }
}


void varhunterskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = varpicktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: physicl(1); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: mentl(1); break;
        case 5: gc(1); break;
        case 6: bc(1); break;
      }
    }
    if (table == 2) {
      varhunter_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: addskill(MECHANICAL, 1); break;
        case 2: addskill(ELECTRONICS, 1); break;
        case 3: techl(1); break;
        case 4: env(1); break;
        case 5: econ(1); break;
        case 6: addskill(COMPUTER, 1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: techl(1); break;
        case 2: explore(1); break;
        case 3: inbrn(1); break;
        case 4: addskill(MEDICAL, 1); break;
        case 5: addskill(HUNTING, 1); break;
        case 6: acad(1); break;
      }
    }
    skills--;
  }
}


void varhunter_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: gc(1); break;
        case 2: mc(1); break;
        case 3: vhcl(1); break;
        case 4: env(1); break;
        case 5: env(1); break;
        case 6: addskill(HUNTING, 1); break;
      }
}

