/* VARMILTA.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void varmilitia();
void varmilitiamot(int term);
int var_mot(int term);
void varmilitiabene();
void varmilitiaskills(int skills);
void varmilitia_tbl(int roll);
int var_success(int dm_val, int need_nbr, int dm_val2, int need2, int *skl);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int var_success();
extern int basic_cash();
extern int var_mot();
extern int basic_bene();
extern int d6();
extern int d12();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int varpicktable();
extern void bumpintl();
extern void bumpsoc();
extern void dropsoc();
extern void bumpedu();
extern void bumpdex();
extern void bumpend();
extern void physicl(int skl_val);
extern void speciall(int skl_val);
extern void techl(int skl_val);
extern void special(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void bc(int skl_val);
extern void inbrn(int skl_val);
extern void mc(int skl_val);
extern void milmed(int skl_val);
extern void vc(int skl_val);
extern void spac(int skl_val);
extern void gc(int skl_val);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_midpsg();
extern void mot_lopsg();
extern void mot_hipsg();

#include "chargen.h"

void varmilitia()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(6);
    newterm = basic_surv(5, str, 5);
    if (newterm == 0) {
      skills += basic_comm(10, soc, 6);
      printf("skills=%d\n", skills);
      newterm = var_success(edu, 9, soc, 6, &skills);
      printf("skills=%d\n", skills);
    }
    if (skills != 0) varmilitiaskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  terms = terms - anagathics;
  varmilitiamot(terms);
}


void varmilitiamot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = 3;
  term = var_mot(term);
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 1000; break;
        case 2: amt = 5000; break;
        case 3: amt = 10000; break;
        case 4: amt = 10000; break;
        case 5: amt = 10000; break;
        case 6: amt = 20000; break;
        case 7: amt = 30000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        varmilitiabene();
	term--;
    }
  }
  while (term > 0)
  {
    varmilitiabene();
    term--;
  }
}


int var_mot(int term)
{
  int rolls;

  rolls = term;
  if (rank >= 1) rolls++;
  if (rank >= 3) rolls++;
  if (rank >= 5) rolls++;
  return (rolls);
}


void varmilitiabene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 3: bumpedu(); bumpedu(); break;
    case 2: bumpintl(); break;
    case 4: mot_weapon(); break;
    case 5: mot_midpsg(); break;
    case 6: mot_hipsg(); break;
    case 7: bumpsoc(); break;
  }
}


void varmilitiaskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = varpicktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: physicl(1); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: vc(1); break;
	case 5: mc(1); break;
        case 6: physicl(1); break;
      }
    }
    if (table == 2) {
      varmilitia_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: vhcl(1); break;
        case 2: addskill(MECHANICAL, 1); break;
        case 3: addskill(ELECTRONICS, 1); break;
        case 4: addskill(TACTICS, 1); break;
	case 5: techl(1); break;
        case 6: milmed(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: special(1); break;
        case 2: addskill(TACTICS, 1); break;
        case 3: bumpsoc(); break;
        case 4: gc(1); break;
        case 5: interp(1); break;
        case 6: inbrn(1); break;
      }
    }
    skills--;
  }
}


void varmilitia_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
  switch (roll) {
    case 1: vhcl(1); break;
    case 2: addskill(VACCSUIT, 1); break;
    case 3: bc(1); break;
    case 4: gc(1); break;
    case 5: addskill(INFIGHTING, 1); break;
    case 6: special(1); break;
  }
}


int var_success(int dm_val, int need_nbr, int dm_val2, int need2, int *skl)
{
  int roll;

  roll = d12();
  if (dm_val >= need_nbr) roll++;
  if (dm_val2 >= need2) roll++;
  if (soc >= 6) roll++;
  if (roll <= 3) {
    dropsoc();
    if (roll <= 2) dropsoc();
    printf("You were not successful this term. Charisma dropped to %d.\n", soc);
    return 1;
  }
  if (roll == 4 && rankeo == 'O') {
    rank--;
    if (rank < 1) rank = 1;
    printf("You were not successful this term. Rank dropped to %d.\n", rank);
  }
  if (roll <= 7) return 0;
  printf("You were successful this term.\n");
  *skl = *skl + 1;
  if (rankeo == 'O') basic_promo(1,1,1);
  if (roll >= 10) bumpsoc();
  if (roll >= 11) basic_promo(1,1,1);
  if (roll >= 12) bumpsoc();
  return 0;
}