/* VARROGUE.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void varrogue();
void varroguemot(int term);
void varroguebene();
void varrogueskills(int skills);
void varrogue_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int var_success();
extern int basic_cash();
extern int var_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int varpicktable();
extern void bumpdex();
extern void bumpend();
extern void bumpedu();
extern void physicl(int skl_val);
extern void techl(int skl_val);
extern void vhcl(int skl_val);
extern void inbrn(int skl_val);
extern void mc(int skl_val);
extern void vc(int skl_val);
extern void interp(int skl_val);
extern void gc(int skl_val);
extern void mot_cash(int amt);
extern void mot_midpsg();
extern void mot_ship();
extern void mot_lopsg();
extern void mot_hipsg();
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_ship();
extern void mot_lopsg();
extern void mot_hipsg();
extern void mot_midpsg();

#include "chargen.h"

void varrogue()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(5);
    newterm = basic_surv(7, intl, 9);
    if (newterm == 0) {
      skills += 2;
      printf("skills=%d\n", skills);
      newterm = var_success(intl, 9, str, 8, &skills);
      printf("skills=%d\n", skills);
    }
    if (skills != 0) varrogueskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(5);
  }
  terms = terms - anagathics;
  varroguemot(terms);
}


void varroguemot(int term)
{

  int  cash, roll, amt;
  char choice;
  
  cash = 3;
  term = var_mot(term);
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: break;
        case 2: break;
        case 3: amt = 10000; break;
        case 4: amt = 10000; break;
        case 5: amt = 50000; break;
        case 6: amt = 100000; break;
        case 7: amt = 100000; break;
      }
	  mot_cash(amt);
    }
	else 
	{
        varroguebene();
        term--;
    }
  }
  while (term > 0)
  {
    varroguebene();
    term--;
  }
}


void varroguebene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: mot_midpsg(); break;
    case 7: mot_ship(); break;
    case 3: mot_hipsg(); break;
    default: mot_weapon(); break;
  }
}


void varrogueskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = varpicktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: physicl(1); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: mc(1); break;
        case 5: vc(1); break;
        case 6: addskill(CAROUSING, 1); break;
      }
    }
    if (table == 2) {
      varrogue_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: vc(1); break;
        case 2: vc(1); break;
        case 3: addskill(STREETWISE, 1); break;
        case 4: addskill(TACTICS, 1); break;
        case 5: inbrn(1); break;
        case 6: interp(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: vc(1); break;
        case 2: addskill(MEDICAL, 1); break;
        case 3: inbrn(1); break;
        case 4: vc(1); break;
        case 5: inbrn(1); break;
        case 6: techl(1); break;
      }
    }
    skills--;
  }
}


void varrogue_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: mc(1); break;
        case 2: addskill(DEMOLITIONS, 1); break;
        case 3: vhcl(1); break;
        case 4: gc(1); break;
        case 5: bumpedu(); break;
        case 6: vhcl(1); break;
      }
}

