/* ASLARTST.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void aslartist();
void artistmot(int term);
void artistbene();
void artistskills(int skills);

extern int asl_spec_duty(int need_nbr);
extern int asl_surv(int need_nbr, int upp_type, int upp_val);
extern int reenlist(int need_nbr);
extern int aslmotrolls();
extern void addskill(int skill, int skl_val);
extern int asl_mot();
extern char getche_mot();
extern int asl_cash();
extern int asl_beneroll();
extern void bumpintl();
extern void bumpedu();
extern void bumpsoc();
extern void bumpdex();
extern void independ();
extern int aslpicktable();
extern int d6();
extern int aslsklroll();
extern void physicl(int skl_val);
extern void aslmentl(int skl_val);
extern void aslacad(int skl_val);
extern void aslinbrn(int skl_val);
extern void aslvc(int skl_val);
extern void asltechl(int skl_val);
extern void aslinterp(int skl_val);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_lopsg();
extern void mot_midpsg();

#include "chargen.h"

void aslartist()
{
  int  skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = asl_spec_duty(4);
    newterm = asl_surv(7, dex, 8);
    if (newterm == 0) {
      skills += 3;
    }
    if (skills != 0) artistskills(skills);
    printf("That completes this term!\n");
    if (newterm == 0) newterm = reenlist(4);
  }
  artistmot(aslmotrolls());
  if (sex == 1 && soc >= 9) addskill(LEADER, 1);
}


void artistmot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = asl_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      roll = asl_cash();
      cash--;
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 500; break;
        case 2: amt = 1000; break;
        case 3: amt = 5000; break;
        case 4: amt = 10000; break;
        case 5: amt = 30000; break;
        case 6: amt = 70000; break;
        default: amt= 100000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        term--;
        artistbene();
    }
  }
  if (sex == 1) credits = credits / 2;
  while (term > 0)
  {
    artistbene();
    term--;
  }
}


void artistbene()
{
  int roll;

  roll = asl_beneroll();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpintl(); bumpintl(); break;
    case 3: bumpedu(); bumpedu(); break;
    case 4: mot_weapon(); break;
    case 5: independ(1); break;
    case 6: bumpsoc(); break;
    default: mot_midpsg(); break;
  }
}


void artistskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = aslpicktable();
    roll = d6();
    if (table == 1) {
      roll = aslsklroll(roll);
      switch (roll) {
        case 1: independ(1); break;
        case 2: bumpdex(); break;
        case 3: bumpdex(); break;
        case 4: physicl(1); break;
        case 5: aslmentl(1); break;
        case 6: aslacad(1); break;
      }
    }
    if (table == 2) {
      roll = aslsklroll(roll);
      switch (roll) {
        case 1: independ(1); break;
        case 2: addskill(TRADITION, 1); break;
        case 3: bumpedu(); break;
        case 4: physicl(1); break;
        case 5: aslinbrn(1); break;
        case 6: aslinbrn(1); break;
      }
    }
    if (table == 3) {
      if (sex == 2) {
        switch (roll) {
          case 1: aslvc(1); break;
          case 2: addskill(MECHANICAL, 1); break;
          case 3: bumpdex(); break;
          case 4: aslinbrn(1); break;
          case 5: asltechl(1); break;
          case 6: aslacad(1); break;
        }
      } else {
        switch (roll) {
          case 1: aslacad(1); break;
          case 2: addskill(TRADITION, 1); break;
          case 3: bumpdex(); bumpdex(); break;
          case 4: asltechl(1); break;
          case 5: aslinterp(1); break;
          case 6: aslinbrn(1); break;
        }
      }
    }
    skills--;
  }
}
