/* ASLBELTR.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void aslbelter();
void aslbeltermot(int term);
void aslbelterbene();
void aslbelterskills(int skills);

extern int asl_spec_duty(int need_nbr);
extern int asl_surv(int need_nbr, int upp_type, int upp_val);
extern int reenlist(int need_nbr);
extern int aslmotrolls();
extern void addskill(int skill, int skl_val);
extern int asl_mot();
extern char getche_mot();
extern int asl_cash();
extern int asl_beneroll();
extern void bumpintl();
extern int aslpicktable();
extern int d6();
extern int aslsklroll();
extern void physicl(int skl_val);
extern void aslmentl(int skl_val);
extern void aslmc();
extern void aslst(int skl_val);
extern void aslvhcl(int skl_val);
extern void aslenv(int skl_val);
extern void asltechl(int skl_val);
extern void aslspace(int skl_val);
extern void aslecon(int skl_val);
extern void aslvc(int skl_val);
extern void corp();
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_lopsg();
extern void mot_midpsg();
extern void mot_ship();

#include "chargen.h"

void aslbelter()
{
  int  skills, newterm;
  
  addskill(VACCSUIT, 1);
  newterm = 0;
  while (newterm != 1) {
    skills = asl_spec_duty(6);
    newterm = asl_surv(9, terms, 0);
    if (newterm == 0) skills += 3;
    if (skills != 0) aslbelterskills(skills);
    printf("That competes this term!\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  aslbeltermot(aslmotrolls());
}


void aslbeltermot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = asl_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      roll = asl_cash();
      cash--;
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: break;
        case 2: break;
        case 3: amt = 1000; break;
        case 4: amt = 10000; break;
        default: amt = 100000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        term--;
        aslbelterbene();
    }
  }
  while (term > 0)
  {
    aslbelterbene();
    term--;
  }
}


void aslbelterbene()
{
  int roll;

  roll = asl_beneroll();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpintl(); break;
    case 3: mot_midpsg(); break;
    case 4: mot_weapon(); break;
    case 5: addskill(INDEPENDENCE, 1); break;
    case 6: mot_ship(); break;
    default: corp(); break;
  }
}


void aslbelterskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = aslpicktable();
    roll = d6();
    roll = aslsklroll(roll);
    if (table == 1) {
      switch (roll) {
        case 1: break;
        case 2: physicl(1); break;
        case 3: physicl(1); break;
        case 4: aslmc(); break;
        case 5: aslmentl(1); break;
        case 6: aslmentl(1); break;
      }
    }
    if (table == 2) {
      switch (roll) {
        case 1: break;
        case 2: aslecon(1); break;
        case 3: aslspace(1); break;
        case 4: aslst(1); break;
        case 5: asltechl(1); break;
        case 6: addskill(PROSPECTING, 1); break;
      }
    }
    if (table == 3) {
      switch (roll) {
        case 1: break;
        case 2: aslecon(1); break;
        case 3: aslspace(1); break;
        case 4: aslst(1); break;
        case 5: aslenv(1); break;
        case 6: addskill(PROSPECTING, 1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: break;
        case 2: aslmc(1); break;
        case 3: addskill(PROSPECTING, 1); break;
        case 4: aslvc(1); break;
        case 5: aslvhcl(1); break;
        case 6: aslst(1); break;
      }
    }
    skills--;
  }
}

