/* ASLFLYER.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void aslflyer();
void aslflyermot(int term);
void aslflyerbene();
void aslflyerskills(int skills);

extern int asl_spec_duty(int need_nbr);
extern int asl_surv(int need_nbr, int upp_type, int upp_val);
extern int reenlist(int need_nbr);
extern int aslmotrolls();
extern void addskill(int skill, int skl_val);
extern int asl_comm(int need_nbr, int upp_val, int adj_val);
extern int asl_promo(int need_nbr, int upp_val, int adj_val);
extern int asl_mot();
extern char getche_mot();
extern int asl_cash();
extern int asl_beneroll();
extern void airc(int skl_val);
extern void bumpedu();
extern void bumpsoc();
extern void independ();
extern int aslpicktable();
extern int d6();
extern int aslsklroll();
extern void aslmc(int skl_val);
extern void land();
extern void aslmentl(int skl_val);
extern void aslecon(int skl_val);
extern void aslinbrn(int skl_val);
extern void aslgc(int skl_val);
extern void asltechl(int skl_val);
extern void aslspace(int skl_val);
extern void aslvhcl(int skl_val);
extern void physicl(int skl_val);
extern int find_skl(int skill);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_nada();
extern void mot_midpsg();

#include "chargen.h"

void aslflyer()
{
  int  skills, newterm;
  
  airc(1);
  newterm = 0;
  while (newterm != 1) {
    skills = asl_spec_duty(6);
    newterm = asl_surv(8, dex, 7);
    if (newterm == 0) {
      if (terms == 1) skills += 3;
      else skills += 2;
      skills += asl_comm(10, soc, 9);
      skills += asl_promo(7, edu, 8);
    }
    if (skills != 0) aslflyerskills(skills);
    printf("That competes this term!\n");
    if (newterm == 0) newterm = reenlist(8);
  }
  aslflyermot(aslmotrolls());
  if (soc >= 9) addskill(LEADER, 1);
}


void aslflyermot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = asl_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      roll = asl_cash();
      cash--;
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 1000; break;
        case 2: amt = 5000; break;
        case 3: amt = 5000; break;
        case 4: amt = 5000; break;
        case 5: amt = 10000; break;
        case 6: amt = 20000; break;
        default: amt = 50000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        term--;
        aslflyerbene();
    }
  }
  while (term > 0)
  {
    aslflyerbene();
    term--;
  }
}


void aslflyerbene()
{
  int roll;

  roll = asl_beneroll();
  switch (roll)
  {
	case 1: mot_nada(); break;
	case 2: bumpedu(); break;
    case 3: mot_weapon(); break;
    case 4: mot_weapon(); bumpedu(); break;
    case 5: addskill(INDEPENDENCE, 1); break;
    case 6: mot_midpsg(); break;
    case 7: bumpsoc(); break;
    case 8: land(); break;
  }
}


void aslflyerskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = aslpicktable();
    roll = d6();
    roll = aslsklroll(roll);
    if (table == 1) {
      switch (roll) {
        case 1: independ(1); break;
        case 2: aslmc(1); break;
        case 3: physicl(1); break;
        case 4: aslmentl(1); break;
        case 5: aslecon(1); break;
      }
    }
    if (table == 2) {
      switch (roll) {
        case 1: physicl(1); break;
        case 2: aslvhcl(1); break;
        case 3: aslvhcl(1); break;
        case 4: aslinbrn(1); break;
        case 5: asltechl(1); break;
      }
    }
    if (table == 3) {
      switch (roll) {
        case 1: addskill(SHIPTAC, 1); break;
        case 2: airc(1); break;
        case 3: aslvhcl(1); break;
        case 4: aslspace(1); break;
        case 5: aslinbrn(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: airc(1); break;
        case 2: aslvhcl(1); break;
        case 3: aslspace(1); break;
        case 4: aslgc(1); break;
        case 5: aslinbrn(1); break;
      }
    }
    skills--;
  }
}


