/* ASLMANGR.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void aslmgmt();
void mgmtmot(int term);
void mgmtbene();
void mgmtskills(int skills);

extern int asl_spec_duty(int need_nbr);
extern int asl_surv(int need_nbr, int upp_type, int upp_val);
extern int reenlist(int need_nbr);
extern int aslmotrolls();
extern void addskill(int skill, int skl_val);
extern int asl_comm(int need_nbr, int upp_val, int adj_val);
extern int asl_promo(int need_nbr, int upp_val, int adj_val);
extern int asl_mot();
extern char getche_mot();
extern int asl_cash();
extern int asl_beneroll();
extern void airc(int skl_val);
extern void bumpedu();
extern void bumpintl();
extern void bumpstr();
extern void bumpdex();
extern int aslpicktable();
extern int d6();
extern int aslsklroll();
extern void aslmc();
extern void aslmentl(int skl_val);
extern void aslecon(int skl_val);
extern void aslvc(int skl_val);
extern void aslacad(int skl_val);
extern void aslinterp(int skl_val);
extern void asltechl(int skl_val);
extern void physicl(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_midpsg();
extern void mot_ship();

#include "chargen.h"

void aslmgmt()
{
  int  skills, newterm;
  
  addskill(ADMIN, 1);
  newterm = 0;
  while (newterm != 1) {
    skills = asl_spec_duty(6);
    newterm = asl_surv(7, intl, 8);
    if (newterm == 0) {
      if (terms == 1) skills += 3;
      else skills += 2;
      skills += asl_comm(9, edu, 8);
      skills += asl_promo(8, intl, 8);
    }
    if (skills != 0) mgmtskills(skills);
    printf("That competes this term!\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  mgmtmot(aslmotrolls());
}


void mgmtmot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = asl_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      roll = asl_cash();
      cash--;
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 5000; break;
        case 2: amt = 5000; break;
        case 3: amt = 10000; break;
        case 4: amt = 20000; break;
        case 5: amt = 20000; break;
        case 6: amt = 40000; break;
        default: amt = 100000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        term--;
        mgmtbene();
    }
  }
  while (term > 0)
  {
    mgmtbene();
    term--;
  }
}


void mgmtbene()
{
  int roll;

  roll = asl_beneroll();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpintl(); bumpintl(); break;
    case 3: bumpedu(); bumpedu(); break;
    case 4: mot_midpsg(); break;
    case 5: addskill(INDEPENDENCE, 1); break;
    case 6: mot_midpsg(); break;
    default: mot_ship(); break;
  }
}


void mgmtskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = aslpicktable();
    roll = d6();
    if (table == 1) {
      roll = aslsklroll(roll);
      switch (roll) {
        case 1: break;
        case 2: bumpstr(); break;
        case 3: bumpdex(); break;
        case 4: physicl(1); break;
        case 5: aslmentl(1); break;
        case 6: aslecon(1); break;
      }
    }
    if (table == 2) {
      roll = aslsklroll(roll);
      switch (roll) {
        case 1: break;
        case 2: aslecon(1); break;
        case 3: aslmc(1); break;
        case 4: addskill(TRADER, 1); break;
        case 5: addskill(TOLERANCE, 1); break;
        case 6: aslacad(1); break;
      }
    }
    if (table == 3) {
      switch (roll) {
        case 1: aslinterp(1); break;
        case 2: aslvc(1); break;
        case 3: aslecon(1); break;
        case 4: aslecon(1); break;
        case 5: aslvc(1); break;
        case 6: asltechl(1); break;
      }
    }
    skills--;
  }
}

