/* ASLMARNR.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void aslmariner();
void aslmarinermot(int term);
void aslmarinerbene();
void aslmarinerskills(int skills);

extern int asl_spec_duty(int need_nbr);
extern int asl_surv(int need_nbr, int upp_type, int upp_val);
extern int reenlist(int need_nbr);
extern int aslmotrolls();
extern void addskill(int skill, int skl_val);
extern int asl_comm(int need_nbr, int upp_val, int adj_val);
extern int asl_promo(int need_nbr, int upp_val, int adj_val);
extern int asl_mot();
extern char getche_mot();
extern int asl_cash();
extern int asl_beneroll();
extern void asltechl(int skl_val);
extern void bumpedu();
extern void bumpintl();
extern void bumpend();
extern void bumpdex();
extern void independ();
extern int aslpicktable();
extern int d6();
extern int aslsklroll();
extern void aslmc(int skl_val);
extern void land();
extern void aslmentl(int skl_val);
extern void aslvc(int skl_val);
extern void aslinterp(int skl_val);
extern void aslgc(int skl_val);
extern void aslenv(int skl_val);
extern void aslspclcmbt(int skl_val);
extern void aslvhcl(int skl_val);
extern void aslinbrn(int skl_val);
extern void aslacad(int skl_val);
extern void boats(int skl_val);
extern int find_skl(int skill);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_midpsg();
extern void mot_ship();
extern void mot_nada();

#include "chargen.h"

void aslmariner()
{
  int  skills, newterm;
  
  boats(1);
  addskill(DEWCLAW, 1);
  newterm = 0;
  while (newterm != 1) {
    skills = asl_spec_duty(6);
    newterm = asl_surv(8, end, 8);
    if (newterm == 0) {
      if (terms == 1) skills += 3;
      else skills += 2;
      skills += asl_comm(10, intl, 9);
      skills += asl_promo(8, edu, 8);
    }
    if (skills != 0) aslmarinerskills(skills);
    printf("That competes this term!\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  aslmarinermot(aslmotrolls());
  if (soc >= 9) addskill(LEADER, 1);
}


void aslmarinermot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = asl_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      roll = asl_cash();
      cash--;
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 1000; break;
        case 2: amt = 1000; break;
        case 3: amt = 5000; break;
        case 4: amt = 5000; break;
        case 5: amt = 10000; break;
        case 6: amt = 20000; break;
        default: amt = 40000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        term--;
        aslmarinerbene();
    }
  }
  while (term > 0)
  {
    aslmarinerbene();
    term--;
  }
}


void aslmarinerbene()
{
  int roll;

  roll = asl_beneroll();
  switch (roll)
  {
	case 1: mot_nada(); break;
	case 2: mot_midpsg(); break;
    case 3: bumpedu(); bumpedu(); break;
    case 4: bumpintl(); break;
    case 5: addskill(INDEPENDENCE, 1); break;
    case 6: mot_weapon(); break;
    case 7: mot_ship(); break;
    case 8: land(); break;
  }
}


void aslmarinerskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = aslpicktable();
    roll = d6();
    roll = aslsklroll(roll);
    if (table == 1) {
      switch (roll) {
        case 1: independ(1); break;
        case 2: aslmc(1); break;
        case 3: bumpdex(); break;
        case 4: bumpend(); break;
        case 5: aslvc(1); break;
      }
    }
    if (table == 2) {
      switch (roll) {
        case 1: aslgc(1); break;
        case 2: asltechl(1); break;
        case 3: addskill(FORWARDOBS, 1); break;
        case 4: aslvhcl(1); break;
        case 5: boats(1); break;
      }
    }
    if (table == 3) {
      switch (roll) {
        case 1: boats(1); break;
        case 2: asltechl(1); break;
        case 3: asltechl(1); break;
        case 4: addskill(TOLERANCE, 1); break;
        case 5: aslspclcmbt(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: aslinbrn(1); break;
        case 2: aslenv(1); break;
        case 3: aslmc(1); break;
        case 4: aslinterp(1); break;
        case 5: aslacad(1); break;
      }
    }
    skills--;
  }
}

