/* ASLMLTRY.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void aslmilitary();
void aslmiloff();
int aslmotrolls();
void mltrymot(int term);
void mltrybene();
int asl_beneroll();
void mltryskills(int skills);
void miloffmot(int term);
void miloffbene();
void miloffskills(int skills);
int aslsklroll(int roll);
void aslaging(int anags);
void aslagedex(int d);
void aslagestr(int s);
void aslageend(int e);
void aslageintl(int i);
void independ(int val);
int asl_spec_duty(int neednbr);
int asl_comm(int neednbr, int modifier, int mod_needs);
int asl_promo(int neednbr, int modifier, int mod_needs);
int asl_mot();
int asl_cash();
int asl_bene();
int asl_surv(int need_nbr, int upp_type, int upp_val);

extern int reenlist(int need_nbr);
extern void addskill(int skill, int skl_val);
extern char getche_mot();
extern void bc(int skl_val);
extern void bumpedu();
extern void bumpsoc();
extern void bumpend();
extern void bumpstr();
extern void bumpdex();
extern void bumpintl();
extern int aslpicktable();
extern int d6();
extern int d12();
extern int anag();
extern void aslmc(int skl_val);
extern void land();
extern void aslmentl(int skl_val);
extern void aslecon(int skl_val);
extern void aslinbrn(int skl_val);
extern void aslgc(int skl_val);
extern void asltechl(int skl_val);
extern void aslspclcmbt(int skl_val);
extern void aslvhcl(int skl_val);
extern void asltechl(int skl_val);
extern void aslcmbtsupt(int skl_val);
extern void aslinterp(int skl_val);
extern void aslmilmed(int skl_val);
extern int bp_adj(int roll, int need_nbr);
extern void getrank();
extern int bp_mot(int roll);
extern void physicl(int skl_val);
extern int chk_skl(int skill, int skl_val);
extern int find_skl(int skill);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_midpsg();
extern void mot_lopsg();

#include "chargen.h"

void aslmilitary()
{
  int  skills, newterm;

  if (sex == 2) addskill(RIFLMAN, 1);
  else addskill(DEWCLAW, 1);
  newterm = 0;
  while (newterm == 0)
  {
    if (sex == 1)
	{
      skills = asl_spec_duty(5);
      newterm = asl_surv(7, end, 8);
    }
	else
	{
      skills = asl_spec_duty(6);
      newterm = asl_surv(8, edu, 7);
    }
    if (newterm == 0)
	{
      if (terms == 1) skills += 3;
      else skills += 2;
      if (sex == 1)
	  {
		skills += asl_comm(10, soc, 9);
      }
	  else
	  {
		skills += asl_comm(9, soc, 9);
      }
      if (rankeo == 'O') newterm = 1;
    }
    if (skills != 0) mltryskills(skills);
    printf("That competes this term!\n");
    if (newterm == 0)
	{
      if (sex == 2)
	  {
		newterm = reenlist(5);
      }
	  else
	  {
		newterm = reenlist(4);
      }
    }
  }
  if (rankeo == 'O')
  {
    if (soc < 9)
	{
      soc = 9;
    }
    aslmiloff();
    return;
  }
  mltrymot(aslmotrolls());
  if (sex == 1 && soc >= 9) addskill(LEADER, 1);
}


void aslmiloff()
{
  int  skills, newterm;

  newterm = 0;
  if (sex == 2) addskill(ADMIN, 1);
  else addskill(TACTICS, 1);
  while (newterm == 0)
  {
    skills = asl_spec_duty(4);
    if (sex == 1) newterm = asl_surv(8, edu, 6);
    else newterm = asl_surv(8, intl, 9);
    if (newterm == 0)
	{
      if (terms == 1) skills += 3;
      else skills += 2;
      if (sex == 1) skills += asl_promo(7, edu, 7);
      else skills += asl_promo(7, intl, 9);
    }
    if (skills != 0) miloffskills(skills);
    printf("That competes this term!\n");
    if (newterm == 0)
	{
      if (sex == 2) newterm = reenlist(6);
      else newterm = reenlist(5);
    }
  }
  miloffmot(aslmotrolls());
  if (sex == 1 && soc >= 9) addskill(LEADER, 1);
}


int aslmotrolls()
{
  int  retval;

  retval = (terms - anagathics) * 2;
  if (rankeo == 'O') {
    retval++;
    if (rank >= 4) retval++;
  }
  if (soc >= 9) retval++;
  return retval;
}


void mltrymot(int term)
{
  int  cash, roll, amt;
  char choice;

  cash = asl_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      roll = asl_cash();
      cash--;
      term--;
	  amt = 0;
      switch (roll)
	  {
		case 1: amt = 500; break;
		case 2: amt = 500; break;
		case 3: amt = 1000; break;
		case 4: amt = 1000; break;
		case 5: amt = 5000; break;
		case 6: amt = 5000; break;
		default: amt = 10000; break;
      }
	  mot_cash(amt);
    }
	else
	{
      term--;
      mltrybene();
    }
  }
  if (sex == 1) credits = credits / 2;
  while (term > 0)
  {
    mltrybene();
    term--;
  }
}


void mltrybene()
{
  int roll;

  roll = asl_beneroll();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpend(); break;
    case 3: bumpedu(); break;
    case 4: mot_weapon(); break;
    case 5: addskill(PERSWEAP, 1); break;
    case 6: mot_midpsg(); break;
    case 7: bumpsoc(); break;
    case 8: land(); break;
  }
}


int asl_beneroll()
{
  return asl_bene();
}


void mltryskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = aslpicktable();
    roll = d6();
    if (table == 1) {
      roll = aslsklroll(roll);
      switch (roll) {
	case 1: independ(1); break;
	case 2: bumpstr(); break;
	case 3: bumpdex(); break;
	case 4: physicl(1); break;
	case 5: aslmentl(1); break;
	case 6: aslecon(1); break;
      }
    }
    if (table == 2) {
      roll = aslsklroll(roll);
      switch (roll) {
	case 1: aslgc(1); break;
	case 2: aslvhcl(1); break;
	case 3: aslmc(1); break;
      case 4: addskill(PERSWEAP, 1); break;
      case 5: aslgc(1); break;
	case 6: aslcmbtsupt(1); break;
      }
    }
    if (table == 3) {
      if (sex == 2) {
        switch (roll) {
          case 1: aslinterp(1); break;
          case 2: addskill(MECHANICAL, 1); break;
          case 3: aslcmbtsupt(1); break;
 	    case 4: asltechl(1); break;
	    case 5: asltechl(1); break;
	    case 6: aslmilmed(1); break;
	  }
      } else {
        switch (roll) {
	    case 1: aslspclcmbt(1); break;
	    case 2: aslmc(1); break;
	    case 3: aslvhcl(1); break;
	    case 4: aslvhcl(1); break;
	    case 5: aslinterp(1); break;
	    case 6: aslinbrn(1); break;
	  }
      }
    }
    skills--;
  }
}


void miloffmot(int term)
{
  int  cash, roll;
  char choice;

  cash = asl_mot();
  while ((term > 0) && (cash > 0)) {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c') {
      roll = asl_cash();
      cash--;
      term--;
      switch (roll) {
	case 1: credits += 1000; break;
	case 2: credits += 1000; break;
	case 3: credits += 5000; break;
	case 4: credits += 5000; break;
	case 5: credits += 10000; break;
	case 6: credits += 20000; break;
	default: credits += 50000; break;
      }
    } else {
      term--;
      miloffbene();
    }
  }
  if (sex == 1) credits = credits / 2;
  while (term > 0) {
    miloffbene();
    term--;
  }
}


void miloffbene()
{
  int roll;

  roll = asl_beneroll();
  switch (roll) {
    case 1: midpsg++; break;
    case 2: bumpintl(); break;
    case 3: bumpedu(); bumpedu(); break;
    case 4: weapons++; break;
    case 5: addskill(INDEPENDENCE, 1); break;
    case 6: midpsg++; break;
    case 7: bumpsoc(); break;
    case 8: land(); break;
  }
}


void miloffskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = aslpicktable();
    roll = d6();
    if (table == 1) {
      roll = aslsklroll(roll);
      switch (roll) {
        case 1: independ(1); break;
        case 2: bumpstr(); break;
	  case 3: bumpdex(); break;
        case 4: physicl(1); break;
        case 5: aslmentl(1); break;
        case 6: aslinterp(1); break;
      }
    }
    if (table == 2) {
      roll = aslsklroll(roll);
      switch (roll) {
        case 1: aslinbrn(1); break;
        case 2: aslvhcl(1); break;
        case 3: aslmc(1); break;
        case 4: addskill(TOLERANCE, 1); break;
		case 5: bc(1); break;
        case 6: aslinbrn(1); break;
      }
    }
    if (table == 3) {
      if (sex == 2) {
        switch (roll) {
          case 1: aslinterp(1); break;
          case 2: aslinterp(1); break;
          case 3: aslcmbtsupt(1); break;
          case 4: asltechl(1); break;
          case 5: asltechl(1); break;
          case 6: aslmilmed(1); break;
	  }
      } else {
        switch (roll) {
          case 1: addskill(INDEPENDENCE, 1); break;
          case 2: aslmc(1); break;
          case 3: addskill(LEADER, 1); break;
          case 4: addskill(TOLERANCE, 1); break;
          case 5: aslinterp(1); break;
          case 6: aslinbrn(1); break;
        }
      }
    }
    skills--;
  }
}


int aslsklroll(int roll)
{
  if (sex == 2) roll++;
  else roll--;
  if (roll < 1) roll = 1;
  if (roll > 6) roll = 6;
  return roll;
}


void aslaging(int anags)
{
  int s, d, e, i;

  if (anags == 0) {
    appearent_age += 8;
  }
  if (appearent_age < 56) return;
  if (appearent_age < 64) {
    s = d = 8;
    e = 7;
    i = 0;
  } else {
    if (appearent_age < 72) {
      s = e = 8;
      d = 9;
      i = 0;
    } else {
      if (appearent_age < 88) {
        s = e = d = 9;
        i = 0;
      } else {
        s = e = d = 10;
        i = 9;
      }
    }
  }
  if (anags == 1) {
    if (dex > str && dex > end) {
      aslagedex(d);
    } else {
      if (str >= dex && str > end) {
        aslagestr(s);
      } else {
        aslageend(e);
      }
    }
    if (i > 0) aslageintl(i);
  } else {
    aslagestr(s);
    aslagedex(d);
    aslageend(e);
    aslageintl(i);
  }
}


void aslagedex(int d)
{
  int roll;

  roll = d12();
  if (roll >= d) return;
  dex--;
  if (appearent_age >= 88) dex--;
  return;
}


void aslagestr(int s)
{
  int roll;

  roll = d12();
  if (roll >= s) return;
  str--;
  if (appearent_age >= 88) str--;
  return;
}


void aslageend(int e)
{
  int roll;

  roll = d12();
  if (roll >= e) return;
  end--;
  if (appearent_age >= 88) end--;
  return;
}


void aslageintl(int i)
{
  int roll;

  roll = d12();
  if (roll >= i) return;
  intl--;
  return;
}


void independ(int val)
{
  int roll;

  if (sex == 1) {
    roll = d12();
    if (roll < soc) {
      printf("Failed to get independence skill.\n");
      return;
    }
  }
  addskill(INDEPENDENCE, val);
}


int asl_spec_duty(int neednbr)
{
  int roll;

  roll = d12();
  if (brownie_points > 0 && roll == (neednbr - 1)) roll = bp_adj(roll, neednbr);
  if (roll >= neednbr) {
    printf("You were given special duties!\n");
    if (roll >= (neednbr + 4)) return 3;
    if (roll >= (neednbr + 2)) return 2;
    return 1;
  }
  return 0;
}


int asl_surv(int neednbr, int modifier, int mod_needs)
{
  int roll, anaguser;

  roll = d12();
  if (mod_needs == 0)
  {
    roll += modifier;
  }
  else 
  {
    if (modifier >= mod_needs) roll += 3;
  }
  anaguser = anag();
  if (anaguser >= 1) roll--;
  printf("Survival requires a %d, your modified roll %d.\n", neednbr, roll);
  if (brownie_points > 0 && roll < neednbr) roll = bp_adj(roll, neednbr);
  if (roll >= neednbr)
  {
    age += 8;
    aslaging(anaguser);
  }
  else
  {
    age += 4;
    if (anaguser == 0) appearent_age += 4;
    printf("You did not survive!\n");
    return 1;
  }
  if (str <= 0 || dex <= 0 || end <= 0 || intl <= 0)
  {
    printf("You retired due to old age!\n");
    return 1;
  }
  printf("You survived.\n");
  return 0;
}


int asl_comm(int neednbr, int modifier, int mod_needs)
{
  int roll, retval;

  retval = 0;
  if (rankeo == 'E' && drafted == 0 && neednbr > 0)
  {
    roll = d12();
    if (modifier >= mod_needs) roll++;
    printf("A commission requires a %d, your modified roll %d.\n", neednbr, roll);
    if (brownie_points > 0 && roll < neednbr) roll = bp_adj(roll, neednbr);
    if (roll >= neednbr)
	{
      printf("You received a commission!\n");
      rankeo = 'O';
      rank = 1;
      retval++;
      if (roll >= (neednbr + 2)) retval++;
      if (roll >= (neednbr + 4)) retval++;
    }
  }
  drafted = 0;
  return (retval);
}


int asl_promo(int neednbr, int modifier, int mod_needs)
{
  int roll, retval;

  retval = 0;
  if (rankeo == 'O' && (rank < 6 || (careernbr == PIRATE && rank < 5)))
  {
    roll = d12();
    if (mod_needs != 0)
	{
      if (modifier >= mod_needs) roll++;
    }
	else
	{
      roll = roll + modifier;
    }
    printf("A promotion requires a %d, your modified roll %d.\n", neednbr, roll);
    if (brownie_points > 0 && roll < neednbr) roll = bp_adj(roll, neednbr);
    if (roll >= neednbr)
	{
      retval++;
      rank++;
      printf("You received a promotion! ");
      getrank();
      if (careernbr == PIRATE && rank == 4) addskill(PILOT, 1);
      if (careernbr == FLYER && rank == 4) addskill(LEADER, 1);
      if (roll >= (neednbr + 2)) retval++;
      if (roll >= (neednbr + 4)) retval++;
    }
  }
  return (retval);
}


int asl_mot()
{
  int retval;
  printf("You are being mustered out.\n");
  if (sex == 2) retval = terms;
  else retval = find_skl(INDEPENDENCE);
  if (anagathics >= 1) retval--;
  return (retval);
}


int asl_cash()
{
  int roll;
  
  roll = d6();
  if (chk_skl(INDEPENDENCE, 3) >= 1) roll++;
  if (brownie_points > 0) roll = bp_mot(roll);
  return (roll);
}


int asl_bene()
{
  int roll;

  roll = d6();
  if (sex == 1) roll++;
  if (soc >= 9) roll++;
  if (brownie_points > 0) roll = bp_mot(roll);
  return (roll);
}