/* ASLOTCST.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void asloutcast();
void asloutcastmot(int term);
void asloutcastbene();
void asloutcastskills(int skills);

extern int asl_spec_duty(int need_nbr);
extern int asl_surv(int need_nbr, int upp_type, int upp_val);
extern int reenlist(int need_nbr);
extern int aslmotrolls();
extern void addskill(int skill, int skl_val);
extern int asl_mot();
extern char getche_mot();
extern int asl_cash();
extern int asl_beneroll();
extern void bumpintl();
extern void bumpedu();
extern void bumpsoc();
extern void bumpend();
extern void bumpdex();
extern void independ();
extern int aslpicktable();
extern int d6();
extern int aslsklroll();
extern void physicl(int skl_val);
extern void aslvhcl(int skl_val);
extern void aslmc(int skl_val);
extern void aslinbrn(int skl_val);
extern void aslvc(int skl_val);
extern void asltechl(int skl_val);
extern void aslinterp(int skl_val);
extern void aslexplore(int skl_val);
extern void aslgc(int skl_val);
extern void aslspace(int skl_val);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_midpsg();
extern void mot_lopsg();

#include "chargen.h"

void asloutcast()
{
  int  skills, newterm;
  
  printf("Outcast ");
  if (sex == 1) addskill(INDEPENDENCE, 1);
  newterm = 0;
  while (newterm != 1) {
    skills = asl_spec_duty(5);
    newterm = asl_surv(8, edu, 6);
    if (newterm == 0) skills += 3;
    if (skills != 0) asloutcastskills(skills);
    printf("That competes this term!\n");
    if (newterm == 0) newterm = reenlist(4);
  }
  asloutcastmot(aslmotrolls());
  if (sex == 1 && soc > 9) addskill(LEADER, 1);
}


void asloutcastmot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = asl_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      roll = asl_cash();
      cash--;
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 1000; break;
        case 2: amt = 1000; break;
        case 3: amt = 5000; break;
        case 4: amt = 5000; break;
        case 5: amt = 10000; break;
        case 6: amt = 20000; break;
        default: amt = 40000; break;
      }
	  mot_cash(amt);
    }
	else 
	{
        term--;
        asloutcastbene();
    }
  }
  while (term > 0)
  {
    asloutcastbene();
    term--;
  }
}


void asloutcastbene()
{
  int roll;

  roll = asl_beneroll();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpintl(); break;
    case 3: bumpedu(); break;
    case 4: mot_weapon(); break;
    case 5: addskill(INDEPENDENCE, 1); break;
    case 6: bumpsoc(); break;
    default: mot_midpsg(); break;
  }
}


void asloutcastskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = aslpicktable();
    roll = d6();
    roll = aslsklroll(roll);
     if (table == 1) {
      switch (roll) {
        case 1: independ(1); break;
        case 2: physicl(1); break;
        case 3: bumpdex(); break;
        case 4: aslmc(1); break;
        case 5: addskill(TOLERANCE, 1); break;
        case 6: aslinbrn(1); break;
      }
    }
    if (table == 2) {
      switch (roll) {
        case 1: aslmc(1); break;
        case 2: addskill(DEWCLAW, 1); break;
        case 3: aslvhcl(1); break;
        case 4: aslgc(1); break;
        case 5: addskill(GAMBLING, 1); break;
        case 6: aslinterp(1); break;
      }
    }
    if (table == 3) {
      switch (roll) {
        case 1: aslvc(1); break;
        case 2: asltechl(1); break;
        case 3: aslvc(1); break;
        case 4: aslexplore(1); break;
        case 5: aslinterp(1); break;
        case 6: aslinbrn(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: aslmc(1); break;
        case 2: aslspace(1); break;
        case 3: aslinterp(1); break;
        case 4: addskill(DEWCLAW, 1); break;
        case 5: aslgc(1); break;
        case 6: aslinbrn(1); break;
      }
    }
    skills--;
  }
}


