/* ASLPIRAT.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void aslpirate();
void aslpiratemot(int term);
void aslpiratebene();
void aslpirateskills(int skills);

extern int asl_spec_duty(int need_nbr);
extern int asl_surv(int need_nbr, int upp_type, int upp_val);
extern int reenlist(int need_nbr);
extern int aslmotrolls();
extern void addskill(int skill, int skl_val);
extern int asl_comm(int need_nbr, int upp_val, int adj_val);
extern int asl_promo(int need_nbr, int upp_val, int adj_val);
extern int asl_mot();
extern char getche_mot();
extern int asl_cash();
extern int asl_beneroll();
extern void aslsc(int skl_val);
extern void bumpintl();
extern void bumpdex();
extern void independ();
extern int aslpicktable();
extern int d6();
extern int aslsklroll();
extern void aslmc(int skl_val);
extern void aslenv(int skl_val);
extern void aslvc(int skl_val);
extern void aslecon(int skl_val);
extern void aslinbrn(int skl_val);
extern void aslgc(int skl_val);
extern void asltechl(int skl_val);
extern void aslspace(int skl_val);
extern void aslvhcl(int skl_val);
extern void aslacad(int skl_val);
extern void aslst(int skl_val);
extern void aslinterp(int skl_val);
extern void physicl(int skl_val);
extern int find_skl(int skill);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_lopsg();
extern void mot_ship();

#include "chargen.h"

void aslpirate()
{
  int  skills, newterm;
  
  printf("pirate ");
  addskill(DEWCLAW, 1);
  newterm = 0;
  while (newterm != 1) {
    skills = asl_spec_duty(7);
    newterm = asl_surv(9, intl, 8);
    if (newterm == 0) {
      if (terms == 1) skills += 3;
      else skills += 2;
      skills += asl_comm(9, str, 10);
      skills += asl_promo(8, intl, 8);
    }
    if (skills != 0) aslpirateskills(skills);
    printf("That competes this term!\n");
    if (newterm == 0) newterm = reenlist(7);
  }
  aslpiratemot(aslmotrolls());
  if (sex == 1 && soc >= 9) addskill(LEADER, 1);
}


void aslpiratemot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = asl_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      roll = asl_cash();
      cash--;
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 5000; break;
        case 2: amt = 10000; break;
        case 3: amt = 20000; break;
        case 4: amt = 20000; break;
        case 5: amt = 40000; break;
        case 6: amt = 70000; break;
        default: amt = 100000; break;
      }
	  mot_cash(amt);
    }
	else
	{
      term--;
      aslpiratebene();
    }
  }
  if (sex == 1) credits = credits / 2;
  while (term > 0)
  {
    aslpiratebene();
    term--;
  }
}


void aslpiratebene()
{
  int roll;

  roll = asl_beneroll();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpintl(); break;
    case 3: mot_weapon(); break;
    case 4: mot_weapon(); break;
    case 5: independ(1); break;
    case 6: independ(1); break;
    default: mot_ship(); break;
  }
}


void aslpirateskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = aslpicktable();
    printf("pirate table = %d\n", table);
    roll = d6();
    roll = aslsklroll(roll);
    if (table == 1) {
      switch (roll) {
        case 1: independ(1); break;
        case 2: physicl(1); break;
        case 3: bumpdex(); break;
        case 4: aslmc(1); break;
        case 5: aslenv(1); break;
        case 6: aslspace(1); break;
      }
    }
    if (table == 2) {
      switch (roll) {
        case 1: aslsc(1); break;
        case 2: aslmc(1); break;
        case 3: aslvhcl(1); break;
        case 4: addskill(TOLERANCE, 1); break;
        case 5: aslinbrn(1); break;
        case 6: aslecon(1); break;
      }
    }
    if (table == 3) {
      switch (roll) {
        case 1: aslsc(1); break;
        case 2: aslst(1); break;
        case 3: aslacad(1); break;
        case 4: aslgc(1); break;
        case 5: aslvc(1); break;
        case 6: aslvc(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: aslsc(1); break;
        case 2: aslvhcl(1); break;
        case 3: aslspace(1); break;
        case 4: asltechl(1); break;
        case 5: aslinterp(1); break;
        case 6: aslinbrn(1); break;
      }
    }
    skills--;
  }
}


