/* AdvEdu.C establishes the characters pre-career choices */

#include <stdio.h>
#include <string.h>

/*
#ifndef APPLE_CC
#include <conio.h>
#endif
*/

void med_flt();
void flight_sch(char name[]);
int pick_med_flt();
void trymedsch();
void tryfltsch();
void pick_flt_branch();
void coacc_flt_sch(char name[]);
void pick_extra_flt();
void pickserv();
void trygradsch();
int pickmajor();
int hardsci();
int lifesci();
int socialsci();
int appliedsci();
void trytechacad();
int techacadskills();
void trylawsch();
int lawschskills();

extern int finearts();
extern int bp_adj();
extern int bp_skill1(int roll, int need_nbr);
extern int picktech();
extern int gettech();
extern void gotflyer();
extern void gotdoc();
extern int d5();
extern int d6();
extern int d8();
extern int d12();
extern int getsel_int(int min, int max);
extern int getsel_bigint(int min, int max);
extern void addskill(int skill, int skl_val);
extern int chk_skl(int skill, int skl_val);
extern int picksci();
extern int pickecon();
extern int pickacad();
extern int getsci();
extern int getecon();
extern int getacad();
extern void bumpedu();
extern void gunner(int skl_val);
extern char getche_y_n();
extern void gotaware();
extern void bumppsi();
extern void gotlawyer();
extern void dispskil(int sequ, int skill);
extern void bp_add(int amt);
extern void prntacceptedu(char accepted[], char schoolname[]);
extern void prntgraduateedu(char graduated[], char schoolname[]);
extern void honors();

#include "chargen.h"

extern int tech_sch, univ, mer_acd, mil_acd, nav_acd, air_acd, flt_sch;

void med_flt()
{
	int choice, max;

	printf("You have the following advanced education options.\n\n");
	printf("   1. none\n");
	max = 1;
	if (med_sch > NOTACCEPTED && (col > 10 
		|| (chk_skl(BIOLOGY, 1) > 0 && chk_skl(CHEMISTRY, 1) > 0))
		|| (race == ZHODANI && rankeo == 'O'))
	{
		printf("   2. medical school (roll 9, edu 10)\n");
		max = 2;
	}
	if (((col % 10) == 1) && tech_acd > NOTACCEPTED && race != ITHKLUR)
	{
		printf("   3. technical academy (roll 7, edu 8, int 8) from Geonee\n");
		max = 3;
	}
	if (((col % 10) == 1 || (col % 10) == 2) && grad_sch > NOTACCEPTED)
	{
		printf("   4. graduate school (roll 9, edu ");
		if (race == ITHKLUR)
		{
			printf("7+)\n");
		}
		else
		{
			printf("10+)\n");
		}
		max = 4;
	}
	if (((col == 11 || col == 12) && (otc >= 1)) 
	    || (col >= 15) || (col == 5) || (col == 6)
		|| (race == ZHODANI && rankeo == 'O')
		&& flt_sch > NOTACCEPTED)
	{
		printf("   5. flight school (roll 9, dex 9)\n"); 
		max = 5;
	}
	if (law_sch > NOTACCEPTED && (col % 10) == 2
		&& race != ZHODANI && race != SOLOMANI && race != ITHKLUR)
	{
		printf("   6. law school (roll 9, soc 10) from TNE\n");
		max = 6;
	}
	if (max == 1)
		choice = 1;
	else
		choice = getsel_int(1, max);
	if (choice == 1)
		return;
	if (col > 10 && choice == 2)
	{
		trymedsch();
	    if (med_sch == NOTACCEPTED)
		{
			med_flt();
			return;
		}
	}
	if ((col % 10) == 1 && choice == 3)
	{
		trytechacad();
		if (tech_acd == NOTACCEPTED)
		{
			med_flt();
			return;
		}
	}
	if (((col % 10) == 1 || (col % 10) == 2) && choice == 4)
	{
	    trygradsch();
		if (grad_sch == NOTACCEPTED)
		{
			med_flt();
			return;
		}
	}
	if ((((col == 11 || col == 12) && (otc >= 1)) 
		|| (col >= 15) || (col == 5) || (col == 6)) && choice == 5)
	{
		tryfltsch();
		if (flt_sch == NOTACCEPTED)
		{
			med_flt();
			return;
		}
	}
	if (choice == 6)
	{
		trylawsch();
		if (law_sch == NOTACCEPTED)
		{
			med_flt();
			return;
		}
	}
}


void trymedsch()
{
	int roll, years;
	char name[15];

	strncpy(name, "Medical School", 15);
	roll = d12();
	if (edu >= 10 || (race == ITHKLUR && edu >= 7))
		roll += 2;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 9);
	if (roll >= 9)
	{
		prntacceptedu("", name);
		roll = d12();
		if (edu > 8) roll += 2;
		if (roll < 8 && brownie_points > 0) roll = bp_adj(roll, 8);
		if (roll < 8)
		{
			years = (d6() + 1) / 2;
			age += years;
			appearent_age += years;
			prntgraduateedu("not ", name);
			addskill(MEDICAL, (years - 1));
		}
		else
		{
			if ((careernbr <= MARINE || careernbr == FLYER) && careernbr > 0)
				branch = 5; /* medical branch */
			if (careernbr == ARMY || careernbr == MARINE) line = 1;
			if (race == ZHODANI && careernbr == NAVY) branch = 6;
			if (careernbr == MERCHANT) branch = 3;
			prntgraduateedu("", name);
			med_sch = GRADUATED;
			if (careernbr == 0)
			{
				gotdoc();
				printf("Your career is %s\n", career);
			}
			bp_add(2);
			bumpedu();
			addskill(MEDICAL, 3);
			addskill(ADMIN, 1);
			med_sch = GRADUATED;
			roll = d12();
			if (edu >= 11) roll++;
			if (roll < 11 && brownie_points > 0) roll = bp_adj(roll, 11);
			if (roll >= 11)
			{
			    honors();
				med_sch = HONORS;
				addskill(MEDICAL, 1);
				addskill(COMPUTER, 1);
			}
			age += 4;
			appearent_age += 4;
			rankeo = 'O';
			if (race == ZHODANI)
			{
				rank = 2;
				gotaware();
				bumppsi();
				bumppsi();
			}
			else
				rank = 3;
		}
	}
	else
	{
		prntacceptedu("not ", name);
		med_sch = NOTACCEPTED;
	}
}


void trylawsch()
{
	int roll, years, skills;
	char name[11];

	strncpy(name, "Law School", 11);
	roll = d12();
	if (soc >= 10)
		roll += 2;
	if (roll < 9 && brownie_points > 0) roll = bp_adj(roll, 9);
	if (roll >= 9)
	{
		prntacceptedu("", name);
		roll = d12();
		if (edu > 8) roll += 2;
	    if (roll < 8 && brownie_points > 0) roll = bp_adj(roll, 8);
		if (roll < 8)
		{
			years = (d6() + 1) / 2;
			age += years;
			appearent_age += years;
			prntgraduateedu("not ", name);
			skills = years;
			while (skills > 0)
			{
				addskill(lawschskills(), 1);
			    skills--;
			}
		}
		else
		{
			prntgraduateedu("", name);
			bp_add(2);
			bumpedu();
			addskill(LEGAL, 1);
			addskill(ADMIN, 1);
			skills = 2;
			law_sch = GRADUATED;
			roll = d12();
			if (edu >= 11) roll++;
			if (roll < 11 && brownie_points > 0) roll = bp_adj(roll, 11);
			if (roll >= 11)
			{
			    honors();
				law_sch = HONORS;
				skills++;
			}
			while (skills > 0)
			{
			    addskill(lawschskills(), 1);
				skills--;
			}
			age += 4;
			appearent_age += 4;
			if (careernbr == 0)
				gotlawyer();
		}
	}
	else
	{
		prntacceptedu("not ", name);
	    law_sch = NOTACCEPTED;
	}
}


int lawschskills()
{
	int choice, val;
  
	val = 0;
	if (pick == 2 || pick == 4)
		choice = d5();
	else
	{
		printf("You need to pick skills from Law School.\n");
		dispskil(1, ADMIN);
		dispskil(2, LEGAL);
		dispskil(3, INTERROGATE);
		dispskil(4, PERCEPTION);
		dispskil(5, PERSUASION);
		choice = getsel_int(1, 5);
	}
	switch (choice)
	{
		case 1: val = ADMIN; break;
	    case 2: val = LEGAL; break;
		case 3: val = INTERROGATE; break;
	    case 4: val = PERCEPTION; break;
		case 5: val = PERSUASION; break;
		default: val = -1; break;
	}
	if (val < 1)
		return lawschskills();
	return (val);
}


void tryfltsch()
{
	int roll;
	char name[20];

	strncpy(name, "Flight School", 14);
	if (col < 13)
	{
	    roll = d12();
		if (dex >+ 9)
			roll++;
	    if (roll < 9 && brownie_points > 0)
			roll = bp_adj(roll, 9);
		if (roll < 9)
		{
			prntacceptedu("not ", name);
			flt_sch = NOTACCEPTED;
			return;
		}
	}
	age++;
	appearent_age++;
	if (careernbr == FLYER && race == IMPERIAL)
		strncat(name, " COACC", 6);
	prntacceptedu("", name);
	if (careernbr == FLYER && race == IMPERIAL)
		coacc_flt_sch(name);
	else
		flight_sch(name);
}


void flight_sch(char name[])
{
#ifdef UNIX
	    int ro;
#endif
	int roll;

	roll = d12();
	if (intl >= 8)
		roll++;
	if (roll < 7 && brownie_points > 0)
		roll = bp_adj(roll, 7);
	if (roll < 7)
	{
	    prntgraduateedu("not ", name);
		return;
	}
	prntgraduateedu("", name);
	bp_add(1);
	flt_sch = GRADUATED;
	roll = d6() - 3;
	if (roll < 1)
		roll = 1;
	addskill(PILOT, roll);
	roll = d6();
	if ((roll >= 4 && race != ITHKLUR) || (race == ITHKLUR && roll >= 6))
		addskill(NAVIGATION, 1);
	roll = d6();
	if (roll >= 4)
		addskill(SHIPBOAT, 1);
	if (careernbr <= MARINE)
	{
		printf("Do you want to xfer to ");
	    if (race == IMPERIAL)
			printf("COACC");
		else
			printf("Flyer");
	    printf("? (Y or N)\n->");
#if defined(_WIN32)
		roll = getche();
#endif
#ifdef UNIX
		while ((ro=getchar()) != '\n')
		{
			roll=ro;
		}
#endif
		printf("\n");
		if (roll == 'Y' || roll == 'y')
			gotflyer();
		line = 1;
		if (careernbr == FLYER)
			branch = 1;
		else
			branch = 2;
	}
}


void coacc_flt_sch(char name[])
{
	int roll;

	roll = d12();
	if (dex >= 9) roll++;
	if (roll < 8 && brownie_points > 0) roll = bp_adj(roll, 8);
	if (roll < 8)
	{
		prntgraduateedu("not ", name);
		return;
	}
	flt_sch = GRADUATED;
	prntgraduateedu("", name);
	bp_add(1);
	addskill(PROPAIR, 1);
	addskill(SURVIVAL, 1);
	if (tech >= TLPRESTEL) pick_extra_flt();
	roll = bp_skill1(d6(), 4);
	if (roll >= 4) addskill(NAVIGATION, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4) addskill(TACTICS, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4) gunner(1);
	branch = 2;
	if (tech >= TLPRESTEL) pick_flt_branch();
}


void pick_extra_flt()
{
	int choice, max;

	printf("Please select your area of flying experience.\n\n");
	dispskil(1, JETAIR);
	dispskil(2, HELICOPTER);
	max = 2;
	if (tech >= TLEARSTEL)
	{
		dispskil(3, GRAVVHCL);
		max = 3;
	}
	choice = getsel_int(1, max);
	switch (choice)
	{
		case 1: addskill(JETAIR, 1); break;
		case 2: addskill(HELICOPTER, 1); break;
	    case 3: addskill(GRAVVHCL, 1); break;
	}
}


void pick_flt_branch()
{
	int choice;

	printf("Please choose your branch in the COACC.\n\n");
	printf("   1. orbit\n   2. atmosphere\n");
	choice = getsel_int(1, 2);
	branch = choice;
}


void trygradsch()
{
	int roll, years;
	char name[16];

	strncpy(name, "Graduate School", 16);
	roll = d12();
	if (edu >= 10 || (race == ITHKLUR && edu >= 7))
		roll = roll + 2;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 9);
	if (roll >= 9)
	{
		prntacceptedu("", name);
	    if (careernbr == ARMY || careernbr == MARINE)
			line = 1;
		roll = d12();
		if (edu > 8)
			roll += 2;
		if (roll < 8 && brownie_points > 0)
			roll = bp_adj(roll, 8);
		if (roll < 8)
		{
			years = (d6() + 1) / 2;
			age += years;
			appearent_age += years;
			prntgraduateedu("not ", name);
			years--;
			while (years > 0)
			{
				addskill(pickmajor(), 1);
		        years--;
			}
		}
		else
		{
			prntgraduateedu("", name);
			bp_add(2);
			bumpedu();
			major = pickmajor();
			addskill(major, 3);
			addskill(pickmajor(), 1);
			grad_sch = GRADUATED;
			age += 4;
			appearent_age += 4;
			roll = d12();
			if (edu >= 11)
				roll++;
			if (roll < 11 && brownie_points > 0)
				roll = bp_adj(roll, 11);
			if (roll >= 11)
			{
				honors();
				addskill(major, 1);
				addskill(pickmajor(), 1);
				grad_sch = HONORS;
			}
		}
	}
	else
	{
		prntacceptedu("not ", name);
		grad_sch = NOTACCEPTED;
	}
}


int pickmajor()
{
	int choice, val;
  
	val = 0;
	if (pick == 2 || pick == 4)
	{
		choice = d6();
		if (choice == 6)
		{
			val = d6();
			if (val > 3)
				choice -= (val - 3);
			val = 0;
		}
	}
	else
	{
		printf("You need to pick your field(s) of study.\n");
		printf("\n   1. hard science\n   2. life science\n   3. social science\n");
		printf("   4. applied science\n   5. fine arts\n");
		dispskil(6, ECONOMIC);
		dispskil(7, LEADER);
		dispskil(8, RESEARCH);
		dispskil(9, INSTRUCTION);
		choice = getsel_int(1, 9);
	}
	switch (choice)
	{
		case 1: val = hardsci(); break;
		case 2: val = lifesci(); break;
		case 3: val = socialsci(); break;
		case 4: val = appliedsci(); break;
		case 5: val = finearts(); break;
		case 6: 
			{
				if (pick == 2 || pick == 4)
					val = getecon();
				else
					val = pickecon();
				break;
			}
		case 7: val = LEADER; break;
		case 8: val = RESEARCH; break;
		case 9: val = INSTRUCTION; break;
	}
	if (val == 0)
		val = pickmajor();
	return (val);
}


int hardsci()
{
	int choice, val;
  
	if (pick == 2 || pick == 4)
	{
		choice = d6() + 1;
		if (race == ITHKLUR && choice == 3)
			choice = d6() + 1;
	}
	else
	{
		printf("You need to pick your field of study within the hard sciences.\n");
		printf("\n   1. none\n");
		dispskil(2, ASTRONOMY);
		dispskil(3, CHEMISTRY);
		dispskil(4, GEOLOGY);
		dispskil(5, MATH);
		dispskil(6, PHYSICS);
		dispskil(7, METEOROLOGY);
		choice = getsel_int(1, 7);
	}
	switch (choice)
	{
		case 1: return 0;
		case 2: val = ASTRONOMY; break;
		case 3: val = CHEMISTRY; break;
		case 4: val = GEOLOGY; break;
		case 5: val = MATH; break;
		case 6: val = PHYSICS; break;
		case 7: val = METEOROLOGY; break;
	}
	if (val == 0)
		val = hardsci();
	return (val);
}


int lifesci()
{
	int choice, val;
  
	if (pick == 2 || pick == 4)
	{
		choice = d5() + 1;
		if (race == ITHKLUR && (choice == 4 || choice == 6))
			choice = d5() + 1;
	}
	else
	{
		printf("You need to pick your field of study within the life sciences.\n");
		printf("\n   1. none\n");
		dispskil(2, SOPHONTOLOGY);
		dispskil(3, BIOLOGY);
		dispskil(4, CRYONICS);
		dispskil(5, GENETICS);
		dispskil(6, MEDICAL);
		choice = getsel_int(1, 6);
	}
	switch (choice)
	{
		case 1: return 0;
		case 2: val = SOPHONTOLOGY; break;
		case 3: val = BIOLOGY; break;
		case 4: val = CRYONICS; break;
		case 5: val = GENETICS; break;
		case 6: val = MEDICAL; break;
	}	
	if (val == 0)
		val = lifesci();
	return (val);
}


int socialsci()
{
	int choice, val;
  
	if (pick == 2 || pick == 4 || (race == ITHKLUR && (col <= 0 || terms > 1)))
	{
		choice = d6() + 1;
		if (race == ITHKLUR && choice >= 5)
			choice = d6() + 1;
	}
	else
	{
		printf("You need to pick your field of study within the social sciences.\n");
		printf("\n   1. none\n");
		dispskil(2, ARCHAEOLOGY);
		dispskil(3, LINGUISTICS);
		dispskil(4, HISTORY);
		dispskil(5, PSYCHOLOGY);
		dispskil(6, SOCIOLOGY);
		dispskil(7, THEOLOGY);
		choice = getsel_int(1, 7);
	}
	switch (choice)
	{
		case 1: return 0;
		case 2: val = ARCHAEOLOGY; break;
		case 3: val = LINGUISTICS; break;
		case 4: val = HISTORY; break;
		case 5: val = PSYCHOLOGY; break;
		case 6: val = SOCIOLOGY; break;
		case 7: val = THEOLOGY; break;
	}
	if (val == 0)
		val = socialsci();
	return (val);
}


int appliedsci()
{
	int choice, val;
  
	if (pick == 2 || pick == 4)
		choice = d8() + 1;
	else
	{
		printf("You need to pick your field of study within the applied sciences.\n");
		printf("\n   1. none\n");
		dispskil(2, COMMO);
		dispskil(3, COMPUTER);
		dispskil(4, ELECTRONICS);
		dispskil(5, ENGINEERING);
		dispskil(6, GRAVITICS);
		dispskil(7, MECHANICAL);
		dispskil(8, ROBOTICS);
		dispskil(9, NAVALARCH);
		choice = getsel_int(1, 9);
	}
	switch (choice)
	{
		case 1: return 0;
		case 2: val = COMMO; break;
		case 3: val = COMPUTER; break;
		case 4: val = ELECTRONICS; break;
		case 5: val = ENGINEERING; break;
		case 6: val = GRAVITICS; break;
		case 7: val = MECHANICAL; break;
		case 8: val = ROBOTICS; break;
		case 9: val = NAVALARCH; break;
	}
	if (val == 0)
		val = appliedsci();
	return (val);
}


void trytechacad()
{
	int roll;
	char name[17];

	strncpy(name, "Techical Academy", 17);
	roll = d12();
	if (edu >= 8)
		roll += 2;
	if (intl >= 8)
		roll++;
	if (roll < 7 && brownie_points > 0)
		roll = bp_adj(roll, 7);
	if (roll >= 7)
	{
		prntacceptedu("", name);
		roll = d12();
		if (end >= 8)
			roll++;
		if (intl >= 8)
			roll += 2;
		if (roll < 9 && brownie_points > 0)
			roll = bp_adj(roll, 9);
		if (roll < 9)
		{
			age++;
			appearent_age++;
			prntgraduateedu("not ", name);
			addskill(techacadskills(), 1);
		}
		else
		{
			prntgraduateedu("", name);
			bumpedu();
			addskill(COMPUTER, 1);
			addskill(techacadskills(), 1);
			addskill(techacadskills(), 1);
			tech_acd = GRADUATED;
			age += 2;
			appearent_age += 2;
			bp_add(1);
			roll = d12();
			if (roll < 10 && brownie_points > 0)
				roll = bp_adj(roll, 10);
			if (roll >= 10)
			{
				honors();
				tech_acd = HONORS;
			}
		}
	}
	else
	{
		prntacceptedu("not ", name);
		tech_acd = NOTACCEPTED;
	}
}


int techacadskills()
{
	int choice, val;

	if (pick == 2 || pick == 4)
		choice = d5();
	else
	{
		printf("You need to pick your field of study at the technical academy.\n\n");
		dispskil(1, HANDYMAN);
		dispskil(2, TECHNICAL);
		dispskil(3, COMPUTER);
		dispskil(4, SCIENCE);
		dispskil(5, ACADEMIC);
		choice = getsel_int(1, 5);
	}
	switch (choice)
	{
		case 1: val = HANDYMAN; break;
		case 2:
			{
				if (pick == 2 || pick == 4)
					val = gettech();
				else
					val = picktech();
				break;
			}
		case 3: val = COMPUTER; break;
		case 4:
			{
				if (pick == 2 || pick == 4)
					val = getsci();
				else
					val = picksci();
				break;
			}
		case 5:
			{
				if (pick == 2 || pick == 4)
					val = getacad();
				else
					val = pickacad();
				break;
			}
	}
	if (val <= 0)
		val = techacadskills();
	return(val);
}
