/* CGMERCH.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
#ifndef APPLE_CC
#include <conio.h>
#endif
*/

#include "chargen.h"

void mer_branch(int branch_nbr);
int mer_doterms();
int mer_do_year();
int mer_xfer();
void mer_get_branch();
int mer_set_branch();
void mer_prt_branch(int branch);
void mer_position();
void merchantmot(int term);
void deck();
void mer_engr();
void purser();
void mer_medic();
void mer_admin();
void sales();
void mer_life();
void mer_ship();
void mer_off();
void mer_skill();
void master();
void mer_planet();
void ft_life();
void ft_service();
void ft_business();
void mer_gen_skl();
int ft_pick();
void mer_duty();
void mer_pick_tbl();
void mer_cross_train();
void mer_branch_tbl(int brnch);
void mer_promo();
void mer_test();
void mer_commission();
void deck_promo();
void noqual();
void mer_do_promo(int need);
void free_promo();
void admn_promo();
void engr_promo();
void sale_promo();
void purs_promo();
void trymerchant();
void pickline();
void join_mega();
void join_sector();
void join_subs();
void join_infc();
void join_fledg();
void join_ft();
void mer_spcl_duty();
void mer_trade_stn();
void mer_cmd_sch();
void mer_deck_sch();
void mer_engr_sch();
void mer_purser_sch();
void mer_bus_sch();
void mer_sec_trng();
void mer_helm_trng();
void mer_drive_trng();
void mer_steward_trng();

extern long mer_cash();
extern int bp_skill(int roll);
extern int bp_skill1(int roll, int need_nbr);
extern int bp_adj(int roll, int nbr);
extern int bp_add(int roll);
extern int mer_asgn();
extern int anag();
extern void adv_aging(int anags);
extern int getrank();
extern int survive(int adjust, int roll);
extern int basic_cash();
extern int basic_mot();
extern int merchantbene();
extern void mer_bonus();
extern int d4();
extern int d5();
extern int d6();
extern int d7();
extern int d8();
extern int d12();
extern int getsel_int(int min, int max);
extern char getche_y_n();
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int chk_skl(int skill, int skl_val);
extern int bp_skill(int roll);
extern int reenlist(int need_nbr);
extern void decorate(int adjust);
extern void bumpdex();
extern void bumpedu();
extern void bc(int skl_val);
extern void gc(int skl_val);
extern void env(int amount);
extern void vhcl(int skl_val);
extern void gotmerch();
extern void gunner(int skl_val);
extern void zhopsiedu();
extern void gotspcldty(int spcldutynbr);
extern void instructor(int spcldutynbr);
extern void mot_cash(int amt);

int  mer_anag, mer_cross[7], position;
int mega, sect, subs, infc, fledg, ft;

void mer_branch(int branch_nbr)
{
	switch (branch_nbr)
	{
		case 1: strncpy(office,"Deck",5); break;
		case 2: strncpy(office,"Engineering",12); break; 
		case 3: strncpy(office,"Purser",7); break; 
		case 4: strncpy(office,"Administration",15); break; 
		case 5: strncpy(office,"Sales",6); break; 
		case 6: strncpy(office,"Free Trader",12); break; 
		default: strncpy(office,"unknown?",9); break;
	}
}


int mer_doterms()
{
	int survival, need_nbr;
  
	assignment = 0;
	if (terms == 0 && rankeo == 'E' && soc >= 10 && race == ZHODANI)
		rankeo = 'O';
	adv_aging(mer_anag);
	do
	{
		survival = mer_do_year();
	} while (((age % 4) != 2) && (survival == 0));
	if (survival != 0) return 1;
	need_nbr = 4;
	if (rankeo == 'O' && rank >= 1)
		need_nbr++;
	survival = reenlist(need_nbr);
	if (survival != 0)
		return 1; 
	branch = mer_xfer();
	mer_anag = anag();
	if (rankeo == 'E')
		rank++;
	return 0;
}


int mer_do_year()
{
	int   adjust, roll;
  
	position = 0;
	age++;
	if (mer_anag == 0)
		appearent_age++;
	assignment = mer_asgn();
	if (rankeo == 'O')
		mer_position();
	if (position != 0)
		mer_promo();
	adjust = 0;
	if (rankeo == 'E' && assignment == 1)
		mer_test();
	if (skil != 0)
	{
		roll = d12();
		if (roll < skil)
			roll = bp_skill(roll);
		if (roll >= (skil + 4))
			if (spec_skill != 0)
			{
				printf("Increasing your specialty skill. ");
				addskill(spec_skill, 1);
			}
			else
			{
				mer_gen_skl();
				mer_gen_skl();
			}
		else
			if (roll >= skil)
				mer_gen_skl();
	}
	roll = d12();
	if (decor != 0)
		mer_bonus();
	return survive(roll, adjust);
}


int mer_xfer()
{
	char choice;
	int  i, roll;

	if (branch == 6)
		return 6;
	if (rankeo == 'O' && rank >= 4)
	{
		mer_cross[1]++;
		printf("You were assigned to the deck branch.\n");
		return 1;
	}
	if (pick == 4)
	{
		roll = d5();
		if (mer_cross[roll] == 0)
		{
			mer_branch(branch);
			printf("You are in the %s branch.\n", office);
			return branch;
		}
		else
		{
			mer_branch(roll);
			printf("You are in the %s branch.\n", office);
			return roll;
		}
	}
	for (i = 1; i <= 5; i++)
	{
		if (mer_cross[i] != 0 && branch != i)
		{
			mer_branch(i);
			printf("You have the option to transfer to the %s branch.\n", office); 
			printf("Do you want to?");
			choice = getche_y_n();
			if (choice == 'Y' || choice == 'y')
				return i;
		}
	}
	return branch;
}


void mer_get_branch()
{
	if (branch != 0)
		return;
	branch = mer_set_branch();
	mer_prt_branch(branch);
}


void mer_prt_branch(int branch)
{
	mer_cross[branch]++;
	mer_branch(branch);
	printf("You were assigned to the %s branch.\n", office);
}


int mer_set_branch()
{
	int roll;

	if (line == 6)
		return 6;
	if ((rankeo == 'O' && rank >= 5) || (chk_skl(PILOT, 1) > 0))
		return 1;
	if (med_sch > 0)
		return 3;
	if (chk_skl(MECHANICAL, 1) > 0 || chk_skl(ENGINEERING, 1) > 0)
		return 2;
	if (chk_skl(TRADER, 1) > 0 || chk_skl(BROKER, 1) > 0)
		return 5;
	if (chk_skl(ADMIN, 1) > 0)
		return 4;
	roll = d6();
	if (rankeo == 'O')
		roll++;
	if (roll <= 3)
		return 3;
	if (line <= 2 && roll == 4 && race != DOLPHINS)
		return 5;
	if (line >= 3 && roll == 7)
		return 1;
	return 2;
}


void mer_position()
{
	int roll;

	if (line <= 2)
	{
		switch (branch)
		{
			case 1: promo = 9; break;
			case 2: promo = 8; break;
			case 3: promo = 7; break;
			case 4: promo = 8; break;
			case 5: promo = 6; break;
		}
	}
	else
	{
		switch (branch)
		{
			case 1: promo = 10; break;
			case 2: promo = 8; break;
			case 3: promo = 6; break;
			case 4: promo = 9; break;
			case 5: promo = 6; break;
			case 6: promo = 8; break;
		}
	}
	roll = d12();
	if (intl >= 9)
		roll++;
	if (line != 6 && edu >= 9)
		roll++;
	if (roll >= promo)
	{
		printf("You got a position. ");
		position = 1;
	}
	else
	{
		printf("You found no position. ");
		position = 0;
	}
}


void merchantmot(int term)
{
//#ifdef UNIX
	int ch;
//#endif
	int  cash;
	long cred;
	int choice;
  
	cash = basic_mot();
	if (cash > term)
		cash = term;
	while ((term > 0) && (cash > 0))
	{
		printf("Do you want to use the cash or benefits table? (c/b)\n->");
		/*
#ifndef APPLE_CC
		choice = getche();
#endif
*/
//#ifdef UNIX
		while ((ch=getchar()) != '\n')
		{
			choice=ch;
		}
//#endif
		printf("\n");
		if (choice == 'C' || choice == 'c')
		{
			cash--;
			term--;
			cred = mer_cash();
			mot_cash(cred);
		}
		else
		{
			if (choice == 'B' || choice == 'b')
			{
				merchantbene();
				term--;
			}
			else
			{
				printf("Wrong - try again!\n");
			}
		}
	}
	while (term > 0)
	{
		merchantbene();
		term--;
	}
}


/* skill tables for merchant characters */

void deck()
{
	int roll;

	roll = d6();
	switch (roll)
	{
		case 1: addskill(NAVIGATION, 1); break;
		case 2: addskill(ADMIN, 1); break;
		case 3: addskill(PILOT, 1); break;
		case 4: addskill(LEGAL, 1); break;
		case 5: addskill(SHIPBOAT, 1); break;
		default: addskill(LEADER, 1); break;
	}
}


void mer_engr()
{
	int roll;

	roll = d6();
	switch (roll)
	{
		case 1: addskill(MECHANICAL, 1); break;
		case 2: addskill(ELECTRONICS, 1); break;
		case 3: addskill(ENGINEERING, 1); break;
		case 4: addskill(ADMIN, 1); break;
		case 5: addskill(ENGINEERING, 1); break;
		default: addskill(GRAVITICS, 1); break;
	}
}


void purser()
{
	int roll;

	roll = d6();
	if (race == HIVER && roll == 5)
		roll = d6();
	switch (roll)
	{
		case 1:
			{
				if (race == HIVER)
					addskill(PSYCHOLOGY, 1);
				else
					addskill(STEWARD, 1);
				break;
			}
	    case 2: addskill(MEDICAL, 1); break;
		case 3:
			{
				if (race == HIVER)
					addskill(TRANSLATOR, 1);
				else
					addskill(LIAISON, 1);
				break;
			}
	    case 4: gunner(1); break;
		case 5: addskill(STEWARD, 1); break;
		default: addskill(LIAISON, 1); break;
	}
}


void mer_medic()
{
	int roll;

	roll = d6();
	if (race == HIVER && roll == 1)
		roll = d6();
	switch (roll)
	{
		case 1: addskill(STEWARD, 1); break;
	    case 2: addskill(MEDICAL, 1); break;
		case 3: addskill(MEDICAL, 1); break;
	    case 4: addskill(MEDICAL, 1); break;
		case 5: addskill(COMPUTER, 1); break;
		default: addskill(MEDICAL, 1); break;
	}
}


void mer_admin()
{
	int roll;

	roll = d6();
	if (race == DOLPHINS && roll == 3)
		roll++;
	if (race == HIVER && roll == 3)
		roll = d6();
	switch (roll)
	{
		case 1: addskill(ADMIN, 1); break;
	    case 2: addskill(LIAISON, 1); break;
		case 3: addskill(BRIBERY, 1); break;
	    case 4: addskill(ADMIN, 1); break;
		case 5: addskill(ADMIN, 1); break;
		default: addskill(STREETWISE, 1); break;
	}
}


void sales()
{
	int roll;

	roll = d6();
	if (race == DOLPHINS && roll <= 2)
		roll += 2;
	if (race == DOLPHINS && roll >= 5)
		roll -= 2;
	switch (roll)
	{
		case 1: addskill(TRADER, 1); break;
		case 2: addskill(BROKER, 1); break;
		case 3: addskill(COMPUTER, 1); break;
		case 4: addskill(LIAISON, 1); break;
		case 5: addskill(TRADER, 1); break;
		default: addskill(BROKER, 1); break;
	}
}


void mer_life()
{
	int roll;

	roll = d6();
	if (race == DOLPHINS && (roll == 3 || roll == 5))
		roll++;
	if (race == HIVER && roll == 1)
		roll = d6();
	switch (roll)
	{
		case 1: addskill(BRAWLING, 1); break;
	    case 2: addskill(CAROUSING, 1); break;
		case 3: addskill(GAMBLING, 1); break;
	    case 4: bumpedu(); break;
		case 5: addskill(TRADER, 1); break;
		default: addskill(CAROUSING, 1); break;
	}
}


void mer_ship()
{
	int roll;

	roll = d6();
	if (race == DOLPHINS && roll == 1)
		roll++;
	if (race == HIVER && roll == 2)
		roll = d6();
	switch (roll)
	{
		case 1: addskill(GAMBLING, 1); break;
	    case 2: bc(1); break;
		case 3: addskill(VACCSUIT, 1); break;
	    case 4: addskill(NOGRAV, 1); break;
		case 5: addskill(COMMO, 1); break;
		default: addskill(HANDYMAN, 1); break;
	}
}


void mer_off()
{
	int roll;

	roll = d6();
	if (race == HIVER && (roll == 1 || roll == 4))
		roll = d6();
	switch (roll)
	{
		case 1: addskill(BRAWLING, 1); break;
	    case 2: vhcl(1); break;
		case 3: addskill(SHIPBOAT, 1); break;
	    case 4: gc(1); break;
		case 5: addskill(LIAISON, 1); break;
	    default:
			{
				if (race == HIVER)
					addskill(MANIPULATION, 1);
				else
					addskill(LIAISON, 1);
				break;
			}
	}
}


void mer_skill()
{
	int roll;

	roll = d6();
	if (race == DOLPHINS && (roll == 2 || roll == 6))
		roll--;
	if (race == DOLPHINS && roll == 3)
		roll++;
	switch (roll)
	{
		case 1: addskill(STREETWISE, 1); break;
		case 2: addskill(BROKER, 1); break;
		case 3: addskill(TRADER, 1); break;
		case 4: addskill(ADMIN, 1); break;
		case 5: addskill(LIAISON, 1); break;
		default: addskill(LEGAL, 1); break;
	}
}


void master()
{
	int roll;

	roll = d6();
	if (race == DOLPHINS && roll == 6)
		roll--;
	if (race == HIVER && roll == 6)
		roll = d6();
	switch (roll)
	{
		case 1:
			{
			if (race == HIVER)
				addskill(MANIPULATION, 1);
			else
				addskill(ADMIN, 1);
			break;
			}
	    case 2: addskill(COMPUTER, 1); break;
		case 3: addskill(NAVIGATION, 1); break;
	    case 4: addskill(PILOT, 1); break;
		case 5: addskill(LEADER, 1); break;
	    default: addskill(BRIBERY, 1); break;
	}
}


void mer_planet()
{
	int roll;

	roll = d6();
	if (race == HIVER && roll >= 4)
		roll = d6();
	switch (roll)
	{
	    case 1: addskill(STREETWISE, 1); break;
		case 2: addskill(VACCSUIT, 1); break;
	    case 3: addskill(VACCSUIT, 1); break;
		case 4: gc(1); break;
		case 5: gc(1); break;
		default: addskill(BRAWLING, 1); break;
	}
}


void ft_life()
{
	int roll;

	roll = d6();
	if (race == DOLPHINS && roll < 4)
		roll += 3;
	if (race == HIVER && roll < 4)
		roll = d6();
	switch (roll)
	{
		case 1: addskill(BRAWLING, 1); break;
	    case 2: addskill(FORGERY, 1); break;
		case 3: addskill(BRIBERY, 1); break;
	    case 4: bumpdex(); break;
		case 5: addskill(STREETWISE, 1); break;
		default: addskill(LEGAL, 1); break;
	}
}


void ft_service()
{
	int roll;

	roll = d6();
	if (race == DOLPHINS && (roll == 2 || roll == 3))
		roll += 2;
	if (race == HIVER && roll == 1)
		roll = d6();
	switch (roll)
	{
		case 1: addskill(STEWARD, 1); break;
	    case 2: addskill(TRADER, 1); break;
		case 3: addskill(BROKER, 1); break;
	    case 4: addskill(ADMIN, 1); break;
		case 5: gunner(1); break;
		default: addskill(LEADER, 1); break;
	}
}


void ft_business()
{
	int roll;

	roll = d6();
	if (race == DOLPHINS && roll == 6)
		roll--;
	if (race == HIVER && roll == 3)
		roll = d6();
	switch (roll)
	{
		case 1: addskill(ENGINEERING, 1); break;
	    case 2: addskill(NAVIGATION, 1); break;
		case 3: addskill(STEWARD, 1); break;
	    case 4: addskill(LEGAL, 1); break;
		case 5: addskill(PILOT, 1); break;
		default: addskill(BROKER, 1); break;
	}
}


void mer_gen_skl()
{
	int roll;

	if (pick <= 2 && line != 6)
	{
		mer_pick_tbl();
		return;
	}
	if (line == 6)
	{
		if (pick <= 2)
			roll = ft_pick();
		else
		{
			roll = d6();
		}
		switch (roll)
		{
			case 1: ft_life(); break;
			case 2: ft_service(); break;
			case 3: ft_business(); break;
			case 4: mer_life(); break;
			case 5: mer_ship(); break;
			case 6: mer_skill(); break;
		}
		return;
	}
	if (rankeo == 'O')
	{
		roll = d7();
		if (roll > 6) roll = 3;
		if (rank < 4 && branch == 1 && roll == 6) roll = 3;
	}
	else
	{
		roll = d6();
		if (roll > 4)
			roll = 3;
	}
	switch (roll)
	{
		case 1: mer_life(); break;
		case 2: mer_duty(); break;
		case 3: mer_branch_tbl(branch); break;
		case 4: mer_skill(); break;
		case 5: mer_off(); break;
		case 6: master(); break;
	}
}


int ft_pick()
{
	int choice;

	printf("\nPlease select the table you wish to use for your new skill.\n\n");
	printf("   1. Free Trader life\n");   
	printf("   2. Free Trader Service\n"); 
	printf("   3. Free Trader Business\n");
	printf("   4. Merchant life\n");   
	printf("   5. Shipboard life\n");   
	printf("   6. Merchant Skills\n");
	choice = getsel_int(1, 6);
	return choice;
}


void mer_duty()
{
	if (branch >= 4)
		mer_planet();
	else
		mer_ship();
}


void mer_pick_tbl()
{
	int choice, max;

	max = 4;
	printf("\nPlease select the table you wish to use for your new skill.\n");
	printf("\n   1. Merchant life\n");   
	mer_branch(branch);
	printf("   2. The table for %s\n", office); 
	if (branch <= 3)
		printf("   3. Shipboard life\n");
	else
		printf("   3. Planet life\n");
	printf("   4. Merchant Skills\n");
	if (rankeo == 'O') 
	{
		printf("   5. Officer Skills\n");
		max = 5;
	}
	if (rankeo == 'O' && rank >= 4 && branch == 1) 
	{
		printf("   6. Master Skills\n");
		max = 6;
	}
	if (race == ZHODANI && soc >= 10)
	{
		printf("   7. Noble/Intendent education\n");
		max = 7;
	}
	choice = getsel_int(1, max);
	switch (choice)
	{
		case 1: mer_life(); break;
		case 2: mer_branch_tbl(branch); break;
		case 3: mer_duty(); break;
		case 4: mer_skill(); break;
		case 5: mer_off(); break;
		case 6: master(); break;
		case 7: zhopsiedu(); break;
	}
}


void mer_cross_train()
{
	int  roll;

	printf("You got cross-training.\n");
	if (pick >= 3)
	{
		roll = d5();
		mer_cross[roll]++;
		mer_branch_tbl(roll);
		if (rankeo == 'E' || rank <= 4)
			branch = roll;
		return;
	}
	printf("You have the option to get cross-training in any field. Pick one.\n");
	printf("\n   1. deck");
	if (mer_cross[1] > 0)
		printf("*");
	printf("\n   2. engineering");
	if (mer_cross[2] > 0)
		printf("*");
	printf("\n   3. purser");
	if (mer_cross[3] > 0)
		printf("*");
	printf("\n   4. administrative");
	if (mer_cross[4] > 0)
		printf("*");
	printf("\n   5. sales");
	if (mer_cross[5] > 0)
		printf("*");
	printf("\n\n* = already cross-trained in this branch\n");
	roll = getsel_int(1, 5);
	mer_branch_tbl(roll);
	mer_cross[roll]++;
	if (rankeo == 'E' || rank <= 4)
		branch = roll;
}


void mer_branch_tbl(int brnch)
{
	switch (brnch)
	{
		case 1: deck(); break;
		case 2: mer_engr(); break;
		case 3:
			{
				if (rankeo == 'O' && rank > 0 && medic != 0)
					mer_medic();
				else
					purser(); 
				break;
			}
		case 4: mer_admin(); break;
		case 5: sales(); break;
	}
}


void mer_promo()
{
	if (rankeo != 'O')
		return;
	if (branch < 6 && branch > 1 && rank >= 4)
		return;
	if (branch == 6 && rank >= 6)
		return;
	if (rank >= 7)
		return;
	switch (branch)
	{
		case 1: deck_promo(); break;
		case 2: engr_promo(); break;
		case 3: purs_promo(); break;
		case 4: admn_promo(); break;
		case 5: sale_promo(); break;
		case 6: free_promo(); break;
	}
}


void mer_test()
{
	int roll, need;

	if (rankeo != 'E')
		return;
	roll = d12();
	switch (branch)
	{
		case 1: need = 6; break;
		case 2: need = 5; break;
		case 3: need = 5; break;
		case 4: need = 5; break;
		case 5: need = 4; break;
		case 6: if (race == HIVER) need = 4; else need = 6; break;
	}
	if (roll < need)
	{
		printf("You did not pass your exam for a comission.\n");
		return;
	}
	mer_commission();
}

void mer_commission()
{
	printf("You passed your exam for a commission.\n");
	rankeo = 'O';
	if (line == 6)
		rank = 1;
	else
		rank = 0;
}


void deck_promo()
{
	int qual, need;

	switch (rank)
	{
		case 0: need = 6; qual = chk_skl(NAVIGATION, 1); break;
		case 1: need = 6; qual = chk_skl(ADMIN, 1); break;
		case 2: need = 7; qual = chk_skl(SHIPBOAT, 1) + chk_skl(PILOT, 2); break;
		case 3: need = 7; qual = chk_skl(PILOT, 1); break;
		case 4: need = 9; qual = chk_skl(LEGAL, 1); break;
		case 5: need = 8; qual = 1; break;
		case 6: need = 8; qual = 1; break;
	}
	/* business school gives plus 1 to attempts for rank 6 and 7 */
	if (special_duty[BUSINESSSCH] > 0 && rank >= 5) need--;
	if (qual == 0)
	{
		noqual();
		return;
	}
	mer_do_promo(need);
}


void noqual()
{
	printf("You did not qualify for your next exam.\n");
}

 
void mer_do_promo(int need)
{
	int roll;

	printf("You qualified to take your exam. ");
	roll = d12();
	if (roll < need)
		roll = bp_adj(roll, need);
	if (roll >= need)
	{
		rank++;
		printf("You were promoted.\n");
		mer_gen_skl();
	}
	else
		printf("You failed your exam.\n");
}


void free_promo()
{
	int qual, need;

	switch (rank)
	{
		case 1: need = 6; qual = chk_skl(ENGINEERING, 1); break;
		case 2: need = 7; qual = chk_skl(NAVIGATION, 1); break;
		case 3: need = 7; qual = chk_skl(PILOT, 1); break;
		case 4: need = 9; qual = chk_skl(LEGAL, 1); break;
		case 5: need = 8; qual = 1; break;
	}
	if (qual == 0)
	{
		noqual();
		return;
	}
	mer_do_promo(need);
}


void admn_promo()
{
	int qual, need;

	switch (rank)
	{
		case 0: need = 6; qual = chk_skl(ADMIN, 1); break;
		case 1: need = 7; qual = chk_skl(ADMIN, 2); break;
		case 2: need = 6; qual = chk_skl(ADMIN, 3); break;
		case 3: need = 7; qual = chk_skl(LIAISON, 2); break;
	}
	if (qual == 0)
	{
		noqual();
		return;
	}
	mer_do_promo(need);
}


void sale_promo()
{
	int qual, need;

	switch (rank)
	{
		case 0: need = 5; qual = chk_skl(TRADER, 1); break;
		case 1: need = 6; qual = chk_skl(BROKER, 1); break;
		case 2: need = 7; qual = chk_skl(BROKER, 2); break;
		case 3: need = 8; qual = chk_skl(BROKER, 3); break;
	}
	if (qual == 0)
	{
		noqual();
		return;
	}
	mer_do_promo(need);
}


void engr_promo()
{
	int qual1, qual2, need;

	switch (rank)
	{
	    case 0:
			{
				need = 8;
				qual2 = chk_skl(GRAVITICS, 1);
				qual1 = chk_skl(ELECTRONICS, 1);
				break;
			}
	    case 1: need = 7; qual2 = 0; qual1 = chk_skl(ENGINEERING, 1); break;
		case 2: need = 7; qual2 = 0; qual1 = chk_skl(ENGINEERING, 2); break;
	    case 3: need = 9; qual2 = 0; qual1 = chk_skl(ENGINEERING, 3); break;
	}
	if (qual1 == 0 && qual2 == 0)
	{
		noqual();
		return;
	}
	mer_do_promo(need);
}


void purs_promo()
{
	int qual, need;

	if (medic >= 1)
	{
		switch (rank)
		{
			case 0: need = 5; qual = chk_skl(STEWARD, 1); break;
			case 1: need = 6; qual = chk_skl(MEDICAL, 1); break;
			case 2: need = 6; qual = chk_skl(MEDICAL, 2); break;
			case 3: need = 7; qual = chk_skl(ADMIN, 1); break;
		}
	} 
	else
	{
		switch (rank)
		{
			case 0: need = 5; qual = chk_skl(STEWARD, 1); break;
			case 1: need = 5; qual = chk_skl(STEWARD, 2); break;
			case 2: need = 6; qual = chk_skl(LIAISON, 1); break;
			case 3: need = 7; qual = chk_skl(ADMIN, 1); break;
		}
	}
	if (qual == 0)
	{
		noqual();
		return;
	}
	mer_do_promo(need);
}


void trymerchant()
{
	int choice;
  
	if (race != SOLOMANI && race != ZHODANI)
	{
		choice = 1;
	    while (line == 0)
			pickline();
		if (line != 0)
			gotmerch();
	}
	else
	{
		choice = d12();
		if (race == SOLOMANI)
		{
			if (edu >= 8)
				choice++;
		    if (str >= 8)
				choice += 2;
			if (choice < 7 && brownie_points > 0)
				choice = bp_adj(choice, 7);
			if (choice >= 7)
				gotmerch();
		}
		else
		{	// Zhodani
			if (edu >= 6)
				choice += 3;
			if (intl >= 6)
				choice += 2;
			if (str >= 7)
				choice++;
			if (choice < 8 && brownie_points > 0)
				choice = bp_adj(choice, 8);
			if (choice >= 8)
				gotmerch();
		}
	}
}


void pickline()
{
  
	int choice, min, max;

	min = 0;
	max = 0;
	printf("\nYou have the option to join one of these lines.\n\n");
	if (mega == 0 && starport == 'A' || starport == 'B')
	{
		printf("   1. Megacorp\n");
		min = 1;
		max = 1;
	}
	if (sect == 0 && starport == 'A' || starport == 'B' || starport == 'C')
	{
		printf("   2. Sector-wide line\n");
		if (min == 0)
			min = 2;
		max = 2;
	}
	if (subs == 0 && starport == 'A' || starport == 'B'
		|| starport == 'C' || starport == 'D')
	{
		printf("   3. Subsector-wide line\n");
		if (min == 0)
			min = 3;
		max = 3;
	}
	if (infc == 0)
	{
		printf("   4. Interface line\n");
		if (min == 0)
			min = 4;
		max = 4;
	}
	if (fledg == 0)
	{
		printf("   5. Fledgling line\n");
		if (min == 0)
			min = 5;
		max = 5;
	}
	if (ft == 0)
	{
		printf("   6. Free Trader\n");
		if (min == 0)
			min = 6;
		max = 6;
	}
	choice = getsel_int(min, max);
	if (choice == 1)
	{
		join_mega();
		mega++;
	}
	if (choice == 2)
	{
		join_sector();
	    sect++;
	}
	if (choice == 3)
	{
		join_subs();
		subs++;
	}
	if (choice == 4)
	{
		join_infc();
		infc++;
	}
	if (choice == 5)
	{
		join_fledg();
		fledg++;
	}
	if (choice == 6)
	{
		join_ft();
		ft++;
	}
}


void join_mega()
{
	int roll;

	if (starport == 'A' || starport == 'B')
	{
		roll = d12();
		if (str >= 7)
			roll++;
	    if (intl >= 6)
			roll = roll + 2;
		if (race == NEWT)
			roll = roll + 2;
	    if (col >= HONORS || roll >= 9)
		{
			printf("You were accepted into a Megacorp.\n");
			line = 1;
		}
	}
}  


void join_sector()
{
	int roll;

	if (starport == 'A' || starport == 'B' || starport == 'C')
	{
		roll = d12();
	    if (str >= 7)
			roll++;
		if (intl >= 6)
			roll = roll + 2;
	    if (race == NEWT)
			roll = roll + 2;
		if (col == HONORS || roll >= 8)
		{
			printf("You were accepted into a sector-wide line.\n");
			line = 2;
		}
	}
}


void join_subs()
{
	int roll;

	if (starport == 'A' || starport == 'B'
		|| starport == 'C' || starport == 'D')
	{    
		roll = d12();
	    if (str >= 7)
			roll++;
		if (intl >= 6)
			roll = roll + 2;
	    if (race == NEWT)
			roll = roll + 2;
		if (col == HONORS || roll >= 7)
		{
			printf("You were accepted into a Subsector-wide line.\n");
			line = 3;
		}
	}
}  


void join_infc()
{
	int roll;

	roll = d12();
	if (str >= 7)
		roll++;
	if (intl >= 6)
		roll = roll + 2;
	if (race == NEWT)
		roll = roll + 2;
	if (col == HONORS || roll >= 7)
	{
		printf("You were accepted into a Interface line.\n");
		line = 4;
	}
}


void join_fledg()
{
	int roll;

	roll = d12();
	if (str >= 7)
		roll++;
	if (intl >= 6)
		roll = roll + 2;
	if (race == NEWT)
		roll = roll + 2;
	if (col == HONORS || roll >= 7)
	{
		printf("You were accepted into a Fledgling line.\n");
		line = 5;
	}
}


void join_ft()
{
	int roll;

	roll = d12();
	if (str >= 7)
		roll++;
	if (intl >= 6) 
		roll = roll + 2;
	if (race == NEWT)
		roll = roll + 2;
	if (col == HONORS || roll >= 7)
	{
		printf("You were accepted as a Free Trader.\n");
		line = 6;
	}
}


void mer_spcl_duty()
{
	int roll;

	printf("You got special duty! ");
	roll = d6();
	if (edu >= 9) roll++;
	if (rankeo == 'O' && rank >= 4 && branch != 1) roll++;
	if (rankeo == 'O')
		switch (roll)
		{
			case 1: mer_trade_stn(); break;
			case 2: mer_cmd_sch(); break;
			case 3: mer_deck_sch(); break;
			case 4: mer_engr_sch(); break;
			case 5: mer_purser_sch(); break;
			case 6: mer_bus_sch(); break;
			default: mer_test(); bp_add(1); break;
		}
	else
		switch (roll)
		{
			case 1: mer_sec_trng(); break;
			case 2: mer_trade_stn(); break;
			case 3: mer_helm_trng(); break;
			case 4: mer_drive_trng(); break;
			case 5: mer_steward_trng(); break;
			default: mer_commission(); bp_add(1); break;
		}
}


void mer_sec_trng()
{
	gotspcldty(SECURITYTRNG);
	if (special_duty[SECURITYTRNG] > 1)
	{
		if ((chk_skl(VACCSUIT, 4) == 1) || (chk_skl(NOGRAV, 4) == 1) 
			|| (chk_skl(HUNTING, 4) == 1) || (chk_skl(RECON, 4) == 1)
			|| (chk_skl(STEALTH, 4) == 1) || (chk_skl(SURVIVAL, 4) == 1)
			|| (chk_skl(EQUESTRIAN, 4) == 1) || (chk_skl(GUARDBEAST, 4) == 1)
			|| (chk_skl(HERDING, 4) == 1) || (chk_skl(EARLYFIREARMS, 4) == 1)
			|| (chk_skl(BRAWLING, 4) == 1) || (chk_skl(COMPUTER, 4) == 1))
		{
			instructor(SECURITYTRNG);
			return;
		}
	}
	if (bp_skill1(d6(), 4) >= 4) addskill(NOGRAV, 1);
	if (bp_skill1(d6(), 4) >= 4) env(1);
	if (bp_skill1(d6(), 4) >= 4) addskill(VACCSUIT, 1);
	if (bp_skill1(d6(), 4) >= 4) addskill(BRAWLING, 1);
	if (bp_skill1(d6(), 4) >= 4) addskill(COMPUTER, 1);
}


void mer_cmd_sch()
{
	gotspcldty(COMMANDCOL);
	if (special_duty[COMMANDCOL] > 1)
	{
		if ((chk_skl(LEADER, 4) == 1) || (chk_skl(LEGAL, 4) == 1) 
			|| (chk_skl(SHIPTAC, 4) == 1) || (chk_skl(ADMIN, 4) == 1))
		{
			instructor(COMMANDCOL);
			return;
		}
	}
	if (bp_skill1(d6(), 5) >= 5) addskill(LEADER, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(LEGAL, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(SHIPTAC, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(ADMIN, 1);
	/* xfer to Deck */
	branch = 1;
	mer_prt_branch(branch);
}


void mer_deck_sch()
{
	gotspcldty(DECKSCH);
	if (special_duty[DECKSCH] > 1)
	{
		if ((chk_skl(COMMO, 4) == 1) || (chk_skl(COMPUTER, 4) == 1) 
			|| (chk_skl(SPINALWEAP, 4) == 1)
			|| (chk_skl(SCREENS, 4) == 1) || (chk_skl(TURRETWEAP, 4) == 1))
		{
			instructor(DECKSCH);
			return;
		}
	}
	if (bp_skill1(d6(), 5) >= 5) addskill(COMMO, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(COMPUTER, 1);
	if (bp_skill1(d6(), 5) >= 5) gunner(1);
	/* xfer to Deck */
	branch = 1;
	mer_prt_branch(branch);
}


void mer_drive_trng()
{
	gotspcldty(DRIVETRNG);
	if (special_duty[DRIVETRNG] > 1)
	{
		if ((chk_skl(GRAVITICS, 4) == 1) || (chk_skl(MECHANICAL, 4) == 1) 
			|| (chk_skl(ENGINEERING, 4) == 1) || (chk_skl(ELECTRONICS, 4) == 1))
		{
			instructor(DRIVETRNG);
			return;
		}
	}
	if (bp_skill1(d6(), 5) >= 5) addskill(GRAVITICS, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(MECHANICAL, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(ENGINEERING, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(ELECTRONICS, 1);
	/* xfer to engineering */
	branch = 2;
	mer_prt_branch(branch);
}


void mer_engr_sch()
{
	gotspcldty(ENGINEERINGSCH);
	if (special_duty[ENGINEERINGSCH] > 1)
	{
		if ((chk_skl(GRAVITICS, 4) == 1) || (chk_skl(MECHANICAL, 4) == 1) 
			|| (chk_skl(ENGINEERING, 4) == 1) || (chk_skl(ELECTRONICS, 4) == 1)
			|| (chk_skl(COMPUTER, 4) == 1) || (chk_skl(ADMIN, 4) == 1))
		{
			instructor(ENGINEERINGSCH);
			return;
		}
	}
	if (bp_skill1(d6(), 5) >= 5) addskill(GRAVITICS, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(MECHANICAL, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(ENGINEERING, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(ELECTRONICS, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(COMPUTER, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(ADMIN, 1);
	/* xfer to engineering */
	branch = 2;
	mer_prt_branch(branch);
}


void mer_helm_trng()
{
	gotspcldty(HELMTRNG);
	if (special_duty[HELMTRNG] > 1)
	{
		if ((chk_skl(PILOT, 4) == 1) || (chk_skl(NAVIGATION, 4) == 1) 
			|| (chk_skl(SENSOROPS, 4) == 1) || (chk_skl(SHIPBOAT, 4) == 1))
		{
			instructor(HELMTRNG);
			return;
		}
	}
	if (bp_skill1(d6(), 5) >= 5) addskill(PILOT, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(NAVIGATION, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(SENSOROPS, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(SHIPBOAT, 1);
	/* xfer to Deck */
	branch = 1;
	mer_prt_branch(branch);
}


void mer_purser_sch()
{
	gotspcldty(PURSERSCH);
	if (special_duty[PURSERSCH] > 1)
	{
		if ((chk_skl(LIAISON, 4) == 1) || (chk_skl(ADMIN, 4) == 1) 
			|| (chk_skl(COMPUTER, 4) == 1))
		{
			instructor(PURSERSCH);
			return;
		}
	}
	if (bp_skill1(d6(), 4) >= 4) addskill(LIAISON, 1);
	if (bp_skill1(d6(), 4) >= 4) addskill(ADMIN, 1);
	if (bp_skill1(d6(), 4) >= 4) addskill(COMPUTER, 1);
	/* xfer to purser's dept */
	branch = 3;
	mer_prt_branch(branch);
}


void mer_steward_trng()
{
	gotspcldty(STEWARDTRNG);
	if (special_duty[STEWARDTRNG] > 1)
	{
		if ((chk_skl(STEWARD, 4) == 1) || (chk_skl(LIAISON, 4) == 1) 
			|| (chk_skl(ADMIN, 4) == 1))
		{
			instructor(STEWARDTRNG);
			return;
		}
	}
	if (bp_skill1(d6(), 4) >= 4) addskill(STEWARD, 1);
	if (bp_skill1(d6(), 4) >= 4) addskill(LIAISON, 1);
	if (bp_skill1(d6(), 4) >= 4) addskill(ADMIN, 1);
	/* xfer to purser's dept */
	branch = 3;
	mer_prt_branch(branch);
}


void mer_trade_stn()
{
	gotspcldty(TRADESTATION);
	if (bp_skill1(d6(), 4) >= 4) addskill(BROKER, 1);
	if (bp_skill1(d6(), 4) >= 4) addskill(LIAISON, 1);
	/* xfer to admin dept */
	branch = 4;
	mer_prt_branch(branch);
}


void mer_bus_sch()
{
	gotspcldty(BUSINESSSCH);
	if (special_duty[BUSINESSSCH] > 1)
	{
		if ((chk_skl(LEGAL, 4) == 1) || (chk_skl(LIAISON, 4) == 1) 
			|| (chk_skl(ADMIN, 4) == 1) || (chk_skl(COMPUTER, 4) == 1))
		{
			instructor(BUSINESSSCH);
			return;
		}
	}
	if (bp_skill1(d6(), 5) >= 5) addskill(LEGAL, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(LIAISON, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(ADMIN, 1);
	if (bp_skill1(d6(), 5) >= 5) addskill(COMPUTER, 1);
	/* xfer to sales dept */
	branch = 5;
	mer_prt_branch(branch);
}
