/* HOMESYS.C is part of the CHARGEN program that selects the characters
   home system information */

#include <stdio.h>
#include <ctype.h>
#include <string.h>

/*
#ifndef APPLE_CC
#include <conio.h>
#endif
*/

void homesys();
int jonker();
int darrian_hs();
int geonee_hs();
int tirrils_hs();
int llellew_hs();
int githiaski_hs();
int luriani_hs();
int answerin_hs();
int cafadi_hs();
int hlanssai_hs();
int sword_hs();
int sword2_hs();
int sword3_hs();
int suerrat_hs();
int irhadre_hs();
int floriani_hs();
int vegan_hs();
int ithklur_hs();
int randhome();
void sp(int random);
void picksp();
void sz(int random);
void evalsz();
int picksz();
void atm(int random);
void evalatmos();
int pickatm();
void popl(int random);
void evalpop();
int pickpop();
void lw(int random);
void evallw();
int picklw();
void gv(int random);
void evalgov();
int pickgov();
int asl_gov();
void h2o(int random);
void evalh2o();
int pickh2o();
void tl(int random);
void evaltl();
int picktl();
void vilaniblood(int random);
void prntvilani();
void prntblueblood();
int wherehome();
void getuwp();
int uwp_conv(char uwp_value);

extern int d6();
extern int d12();
extern int getsel_int(int min, int max);
extern char getche_y_n();
extern int getsel_bigint(int min, int max);

#include "chargen.h"

void homesys()
{
	int pick = 0;

	if (race == JONKEREEN)
		pick = jonker();
	if (race == DARRIAN)
		pick = darrian_hs();
	if (race == TIRRILS)
		pick = tirrils_hs();
	if (race == GEONEE)
		pick = geonee_hs();
	if (race == LLELLEWYLOLY)
		pick = llellew_hs();
	if (race == GITHIASKIO)
		pick = githiaski_hs();
	if (race == LURIANI)
		pick = luriani_hs();
	if (race == CAFADI)
		pick = cafadi_hs();
	if (race == ANSWERIN)
		pick = answerin_hs();
	if (race == HLANSSAI)
		pick = hlanssai_hs();
	if (race == SWORDWORLD)
		pick = sword_hs();
	if (race == SUERRAT)
		pick = suerrat_hs();
	if (race == IRHADRE)
		pick = irhadre_hs();
	if (race == FLORIANI)
		pick = floriani_hs();
	if (race == VEGAN)
		pick = vegan_hs();
	if (race == ITHKLUR)
		pick = ithklur_hs();
	if (pick == 0)
		pick = randhome();
	sp(pick);
	sz(pick);
	atm(pick);
	h2o(pick);
	popl(pick);
	lw(pick);
	gv(pick);
	tl(pick);
	if (race == VILANI)
		vilaniblood(pick);
}


int jonker()
{
	int choice;

	printf("Are you a resident of Jonkeer?");
	choice = getche_y_n();
	if (choice == 'Y' || choice == 'y')
	{
		strcpy(uwp, "C4908C99 (Jonkeer)");
		return(2);
	}
	return(0);
}


int geonee_hs()
{
	int choice;

	printf("Which Geonee world are you from?\n\n");
	printf("   1. Rigaal (B100679E)\n   2. Hiponee (B686351B)\n");
	printf("   3. Dreva (E30089D7)\n   4. LAGNA (A110A97G)\n");
	printf("   5. Stenardee (B110346D)\n   6. Ashavakuna (B5676229)\n");
	printf("   7. Prindee (D4435789)\n   8. Shiwonee (AA86831G)\n");
	printf("   9. Tlasov (A100663F)\n   10. some other world\n");
	choice = getsel_int(1, 10);
	if (choice == 10)
		return(0);
	switch (choice)
	{
		case 1: strcpy(uwp, "B100679E (Rigaal)"); break;
		case 2: strcpy(uwp, "B686351B (Hiponee)"); break;
		case 3: strcpy(uwp, "E30089D7 (Dreva)"); break;
		case 4: strcpy(uwp, "A110A97G (LAGNA)"); break;
		case 5: strcpy(uwp, "B110346D (Stenardee)"); break;
		case 6: strcpy(uwp, "B5676229 (Ashavakuna)"); break;
		case 7: strcpy(uwp, "D4435789 (Prindee)"); break;
		case 8: strcpy(uwp, "AA86831G (Shiwonee)"); break;
		case 9: strcpy(uwp, "A100663F (Tlasov)"); break;
	}
	return (2);
}


int darrian_hs()
{
	int choice;

	printf("Which Darrian world are you from?\n\n");
	printf("   1. Darrian (A463955G)\n   2. Mire (A665A95B)\n");
	printf("   3. Zamine (E897977A)\n   4. Jacent (A333644D)\n");
	printf("   5. Stern-Stern (B321588B)\n   6. Laberv (B3544437)\n");
	printf("   7. Ilium (B4448319)\n   8. Nosea (B2326BBC)\n");
	printf("   9. some other world\n");
	choice = getsel_int(1, 9);
	if (choice == 9)
		return(0);
	switch (choice)
	{
		case 1: strcpy(uwp, "A463955G (Darrian)"); break;
		case 2: strcpy(uwp, "A665A95B (Mire)"); break;
		case 3: strcpy(uwp, "E897977A (Zamine)"); break;
		case 4: strcpy(uwp, "A333644D (Jacent)"); break;
		case 5: strcpy(uwp, "B321588B (Stern-Stern)"); break;
		case 6: strcpy(uwp, "B3544437 (Laberv)"); break;
		case 7: strcpy(uwp, "B4448319 (Ilium)"); break;
		case 8: strcpy(uwp, "B2326BBC (Nosea)"); break;
	}
	return(2);
}


int tirrils_hs()
{
	strcpy(uwp, "B463645A (Tirrokoelaegz)");
	return(2);
}


int llellew_hs()
{
	strcpy(uwp, "B434ABD9 (Junidy)");
	return(2);
}


int githiaski_hs()
{
	strcpy(uwp, "A789886C (Githiaski)");
	return(2);
}


int luriani_hs()
{
	strcpy(uwp, "B76AAA8C (Derri)");
	return(2);
}


int answerin_hs()
{
	strcpy(uwp, "B584A84F (Answerin)");
	return(2);
}


int cafadi_hs()
{
	strcpy(uwp, "E6665546 (Cafad)");
	return(2);
}


int hlanssai_hs()
{
	strcpy(uwp, "B6577217 (Vrirhlanz)");
	return(2);
}


int sword_hs()
{
	int choice;

	printf("Which Sword World are you from?\n\n");
	printf("   1. Entrope (E336AAAC)\n   2. Tizon (B386887A)\n");
	printf("   3. Narsil (B574A55A)\n   4. Anduril (B985855B)\n");
	printf("   5. Gram (A895957B)\n   6. Sacnoth (B775956C)\n");
	printf("   7. Beater (B685866A)\n   8. Sting (B645896A)\n");
	printf("   9. a smaller sword world\n");
	choice = getsel_int(1, 9);
	if (choice == 9)
		return(sword2_hs());
	switch (choice)
	{
		case 1: strcpy(uwp, "E336AAAC (Entrope)"); break;
		case 2: strcpy(uwp, "B386887A (Tizon)"); break;
		case 3: strcpy(uwp, "B574A55A (Narsil)"); break;
		case 4: strcpy(uwp, "B985855B (Anduril)"); break;
		case 5: strcpy(uwp, "A895957B (Gram)"); break;
		case 6: strcpy(uwp, "B775956C (Sacnoth)"); break;
		case 7: strcpy(uwp, "B685866A (Beater)"); break;
		case 8: strcpy(uwp, "B645896A (Sting)"); break;
	}
	return (2);
}


int sword2_hs()
{
	int choice;

	printf("Which Sword World are you from?\n\n");
	printf("   0. a bigger Sword World\n");
	printf("   1. Hrunting (B4637479)\n   2. Colada (B364685B)\n");
	printf("   3. Joyeuse (B464778A)\n   4. Orcrist (B8A6733A)\n");
	printf("   5. Gungnir (B4447798)\n   6. Excalibur (B324755A)\n");
	printf("   7. Tyrfing (B637735A)\n   8. Biter (B354623A)\n");
	printf("   9. an even smaller sword world\n");
	choice = getsel_int(0, 9);
	if (choice == 0)
		return(sword_hs());
	if (choice == 9)
		return(sword3_hs());
	switch (choice)
	{
		case 1: strcpy(uwp, "B4637479 (Hrunting)"); break;
		case 2: strcpy(uwp, "B364685B (Colada)"); break;
		case 3: strcpy(uwp, "B464778A (Joyeuse)"); break;
		case 4: strcpy(uwp, "B8A6733A (Orcrist)"); break;
		case 5: strcpy(uwp, "B4447798 (Gungnir)"); break;
		case 6: strcpy(uwp, "B324755A (Excalibur)"); break;
		case 7: strcpy(uwp, "B637735A (Tyrfing)"); break;
		case 8: strcpy(uwp, "B354623A (Biter)"); break;
	}
	return (2);
}


int sword3_hs()
{
	int choice;

	printf("Which Sword World are you from?\n\n");
	printf("   0. a bigger Sword World\n");
	printf("   1. Winston (E8875736)\n   2. Anselhome (C1105888)\n");
	printf("   3. Mjolnir (B530544A)\n   4. Enos (E25059B4)\n");
	printf("   5. Dyrnwyn (B958512A)\n   6. Durendal (B687334B)\n");
	printf("   7. Hofud  (B666553A)\n   8. some other world\n");
	choice = getsel_int(0, 8);
	if (choice == 0)
		return(sword2_hs());
	if (choice == 8)
		return(0);
	switch (choice)
	{
		case 1: strcpy(uwp, "E8875736 (Winston)"); break;
		case 2: strcpy(uwp, "C1105888 (Anselhome)"); break;
		case 3: strcpy(uwp, "B530544A (Mjolnir)"); break;
		case 4: strcpy(uwp, "E25059B4 (Enos)"); break;
		case 5: strcpy(uwp, "B958512A (Dyrnwyn)"); break;
		case 6: strcpy(uwp, "B687334B (Durendal)"); break;
		case 7: strcpy(uwp, "B666553A (Hofud)"); break;
	}
	return (2);
}


int suerrat_hs()
{
	int choice;

	printf("Are you a resident of Volomili?");
	choice = getche_y_n();
	if (choice == 'Y' || choice == 'y')
	{
		strcpy(uwp, "A483723D (Volomili)");
		return(2);
	}
	return(0);
}


int irhadre_hs()
{
	strcpy(uwp, "C220973E (Welling)");
	return(2);
}


int floriani_hs()
{
	int choice;

	printf("Are you a resident of Floria?");
	choice = getche_y_n();
	if (choice == 'Y' || choice == 'y')
	{
		strcpy(uwp, "A467942F (Floria)");
		return(2);
	}
	return(0);
}


int vegan_hs()
{
	int choice;

	printf("Are you a resident of Muan Gwi?");
	choice = getche_y_n();
	if (choice == 'Y' || choice == 'y')
	{
		strcpy(uwp, "A456A86F (Muan Gwi)");
		return(2);
	}
	return(0);
}


int ithklur_hs()
{
	int choice;

	printf("Are you a resident of the Hive Federation?");
	choice = getche_y_n();
	if (choice == 'Y' || choice == 'y')
		blue_blood = 10;
	else
		blue_blood = 20;
	return(0);
}


int randhome()
{
	int answer;
  
	printf("You have several options for selecting a home system.\n\n");
	printf("   1. generate a random home system\n   2. enter UWP\n");
	printf("   3. pick general system characteristics\n");
	answer = getsel_int(1, 3);
	if (answer == 2)
		getuwp();
	return answer;
}


void sp(int random)
{
	int   type;

	if (random == 1)
	{
		type = d12();
		if (type <= 6)
			starport = 'A';
		else
			if (type <= 9)
				starport = 'B';
			else
				if (type <= 11)
					starport = 'C';
				else
				{
					type = d6();
					if (type <= 3)
						starport = 'D';
					else
						if (type <= 5)
							starport = 'E';
						else
							starport = 'X';
				}
	}
	else
		if (random == 2)
			starport = uwp[0];
		else
			picksp();
	printf("starport = %c\n", starport);
}


void picksp()
{
//#ifdef UNIX
	int ch;
//#endif
	int choice;                   

	printf("Please enter your home systems starport type (A, B, C, D, E, or X)\n");
	printf("Be sure to use an upper case letter.\n->");
	/*
#ifndef APPLE_CC
	choice = getche();
#endif
*/
//#ifdef UNIX
	while ((ch=getchar()) != '\n')
	{
		choice=ch;
	}
//#endif
	printf("\n");
	if (((choice < 'A') || (choice > 'E')) && (choice != 'X'))
	{
		printf("Please enter one of the legitimate values.\n");
		picksp();
		return;
	}
	starport = choice;
	return;
}


void sz(int random)
{
	int  type;

	if (random == 1)
	{
		type = d12();
		if (race == DOLPHINS)
			type++;
	}
	if (random == 2)
		type = (uwp_conv(uwp[1])) + 2;
	if (random == 1 || random == 2)
		if (type <= 2)
			size = 1;
		else
			if (type <= 6)
				size = 2;
			else
				if (type <= 9)
					size = 3;
				else
					size = 4;
	else
		size = picksz();
	evalsz();
}


void evalsz()
{
	switch (size)
	{
		case SZASTRO: strncpy(size_descr,"asteroid",9); break;
		case SZSMALL: strncpy(size_descr,"small",6); break;
		case SZMED: strncpy(size_descr,"medium",7); break;
		case SZLARGE: strncpy(size_descr,"large",6); break;
	}	
	printf("Size = %s\n", size_descr);
}


int picksz()
{
	int  type;
  
	printf("Please select the size of your home planet.\n\n");
	if (race != DOLPHINS)
		printf("   1. asteroid (< 200 km)\n");
	printf("   2. small    (200 to 799 km)\n");
	printf("   3. medium   (800 to 7199 km)\n");
	printf("   4. large    (> 7200 km)\n"); 
	type = getsel_int(1, 4);
	if (race == DOLPHINS && type == 1)
	{
		printf("Wrong - try again!\n");
		return picksz();
	}
	return type;
}


void atm(int random)
{
	int  type;

	if (random == 1)
	{
		type = d12();
		if (size == 1)
			type -= 9;
		if (size == 2)
			type -= 2;
		if (size == 4)
			type += 2;
		if (race == DOLPHINS)
			type += 2;
	}
	if (random == 2)
	{
		type = (uwp_conv(uwp[2]));
		if (type >= 8)
			type--;
	}
	if (random == 1 || random == 2)
		if (type <= 3)
			atmos = ATMVAC;
		else
			if (type <= 5)
				atmos = ATMTHN;
			else
				if (type <= 8)
					atmos = ATMSTD;
				else
					if (type <= 10)
						atmos = ATMDEN;
					else
						atmos = ATMEXO;
	else
		atmos = pickatm();
	evalatmos();
}


void evalatmos()
{
	switch (atmos)
	{
		case ATMVAC: strncpy(atmos_descr,"vacuum",7); break;
		case ATMTHN: strncpy(atmos_descr,"thin",5); break;
		case ATMSTD: strncpy(atmos_descr,"standard",9); break;
		case ATMDEN: strncpy(atmos_descr,"dense",6); break;
		case ATMEXO: strncpy(atmos_descr,"exotic",7); break;
	}
	printf("Atmosphere = %s\n", atmos_descr);
}


int pickatm()
{
	int  type;

	printf("Please select the atmosphere of your home planet.\n\n");
	if (race != DOLPHINS)
		printf("   1. vacuum\n");
	printf("   2. thin\n");
	printf("   3. standard\n");
	printf("   4. dense\n"); 
	printf("   5. exotic\n"); 
	type = getsel_int(1, 5);
	return type;
}


void h2o(int random)
{
	int  type;

	if (random == 1)
	{
		type = d12();
		if (race == ASLAN)
		{
			if (size == 2)
				type -= 2;
			if (size == 4)
				type += 2;
		}
		if (race == JONKEREEN)
			type -= 7;
		if (race == DOLPHINS || race == NEWT)
			type += 3;
	}
	if (random == 2)
		type = (uwp_conv(uwp[3])) + 2;
	if (random == 1 || random == 2)
		if (type <= 3)
			hydro = HYDDES;
		else
			if (type <= 5)
				hydro = HYDDRY;
			else
				if (type <= 11)
					hydro = HYDWET;
				else
					hydro = HYDWTR;
	else
		hydro = pickh2o();
	evalh2o();
}


void evalh2o()
{
	switch (hydro)
	{
		case HYDDES: strncpy(hydro_descr,"desert",7); break;
		case HYDDRY: strncpy(hydro_descr,"dry",4); break;
		case HYDWET: strncpy(hydro_descr,"wet",4); break;
		case HYDWTR: strncpy(hydro_descr,"water",6); break;
	}
	printf("Hydro = %s\n", hydro_descr);
}


int pickh2o()
{
	int  type, max;

	printf("Please select the hydrosphere of your home planet.\n\n");
	printf("   1. desert (< 5% water)\n");
	printf("   2. dry    (5-24% water)\n");
	max = 2;
	if (race != JONKEREEN)
	{
		printf("   3. wet    (25-94% water)\n");
		printf("   4. water  (>95% water)\n");
		max = 4;
	}
	type = getsel_int(1, max);
	return type;
}


void popl(int random)
{
	int  type;

	if (random == 1)
	{
		type = d12();
		if (type > 7)
			type++; /* adjust dice roll to match UWP */
		if (race == DOLPHINS && hydro == HYDWTR)
			type -= 2;
	}
	if (random == 2)
		type = (uwp_conv(uwp[4]));
	if (random == 1 || random == 2)
		if (type <= 3)
			pop = POPLO;
		else
			if (type <= 8)
				pop = POPMID;
			else
				pop = POPHI;
	else
		pop = pickpop();
	evalpop();
}


void evalpop()
{
	switch (pop)
	{
		case POPLO: strncpy(pop_descr,"low",4); break;
		case POPMID: strncpy(pop_descr,"moderate",9); break;
		case POPHI: strncpy(pop_descr,"high",5); break;
	}
	printf("Population = %s\n", pop_descr);
}


int pickpop()
{
	int  type;

	printf("Please select the population of your home planet.\n\n");
	printf("   1. low (less than 10,000)\n");
	printf("   2. moderate (10,000 to 1 billion)\n");
	printf("   3. high (more than 1 billion)\n");
	type = getsel_int(1, 3);
	return type;
}


void gv(int random)
{
	int  type, row, column;

	type = 0;
	if (random == 1)
	{
		if (race == ASLAN)
		{
			row = d6();
			column = d6();
			if (pop == POPLO) row -= 3;
			if (pop == POPHI) row += 3;
			if (row < 1) type = 16;
			if ((row > 6 || column == 1) && type == 0) type = 17;
			if (column == 2 && type == 0) type = 18;
			if (column == 3 && type == 0) type = 19;
			if (column == 4 && type == 0) type = 20;
			if (column == 5 && type == 0) type = 21;
			if (column == 6 && type == 0) type = 22;
//			printf("Gov=%d", type);
		}
		else
		{
			type = d12();
			if (type <= 3)
				type = d6();
			if (type >= 11)
				type = 9 + d6();
		}
	}
	if (random == 2)
		type = (uwp_conv(uwp[5]));
	if (random == 1 || random == 2)
		gov = type;
	else
		if (race == ASLAN)
			gov = asl_gov();
		else
			gov = pickgov();
	evalgov();
}


void evalgov()
{
	switch (gov)
	{
		case 0: strncpy(gov_descr,"none",5); break;
		case 1: strncpy(gov_descr,"company",8); break;
		case 2: strncpy(gov_descr,"part. democracy",16); break;
		case 3: strncpy(gov_descr,"oligarchy",10); break;
		case 4: strncpy(gov_descr,"rep. demcoracy",15); break;
		case 5: strncpy(gov_descr,"feudal",7); break;
		case 6: strncpy(gov_descr,"colonial",9); break;
		case 7: strncpy(gov_descr,"balkanization",14); break;
		case 8: strncpy(gov_descr,"civ. bureaucracy",17); break;
		case 9: strncpy(gov_descr,"imp. bureaucracy",17); break;
		case 10: strncpy(gov_descr,"char. dictator",15); break;
		case 11: strncpy(gov_descr,"other dictator",15); break;
		case 12: strncpy(gov_descr,"char. oligarchy",16); break;
		case 13: strncpy(gov_descr,"religious dict.",16); break;
		case 14: strncpy(gov_descr,"religious auto.",16); break;
		case 15: strncpy(gov_descr,"totaliarian",12); break;
		case 16: strncpy(gov_descr,"small station",14); break;
		case 17: strncpy(gov_descr,"split control",14); break;
		case 18: strncpy(gov_descr,"single world clan",18); break;
		case 19: strncpy(gov_descr,"small clan",11); break;
		case 20: strncpy(gov_descr,"major clan",11); break;
		case 21: strncpy(gov_descr,"vassel clan",12); break;
		case 22: strncpy(gov_descr,"major vassel clan",18); break;
	}
	printf("Gov code = %s\n", gov_descr);
}


int pickgov()
{
	int  type;

	printf("Please select the government code of your home planet.\n\n");
	printf("   1. no government\n");
	printf("   2. company\n");
	printf("   3. participatory democracy\n");
	printf("   4. oligarchy\n"); 
	printf("   5. representative democracy\n"); 
	printf("   6. feudal\n");
	printf("   7. colonial\n");
	printf("   8. balkanization\n");
	printf("   9. civil service bureaucracy\n"); 
	printf("  10. impersonal bureaucracy\n"); 
	printf("  11. charismatic dictator\n");
	printf("  12. other dictator\n");
	printf("  13. charismatic oligarchy\n");
	printf("  14. religious dictator\n"); 
	printf("  15. religious autocracy\n"); 
	printf("  16. totalitarian\n"); 
	type = getsel_bigint(1, 16);
	type--;
	return type;
}


int asl_gov()
{
	int  type;

	printf("Please select the government code of your home planet.\n\n");
	printf("   1. small station\n");
	printf("   2. split control\n");
	printf("   3. single world clan\n");
	printf("   4. small clan\n"); 
	printf("   5. major clan\n"); 
	printf("   6. vassal clan\n");
	printf("   7. major vassal clan\n");
	type = getsel_bigint(1, 7);
	type += 15;
	return type;
}


void lw(int random)
{
	int  type;

	if (random == 1)
	{
		type = d12();
		if (race == DOLPHINS && hydro == HYDWTR)
			type -= 2;
		if (race != ASLAN)
		{
			if (pop == 1)
				type--;
			if (pop == 3)
				type++;
		}
	}
	if (random == 2)
		type = (uwp_conv(uwp[6])) + 2;
	if (random == 1 || random == 2)
	{
		if (type <= 2)
			law = LAWNO;
		else
			if (random == 1 && (race == ASLAN || race == VARGR)
				&& type <= 5)
				law = LAWLO;
			else
				if (type <= 4)
					law = LAWLO;
				else
					if (random == 1 && (race == ASLAN || race == VARGR)
						&& type <= 10)
						law = LAWMOD;
					else
						if (type <= 9)
							law = LAWMOD;
						else
							if (type <= 11)
								law = LAWHI;
							else
								law = LAWEXT;
	}
	else
		law = picklw();
	evallw();
}


void evallw()
{
	switch (law)
	{
		case LAWNO: strncpy(law_descr,"no",3); break;
		case LAWLO: strncpy(law_descr,"low",4); break;
		case LAWMOD: strncpy(law_descr,"moderate",9); break;
		case LAWHI: strncpy(law_descr,"high",5); break;
		case LAWEXT: strncpy(law_descr,"extreme",8); break;
	}
	printf("Law code = %s\n", law_descr);
}


int picklw()
{
	int  type;

	printf("Please select the law code of your home planet.\n\n");
	printf("   1. no law\n");
	printf("   2. low law\n");
	printf("   3. moderate law\n");
	printf("   4. high law\n"); 
	printf("   5. extreme law\n"); 
	type = getsel_int(1, 5);
	return type;
}


void tl(int random)
{
	int  type;

	if (random == 3)
	{
		tech = picktl();
	}
	else
	{
		if (random == 1)
		{
			type = d12();
			if (starport == 'A')
				type += 3;
			if (starport == 'B')
				type += 2;
			if (starport == 'C')
				type++;
			if (starport == 'X')
				if (race == ASLAN)
					type--;
				else
					type -= 2;
			if (size == SZASTRO)
				type++;
			if (hydro == HYDWTR)
				type++;
			if (race != ASLAN)
			{
				if (pop == POPLO)
					type++;
				if (pop == POPHI)
					type += 2;
			}
			else
			{
				if (pop == POPHI)
					type++;
				if (pop == POPLO)
					type += 2;
			}
			if (race == ITHKLUR && blue_blood >= 20)
				type--; // Ithklur Client State TL is one pip lower...
			if (type > 14)
				type = 14;
			if (type < 1)
				type = 1;
		}
		else
		{
			type = uwp_conv(uwp[7]);
			if (type >= 3)
				type--;
			if (type >= 8)
				type--;
			if (type >= 11)
				type--;
		}
		if (type <= 2)
		{
			tech = TLPREIND;
		}
		else
		{
			if (type <= 4)
			{
				tech = TLIND;
			}
			else
			{
				if (type <= 6)
				{
					tech = TLPRESTEL;
				}
				else
				{
					if (type <= 8)
					{
						tech = TLEARSTEL;
					}
					else
					{
						if (((race == ASLAN || race == VARGR) 
							&& type <= 11) || (type <= 10))
						{
							tech = TLAVGSTEL;
						}
						else
						{
							if (type <= 14 || race == ASLAN || race == VARGR)
							{
								tech = TLHISTEL;
							}
							else
							{
								tech = TLEXTSTEL;
							}
						}
					}
				}
			}
		}
	}
	evaltl();
}


void evaltl()
{
	switch (tech)
	{
		case TLPREIND: strncpy(tech_descr,"pre-industrial",15); break;
		case TLIND: strncpy(tech_descr,"industrial",11); break;
		case TLPRESTEL: strncpy(tech_descr,"pre-stellar",12); break;
		case TLEARSTEL: strncpy(tech_descr,"early stellar",14); break;
		case TLAVGSTEL: strncpy(tech_descr,"avg stellar",12); break;
		case TLHISTEL: strncpy(tech_descr,"high stellar",13); break;
		case TLEXTSTEL: strncpy(tech_descr,"extreme stellar",16); break;
	}
	printf("tech code = %s\n", tech_descr);
}


int picktl()
{
	int  type;

	printf("Please select the tech code of your home planet.\n\n");
	printf("   1. pre-industrial\n");
	printf("   2. industrial\n");
	printf("   3. pre-stellar\n");
	printf("   4. early stellar\n"); 
	printf("   5. avg stellar\n"); 
	printf("   6. high stellar\n"); 
	type = getsel_int(1, 6);
	return type;
}


void vilaniblood(int random)
{
	int roll;

	blue_blood = d12();
	if (law == 1 || law == 5)
		blue_blood++;
	if (random == 1)
	{
		roll = d12();
	}
	else
	{
		roll = wherehome();
	}
	if (roll == 12)
	{
		blue_blood += 4;
		printf("You are from the Vilani cultural region!\n");
	}
	else
	{
		if (roll >= 10)
		{
			blue_blood += 3;
			printf("You are from the Vland sector!\n"); 
		}
		else
		{
			if (roll >= 8)
			{
				blue_blood += 2;
				printf("You are from the Vland domain!\n");
			}
			else
			{
				if (roll >= 6)
				{
					blue_blood++;
					printf("You are from within the First Imperium borders!\n");
				}
			}
		}
	}
	printf("You are of ");
	prntvilani();
	printf("!\n");
}


void prntvilani()
{
	if (blue_blood <= 10)
		printf("mostly non-Vilani ancestry");
	else
	{
		if (blue_blood <= 13)
			printf("mixed Vilani lineage");
		else
		{
			if (blue_blood == 14)
				printf("average pure Vilani");
			else
			{
				blue_blood = 15;
				printf("bloodline renowned for longevity");
			}
		}
	}
}


void prntblueblood()
{
	printf("(");
	if (race == VILANI)
		prntvilani();
	if (race == FLORIANI)
	{
		if (blue_blood == 2)
			printf("Feskals");
		else
			printf("Barnai");
	}
	if (race == SUERRAT)
	{
		if (blue_blood < 20)
			printf("troglodyte");
		else
			printf("astronaut");
		if ((blue_blood % 10) == 1) printf("-albino");
	}
	if (race == ITHKLUR)
	{
		if (blue_blood < 20)
			printf("Hive Fed.");
		else
			printf("Client State");
	}
	printf(")");
}


int wherehome()
{
	int choice;

	printf("Which most accurately describes the location of your home world?\n\n");
	printf("   1. none of these\n");
	printf("   2. within the First Imperium borders\n");
	printf("   3. within the Vland domain\n");
	printf("   4. within the Vland sector\n");
	printf("   5. within the Vilani cultural region\n");
	choice = getsel_int(1, 5);
	switch (choice)
	{
		case 1: return 3;
		case 2: return 6;
		case 3: return 8;
		case 4: return 10;
		case 5: return 12;
		default: return (choice);
	}
}


void getuwp()
{
	int i, len;
	char uwpentry[26];

	printf("Enter the character's home world UWP in X9999999 (name)\n");
	printf("format, where the name is optional.\n->");
	fgets(uwpentry, 26, stdin);
	if (uwpentry[strlen(uwpentry) - 1] == '\n')
		uwpentry[strlen(uwpentry) - 1] = '\0';
	if ((strlen(uwpentry)) < 8 || uwpentry[7] == '-')
	{
		printf("Invalid UWP (skip the dash) - try again!\n");
		getuwp();
		return;
	}
	len = strlen(uwpentry);
	for (i = 0; i < len; i++)
	{
		if ((isascii(uwpentry[i])) != 0)
			uwp[i] = uwpentry[i];
		else
		{
			printf("Invalid UWP - try again!\n");
			getuwp();
			return;
		}
	}
}


int uwp_conv(char uwp_value)
{
  int uwp_int;

  switch (uwp_value)
  {
      case '0': uwp_int = 0; break;
      case '1': uwp_int = 1; break;
      case '2': uwp_int = 2; break;
      case '3': uwp_int = 3; break;
      case '4': uwp_int = 4; break;
      case '5': uwp_int = 5; break;
      case '6': uwp_int = 6; break;
      case '7': uwp_int = 7; break;
      case '8': uwp_int = 8; break;
      case '9': uwp_int = 9; break;
      case 'a': uwp_int = 10; break;
      case 'b': uwp_int = 11; break;
      case 'c': uwp_int = 12; break;
      case 'd': uwp_int = 13; break;
      case 'e': uwp_int = 14; break;
      case 'f': uwp_int = 15; break;
      case 'g': uwp_int = 16; break;
      case 'h': uwp_int = 17; break;
      case 'j': uwp_int = 18; break;
      case 'k': uwp_int = 19; break;
      case 'l': uwp_int = 20; break;
      case 'A': uwp_int = 10; break;
      case 'B': uwp_int = 11; break;
      case 'C': uwp_int = 12; break;
      case 'D': uwp_int = 13; break;
      case 'E': uwp_int = 14; break;
      case 'F': uwp_int = 15; break;
      case 'G': uwp_int = 16; break;
      case 'H': uwp_int = 17; break;
      case 'J': uwp_int = 18; break;
      case 'K': uwp_int = 19; break;
      case 'L': uwp_int = 20; break;
      case 'M': uwp_int = 21; break;
      case 'N': uwp_int = 22; break;
      default: uwp_int = 0; break; /* covers size 'r' & 's' */
  }
  return uwp_int;
}
