/* SCHOOLS.C establishes the characters pre-career choices */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
#ifndef APPLE_CC
#include <conio.h>
#endif
*/

void precareer();
void makeprecar();
int techschool();
int techskills();
int pickts();
int getts();
int swts(int choice);
void honors();
int college();
void col_skills(int years);
void pickotc();
void makeotc();
int tulifesci();
int tusocsci();
int technouniv();
int technounivskills();
int tuweapon();
int tusocsci();
int preinduniv();
int piunivskills();
int piusocsci();
int piulifesci();
void pickserv();
void prntschooltype();
void prntacceptedu(char accepted[], char schoolname[]);
void prntgraduateedu(char graduated[], char schoolname[]);

extern void trytechacad();
extern int mil_acad();
extern int air_acad();
extern int nav_acad();
extern int merch_acad();
extern void med_flt();
extern int pickmajor();
extern int hardsci();
extern void background();
extern int finearts();
extern int bgtech();
extern void prntupp();
extern void anykey();
extern int bp_adj();
extern int picktech();
extern int gettech();
extern int pickairc();
extern int getairc();
extern void gotarmy();
extern void gotflyer();
extern void gotnavy();
extern void gotmarines();
extern int d3();
extern int d5();
extern int d6();
extern int d7();
extern int d12();
extern int getsel_int(int min, int max);
extern void addskill(int skill, int skl_val);
extern int pickinvest();
extern void bumpdex();
extern void bumpedu();
extern int pickgc();
extern int pickfag();
extern int getgc();
extern int getfag();
extern void dispskil(int sequ, int skl_val);
extern void bp_add(int amt);

#include "chargen.h"

signed int  tech_sch, univ, mer_acd, mil_acd, nav_acd, air_acd;

void precareer()
{
	tech_sch = 0;
	univ = tech_sch;
	mer_acd = tech_sch;
	mil_acd = tech_sch;
	nav_acd = tech_sch;
	air_acd = tech_sch;
	background();
	makeprecar();
}


void makeprecar()
{
	int choice, max;

	prntupp();
	max = 1;
	printf("You have the following pre-career options:\n\n");
	printf("   1. none\n");
	if (tech_sch > NOTACCEPTED)
		if (tech == TLPREIND)
		{
			if (edu >= 5 && soc >= 10)
			{
				printf("   2. Pre-Industrial Technical University (roll 7) from TNE\n");
				max = 2;
			}
		}
		else
		{
			printf("   2. technical school (roll 7, edu 8+) based on Geonee & Scientist\n");
			max = 2;
		}
	if (univ > NOTACCEPTED)
	{
		if (tech == TLPREIND)
		{
			if (edu >= 5)
			{
				printf("   3. Pre-Industrial University (roll 6) from TNE\n");
				max = 3;
			}
		}
		else
		{
			printf("   3. college (roll 9, edu 9+) based on Scientists\n");
			max = 3;
		}
	}
	if ((mer_acd > NOTACCEPTED) && tech >= TLEARSTEL &&
		(starport == 'A' || starport == 'B' || starport == 'C'))
	{
		printf("   4. merchant");
		prntschooltype();
		printf("9, edu 10+)\n");
		max = 4;
	}
	if (mil_acd > NOTACCEPTED && soc >= 6 && tech >= TLPRESTEL)
	{
		printf("   5. military");
		prntschooltype();
		printf("10, str 10+)\n");
		max = 5;
	}
	if (nav_acd > NOTACCEPTED && soc >= 8 && tech >= TLPRESTEL)
	{
		printf("   6. naval");
		prntschooltype();
		printf("10, soc 10+)\n");
		max = 6;
	}
	if (air_acd > NOTACCEPTED && soc >= 8 && tech >= TLIND 
		&& atmos >= 2 && pop >= 2)
	{
		printf("   7. air");
		prntschooltype();
		printf("10, dex 9+)\n");
		max = 7;
	}
	choice = getsel_int(1, max);
	if ((choice > 5 && soc < 8)
		|| (choice == 4 && tech < TLEARSTEL)
		|| (choice > 4 && choice < 7 && (soc < 6 || tech < TLPRESTEL)))
	{
		printf("That was an invalid selection - try again.\n");
		makeprecar();
		return;
	}
	if (choice == 1)
		return;
	if (choice == 2)
	{
		if (tech > TLPREIND)
		{
			if ((tech_sch = techschool()) < 0)
			{
				makeprecar();
				return;
			}
			else
				if (tech_sch > 0)
				{
					med_flt();
					return;
				}
		}
		else
		{
			if ((tech_sch = technouniv()) < 0)
			{
				makeprecar();
				return;
			}
		}
	}
	if (choice == 3)
	{
		if (tech > TLPREIND)
		{
			if ((univ = college()) < 0)
			{
				makeprecar();
				return;
			}
			else
				if (univ > 0)
				{
					med_flt();
					return;
				}
		}
		else
		{
			if ((univ = preinduniv()) < 0)
			{
				makeprecar();
				return;
			}
		}
	}
	if (choice == 4)
	{
		if ((mer_acd = merch_acad()) < 0 && careernbr == 0)
		{
			makeprecar();
			return;
		}
		else
			if (mer_acd > 0)
			{
				med_flt();
				return;
			}
	}
	if (choice == 5)
	{
		if ((mil_acd = mil_acad()) < 0 && careernbr == 0)
		{
			makeprecar();
			return;
		}
		else
			if (mil_acd > 0)
			{
				med_flt();
				return;
			}
	}
	if (choice == 6)
	{	 
		if ((nav_acd = nav_acad()) < 0 && careernbr == 0)
		{
			makeprecar();
			return;
		}
		else
			if (nav_acd > 0)
			{
				med_flt();
				return;
			}
	}
	if (choice == 7)
	{	 
		if ((air_acd = air_acad()) < 0 && careernbr == 0)
		{
			makeprecar();
			return;
		}
		else
			if (air_acd > 0)
			{
				med_flt();
				return;
			}
	}
}


void prntschooltype()
{
	if (race == HIVER)
		printf(" education ");
	else
		printf(" academy ");
	printf("(roll ");
}


void prntacceptedu(char accepted[], char schoolname[])
{
	printf("You were %saccepted in %s.\n", accepted, schoolname);
}


void prntgraduateedu(char graduated[], char schoolname[])
{
	printf("You did %sgraduate from %s.\n", graduated, schoolname);
}


int techschool()
{
	int roll, skills, years, retval;
	char name[17];

	strncpy(name,"Technical School",17);
	roll = d12();
	if (race == ITHKLUR)
	{
		if (edu >= 5)
			roll++;
	}
	else
	{
		if (edu >= 8) roll++;
	}
	if (roll < 7 && brownie_points > 0)
		roll = bp_adj(roll, 7);
	if (roll < 7)
	{
		prntacceptedu("not ", name);
	    return NOTACCEPTED;
	}
	prntacceptedu("", name);
	roll = d12();
	retval = 0;
	if (intl >= 7)
		roll += 2;
	if (roll < 7 && brownie_points > 0)
		roll = bp_adj(roll, 7);
	if (roll < 7)
	{
		years = (d6() + 1) / 2;
	    age += years;
		appearent_age += years;
	    prntgraduateedu("not ", name);
		skills = (d12() - 9 + years) % 2;
	    while (skills > 0)
		{
			roll = techskills();
			if (roll != 0)
			{
				addskill(roll, 1);
				skills--;
			}
		}
		return 0;
	}
    prntgraduateedu("", name);
	col = 1;
	retval = GRADUATED;
	bumpedu();
	bumpdex();
	addskill(COMPUTER, 1);
	skills = 1;
	if (intl >= 9)
		skills++;
	pickotc();
	roll = d12();
	if (intl >= 9)
		roll++;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 9);
	if (roll >= 9)
	{
		honors();
		retval = HONORS;
		skills++;
	}
	age += 4;
	appearent_age += 4;
	bp_add(1);
	while (skills >= 0)
	{
	    roll = techskills();
		if (roll != 0)
		{
			addskill(roll, 1);
			skills--;
		}
	}
	return retval;
}


int techskills()
{
	if (pick == 2 || pick == 4)
		return getts();
	else
		return pickts();
}


int pickts()
{
	int choice, val, max;
 
	printf("You need to pick your field of study at technical school.\n");
	dispskil(1, HANDYMAN);
	dispskil(2, MECHANICAL);
	dispskil(3, ELECTRONICS);
	dispskil(4, COMPUTER);
	dispskil(5, TECHNICAL);
	max = 5;
	if (race == ITHKLUR)
	{
		dispskil(6, AIRCRAFT);
		dispskil(7, ARTISAN);
		max = 7;
	}
	choice = getsel_int(1, max);
	if (choice > 0)
		val = swts(choice);
	return (val);
}


int getts()
{
	int  choice;

	if (race == ITHKLUR)
	{
		choice = d6();
		if (choice == 4)
			choice = d6();
	}
	else
		choice = d5();
	return swts(choice);
}


int swts(int choice)
{
	switch (choice)
	{
	    case 1: return HANDYMAN;
		case 2: return MECHANICAL;
	    case 3: return ELECTRONICS;
		case 4: return COMPUTER;
	    case 5:
			{
				if (pick == 2 || pick == 4)
					return gettech();
				else
					return picktech();
				break;
			}
	    case 6:
			{
				if (pick == 2 || pick == 4)
					return getairc();
				else
					return pickairc();
				break;
			}
	}
	return -1;
}


void honors()
{
	printf("Congratulations, you made honors!\n");
	if (edu < 10 && col > 1)
	{
		printf("Edu increased to 10\n");
	    edu = 10;
	}
	else
		bumpedu();
	if (col < 10) col += 10;
	bp_add(1);
}


int college()
{
	int roll, years, retval;
	char name[17];

	strncpy(name,"College",8);
	roll = d12();
	if (race == ITHKLUR)
	{
		if (edu >= 6)
			roll += 2;
	}
	else
		if (edu >= 9)
			roll += 2;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 9);
	if (roll < 9)
	{
		prntacceptedu("not ", name);
	    return NOTACCEPTED;
	}
	prntacceptedu("", name);
	roll = d12();
	if (intl >= 8)
		roll += 2;
	if (roll < 7 && brownie_points > 0)
		roll = bp_adj(roll, 7);
	if (roll < 7)
	{
		years = (d6() + 1) / 2;
	    age += years;
		appearent_age += years;
		prntgraduateedu("not ", name);
		printf("You studied for %d years.\n", years);
		col_skills((years+1) / 2);
	    roll = (d6() - 5 + years) / 2;
		while (roll > 0)
		{ 
			bumpedu(); 
			roll--; 
		}
		return 0;
	}
	prntgraduateedu("", name);
	years = 4;
	col = 2;
	retval = GRADUATED;
	roll = d6() - 2;
	if (roll < 1)
		roll = 1;
	if (intl >= 9)
		roll++;
	while (roll > 0)
	{ 
		bumpedu(); 
		roll--; 
	}
	pickotc();
	roll = d12();
	if (intl >= 10)
		roll++;
	if (roll < 10 && brownie_points > 0)
		roll = bp_adj(roll, 10);
	if (roll >= 10)
	{
		honors();
		retval = HONORS;
	}
	age += years;
	appearent_age += years;
	bp_add(1);
	col_skills(years);
	return retval;
}

void col_skills(int years)
{
	int choice, skills;

	printf("What method do you wish to use for college skills?\n");
	printf("   1. Scientists (Challenge #29)\n   2. TNE (use education)\n");
	printf("   3. house A (1 per year)\n   4. house B (1/2 education)\n");
	choice = getsel_int(1, 4);
	switch (choice)
	{
		case 1:
		{
			skills = d6() - 3;
			if (skills < 1)
				skills = 1;
			if (intl >= 9)
				skills++;
			if (col >= 10)
				skills++;
			skills = skills * years / 4;
			break;
		}
		case 2: skills = edu * years / 4; break;
		case 3: skills = years; break;
		case 4: skills = (edu / 2) * years / 4; break;
	}
	while (skills > 0)
	{
		addskill(pickmajor(), 1);
	    skills--;
	}
}

int atc, ntc, mtc;

void pickotc()
{
	atc = 0;
	ntc = 0;
	mtc = 0;
	if (tech < TLPRESTEL)
		return;
	if (race == ITHKLUR)
		return;
	makeotc();
}


void makeotc()
{
	int  roll, choice, max;
	char name[5];

	printf("While pursuing your college or technical degree you have these options:\n\n");
	printf("   1. none\n");   
	if (mtc == 0)
		printf("   2. officer training corps (roll 8, soc 8+)\n");   
	if (ntc == 0)
		printf("   3. naval officer training corps (roll 9, soc 10+)\n");
	max = 3;
	if (atc == 0 && tech >= TLIND && atmos >= ATMTHN && pop >= POPMID)
	{
		printf("   4. air officer training corps (roll 8, soc 8+)\n");
		max = 4;
	}
	choice = getsel_int(1, max);
	if (choice == 1)
		return;
	if (choice == 2)
	{
		strncpy(name, "OTC", 4);
		roll = d12();
	    if (soc >= 8)
			roll++;
		if (roll < 8 && brownie_points > 0)
			roll = bp_adj(roll, 8);
	    if (roll >= 8)
		{
			prntacceptedu("", name);
			otc = 1;
			gotarmy();
			if ((col % 10) == 1)
				branch = 6; /* army support branch */
		}
		else 
		{
			prntacceptedu("not ", name);
			mtc++;
		}
	}
	if (choice == 3)
	{
		strncpy(name, "NOTC", 5);
		roll = d12();
	    if (soc >= 10)
			roll++;
		if (roll < 9 && brownie_points > 0)
			roll = bp_adj(roll, 9);
	    if (roll >= 9) 
		{
			prntacceptedu("", name);
			otc = 2;
			pickserv();
			if ((col % 10) == 1) 
			{
				if (careernbr == NAVY) 
					branch = 4; /* navy engineering branch */
				else 
					branch = 6; /* marine support branch */
			}
		}
		else
		{
			prntacceptedu("not ", name);
			ntc++;
		}
	}
	if (choice == 4)
	{
		strncpy(name, "AOTC", 5);
		roll = d12();
	    if (soc >= 8)
			roll++;
		if (roll < 8 && brownie_points > 0)
			roll = bp_adj(roll, 8);
		if (roll >= 8) 
		{
			prntacceptedu("", name);
			otc = 5;
			gotflyer();
			if ((col % 10) == 1)
				branch = 3; /* COACC technical branch */
		}
		else
		{
			prntacceptedu("not ", name);
			atc++;
		}
	}
	if (careernbr == 0)
		makeotc();
	rankeo = 'O';
	if (race != ZHODANI)
		rank = 1;
	return;
}


void pickserv()
{
	int  choice;

	printf("Which branch do you wish to serve in?\n\n");
	printf("   1. navy\n   2. marines\n");
	choice = getsel_int(1, 2);
	if (choice == 1)
	{
		gotnavy();
		line = 2; /* reserve fleet */
	}
	else
		gotmarines();
}


int preinduniv()
{
	int roll, skills, years, retval;
	char name[26];

	strncpy(name, "Pre-inductrial University", 26);
	roll = d12();
	if (edu >= 8)
		roll++;
	if (roll < 6 && brownie_points > 0)
		roll = bp_adj(roll, 6);
	if (roll < 6)
	{
		prntacceptedu("not ", name);
	    return NOTACCEPTED;
	}
	retval = 0;
	prntacceptedu("", name);
	roll = d12();
	if (intl >= 7)
		roll += 2;
	if (roll < 7 && brownie_points > 0)
		roll = bp_adj(roll, 7);
	if (roll < 7)
	{
		years = (d6() + 1) / 2;
		age += years;
	    appearent_age += years;
		prntgraduateedu("not ", name);
		printf("You studied for %d years.\n", years);
	    skills = (d12() - 9 + years) % 2;
		while (skills > 0)
		{
			roll = piunivskills();
			if (roll != 0)
			{
				addskill(roll, 1);
				skills--;
			}
		}
		return retval;
	}
	prntgraduateedu("", name);
	col = 7;
	retval = GRADUATED;
	bumpedu();
	skills = d6() - 3;
	if (skills < 1)
		skills = 1;
	if (intl >= 9)
		skills++;
	roll = d12();
	if (intl >= 9)
		roll++;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 9);
	if (roll >= 9)
	{
		honors();
		retval = HONORS;
		skills++;
	}
	age += 4;
	appearent_age += 4;
	bp_add(1);
	while (skills >= 0)
	{
		roll = piunivskills();
	    if (roll != 0)
		{
			addskill(roll, 1);
			skills--;
		}
	}
	return retval;
}


int piunivskills()
{
	int choice, val;
 
	printf("You need to pick your field of study at the Pre-Industrial University.\n");
	printf("\n   1. Fine Arts *\n   2. Physical Science *\n");
	dispskil(3, INVESTIGATION);
	printf("   4. Life Sciences *\n   5. Social Sciences*\n");
	choice = getsel_int(1, 5);
	switch (choice)
	{
		case 1: val = finearts(); break;
	    case 2: val = hardsci(); break;
		case 3: val = pickinvest(); break;
	    case 4: val = piulifesci(); break;
		case 5: val = piusocsci(); break;
	}
	if (val <= 0)
		val = piunivskills();
	return (val);
}


int piulifesci()
{
	int choice, val;
  
	if (pick == 2 || pick == 4)
		choice = d5() + 1;
	else
	{
		printf("You need to pick your field of study within the life sciences.\n");
		printf("\n   1. none\n");
		dispskil(2, NAVIGATION);
		dispskil(3, BIOLOGY);
		dispskil(4, FARMING);
		dispskil(5, RESEARCH);
		dispskil(6, MEDICAL);
		choice = getsel_int(1, 6);
	}
	switch (choice)
	{
		case 1: return 0;
	    case 2: val = NAVIGATION; break;
		case 3: val = BIOLOGY; break;
	    case 4: val = FARMING; break;
		case 5: val = RESEARCH; break;
	    case 6: val = MEDICAL; break;
	}
	if (val == 0)
		val = piulifesci();
	return (val);
}


int piusocsci()
{
	int choice, val;
  
	if (pick == 2 || pick == 4)
		choice = d7() + 1;
	else
	{
		printf("You need to pick your field of study within the social sciences.\n");
		printf("\n   1. none\n");
		dispskil(2, INSTRUCTION);
		dispskil(3, LINGUISTICS);
		dispskil(4, HISTORY);
		dispskil(5, PSYCHOLOGY);
		dispskil(6, SOCIOLOGY);
		dispskil(7, THEOLOGY);
		dispskil(8, PERSUASION);
		choice = getsel_int(1, 8);
	}
	switch (choice)
	{
		case 1: return 0;
	    case 2: val = INSTRUCTION; break;
		case 3: val = LINGUISTICS; break;
	    case 4: val = HISTORY; break;
		case 5: val = PSYCHOLOGY; break;
	    case 6: val = SOCIOLOGY; break;
		case 7: val = THEOLOGY; break;
	    case 8: val = PERSUASION; break;
	}
	if (val == 0)
		val = piusocsci();
	return (val);
}


int technouniv()
{
	int roll, skills, years, retval;
	char name[36];

	strncpy(name, "Pre-industrial Technical University", 36);
	roll = d12();
	if (edu >= 8)
		roll++;
	if (roll < 7 && brownie_points > 0)
		roll = bp_adj(roll, 7);
	if (roll < 7)
	{
		prntacceptedu("not ", name);
	    return NOTACCEPTED;
	}
	prntacceptedu("", name);
	roll = d12();
	if (intl >= 7)
		roll += 2;
	if (roll < 7 && brownie_points > 0)
		roll = bp_adj(roll, 7);
	if (roll < 7)
	{
		years = (d6() + 1) / 2;
	    age += years;
		appearent_age += years;
		prntgraduateedu("not ", name);
		printf("You studied for %d years.\n", years);
		skills = (d12() - 9 + years) % 2;
	    while (skills > 0)
		{
			roll = technounivskills();
			if (roll != 0)
			{
				addskill(roll, 1);
				skills--;
			}
		}
		return 0;
	}
	retval = GRADUATED;
	prntgraduateedu("", name);
	col = 8;
	bumpedu();
	skills = d6() - 3;
	if (skills < 1)
		skills = 1;
	if (intl >= 9)
		skills++;
	roll = d12();
	if (intl >= 9)
		roll++;
	if (roll < 9 && brownie_points > 0)
		roll = bp_adj(roll, 9);
	if (roll >= 9)
	{
		honors();
		retval = HONORS;
		skills++;
	}
	age += 4;
	appearent_age += 4;
	bp_add(1);
	while (skills >= 0)
	{
		roll = technounivskills();
	    if (roll != 0)
		{
			addskill(roll, 1);
			skills--;
		}
	}
	return retval;
}


int technounivskills()
{
	int choice, val;
 
	if (pick == 2 || pick == 4)
		choice = d3();
	else
	{
		printf("You need to pick your field of study at the Pre-Ind. Tech. Univ.\n");
		printf("\n   1. Technology *\n   2. Social *\n   3. Weapons *\n");
		choice = getsel_int(1, 3);
	}
	switch (choice)
	{
		case 1: val = bgtech(); break;
	    case 2: val = tusocsci(); break;
		case 3: val = tuweapon(); break;
	}
	if (val <= 0)
		val = technounivskills();
	return (val);
}


int tuweapon()
{
	int choice, val;
  
	if (pick == 2 || pick == 4)
		choice = d5() + 1;
	else
	{
		printf("You need to pick your field of study within the life sciences.\n");
		printf("\n   1. none\n");
		dispskil(2, FORWARDOBS);
		dispskil(3, ROBOTOPS);
		dispskil(4, FAGUNNERY);
		dispskil(5, HEAVYWEAP);
		dispskil(6, GUNCMBT);
		choice = getsel_int(1, 6);
	}
	switch (choice)
	{
		case 1: return 0;
	    case 2: val = FORWARDOBS; break;
		case 3: val = ROBOTOPS; break;
	    case 4:
			{
				if (pick == 2 || pick == 4)
					val = getfag();
				else
					val = pickfag();
				break;
			}
		case 5: val = HEAVYWEAP; break;
	    case 6:
			{
				if (pick == 2 || pick == 4)
					val = getgc();
				else
					val = pickgc();
				break;
			}
	}
	if (val == 0)
		val = tuweapon();
	return (val);
}


int tusocsci()
{
	int choice, val;
  
	if (pick == 2 || pick == 4)
		choice = d5() + 1;
	else
	{
		printf("You need to pick your field of study within the social sciences.\n");
		printf("\n   1. none\n");
		dispskil(2, INSTRUCTION);
		dispskil(3, LINGUISTICS);
		dispskil(4, ACTING);
		dispskil(5, COMMO);
		dispskil(6, RECRUITING);
		choice = getsel_int(1, 6);
	}
	switch (choice)
	{
		case 1: return 0;
	    case 2: val = INSTRUCTION; break;
		case 3: val = LINGUISTICS; break;
	    case 4: val = ACTING; break;
		case 5: val = COMMO; break;
		case 6: val = RECRUITING; break;
	}
	if (val == 0)
		val = tusocsci();
	return (val);
}
