/* DROPRINT.C is part of the MEGATRAVELER (c) character generation */
/* program written by Greg Svenson. It prints out the resulting character. */

#include <stdio.h>


void printhim();
void getbranch();
void getrankp();
void drorank();
void prntstuf();
void mot_kit();

extern void prntskil(int end);
extern void anykey();
extern void clrscr();
extern void prntrace();
extern void prntsex();
extern void disp_special_duty();

#include "chargen.h"

void printhim()  
{
  printf("Here is a review of your characters skills.\n");
  prntskil(1);
  anykey();
  clrscr();
  printf("                         Character Description\n");        
  printf("\nName: _________________________ ");
  printf("    ");
  prntrace();
  printf(" ");
  prntsex();
  printf("\n");    
  printf(" str dex end int ");
  printf("sen ");
  printf("cas");
  printf(" Home World: star port = %c\n", starport);
  printf("  %2d  %2d  %2d  %2d  %2d  %2d            ", 
    str, dex, end, intl, edu, soc);
  printf("      size = %s\n", size_descr);
  printf("         age: %2d                    ", age);
  printf("atmosphere = %s\n", atmos_descr);
  printf("apparent age: %2d                    ", appearent_age);
  printf("     hydro = %s\n", hydro_descr);
  printf("                                    ");
  printf("population = %s\n", pop_descr);              
  printf("                                     ");
  printf("      law = %s\n", law_descr);
  printf("                                    ");
  printf("  tech lvl = %s\n", tech_descr);
  printf("Career: %s", career);
  if (branch != 0) getbranch();
  if (medic != 0) printf(" medic");
  printf("\n");
  getrankp();
  disp_special_duty();
  printf("\nSkills:\n");
  prntskil(2);
  printf("\nProperty:               Credits: %ld", credits);
  prntstuf();
}


void getbranch()
{
  printf(" %s ", office);
  if (careernbr <= MARINE || careernbr == FLYER) printf("branch");
  else printf("office");
}


void getrankp()
{
  drorank();
}


void drorank()
{
  if (soc == 1) {
    if (alt_career > 0) printf("Building");
    if (alt_career == 0) printf("Laboring");
    if (alt_career < 0) printf("Farming");
    printf(" Worker-%d", terms);
  }
  if (soc == 2) {
    if (alt_career > 0) printf("Voyaging");
    if (alt_career == 0) printf("Guard");
    if (alt_career < 0) printf("Battling");
    printf(" Warrior-%d", terms);
  }
  if (soc == 3) {
    if (alt_career > 0) printf("Social");
    if (alt_career == 0) printf("Priestly");
    if (alt_career < 0) printf("Family");
    printf(" Drone-%d", terms);
  }
  if (soc == 4) {
    if (alt_career > 0) printf("Dreaming");
    if (alt_career == 0) printf("Artificer");
    if (alt_career < 0) printf("Fixing");
    printf(" Technician-%d", terms);
  }
  if (soc == 5) {
    if (alt_career > 0) printf("Finding");
    if (alt_career == 0) printf("Speaker");
    if (alt_career < 0) printf("Seeking");
    printf(" Sport-%d", terms);
  }
  if (soc == 6) {
    if (alt_career > 0) printf("Leader (of)");
    if (alt_career == 0) printf("Priestly");
    if (alt_career < 0) printf("Military");
    printf(" Leader-%d", terms);
  }
}


void prntstuf()
{
  printf("\n");
  if (ship > 0) {
    if (soc == 6) printf("Droyne Explorer");
    else printf("Mech. Wings");
    printf(", ");
  }
  if (kit > 0)
  {
    if (soc == 4) printf("Tool Kit");
    else 
	if (soc == 3) printf("36 Coyns");
	else printf("Vacc Suit");
    if (kit > 1) printf("x%d,", kit);
    else printf(",\n");
  }
  if (weapons > 0)
  {
    printf("Weapon");
    if (weapons > 1) printf("x%d", weapons);
    printf(", ");
  }
  printf("\n");
}


void mot_kit()
{
	kit++;
	printf("You got ");
	if (soc == 4) printf("a Tool Kit");
	else
		if (soc == 3) printf("36 Coyns");
		else printf("a Vacc Suit");
	printf("\n");
}