/* HIVCARER.C is part of the MegaTraveller (C) character generation */
/* program. It is used each term to select the hiver characters career. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void careers();
void hivgetcareer();
void hivcareer();
int hivdoterm();
void hivpickcareer();
void hivpickmil();
void hivpickciv();
int newmanipulator();
void hivdraft();
void hivtrystory();
void hivtryexplorer();
void hivtrynavy();
void hivtrygroundsupport();
void hivgotgroundsupport();
void hivgotgroundadvisor();
void hivtrytechy();
void hivtrysci();
void hivtrydiplomat();
void hivtrymedic();
void hivtryleader();
void hivgotleader();
void hivgotarmy();
void gotstory();
void gotmedic();
void hivgotexplorer();
void altcareertbl();

extern void cascades();
extern void background();
extern void dfltech();
extern void dfltcareer();
extern char getche_y_n();
extern int hivnavy();
extern int hivmedic();
extern int hivsci();
extern int hivdplmt();
extern int hivarmy();
extern int hivmanipulator();
extern int hivmerchant();
extern int hivexplorer();
extern int hivstory();
extern int hivtechy();
extern int hivleader();
extern int d5();
extern int d12();
extern int reenlist();
extern int getsel_int(int min, int max);
extern void trymerchant();
extern void addskill(int skill, int skl_val);
extern void manipmot(int val);
extern void gotnavy();
extern void gottechy();
extern void gotdiplomat();
extern void gotscient();
extern void gotmerch();
extern void gotleader();
extern void bumpedu();
extern void bumpsoc();
extern void ithcareer();
extern void ithgetcareer();
extern void hivprecareer();

#include "chargen.h"

void careers()
{
	cascades();
	dfltech();
	if (race == ITHKLUR)
	{
		ithgetcareer();
		ithcareer();
	}
	if (race == HIVER)
	{
		hivprecareer();
		hivgetcareer();
		printf("Career = %s (%d)\n", career, careernbr);
		dfltcareer();
		hivcareer();
	}
}


void hivgetcareer()
{
	int choice;

	blue_blood = 0;
	km_land = blue_blood;
	age -= 4;
	appearent_age = age;
	if (careernbr != 0)
		return;
	printf("Career selection can be random or you can try to pick your\n");
	printf("characters career. Do you want to try to pick your characters\n");
	printf("career?");
	choice = getche_y_n();
	printf("\n");
	if (choice == 'Y' || choice == 'y')
		hivpickcareer();
	else
		hivdraft();
}


void hivcareer()
{
	int newterm;

	newterm = 0;
	while (newterm == 0)
		newterm = hivdoterm();
}


int hivdoterm()
{
	int newterm, choice, cont;

	if (terms > 0)
	{
		if (careernbr == 0)
		{
			printf("Do you wish to continue your pregaming career?");
			choice = getche_y_n();
			if (choice == 'N' || choice == 'n')
				return 1;
		}
	}
	if (blue_blood == 0 && km_land >= 5)
		blue_blood = newmanipulator();
	if (blue_blood == 0)
		hivpickcareer();
	else
	{
		printf("Do you wish to use manipulator resolution this term?");
		choice = getche_y_n();
		printf("\n");
		if (choice == 'Y' || choice == 'y')
		{
			careernbr = MANIPULATOR;
			strncpy(career,"Manipulator",12);
		}
		else 
			hivpickcareer();
	}
	switch (careernbr)
	{
		case ARMY: newterm = hivarmy(); break;
		case NAVY: newterm = hivnavy(); break;
		case DOCTOR: newterm = hivmedic(); break;
		case DIPLOMAT: newterm = hivdplmt(); break;
		case SCIENTIST: newterm = hivsci(); break;
		case MANIPULATOR: newterm = hivmanipulator(); break;
		case MERCHANT: newterm = hivmerchant(); break;
		case EXPLORER: newterm = hivexplorer(); break;
		case STORYTELLER: newterm = hivstory(); break;
		case TECHY: newterm = hivtechy(); break;
		case PARTY: newterm = hivleader(); break;
		default: newterm = 1; printf("unknown Hiver career %d", careernbr); break;
	}
	printf("That completes this term!\n");
	if (newterm == 0 && (km_land > ((terms-1) / 2)))
	{
		switch (careernbr)
		{
			case ARMY: cont = 4; break;
			case NAVY: cont = 4; break;
			case DOCTOR: cont = 5; break;
			case DIPLOMAT: cont = 5; break;
			case SCIENTIST: cont = 5; break;
			case MANIPULATOR: cont = 5; break;
			case MERCHANT: cont = 4; break;
			case EXPLORER: cont = 5; break;
			case STORYTELLER: cont = 5; break;
			case TECHY: cont = 5; break;
			case PARTY: cont = 6; break;
			default:
			{
				cont = 13;
				printf("unknown career for continuation %d", careernbr);
				break;
			}
		}
		choice = reenlist(cont);
	}
	else
	{
		if (newterm == 0)
			printf("You can not continue in your career without satisfaction(%d).\n",
				km_land);
		newterm = 1;
		choice = 0;
	}
	if (choice != 0)
		careernbr = 0;
	return newterm;
}


void hivpickcareer()
{
	int choice;

	if (careernbr != 0)
		return;
	printf("\nWhat career do you want? Remember, if you fail\n");
	printf("your enlistment, you will be drafted.\n\n");
	printf("   1. pick one at random\n");
	printf("   2. military\n");
	printf("   3. civilian\n");
	choice = getsel_int(1, 3);
	switch (choice)
	{
		case 1: hivdraft(); break;
		case 2: hivpickmil(); break;
		case 3: hivpickciv(); break;
	}
	if (careernbr == 0)
	{
		hivpickcareer();
		return;
	}
	if (careernbr == MERCHANT)
		addskill(TRADER, 1);
}


void hivpickmil()
{
	int choice, max;

	printf("\nWhat career do you want? Remember, if you fail\n");
	printf("your enlistment, you will be drafted.\n\n");
	printf("   1. none\n");
	printf("   2. navy (roll 5, Str 8+)\n");
	printf("   3. explorer (roll 7, Soc 9+)\n");
	printf("   4. ground forces - support (roll 6, Int 9+)\n");
	max = 4;
	if (mil_acd > 0)
	{
		printf("   5. ground forces - advisor (automatic)\n");
		max = 5;
	}
	choice = getsel_int(1, max);
	switch (choice)
	{
		case 1: return;
		case 2: hivtrynavy(); break;
		case 3: hivtryexplorer(); break;
		case 4: hivtrygroundsupport(); break;
	    case 5: hivgotgroundadvisor(); break;
	}
	if (careernbr == 0)
	{
		printf("You failed your enlistment\n");
		hivdraft();
	}
}


void hivpickciv()
{
	int choice, max;

	if (careernbr != 0)
		return;
	printf("\nWhat career do you want? Remember, if you fail\n");
	printf("your enlistment, you will be drafted.\n\n");
	printf("   1. none\n");
	printf("   2. diplomat (roll 7, soc 7+)\n");
	printf("   3. medical (roll 6, dex 5+)\n");
	printf("   4. technician (roll 6, Int 7+)\n");
	printf("   5. merchant (varies by line)\n");
	printf("   6. story teller (roll 6, soc 5+)\n");
	printf("   7. leader (roll 6, any 10+)\n");
	max = 7;
	if (grad_sch >= 1)
	{
		printf("   8. scientist (roll 7, edu 7+)\n");
		max = 8;
	}
	choice = getsel_int(1, max);
	switch (choice)
	{
		case 1: return;
		case 2: hivtrydiplomat(); break;
		case 3: hivtrymedic(); break;
		case 4: hivtrytechy(); break;
		case 5: trymerchant(); break;
	    case 6: hivtrystory(); break;
		case 7: hivtryleader(); break;
		case 8: hivtrysci(); break;
	}
	if (careernbr == 0)
	{
		printf("You failed your enlistment\n");
		hivdraft();
	}
}


int newmanipulator()
{
	int roll;

	roll = d12();
	if (careernbr == NAVY || careernbr == ARMY)
	{
		if (intl >= 10)
			roll += 2;
		if (roll < 10)
			return 0;
	}
	if (careernbr == MERCHANT || careernbr == DOCTOR)
	{
		if (intl >= 9)
			roll += 2;
		if (roll < 10)
			return 0;
	}
	if (careernbr == PARTY || careernbr == DIPLOMAT)
	{
		if (intl >= 10)
			roll += 2;
		if (roll < 9)
			return 0;
	}
	if (careernbr == EXPLORER || careernbr == TECHY)
	{
		if (intl >= 11)
			roll += 2;
	    if (roll < 11)
			return 0;
	}
	if (careernbr == STORYTELLER || careernbr == SCIENTIST)
	{
		if (edu >= 8)
			roll += 2;
		if (roll < 9)
			return 0;
	}
	printf("Congratulations, you are now a manipulator!\n");
	addskill(MANIPULATION, 1);
	manipmot(1);
	return 1;
}


void hivdraft()
{
	int  roll;

	roll = d5();
	switch (roll)
	{
		case 1: gotnavy(); break;
	    case 2: hivgotexplorer(); break;
	    case 3: line = 6; gotmerch(); break;
		case 4: gotstory(); break;
		case 5: gotleader(); break;
	}
}


void hivtrystory()
{
	int  enlist;

	enlist = d12();
	if (soc >= 5)
		enlist += 2;
	if (intl >= 7)
		enlist++;
	if (enlist >= 6)
		gotstory();
}


void hivtrydiplomat()
{
	int  enlist;

	enlist = d12();
	if (soc >= 7)
		enlist += 2;
	if (intl >= 7)
		enlist++;
	if (enlist >= 7)
		gotdiplomat();
}


void hivtrytechy()
{
	int  enlist;

	enlist = d12();
	if (intl >= 7)
		enlist += 2;
	if (edu >= 6)
		enlist++;
	if (enlist >= 6)
		gottechy();
}


void hivtrysci()
{
	int  enlist;

	enlist = d12();
	if (edu >= 7)
		enlist += 2;
	if (soc >= 7)
		enlist++;
	if (enlist >= 7)
		gotscient();
}


void hivtrymedic()
{
	int  enlist;

	enlist = d12();
	if (dex >= 5)
		enlist += 2;
	if (intl >= 7)
		enlist++;
	if (enlist >= 6 || med_sch > 0)
		gotmedic();
}


void hivtryexplorer()
{
	int  enlist;

	enlist = d12();
	if (str >= 6)
		enlist++;
	if (soc >= 9)
		enlist += 2;
	if (enlist >= 7)
		hivgotexplorer();
}


void hivtrynavy()
{
	int  enlist;

	enlist = d12();
	if (end >= 5)
		enlist++;
	if (str >= 8)
		enlist += 2;
	if (enlist >= 5)
		gotnavy();
}


void hivtrygroundsupport()
{
	int  enlist;

	enlist = d12();
	if (edu >= 8)
		enlist++;
	if (intl >= 9)
		enlist += 2;
	if (enlist >= 6)
		hivgotgroundsupport();
}


void hivgotgroundsupport()
{
	hivgotarmy();
	branch = 6;
}


void hivgotgroundadvisor()
{
	hivgotarmy();
	branch = 1;
	rankeo = 'O';
	rank = 1;
}


void hivtryleader()
{
	int  enlist;

	enlist = d12();
	if (intl >= 10 || str >= 10 
		|| dex >= 10 || end >= 10 
	    || edu >= 10 || soc >= 10)
		enlist += 2;
	if (enlist >= 6)
		hivgotleader();
}


void hivgotleader()
{
	gotleader();
	addskill(LEADER, 1);
}


void hivgotarmy()
{
	strncpy(career,"Ground Support",15);
	careernbr = ARMY;
}


void gotstory()
{
	strncpy(career,"Story Teller",13);
	careernbr = STORYTELLER;
	bumpedu();
}


void gotmedic()
{
	strncpy(career,"Medical",8);
	careernbr = DOCTOR;
	if (med_sch > 0)
		rankeo = 'O';
	rank = 1;
}


void hivgotexplorer()
{
	strncpy(career,"Explorer",9);
	careernbr = EXPLORER;
	bumpsoc();
}


void altcareertbl()
{
}