/* ITHBELTR.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

int ithbelter();
void ithbeltermot(int term);
void ithbelterbene();
void ithbelterskills(int skills);
void ithbelter_tbl(int roll);

extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int ith_comm(int need_nbr, int skill1, int skill2, int skl_val);
extern int ith_promo(int need_nbr, int skill1, int skill2, int skl_val);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void bumpdex();
extern void bumpintl();
extern void bumpend();
extern void physicl(int skl_val);
extern void spac(int skl_val);
extern void techl(int skl_val);
extern void mc(int skl_val);
extern void explore(int skl_val);
extern void spacetech(int skl_val);
extern void inbrn(int skl_val);
extern void vc(int skl_val);
extern void gc(int skl_val);
extern void mot_cash(int amt);
extern void mot_ship();
extern void mot_weapon();
extern void mot_hipsg();
extern void mot_lopsg();

#include "chargen.h"

int ithbelter()
{
	int     skills, newterm;
  
	newterm = 0;
	skills = basic_spec_duty(6);
	newterm = basic_surv(9, (terms + 1), 0);
	if (newterm == 0)
	{
		skills++;
		if (terms == 3)
			addskill(NOGRAV, 1);
		if (rankeo == 'E')
			skills += ith_comm(10, end, intl, 13);
		else
			skills += ith_promo(12, end, intl, 13);
	}
	if (skills != 0)
		ithbelterskills(skills);
	ithbeltermot(1);
	return newterm;
}


void ithbeltermot(int term)
{

	int  cash, roll, amt;
	char choice;

	term = basic_mot(term);
	if (term < 3)
		cash = term;
	else
		cash = 3;
	while ((term > 0) && (cash > 0))
	{
		choice = getche_mot();
		if (choice == 'C' || choice == 'c')
		{
			cash--;
			roll = basic_cash();
			term--;
			amt = 0;
			switch (roll)
			{
				case 1: break;
				case 2: break;
				case 3: amt = 1000; break;
				case 4: amt = 10000; break;
				case 5: amt = 50000; break;
				case 6: amt = 100000; break;
				case 7: amt = 100000; break;
			}
			mot_cash(amt);
		}
		else
		{
			ithbelterbene();
			term--;
		}
	}
	while (term > 0)
	{
		ithbelterbene();
		term--;
	}
}


void ithbelterbene()
{
	int roll;

	roll = basic_bene();
	switch (roll)
	{
		case 1: mot_lopsg(); break;
		case 2: bumpintl(); break;
		case 3: mot_weapon(); break;
		case 4: mot_weapon(); break;
		case 5: mot_hipsg(); break;
		default: mot_ship(); break;
	}
}


void ithbelterskills(int skills)
{
	int  table, roll;

	while (skills > 0)
	{
		table = picktable();
		roll = d6();
		if (table == 1)
		{
			switch (roll)
			{
				case 1: physicl(1); break;
				case 2: bumpdex(); break;
				case 3: bumpend(); break;
				case 4: mc(1); break;
				case 5: vc(1); break;
				case 6: addskill(VACCSUIT, 1); break;
			}
		}
		if (table == 2)
		{
			ithbelter_tbl(roll);
		}
		if (table == 3)
		{
			switch (roll)
			{
				case 1: spac(1); break;
				case 2: explore(1); break;
				case 3: addskill(SHIPBOAT, 1); break;
				case 4: addskill(MECHANICAL, 1); break;
				case 5: addskill(ELECTRONICS, 1); break;
				case 6: addskill(PROSPECTING, 1); break;
			}
		}
		if (table == 4)
		{
			switch (roll)
			{
				case 1: addskill(MEDICAL, 1); break;
				case 2: spacetech(1); break;
				case 3: spac(1); break;
				case 4: spacetech(1); break;
				case 5: inbrn(1); break;
				case 6: techl(1); break;
			}
		}
		skills--;
	}
}


void ithbelter_tbl(int roll)
{
	if (roll < 1 || roll > 6)
		roll = d6();
	switch (roll)
	{
		case 1: spac(1); break;
		case 2: addskill(PROSPECTING, 1); break;
		case 3: spac(1); break;
		case 4: gc(1); break;
		case 5: addskill(NOGRAV, 1); break;
		case 6: addskill(PROSPECTING, 1); break;
	}
}