/* ITHHUNTR.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

int ithhunter();
void ithhuntermot(int term);
void ithhunterbene();
void ithhunterskills(int skills);
void ithhunter_tbl(int roll);

extern int ith_comm(int need_nbr, int skill1, int skill2, int skl_val);
extern int ith_promo(int need_nbr, int skill1, int skill2, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot(int term);
extern int basic_bene();
extern int d6();
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void bumpdex();
extern void bumpend();
extern void physicl(int skl_val);
extern void mentl(int skl_val);
extern void techl(int skl_val);
extern void explore(int skl_val);
extern void vhcl(int skl_val);
extern void econ(int skl_val);
extern void acad(int skl_val);
extern void inbrn(int skl_val);
extern void env(int skl_val);
extern void mc(int skl_val);
extern void spac(int skl_val);
extern void gc(int skl_val);
extern void vc(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_weapon();
extern void mot_midpsg();
extern void mot_hipsg();
extern void mot_ship();

#include "chargen.h"

int ithhunter()
{
	int skills, newterm;

	newterm = 0;
	skills = basic_spec_duty(6);
	newterm = basic_surv(6, str, 10);
	if (newterm == 0)
	{
		skills++;
		if (rankeo == 'E')
			skills += ith_comm(11, str, soc, 14);
		else
			skills += ith_promo(13, str, soc, 14);
	}
	if (skills != 0)
		ithhunterskills(skills);
	ithhuntermot(1);
	return newterm;
}


void ithhuntermot(int term)
{

	int  cash, roll, amt;
	char choice;
  
	term = basic_mot(term);
	if (term < 3)
		cash = term;
	else
		cash = 3;
	while ((term > 0) && (cash > 0))
	{
		choice = getche_mot();
		if (choice == 'C' || choice == 'c')
		{
			cash--;
			roll = basic_cash();
			term--;
			amt = 0;
			switch (roll)
			{
				case 1: amt = 1000; break;
				case 2: amt = 1000; break;
				case 3: amt = 5000; break;
				case 4: amt = 5000; break;
				case 5: amt = 10000; break;
				case 6: amt = 100000; break;
				case 7: amt = 100000; break;
			}
			mot_cash(amt);
		}
		else
		{
			ithhunterbene();
			term--;
		}
	}
	while (term > 0)
	{
		ithhunterbene();
		term--;
	}
}


void ithhunterbene()
{
	int roll;

	roll = basic_bene();
	switch (roll)
	{
		case 1: mot_lopsg(); break;
		case 2: mot_midpsg(); break;
		case 3: mot_weapon(); break;
		case 4: mot_weapon(); break;
		case 5: mot_weapon(); break;
		case 6: mot_hipsg(); break;
		default: mot_ship(); break;
	}
}


void ithhunterskills(int skills)
{
	int  table, roll;

	while (skills > 0)
	{
		table = picktable();
		roll = d6();
		if (table == 1)
		{
			switch (roll)
			{
				case 1: physicl(1); break;
				case 2: bumpdex(); break;
				case 3: bumpend(); break;
				case 4: mentl(1); break;
				case 5: vc(1); break;
				case 6: mc(1); break;
			}
		}
		if (table == 2)
			ithhunter_tbl(roll);
		if (table == 3)
		{
			switch (roll)
			{
				case 1: addskill(MECHANICAL, 1); break;
				case 2: addskill(ELECTRONICS, 1); break;
				case 3: techl(1); break;
				case 4: env(1); break;
				case 5: econ(1); break;
				case 6: gc(1); break;
			}
		}
		if (table == 4)
		{
			switch (roll)
			{
				case 1: techl(1); break;
				case 2: explore(1); break;
				case 3: inbrn(1); break;
				case 4: spac(1); break;
				case 5: addskill(HUNTING, 1); break;
				case 6: acad(1); break;
			}
		}
		skills--;
	}
}


void ithhunter_tbl(int roll)
{
	if (roll < 1 || roll > 6)
		roll = d6();
	switch (roll)
	{
		case 1: gc(1); break;
		case 2: mc(1); break;
		case 3: vhcl(1); break;
		case 4: env(1); break;
		case 5: env(1); break;
		case 6: addskill(HUNTING, 1); break;
	}
}