/* ITHPHLNG.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

int ithphilangist();
void ithphilangistmot(int term);
void ithphilangistbene();
void ithphilangistskills(int skills);

extern int ith_comm(int need_nbr, int skill1, int skill2, int skl_val);
extern int ith_promo(int need_nbr, int skill1, int skill2, int skl_val);
extern int basic_spec_duty(int need_nbr);
extern int basic_surv(int need_nbr, int upp_type, int upp_val);
extern int reenlist(int need_nbr);
extern void addskill(int skill, int skl_val);
extern int basic_mot();
extern char getche_mot();
extern int basic_cash();
extern int basic_bene();
extern int socialsci();
extern void bumpintl();
extern void bumpsoc();
extern int picktable();
extern int d6();
extern void econ(int skl_val);
extern void spacetech(int skl_val);
extern void explore(int skl_val);
extern void techl(int skl_val);
extern void sci(int skl_val);
extern void influ(int skl_val);
extern void inbrn(int skl_val);
extern void vhcl(int skl_val);
extern void gc(int skl_val);
extern void pc(int skl_val);
extern void vc(int skl_val);
extern void animal(int skl_val);
extern void arts(int skl_val);
extern void spac(int skl_val);
extern void env(int skl_val);
extern void interp(int skl_val);
extern void miscskills(int amount);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_weapon();
extern void mot_midpsg();
extern void mot_hipsg();
extern void mot_tas();

#include "chargen.h"

int ithphilangist()
{
	int     skills, newterm;
  
	newterm = 0;
	skills = basic_spec_duty(4);
	newterm = basic_surv(6, intl, 8);
	if (newterm == 0)
	{
		skills++;
		if (rankeo == 'E')
			skills += ith_comm(10, str, intl, 16);
		else
			skills += ith_promo(14, str, intl, 16);
	}
	if (skills != 0)
		ithphilangistskills(skills);
	ithphilangistmot(1);
	return newterm;
}


void ithphilangistmot(int term)
{
	int  cash, roll, amt;
	char choice;
  
	cash = basic_mot();
	while ((term > 0) && (cash > 0))
	{
		choice = getche_mot();
		if (choice == 'C' || choice == 'c')
		{
			roll = basic_cash();
			cash--;
			term--;
			amt = 0;
			switch (roll)
			{
			case 1: amt = 1000; break;
			case 2: amt = 2000; break;
			case 3: amt = 5000; break;
			case 4: amt = 10000; break;
			case 5: amt = 20000; break;
			case 6: amt = 30000; break;
			default: amt = 50000; break;
			}
			mot_cash(amt);
		}
		else
		{
			term--;
			ithphilangistbene();
		}
	}
	while (term > 0)
	{
		ithphilangistbene();
		term--;
	}
}


void ithphilangistbene()
{
	int roll;

	roll = basic_bene();
	switch (roll)
	{
	case 1: mot_lopsg(); break;
	case 2: bumpintl(); break;
	case 3: mot_midpsg(); break;
	case 4: mot_weapon(); break;
	case 5: bumpsoc(); break;
	case 6: mot_hipsg(); break;
	case 7: mot_tas(); break;
	}
}


void ithphilangistskills(int skills)
{
	int  table, roll;

	while (skills > 0)
	{
		table = picktable();
		roll = d6();
		if (table == 1)
		{
			switch (roll)
			{
			case 1: addskill(BRAWLING, 1); break;
			case 2: gc(1); break;
			case 3: addskill(SWIMMING, 1); break;
			case 4: pc(1); break;
			case 5: env(1); break;
			case 6: vc(1); break;
			}
		}
		if (table == 2)
		{
			switch (roll)
			{
			case 1: miscskills(1); break;
			case 2: techl(1); break;
			case 3: inbrn(1); break;
			case 4: sci(1); break;
			case 5: addskill(socialsci(), 1); break;
			case 6: animal(1); break;
			}
		}
		if (table == 3)
		{
			switch (roll)
			{
			case 1: econ(1); break;
			case 2: addskill(ARTISAN, 1); break;
			case 3: influ(1); break;
			case 4: arts(1); break;
			case 5: interp(1); break;
			case 6: miscskills(1); break;
			}
		}
		if (table == 4)
		{
			switch (roll)
			{
			case 1: spacetech(1); break;
			case 2: addskill(TACTICS, 1); break;
			case 3: explore(1); break;
			case 4: env(1); break;
			case 5: vhcl(1); break;
			case 6: spac(1); break;
			}
		}
		skills--;
	}
}

