/* DARCARER.C is part of the MegaTraveller (C) character generation */
/* program. It is used to select the dargr characters career. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void darpickcareer();
void dardraft();
void darrandcareer();
void dartryarmy();
void dartrymarine();
void dartrynavy();
void dargotnavy();
void dartryspecarm();
int darnavroll();
void dartryacad();
void dartrynoble();
void gotacad();
int darpicktable();

extern int getsel_int(int min, int max);
extern void background();
extern void trymerchant();
extern int d3();
extern int d4();
extern int d6();
extern void gotarmy();
extern void gotmarines();
extern void gotmerch();
extern int d12();
extern void gotnavy();
extern char getche_y_n();
extern void gotnoble();

#include "chargen.h"

//void *strncpy();


void darpickcareer()
{
  int choice, max;

  max = 6;
  background();
  printf("\nWhat career do you want? Remember, if you fail\n");
  printf("your enlistment, you will be drafted.\n\n");
  printf("   1. pick one at random\n");
  printf("   2. army (roll 6, int 8+, dex 8+, str 8+)\n");
  printf("   3. marine (roll 6, int 8+, dex 8+, str 8+)\n");
  printf("   4. navy (roll 7, int 8+, dex 9+)\n");
  printf("   5. merchant (based on line)\n");
  printf("   6. academic (roll 8, edu 10+, int 9+)\n");
  if (soc >= 11 || (edu > 11 && intl >= 10))
  {
    printf("   7. noble (roll 14, soc 11+, int 10+, edu 11+)\n");
	max = 7;
  }
  choice = getsel_int(1, max);
  switch (choice) {
    case 1: darrandcareer(); break;
    case 2: dartryarmy(); break;
    case 3: dartrymarine(); break;
    case 4: dartrynavy(); break;
    case 5: trymerchant(); break;
    case 6: dartryacad(); break;
    case 7: dartrynoble(); break;
  }
  if (careernbr == 0) dardraft();
}


void dardraft()
{
  int  roll;

  roll = d6();
  switch (roll) {
    case 1: gotarmy(); break;
    case 2: gotmarines(); break;
    case 3:
		{
	      line = 2;
		  dargotnavy(); 
	      break;
		}
    case 4: gotmerch(); break;
    case 5: gotacad(); break;
    default: dardraft(); break;
  }
}


void darrandcareer()
{
  int  roll;

  roll = d6();
  if (roll == 1) dartryarmy();
  else
  {
    if (roll == 2) dartrymarine();
    else
	{
      if (roll == 3) dartrynavy();
      else
	  {
        if (roll == 4) trymerchant();
        else
		{
          if (roll == 5) dartryacad();
          else
		  {
            if (roll == 6 && (soc >= 11 
              || (edu >= 11 && intl >= 10))) dartrynoble();
          }
        }
      }
    }
  }
  if (careernbr == 0) darrandcareer();
}


void dartryarmy()
{
  int  enlist;

  enlist = d12();
  if (str >= 8) enlist++;
  if (dex >= 8) enlist += 2;
  if (intl >= 8) enlist += 3;
  if (enlist >= 6) gotarmy();
}


void dartrymarine()
{
  int  enlist;

  enlist = d12();
  if (str >= 8) enlist++;
  if (dex >= 8) enlist += 2;
  if (intl >= 8) enlist += 3;
  if (enlist >= 6) gotmarines();
}


void dartrynavy()
{
  int  enlist;

  enlist = darnavroll();
  if (enlist >= 9)
  {
    line = 1;
    dargotnavy();
  }
  else
  {
    enlist = darnavroll();
    if (enlist >= 7)
	{
      line = 3;
      dargotnavy();
    }
  }
}


void dargotnavy()
{
  gotnavy();
  if (soc >= 10)
  {
    rankeo = 'O';   
    rank = 0;
  }
  dartryspecarm();
}


void dartryspecarm()
{
  int enlist, choice;

  if (line != 1) return;
  printf("You have the option to join the Special Arm. Do you want to?");
  choice = getche_y_n();
  if (choice == 'n' || choice == 'N') return;
  enlist = d12();
  if (enlist >= 10)
  {
    branch = 7;
    printf("Congratulations, you were accepted into the Special Arm.\n");
  }
  else
	  printf("Sorry, you were not accepted in the Special Arm.\n");
}


int darnavroll()
{
  int roll;

  roll = d12();
  if (dex >= 9) roll++;
  if (intl >= 8) roll += 3;
  return roll;
}


void dartryacad()
{
  int  enlist;

  enlist = d12();
  if (intl >= 9) enlist += 2;
  if (edu >= 10) enlist += 3;
  if (enlist >= 8) gotacad();
}


void dartrynoble()
{
  int  enlist;

  enlist = d12();
  if (edu >= 11) enlist++;
  if (intl >= 10) enlist += 2;
  if (soc >= 11) enlist += 3;
  if (enlist >= 14) gotnoble();
}


void gotacad()
{
  strncpy(career,"Academic",9);
  careernbr = SCIENTIST;
}


int darpicktable()
{
  int choice, max;

  if (pick > 2)
  {
    if (soc < 10)
	{
      return (d3());
    }
	else
	{
      return (d4());
    }
  }
  max = 3;
  printf("\nWhich table do you wish to take your new skill on?\n\n");
  printf("   1. personal development table\n   2. service skills table\n");
  printf("   3. education table\n");
  if (soc >= 10)
  {
    printf("   4. advanced education table\n");
	max = 4;
  }
  choice = getsel_int(1, max);
  return choice;
}
