/* HUMPRINT.C is part of the MEGATRAVELER (c) character generation */
/* program written by Greg Svenson. It prints out the resulting character. */

#include <stdio.h>

void printhim();
void pension();
void getbranch();
void getrankp();
void armyrank();
void zhoarmyrank();
void coaccrank();
void marinerank();
void navyrank();
void zhonavyrank();
void darnavyrank();
void merchrank();
void merdeck();
void merengr();
void merpur();
void meradm();
void mersales();
void scoutrank();
void flyerrank();
void sailorank();
void coprank();
void diplomatrank();
void barbarank();
void bureaurank();
void noblerank();
void piraterank();
void iris_rank();
void zhoguardrank();
void zhogovrank();
void zhoprolerank();
void solmarrank();
void solarmyrank();
void solmerrank();
void solsecrank();
void solpartyrank();
void journalrank();
void prntstuf();

extern void prntskil(int end);
extern void anykey();
extern void clrscr();
extern void prntrace();
extern void prntblueblood();
extern void prntsex();
extern void prtsch();
extern void prtgrad();
extern void prtflt();
extern void getline();
extern void awards();
extern void discover();
extern void commend();
extern void cmd_clstr();
extern void loan();
extern void prtgames();
extern void disp_special_duty();

#include "chargen.h"

void printhim()  
{
  if (seh > 0 && careernbr != SCIENTIST)
  {
    if ((rankeo == 'E' && rank < 9) 
      || (careernbr != NAVY && rankeo == 'O' && rank < 10)
      || (careernbr == NAVY && rankeo == 'O' && line == 1 && rank < 10)
      || (careernbr == NAVY && rankeo == 'O' && line == 2 && rank < 8)
      || (careernbr == NAVY && rankeo == 'O' && line == 3 && rank < 7)) rank++;
  }
  printf("Here is a review of your characters skills.\n");
  prntskil(1);
  anykey();
  if (race == ZHODANI && soc >= 11) credits = credits * 2;
  clrscr();
  printf("                         Character Description\n");        
  printf("\nName: _________________________ ");
  if (med_sch >= 1)
	  printf("M.D.");
  else
    if (grad_sch >= 1)
		printf("Ph.D.");
    else
      if (careernbr == DOCTOR)
		  printf("D.O.");
      else
        if (tech_acd >= 1)
			printf("M.T.S.");
  printf(" ");
  prntrace();
  if (race == ZHODANI)
  {
	  if (soc >= 11) printf(" Noble");
	  if (soc == 10) printf(" Intendent");
	  if (soc <= 9) printf(" Prole");
  }
  printf(" ");
  prntsex();
  if (blue_blood != 0)
	  prntblueblood();
  if (uwp[0] != '\0') printf(" UWP=%s", uwp);
  printf("\n");
  printf(" str dex end int edu ");
  if (race == SOLOMANI) printf("par");
  else printf("soc");
  printf(" Home World: star port = %c\n", starport);
  printf("  %2d  %2d  %2d  %2d  %2d  %2d            ",
    str, dex, end, intl, edu, soc);
  printf("      size = %s\n", size_descr);
  printf("         age: %2d                    ", age);
  printf("atmosphere = %s\n", atmos_descr);
  printf("apparent age: %2d                    ", appearent_age);
  printf("     hydro = %s\n", hydro_descr);
  prtgames();
  printf("population = %s\n", pop_descr);
  prtsch();
  printf("      law = %s\n", law_descr);
  prtgrad();
  printf("government = %s\n", gov_descr);
  prtflt();
  printf("  tech lvl = %s\n", tech_descr);
  printf("Career: %s", career);
  if (line != 0) getline();
  if (branch != 0) getbranch();
  if (medic != 0 && careernbr != DOCTOR) printf(" medic");
  if (alt_career == LANDGUARD) printf(" army home guard");
  if (alt_career == SPACEGUARD) printf(" navy home guard");
  if ((rank != 0 || careernbr == MERCHANT || (race == ZHODANI && (careernbr == ZHOGOVT
	  || careernbr == ZHOGUARD || careernbr == ZHOPROLES)) ||
	  (alt_career == LANDGUARD || alt_career == SPACEGUARD)))
  {
      printf("\n");
      getrankp();
  }
  if (terms >= 5 || prevterms >= 5) pension();
  if ((careernbr <= MARINE || careernbr == FLYER) ||
	(prevcareernbr > 0 && (prevcareernbr <= MARINE || prevcareernbr == FLYER))) 
		if (race == DARRIAN || race <= VILANI || race == JONKEREEN || race == ZHODANI)
			awards();
  if (careernbr == SCIENTIST || prevcareernbr == SCIENTIST)
	  discover();
  if (careernbr == IRIS || prevcareernbr == IRIS)
	  commend();
  disp_special_duty();
  printf("\nSkills:\n");
  prntskil(2);
  printf("\nProperty:               Credits: %ld", credits);
  prntstuf();
}


void pension()
{
  int svcterms;

  if (terms >= 5) 
	  svcterms = terms;
  else
	  svcterms = prevterms;
  printf("     Pension: ");
  if (race == SOLOMANI || race == DARRIAN) 
  {
    if (careernbr == BUREAUCRAT || careernbr > BARBARIAN)
        printf("%d", (svcterms * 2000));
    else 
		printf("%d", (svcterms * 1000));
  } 
  else 
  {
	  if (race == ZHODANI)
		  if (soc >= 11)
			  printf("%d", 2 * (4000 + 2000 * (terms - 5)));
		  else
			  printf("%d", (4000 + 2000 * (terms - 5)));
	  else
		  if (careernbr == IRIS) 
			printf("%d", (rank * 1000));
	      else 
			printf("%d", (svcterms * 2000));
  }
}


void getbranch()
{
  if (office[0] == '\0') return;
  printf(" %s ", office);
  if (careernbr == PIRATE || careernbr == BELTER) return;
  if (careernbr <= MARINE) printf("branch");
  else printf("office");
}


void getrankp()
{
  if (rank == 0 && (careernbr == SCIENTIST || careernbr == DOCTOR
	  || careernbr == BELTER || careernbr == ROGUE || careernbr == HUNTER))
  {
      rank = (terms / 2) + 1;
      if (col > 0) rankeo = 'O';
      if (med_sch > 0 || grad_sch > 0) rank++;
  }
  printf("  Rank: %c%d ", rankeo, rank);
  switch (careernbr)
  {
    case ARMY:
		{
		if (race == SOLOMANI) solarmyrank();
		else
			if (race == ZHODANI) zhoarmyrank();
			else armyrank();
	    }
      break;
    case NAVY: {
      if (race == SOLOMANI) sailorank();
      else
	  if (race == DARRIAN) darnavyrank();
	  else
		  if (race == ZHODANI) zhonavyrank();
		  else navyrank();
      }
      break;
    case MARINE:
		{
		if (race == SOLOMANI) solmarrank();
		else
			if (race == ZHODANI) zhoarmyrank();
			else marinerank();
		}
      break;
    case SCOUT: scoutrank(); break;
    case FLYER:
		{
		if (race == IMPERIAL) coaccrank();
		else flyerrank();
		}
		break;
    case SAILOR: sailorank(); break;
    case COP: coprank(); break;
    case DOCTOR: break;
    case DIPLOMAT: diplomatrank(); break;
    case BUREAUCRAT: bureaurank(); break;
    case SCIENTIST: break;
    case NOBLE:
		{
		if (race == ZHODANI)
			zhogovrank();
		else
			noblerank();
		}
		break;
    case MERCHANT:
		{
		if (race == SOLOMANI) solmerrank();
		else merchrank();
		}
		break;
    case BELTER: break;
    case PIRATE: piraterank(); break;
    case ROGUE: break;
    case HUNTER: break;
    case BARBARIAN: barbarank(); break;
    case IRIS:
		{
		if (race == SOLOMANI) solarmyrank(); /*SolSec*/
		else iris_rank();
		}
		break;
    case LANDGUARD: if (race == ZHODANI) zhoguardrank(); break; /* home guard army or Zhodani Consular Guard */
    case SPACEGUARD: break; /*home guard navy*/
    case TECHNOPRIEST:
		{
			if (rankeo == 'O') printf("Priest");
			else printf("Acolyte");
			break; /*techical priesthood*/
		}
    case JOURNALIST: journalrank(); break; /*journalist*/
    case WANDERER: break; /*wander/loner*/
    case ARTIST: break; /*artist*/
    case TECHY: break; /*techy*/
    case ASSASSIN: break; /*assassin*/
    case OUTCAST: break; /*outcast*/
    case PARTY: if (race == SOLOMANI) solpartyrank(); break;
	case ZHOPROLES: if (race == ZHODANI) zhoprolerank(); break;
    default: printf("rank?"); break;
	}
	if (alt_career == LANDGUARD || alt_career == SPACEGUARD) 
	{
	  printf("(");
	  if (alt_career == LANDGUARD) solarmyrank();
	  if (alt_career == SPACEGUARD) sailorank();
	  printf(")");
	}
	if (prevcareernbr != 0) 
		printf("(%s %s %c%d ret.)", prevcareer, prevoffice, prevrankeo, prevrank);
}


void armyrank()
{
  if (rankeo == 'E') {
    switch (rank) {
      case 1: printf("Privite"); break;
      case 2: printf("Lance Corporal"); break;
      case 3: printf("Corporal"); break;
      case 4: printf("Lance Sargent"); break;
      case 5: printf("Sargent"); break;
      case 6: printf("Gunnery Sargent"); break;
      case 7: printf("Leading Sargent"); break;
      case 8: printf("First Sargent"); break;
      case 9: printf("Sargent Major"); break;
      default: printf("rank?"); break;
    }
  } else {
    switch (rank) {
      case 1: printf("2nd Lieutenant"); break;
      case 2: printf("1st Lieutenant"); break;
      case 3: printf("Captain"); break;
      case 4: printf("Major"); break;
      case 5: printf("Lieutenant Colonel"); break;
      case 6: printf("Colonel"); break;
      case 7: printf("Brigadier General"); break;
      case 8: printf("Major General"); break;
      case 9: printf("Lieutenant General"); break;
      case 10: printf("General"); break;
      default: printf("rank?"); break;
    }
  
  }
}


void zhoarmyrank()
{
  if (rankeo == 'E') {
    switch (rank) {
      case 1: printf("Recruit"); break;
      case 2: printf("Trooper"); break;
      case 3: printf("Follower"); break;
      case 4: printf("Leader of Five"); break;
      case 5: printf("Leader of Ten"); break;
      case 6: printf("Leader of Twenty"); break;
      case 7: printf("Leader of Fifty"); break;
      case 8: printf("Leader of Hundred"); break;
      case 9: printf("Leader of Thousand"); break;
      default: printf("rank?"); break;
    }
  } else {
    switch (rank) {
      case 0: printf("Waiting Officer"); break;
      case 1: printf("Officer of Twenty"); break;
      case 2: printf("Officer of Fifty"); break;
      case 3: printf("Officer of Hundred"); break;
      case 4: printf("Officer Advisor"); break;
      case 5: printf("Officer of Five Hundred"); break;
      case 6: printf("Officer of Thousand"); break;
      case 7: printf("Officer of Two Thousand"); break;
      case 8: printf("Officer of Five Thousand"); break;
      case 9: printf("Officer of Ten Thousand"); break;
      case 10: printf("Officer of Millions"); break;
      default: printf("rank?"); break;
    }
  }
}


void coaccrank()
{
  if (rankeo == 'E') {
    switch (rank) {
      case 1: printf("Aircrafthand"); break;
      case 2: printf("Leading Aircrafthand"); break;
      case 3: printf("Senior Aircrafthand"); break;
      case 4: printf("Crew Chief"); break;
      case 5: printf("Flight Sargent"); break;
      case 6: printf("Leading Flight Sargent"); break;
      case 7: printf("Senior Flight Sargent"); break;
      case 8: printf("Master Flight Sargent"); break;
      case 9: printf("Flight Sargent Major"); break;
      default: printf("rank?"); break;
    }
  } else {
    switch (rank) {
      case 1: printf("Pilot Officer"); break;
      case 2: printf("Flying Officer"); break;
      case 3: printf("Flight Lieutenant"); break;
      case 4: printf("Squadron Leader"); break;
      case 5: printf("Group Captain"); break;
      case 6: printf("Wing Commander"); break;
      case 7: printf("Air Commodore"); break;
      case 8: printf("Vice Air Marshal"); break;
      case 9: printf("Air Marshal"); break;
      case 10: printf("Chief Air Marshal"); break;
      default: printf("rank?"); break;
    }
  
  }
}


void marinerank()
{
  if (rankeo == 'E') {
    switch (rank) {
      case 1: printf("Privite"); break;
      case 2: printf("Lance Corporal"); break;
      case 3: printf("Corporal"); break;
      case 4: printf("Lance Sargent"); break;
      case 5: printf("Sargent"); break;
      case 6: printf("Gunnery Sargent"); break;
      case 7: printf("Leading Sargent"); break;
      case 8: printf("First Sargent"); break;
      case 9: printf("Sargent Major"); break;
      default: printf("rank?"); break;
    }
  } else {
    switch (rank) {
      case 1: printf("2nd Lieutenant"); break;
      case 2: printf("1st Lieutenant"); break;
      case 3: printf("Captain"); break;
      case 4: printf("Force Commander"); break;
      case 5: printf("Lieutenant Colonel"); break;
      case 6: printf("Colonel"); break;
      case 7: printf("Brigadier General"); break;
      case 8: printf("Major General"); break;
      case 9: printf("Lieutenant General"); break;
      case 10: printf("General"); break;
      default: printf("rank?"); break;
    }
  }
}


void navyrank()
{
  if (rankeo == 'E') {
    switch (rank) {
      case 1: printf("Recruit"); break;
      case 2: printf("Apprentice"); break;
      case 3: printf("Spacehand"); break;
      case 4: printf("Petty Officer 3rd Class"); break;
      case 5: printf("Petty Officer 2nd Class"); break;
      case 6: printf("Petty Officer 1st Class"); break;
      case 7: printf("Chief Petty Officer"); break;
      case 8: printf("Senior Chief Petty Officer"); break;
      case 9: printf("Master Chief Petty Officer"); break;
      default: printf("rank?"); break;
    }
  } else {
    switch (rank) {
      case 1: printf("Ensign"); break;
      case 2: printf("Sublieutenant"); break;
      case 3: printf("Lieutenant"); break;
      case 4: printf("Lieutenant Commander"); break;
      case 5: printf("Commander"); break;
      case 6: printf("Captain"); break;
      case 7: printf("Commodore"); break;
      case 8: printf("Fleet Admiral"); break;
      case 9: printf("Sector Admiral"); break;
      case 10: printf("Grand Admiral"); break;
      default: printf("rank?"); break;
    }
  }
}


void zhonavyrank()
{
  if (rankeo == 'E') {
    switch (rank) {
      case 1: printf("Recruit"); break;
      case 2: printf("Trainee"); break;
      case 3: printf("Spacer"); break;
      case 4: printf("Advanced Spacer"); break;
      case 5: printf("Section Leader"); break;
      case 6: printf("Compartment Leader"); break;
      case 7: printf("Deck Leader"); break;
      case 8: printf("Crew Leader"); break;
      case 9: printf("Base Leader"); break;
      default: printf("rank?"); break;
    }
  } else {
    switch (rank) {
      case 0: printf("Waiting Officer"); break;
      case 1: printf("Learning Officer"); break;
      case 2: printf("Watch Officer"); break;
      case 3: printf("Deck Officer"); break;
      case 4: printf("Destroyer Officer"); break;
      case 5: printf("Cruiser Officer"); break;
      case 6: printf("Battleship Officer"); break;
      case 7: printf("Squadron Officer"); break;
      case 8: printf("Fleet Officer"); break;
      case 9: printf("Sector Officer"); break;
      case 10: printf("Consulate Officer"); break;
      default: printf("rank?"); break;
    }
  }
}


void darnavyrank()
{
  if (rankeo == 'E') {
    switch (rank) {
      case 1: printf("Recruit"); break;
      case 2: printf("Trainee"); break;
      case 3: printf("Spacer"); break;
      case 4: printf("Advanced Spacer"); break;
      case 5: printf("Section Leader"); break;
      case 6: printf("Compartment Leader"); break;
      case 7: printf("Deck Leader"); break;
      case 8: printf("Crew Leader"); break;
      case 9: printf("Base Leader"); break;
      default: printf("rank?"); break;
    }
  } else {
    switch (rank) {
      case 0: printf("Subaltern"); break;
      case 1: printf("Ensign"); break;
      case 2: printf("Sublieutenant"); break;
      case 3: printf("Lieutenant"); break;
      case 4: printf("Lieutenant Commander"); break;
      case 5: printf("Commander"); break;
      case 6: printf("Captain"); break;
      case 7: printf("Commodore"); break;
      case 8: printf("Fleet Admiral"); break;
      default: printf("rank?"); break;
    }
  }
}


void merchrank()
{
  if (rankeo == 'E') {
    printf("Enlisted");
  } else {
    switch (branch) {
      case 1: merdeck(); break;
      case 2: merengr(); break;
      case 3: merpur(); break;
      case 4: meradm(); break;
      case 5: mersales(); break;
    }
  }
}


void merdeck()
{
  switch (rank) {
    case 0: printf("Apprentice"); break;
    case 1: printf("4th Officer"); break;
    case 2: printf("3rd Officer"); break;
    case 3: printf("2nd Officer"); break;
    case 4: printf("1st Officer"); break;
    case 5: printf("Captain"); break;
    case 6: printf("Senior Captain"); break;
    case 7: printf("Line Commodore"); break;
  }
}


void merengr()
{
  switch (rank) {
    case 0: printf("Asst Drive Hand"); break;
    case 1: printf("Drive Hand"); break;
    case 2: printf("Asst Engineer"); break;
    case 3: printf("Engineer"); break;
    case 4: printf("Chief Engineer"); break;
    default: merdeck(); break;
  }
}


void merpur()
{
  if (medic == 0) {
    switch (rank) {
      case 0: printf("Steward"); break;
      case 1: printf("Junior Purser"); break;
      case 2: printf("Assistant Purser"); break;
      case 3: printf("Purser"); break;
      case 4: printf("Chief Purser"); break;
      default: merdeck(); break;
    }
  } else {
    switch (rank) {
      case 0: printf("Steward"); break;
      case 1: printf("Junior Purser"); break;
      case 2: printf("Assistant Medic"); break;
      case 3: printf("Medic"); break;
      case 4: printf("Chief Purser"); break;
      default: merdeck(); break;
    }
  }
}


void meradm()
{
  switch (rank) {
    case 0: printf("Clerk"); break;
    case 1: printf("Asst Manager"); break;
    case 2: printf("Manager"); break;
    case 3: printf("Asst Station Head"); break;
    case 4: printf("Station Head"); break;
    default: merdeck(); break;
  }
}


void mersales()
{
  switch (rank) {
    case 0: printf("Apprentice"); break;
    case 1: printf("Clerk"); break;
    case 2: printf("Asst Broker"); break;
    case 3: printf("Broker"); break;
    case 4: printf("Senior Broker"); break;
    default: merdeck(); break;
  }
}


void scoutrank()
{
	if (line == 1)	// scouts in the field do not have rank
	{
		printf("Scout");
		return;
	}
	if (rankeo == 'E')
	{
		switch (rank)
		{
			case 1: printf("IS-1 Recruit"); break;
			case 2: printf("IS-2 Apprentice"); break;
			case 3: printf("IS-3 Journeyman"); break;
			case 4: printf("IS-4 Skilled Worker"); break;
			case 5: printf("IS-5 Asst Team Leader"); break;
			case 6: printf("IS-6 Team Leader"); break;
			case 7: printf("IS-7 Asst Supervisor"); break;
			case 8: printf("IS-8 Supervisor"); break;
			case 9: printf("IS-9 Senior Superviser"); break;
			default: printf("rank?"); break;
		}
	}
	else
	{
		switch (rank)
		{
			case 1: printf("IS-10 Admin Trainee"); break;
			case 2: printf("IS-11 Jr Administrator"); break;
			case 3: printf("IS-12 Administrator"); break;
			case 4: printf("IS-13 Group Administrator"); break;
			case 5: printf("IS-14 Senior Administrator"); break;
			case 6: printf("IS-15 Scout Commander"); break;
			case 7: printf("IS-16 Scout Leader"); break;
			case 8: printf("IS-17 Senior Scout Leader"); break;
			case 9: printf("IS-18 Senior Scout Leader*"); break;
			default: printf("rank?"); break;
		}
	}
}


void flyerrank()
{
  switch (rank)
  {
    case 0: printf("airman"); break;
    case 1: printf("Pilot"); break;
    case 2: printf("Flight Leader"); break;
    case 3: printf("Squadron Leader"); break;
    case 4: printf("Staff Major"); break;
    case 5: printf("Group Leader"); break;
    case 6: printf("Air Marshal"); break;
  }
}


void journalrank()
{
  switch (rank)
  {
    case 0: printf("Cub Reporter"); break;
    case 1: printf("Reporter"); break;
    case 2: printf("Senior Reporter"); break;
    case 3: printf("Columnist"); break;
    case 4: printf("Assistant Editor"); break;
    case 5: printf("Editor"); break;
    case 6: printf("Publisher"); break;
  }
}


void zhoguardrank()
{
  switch (rank)
  {
    case 0: printf("Subaltern"); break;
    case 1: printf("Lieutenant"); break;
    case 2: printf("Captain"); break;
    case 3: printf("Major"); break;
    case 4: printf("Lt Colonel"); break;
    case 5: printf("Colonel"); break;
    case 6: printf("General"); break;
  }
}


void zhogovrank()
{
  switch (rank)
  {
    case 0: printf("Clerk"); break;
    case 1: printf("Asst Supervisor"); break;
    case 2: printf("Supervisor"); break;
    case 3: printf("Executive"); break;
    case 4: printf("Consul"); break;
    case 5: printf("World Consul"); break;
    case 6: printf("High Consul"); break;
  }
}


void zhoprolerank()
{
  switch (rank)
  {
    case 0: printf("Worker"); break;
    case 1: printf("Asst Supervisor"); break;
    case 2: printf("Supervisor"); break;
    case 3: printf("Manager"); break;
    case 4: printf("Executive"); break;
    case 5: printf("Sr Executive"); break;
    case 6: printf("Director"); break;
  }
}


void sailorank()
{
  switch (rank)
  {
    case 0: printf("enlisted"); break; 
    case 1: printf("Ensign"); break;
    case 2: printf("Lieutenant"); break;
    case 3: printf("Lt Commander"); break;
    case 4: printf("Commander"); break;
    case 5: printf("Captain"); break;
    case 6: printf("Admiral"); break;
  }
}


void coprank()
{
  switch (rank)
  {
    case 1: printf("Corporal"); break;
    case 2: printf("Sergeant"); break;
    case 3: printf("Lieutenant"); break;
    case 4: printf("Detective"); break;
    case 5: printf("Chief"); break;
    case 6: printf("Commissioner"); break;
  }
}


void diplomatrank()
{
  switch (rank)
  {
    case 1: printf("3rd Secretary"); break;
    case 2: printf("2nd Secretary"); break;
    case 3: printf("1st Secretary"); break;
    case 4: printf("Counselor"); break;
    case 5: printf("Minister"); break;
    case 6: printf("Ambassador"); break;
  }
}


void bureaurank()
{
  switch (rank)
  {
    case 1: printf("Clerk"); break;
    case 2: printf("Supervisor"); break;
    case 3: printf("Assistant Manager"); break;
    case 4: printf("Manager"); break;
    case 5: printf("Executive"); break;
    case 6: printf("Director"); break;
  }
}


void noblerank()
{
  switch (rank)
  {
    case 1: printf("Knight"); break;
    case 2: printf("Baron"); break;
    case 3: printf("Marquis"); break;
    case 4: printf("Count"); break;
    case 5: printf("Duke"); break;
    case 6: printf("Archduke"); break;
  }
}


void piraterank()
{
  if (rankeo == 'E')
  {
    switch (rank)
	{
      case 1: printf("2nd Henchman"); break;
      case 2: printf("1st Henchman"); break;
      case 3: printf("2nd Corporal"); break;
      case 4: printf("1st Corporal"); break;
      case 5: printf("3rd Sergeant"); break;
      case 6: printf("2nd Sergeant"); break;
      case 7: printf("1st Sergeant"); break;
      case 8: printf("3rd Lieutenant"); break;
      case 9: printf("2nd Lieutenant"); break;
      default: printf("1st Lieutenant"); break;
    }
  }
  else
  {
    switch (rank)
	{
      case 1: printf("2nd Assistant Leader"); break;
      case 2: printf("1st Assistant Leader"); break;
      case 3: printf("3rd Leader"); break;
      case 4: printf("2nd Leader"); break;
      default: printf("1st Leader"); break;
    }
  }
}


void barbarank()
{
  switch (rank)
  {
    case 1: printf("Brave"); break;
    case 2: printf("Warrior"); break;
    case 3: printf("Leader"); break;
    case 4: printf("Chieftain"); break;
    case 5: printf("Chief"); break;
    case 6: printf("Elder"); break;
  }
}


void iris_rank()
{
  switch (rank)
  {
    case 0: printf("Trainee"); break;
    case 1: printf("Jr Operative"); break;
    case 2: printf("Operative"); break;
    case 3: printf("Sr Operative"); break;
    case 4: printf("Team Leader"); break;
    case 5: printf("Captain"); break;
    case 6: printf("Major"); break;
    case 7: printf("Colonel"); break;
    case 8: printf("Lt Commander"); break;
    case 9: printf("Commander"); break;
    case 10: printf("Asst Director"); break;
    case 11: printf("Director"); break;
    case 12: printf("Sr Director"); break;
    case 13: printf("Regent"); break;
  }
}


void solarmyrank()
{
  switch (rank)
  {
    case 0: printf("Trooper"); break;
    case 1: printf("Lieutenant"); break;
    case 2: printf("Captain"); break;
    case 3: printf("Major"); break;
    case 4: printf("Lt Colonel"); break;
    case 5: printf("Colonel"); break;
    case 6: printf("General"); break;
  }
}


void solmarrank()
{
  switch (rank)
  {
    case 0: printf("enlisted"); break;
    case 1: printf("Lieutenant"); break;
    case 2: printf("Captain"); break;
    case 3:
		{
	  if (race == VARGR) printf("Force Commander");
	  else printf("Major");
      }
      break;
    case 4: printf("Lt Colonel"); break;
    case 5: printf("Colonel"); break;
    case 6: printf("Brigadier"); break;
  }
}


void solsecrank()
{
  switch (rank)
  {
    case 1: printf("Lieutenant"); break;
    case 2: printf("Captain"); break;
    case 3: printf("Major"); break;
    case 4: printf("Lt Colonel"); break;
    case 5: printf("Colonel"); break;
    case 6: printf("General"); break;
  }
}


void solmerrank()
{
  switch (rank)
  {
    case 0: printf("Deck Hand"); break;
    case 1: printf("4th Officer"); break;
    case 2: printf("3rd Officer"); break;
    case 3: printf("2nd Officer"); break;
    case 4: printf("1st Officer"); break;
    case 5: printf("Captain"); break;
    case 6: printf("Sr Captain"); break;
  }
}


void solpartyrank()
{
  switch (rank)
  {
    case 0: printf("member"); break;    
    case 1: printf("Alternate"); break;
    case 2: printf("Delegate"); break;
    case 3: printf("Deputy"); break;
    case 4: printf("Commissioner"); break;
    case 5: printf("Leader"); break;
    case 6: printf("High Leader"); break;
  }
}


void prntstuf()
{
  printf("\n");
  if (ship > 0)
  {
    if (careernbr == SCOUT)
		printf("Scout");
    if (careernbr == SCIENTIST)
		printf("Lab Ship");
    if (careernbr == NOBLE || careernbr == IRIS || careernbr == PARTY
		|| careernbr == LAWYER)
		if (race != ZHODANI)
			printf("Yacht");
		else
			printf("ZC Courier");
    if (careernbr == MERCHANT || careernbr == MANAGEMENT)
		if (race != ZHODANI)
			printf("Free Trader");
		else
			printf("ZM Trader");
    if (careernbr == BELTER)
		printf("Seeker");
    if (careernbr == PIRATE)
		printf("Corsair");
    if (careernbr == HUNTER)
		printf("Safari Ship");
    loan();
  }
  if (kit > 0)
  {
    switch (careernbr)
	{
		case COP: printf("Forensic Kit"); break;
		case DOCTOR: printf("Medical Instruments"); break;
		case BUREAUCRAT: printf("Watch"); break;
		case PIRATE: printf("Letter"); break;
		case TECHY: printf("Technical tools"); break;
		case JOURNALIST: printf("Recorder"); break;
		default: printf("Voucher"); break;
    }
    if (careernbr < IRIS) 
      if (kitval > 0)
		  printf(" (value %d)", kitval);
    else
      if (kit > 1)
		  printf("x%d", kit);
    printf(", ");
  }
  if (weapons > 0)
  {
    if (race != DOLPHINS)
	{
      printf("Weapon");
      if (weapons > 1)
		  printf("x%d", weapons);
      printf(", ");
    }
	else
	{
      if (weapons >= 1)
	  {
        printf("TeeSuit");
        if (weapons >= 2) printf(", Waldo");
        if (weapons >= 3) printf(", Weapon");
        if (weapons > 3) printf("x%d", weapons - 2);
        printf(", ");
      }
    }
  }
  if (tas > 0)
  {
    if (race == GEONEE && careernbr == TECHY)
	{
		printf("hand computer");
		if (tas > 1) printf("x%d", tas);
		printf(", ");
    }
	else
		if (race == ZHODANI)
			printf("Legion of Merit, ");
		else
			printf("Travellers Aid Society, ");
  }
  if (race == ZHODANI) {
	  if (soc >= 10 && lopsg > 0)
	  {
		  midpsg += lopsg;
		  lopsg = 0;
	  }
	  if (soc >= 11 && midpsg > 0)
	  {
		  hipsg += midpsg;
		  midpsg = 0;
	  }
  }
  if (hipsg > 0) {
    printf("High Passage");
    if (hipsg > 1) printf("x%d", hipsg);
    printf(", ");
  }
  if (midpsg > 0) {
    printf("Middle Passage");
    if (midpsg > 1) printf("x%d", midpsg);
    printf(", ");
  }
  if (lopsg > 0) {
    printf("Low Passage");
    if (lopsg > 1) printf("x%d", lopsg);
    printf(", ");
  }
}


void prtgames()
{
	if (race == ZHODANI && psigames > 0)
	{
		printf("Psionic Games ");
		if (psigames > 1)
			printf("winner");
		else
			printf("      ");
	}
	else printf("                    ");
	printf("                ");
}
