/* SCIENT.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void scientist();
int sci_doterms();
void scientistmot(int term);
void scientistbene();

extern int anag();
extern void adv_aging(int anags);
extern int sci_do_year();
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern char getche_mot();
extern int reenlist(int need_nbr);
extern void bumpsoc();
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_midpsg();
extern void mot_hipsg();
extern void mot_ship();
extern void mot_weapon();

#include "chargen.h"

extern int  sci_anag, duty;

void scientist()
{
	while (sci_doterms() == 0);
	terms = terms - anagathics;
	scientistmot(terms);
}

int sci_doterms()
{
	int survival;
  
	assignment = 0;
	duty = 0;
	survival = 0;
	adv_aging(sci_anag);
	do
	{
		survival = sci_do_year();
	} while (((age % 4) != 2) && (survival == 0));
	if (survival != 0)
		return 1;
	survival = reenlist(4);
	if (survival != 0)
		return 1; 
	sci_anag = anag();
	return 0;
}


void scientistmot(int term)
{
	int  cash, roll, amt;
	char choice;
  
	cash = basic_mot();
	term += ((seh + mcg) / 2);
	while ((term > 0) && (cash > 0))
	{
		choice = getche_mot();
		term--;
		if (choice == 'C' || choice == 'c')
		{
			cash--;
			roll = basic_cash();
			amt = 0;
			switch (roll)
			{
				case 1: amt = 1000; break;
				case 2: amt = 2000; break;
				case 3: amt = 5000; break;
				case 4: amt = 10000; break;
				case 5: amt = 20000; break;
				case 6: amt = 30000; break;
				case 7: amt = 40000; break;
			}
			mot_cash(amt);
		}
		else
		{
			scientistbene();
		}
	}
	while (term > 0)
	{
		scientistbene();
		term--;
	}
}


void scientistbene()
{
	int roll;

	roll = basic_bene();
	switch (roll)
	{
		case 1: mot_lopsg(); break;
		case 2: mot_midpsg(); break;
		case 3: bumpsoc(); break;
		case 4: mot_weapon(); break;
		case 5: mot_hipsg(); break;
		case 6: mot_ship(); break;
		case 7: mot_ship(); break;
	}
}
