/* ZHOGOV.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void zhogov();
void zhogovmot(int term);
void zhogovbene();
void zhogovskills(int skills);

#include "chargen.h"

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void bumpdex();
extern void bumpsoc();
extern void bumpintl();
extern void bumpedu();
extern void bumpstr();
extern void bumpend();
extern void bc(int skl_val);
extern void gc(int skl_val);
extern void vhcl(int skl_val);
extern void mot_cash(int amt);
extern void mot_hipsg();
extern void mot_ship();
extern void mot_tas();

void zhogov()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm == 0) {
    skills = basic_spec_duty(5);
    newterm = basic_surv(5, edu, 8);
    if (newterm == 0) {
      skills += basic_comm(9, edu, 10);
      skills += basic_promo(9, soc, 11);
    }
    skills = specskl(skills);
    if (skills != 0) zhogovskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  terms = terms - anagathics;
  zhogovmot(terms);
}


void zhogovmot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 5000; break;
        case 2: amt = 5000;break;
        case 3: amt = 10000; break;
        case 4: amt = 10000; break;
        case 5: amt = 20000; break;
        case 6: amt = 20000; break;
        case 7: amt = 40000; break;
      }
	  mot_cash(amt);
    }
	else
	{
      zhogovbene();
      term--;
    }
  }
  while (term > 0)
  {
    zhogovbene();
    term--;
  }
}


void zhogovbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: bumpsoc(); break;
    case 2: bumpintl(); bumpintl(); break;
    case 3: bumpedu(); bumpedu(); break;
    case 4: bumpsoc(); bumpsoc(); break;
    case 5: mot_tas(); break;
    case 6: mot_hipsg(); break;
    case 7: mot_ship(); break;
  }
}


void zhogovskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = picktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: bumpstr(); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: bumpintl(); break;
        case 5: bumpedu(); break;
        case 6: bumpedu(); break;
      }
    }
    if (table == 2) {
      switch (roll) {
        case 1: vhcl(1); break;
        case 2: addskill(ADMIN, 1); break;
        case 3: addskill(ADMIN, 1); break;
        case 4: addskill(COMPUTER, 1); break;
        case 5: bc(1); break;
        case 6: gc(1); break;
      }
    }
    if (table == 3) {
      switch (roll) {
        case 1: addskill(COMPUTER, 1); break;
        case 2: addskill(ADMIN, 1); break;
        case 3: addskill(LIAISON, 1); break;
        case 4: addskill(PSYCHOLOGY, 1); break;
        case 5: addskill(NVCOMM, 1); break;
        case 6: addskill(LIAISON, 1); break;
      }
    }
    skills--;
  }
}
