/* GIRUGKAGH.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void girugkagh();
void girugkaghskills(int skills);

extern void addskill(int skill, int skl_val);
extern int d6();
extern int d12();
extern int krepicktable();
extern int basic_surv(int need_nbr, int mod_val, int mod_nbr);
extern int reenlist(int need_nbr);
extern void bumpdex();
extern void bumpedu();
extern void bumpstr();
extern void bumpend();
extern int getsel_int(int min, int max);

#include "chargen.h"

extern int nv_anag, aide;

void girugkagh()
{
  int  skills, newterm;

  if (line == 4) addskill(TOLERANCE, 1);
  else addskill(STREETWISE, 1);
  newterm = 0;
  while (newterm == 0)
  {
    skills = 2;
    newterm = basic_surv(5, edu, 8);
    if (skills != 0) girugkaghskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(6);
  }
}


void girugkaghskills(int skills)
{
  int  roll, table;

  while (skills > 0)
  {
    roll = d6();
    table = krepicktable();
    if (table == 1)
	{
		switch (roll)
		{
		    case 1: bumpstr(); break;
			case 2: bumpdex(); break;
			case 3: bumpedu(); break;
			case 4: addskill(TOLERANCE, 1); break;
		    case 5: addskill(GAMBLING, 1); break;
			case 6: bumpend(); break;
		}
    }
	else
	{
      if (table == 2)
	  {
		  switch (roll)
		  {
		    case 1: addskill(STEWARD, 1); break;
		    case 2: addskill(STREETWISE, 1); break;
			case 3: addskill(STEWARD, 1); break;
		    case 4: addskill(HANDYMAN, 1); break;
			case 5: addskill(LINGUISTICS, 1); break;
		    case 6: addskill(TOLERANCE, 1); break;
		  }
      }
	  else
	  {
		  if (line == 4)
		  {
	        switch (roll)
			{
			  case 1: addskill(TOLERANCE, 1); break;
	          case 2: addskill(ADMIN, 1); break;
		      case 3: addskill(COMPUTER, 1); break;
			  case 4: addskill(LINGUISTICS, 1); break;
	          case 5: addskill(ADMIN, 1); break;
		      case 6: addskill(LIAISON, 1); break;
			}
		  }
		  else
		  {
	        switch (roll)
			{
			  case 1: addskill(BROKER, 1); break;
	          case 2: addskill(STREETWISE, 1); break;
		      case 3: addskill(ADMIN, 1); break;
			  case 4: addskill(COMPUTER, 1); break;
	          case 5: addskill(BRIBERY, 1); break;
		      case 6: addskill(TRADER, 1); break;
			}
		  }
      }
    }
    skills--;
  }
}
