/* KREPRINT.C is part of the MEGATRAVELER (c) character generation */
/* program written by Greg Svenson. It prints out the resulting character. */

#include <stdio.h>

void printhim();
void kreline();
void getbranch();
void getrankp();
void kremercrank();
void krefleetrank();
void merchrank();
void merdeck();
void merengr();
void merpur();
void meradm();
void mersales();
void bureaurank();
void prntstuf();

extern void prntskil(int end);
extern void anykey();
extern void clrscr();
extern void prntrace();
extern void prntsex();
extern void prtfinalspclduty();
extern void disp_special_duty();

#include "chargen.h"

void printhim()
{
  printf("Here is a review of your characters skills.\n");
  prntskil(1);
  anykey();
  clrscr();
  printf("                         Character Description\n");        
  printf("\nName: _________________________ ");
  printf("    ");
  prntrace();
  printf(" ");
  prntsex();
  printf("\n");
  printf(" str dex end int ");
  printf("edu "); 
  printf("cas");
  printf(" Home World: star port = %c\n", starport);
  printf("  %2d  %2d  %2d  %2d  %2d  %2d            ", 
    str, dex, end, intl, edu, soc);
  printf("      size = %s\n", size_descr);
  printf("         age: %2d                    ", age);
  printf("atmosphere = %s\n", atmos_descr);
  printf("apparent age: %2d                    ", appearent_age);
  printf("     hydro = %s\n", hydro_descr);
  printf("                                    ");
  printf("population = %s\n", pop_descr);
  printf("                                     ");
  printf("      law = %s\n", law_descr);
  printf("                                    ");
  printf("  tech lvl = %s\n", tech_descr);
  printf("Career: %s", career);
  if (line != 0) kreline();
  if (branch != 0) getbranch();
  if (medic != 0) printf(" medic");
  if ((rank != 0 || careernbr == MERCHANT) && careernbr != SCIENTIST) {
      printf("\n");
      getrankp();
  }
  disp_special_duty();
  printf("\nSkills:\n");
  prntskil(2);
  printf("\nProperty:               Credits: %ld", credits);
  printf(" per male");
  prntstuf();
}


void kreline()
{
  switch (line) {
    case 1: printf(" Noble"); break;
    case 2: printf(" Well Born"); break;
    case 3: printf(" Servant"); break;
	case 4: printf(" diplomatic"); break;
	case 5: printf(" merchant"); break;
  }
}


void getbranch()
{
  int save_career;

  if (careernbr > MARINE)
  {
    save_career = careernbr;
    careernbr = alt_career;
    printf("(");
  }
  else
	  save_career = 0;
  switch (careernbr)
  {
    case ARMY:
		{
			if (save_career != 0) printf("surface warrior");
		    break;
		}
    case NAVY:
		{
			if (save_career != 0) printf("space warrior");
			break;
	    }
    case MARINE:
		{
			if (save_career != 0) printf("surface warrior");
			break;
		}
  }
  printf(" %s ", office);
  if (careernbr <= MARINE) printf("branch");
  else printf("office");
  if (save_career > MARINE)
  {
    careernbr = save_career;
    printf(")");
  }
}


void getrankp()
{
  int save_career;

  if (careernbr > MARINE) {
    save_career = careernbr;
    careernbr = alt_career;
    printf("(");
  } else save_career = 0;
  if (careernbr == SCIENTIST) {
      rank = (terms / 2) + 1;
      if (col > 0) rankeo = 'O';
      if (med_sch > 0 || grad_sch > 0) rank++;
  }
  printf("  Rank: %c%d ", rankeo, rank);
  switch (careernbr) {
    case ARMY: kremercrank(); break;
    case NAVY: krefleetrank(); break;
    case MARINE: kremercrank(); break;
    case BUREAUCRAT: bureaurank(); break;
    case MERCHANT: merchrank(); break;
    default: printf("rank?"); break;
  }
  if (save_career > 3) {
    careernbr = save_career;
    printf(")");
  }
}


void kremercrank()
{
  if (line == 1) {
    switch (rank) {
      case 1: printf("Recruit"); break;
      case 2: printf("Colonel-subordinate"); break;
      case 3: printf("Colonel"); break;
      case 4: printf("Colonel-senior"); break;
      case 5: printf("Brigadier"); break;
      case 6: printf("Brigadier-senior"); break;
      case 7: printf("General"); break;
      case 8: printf("General-leader"); break;
      case 9: printf("General-commander"); break;
      case 10: printf("Field General"); break;
      case 11: printf("Staff General"); break;
      default: printf("Marshal"); break;
    }
  }
  if (line == 2) {
    switch (rank) {
      case 1: printf("Recruit"); break;
      case 2: printf("Sargeant-commander"); break;
      case 3: printf("Field Sargeant"); break;
      case 4: printf("Staff Sargeant"); break;
      case 5: printf("Junior Specialist"); break;
      case 6: printf("Senior Specialist"); break;
      case 7: printf("Lt Junior"); break;
      case 8: printf("Lieutenant"); break;
      case 9: printf("Lt Senior"); break;
      case 10: printf("Captain"); break;
      case 11: printf("Captain Senior"); break;
      default: printf("Major"); break;
    }
  }
  if (line == 3) {
    switch (rank) {
      case 1: printf("Recruit"); break;
      case 2: printf("Private"); break;
      case 3: printf("Private Senior"); break;
      case 4: printf("Corporal-junior"); break;
      case 5: printf("Corporal"); break;
      case 6: printf("Corporal-senior"); break;
      case 7: printf("Sergeant-junior"); break;
      case 8: printf("Sergeant"); break;
      case 9: printf("Sergeant-leader"); break;
      case 10: printf("Sergeant-commander"); break;
      case 11: printf("Field Sergeant"); break;
      default: printf("Staff Sergeant"); break;
    }
  }
}


void krefleetrank()
{
  if (line == 1) {
    switch (rank) {
      case 1: printf("Recruit"); break;
      case 2: printf("Commander"); break;
      case 3: printf("Commander-senior"); break;
      case 4: printf("Ship Commander"); break;
      case 5: printf("Ship Captain-junior"); break;
      case 6: printf("Ship Captain"); break;
      case 7: printf("Ship Captain-senior"); break;
      case 8: printf("Squadron Captain"); break;
      case 9: printf("Squadron Captain-senior"); break;
      case 10: printf("Squadron Admiral"); break;
      default: printf("Fleet Admiral"); break;
    }
  }
  if (line == 2) {
    switch (rank) {
      case 1: printf("Recruit"); break;
      case 2: printf("Master-junior"); break;
      case 3: printf("Master"); break;
      case 4: printf("Master-senior"); break;
      case 5: printf("Master Leader"); break;
      case 6: printf("Master Commander"); break;
      case 7: printf("Ensign"); break;
      case 8: printf("Ensign-senior"); break;
      case 9: printf("Lieutenant-junior"); break;
      case 10: printf("Lieutenant"); break;
      case 11: printf("Lieutenant Senior"); break;
      default: printf("Lieutenant Commander"); break;
    }
  }
  if (line == 3) {
    switch (rank) {
      case 1: printf("Recruit"); break;
      case 2: printf("Hand"); break;
      case 3: printf("Hand Senior"); break;
      case 4: printf("Hand Leader"); break;
      case 5: printf("Chief Hand-junior"); break;
      case 6: printf("Chief Hand"); break;
      case 7: printf("Chief Hand-senior"); break;
      case 8: printf("Chief Hand Leader"); break;
      case 9: printf("Master-junior"); break;
      case 10: printf("Master"); break;
      case 11: printf("Master-senior"); break;
      default: printf("Master Leader"); break;
    }
  }
}


void merchrank()
{
  if (rankeo == 'E') {
    printf("Enlisted");
  } else {
    switch (branch) {
      case 1: merdeck(); break;
      case 2: merengr(); break;
      case 3: merpur(); break;
      case 4: meradm(); break;
      case 5: mersales(); break;
    }
  }
}


void merdeck()
{
  switch (rank) {
    case 0: printf("Apprentice"); break;
    case 1: printf("4th Officer"); break;
    case 2: printf("3rd Officer"); break;
    case 3: printf("2nd Officer"); break;
    case 4: printf("1st Officer"); break;
    case 5: printf("Captain"); break;
    case 6: printf("Senior Captain"); break;
    case 7: printf("Line Commodore"); break;
  }
}


void merengr()
{
  switch (rank) {
    case 0: printf("Asst Drive Hand"); break;
    case 1: printf("Drive Hand"); break;
    case 2: printf("Asst Engineer"); break;
    case 3: printf("Engineer"); break;
    case 4: printf("Chief Engineer"); break;
    default: merdeck(); break;
  }
}


void merpur()
{
  if (medic == 0) {
    switch (rank) {
      case 0: printf("Steward"); break;
      case 1: printf("Junior Purser"); break;
      case 2: printf("Assistant Purser"); break;
      case 3: printf("Purser"); break;
      case 4: printf("Chief Purser"); break;
      default: merdeck(); break;
    }
  } else {
    switch (rank) {
      case 0: printf("Steward"); break;
      case 1: printf("Junior Purser"); break;
      case 2: printf("Assistant Medic"); break;
      case 3: printf("Medic"); break;
      case 4: printf("Chief Purser"); break;
      default: merdeck(); break;
    }
  }
}


void meradm()
{
  switch (rank) {
    case 0: printf("Clerk"); break;
    case 1: printf("Asst Manager"); break;
    case 2: printf("Manager"); break;
    case 3: printf("Asst Station Head"); break;
    case 4: printf("Station Head"); break;
    default: merdeck(); break;
  }
}


void mersales()
{
  switch (rank) {
    case 0: printf("Apprentice"); break;
    case 1: printf("Clerk"); break;
    case 2: printf("Asst Broker"); break;
    case 3: printf("Broker"); break;
    case 4: printf("Senior Broker"); break;
    default: merdeck(); break;
  }
}


void bureaurank()
{
  switch (rank) {
    case 1: printf("Clerk"); break;
    case 2: printf("Supervisor"); break;
    case 3: printf("Assistant Manager"); break;
    case 4: printf("Manager"); break;
    case 5: printf("Executive"); break;
    case 6: printf("Director"); break;
  }
}


void prntstuf()
{
  printf("\n");
  if (ship > 0)
  {
    if (line == 1) printf("Courier");
    else printf("Merchant Ship");
    printf(", ");
  }
  if (kit > 0)
  {
    printf("Family Tools");
    if (kit > 1) printf("x%d", kit);
    printf(", ");
  }
  if (weapons > 0)
  {
    printf("Family Guns");
    if (weapons > 1) printf("x%d", weapons);
    printf(", ");
  }
  printf("\n");
  if (tas > 0)
  {
    printf("Travellers Aid Society, ");
  }
  if (hipsg > 0)
  {
    printf("High Passage");
    if (hipsg > 1) printf("x%d", hipsg);
    printf(", ");
  }
  if (midpsg > 0)
  {
    printf("Family Polearms");
    if (midpsg > 1) printf("x%d", midpsg);
    printf(", ");
  }
  if (lopsg > 0)
  {
    printf("Family Skills");
    if (lopsg > 1) printf("x%d", lopsg);
    printf(", ");
  }
}
