/* KREWIFE.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void krewife();
void krewifeskills(int skills);
int kre_caste_skill();

extern int kre_end_term();
extern int basic_spec_duty(int roll);
extern void addskill(int skill, int skl_val);
extern int d6();
extern int d12();
extern void bumpintl();
extern void bumpdex();
extern void bumpedu();
extern void bumpstr();
extern void bumpend();

#include "chargen.h"

void krewife()
{
  int  skills, term;
  
  skills = 1;
  term = terms;
  while (term > 0) {
    skills += kre_caste_skill(soc);
    if (skills != 0) krewifeskills(skills);
    kre_end_term();
    term--;
    skills = 0;
  }
}


void krewifeskills(int skills)
{
  int  roll;

  while (skills > 0) {
    roll = d6();
    if (line == 1) {
      switch (roll) {
        case 1: addskill(STEWARD, 1); break;
        case 2: bumpintl(); break;
        case 3: addskill(HANDYMAN, 1); break;
        case 4: bumpstr(); break;
        case 5: addskill(DIVERSION, 1); break;
        case 6: bumpedu(); break;
      }
    }
    if (line != 1) {
      switch (roll) {
        case 1: addskill(STEWARD, 1); break;
        case 2: addskill(MEDICAL, 1); break;
        case 3: bumpstr(); break;
        case 4: addskill(HANDYMAN, 1); break;
        case 5: bumpdex(); break;
        case 6: addskill(DIVERSION, 1); break;
      }
    }
    skills--;
  }
}


int kre_caste_skill()
{
  int roll, skills;

  roll = d12();
  if (sex == 1) skills = basic_spec_duty(5) + 1;
  else skills = basic_spec_duty(7);
  if (roll >= soc) skills++;
  return skills;
}