/* VARAIDER.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void varraider();
void varraidermot(int term);
void varraiderbene();
void varraiderskills(int skills);
void varraider_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int var_success();
extern int basic_cash();
extern int var_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int varpicktable();
extern void bumpdex();
extern void bumpintl();
extern void bumpsoc();
extern void bumpedu();
extern void bumpend();
extern void physicl(int skl_val);
extern void mentl(int skl_val);
extern void techl(int skl_val);
extern void mc(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void econ(int skl_val);
extern void acad(int skl_val);
extern void inbrn(int skl_val);
extern void special(int skl_val);
extern void milmed(int skl_val);
extern void vc(int skl_val);
extern void bc(int skl_val);
extern void gc(int skl_val);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_lopsg();
extern void mot_hipsg();

#include "chargen.h"

void varraider()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(4);
    newterm = basic_surv(6, end, 8);
    if (newterm == 0) {
      skills += basic_comm(9, edu, 7);
      printf("skills=%d\n", skills);
      newterm = var_success(soc, 8, soc, 6, &skills);
      printf("skills=%d\n", skills);
    }
    if (skills != 0) varraiderskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  terms = terms - anagathics;
  varraidermot(terms);
}


void varraidermot(int term)
{

  int  cash, roll, amt;
  char choice;
  
  cash = 3;
  term = var_mot(term);
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 2000; break;
        case 2: amt = 5000; break;
        case 3: amt = 5000; break;
        case 4: amt = 10000; break;
        case 5: amt = 20000; break;
        case 6: amt = 30000; break;
        case 7: amt = 40000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        varraiderbene();
        term--;
    }
  }
  while (term > 0)
  {
    varraiderbene();
    term--;
  }
}


void varraiderbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 3: bumpedu(); break;
    case 2: bumpintl(); bumpintl(); break;
    case 4: mot_weapon(); break;
    case 5: mot_hipsg(); break;
    case 6: mot_hipsg(); break;
    case 7: bumpsoc(); bumpsoc(); break;
  }
}


void varraiderskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = varpicktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: physicl(1); break;
        case 2: bumpdex(); break;
        case 3: bumpsoc(); break;
        case 4: vc(1); break;
        case 5: mc(1); break;
        case 6: physicl(1); break;
      }
    }
    if (table == 2) {
      varraider_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: vhcl(1); break;
        case 2: special(1); break;
        case 3: mc(1); break;
        case 4: addskill(TACTICS, 1); break;
        case 5: techl(1); break;
        case 6: milmed(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: special(1); break;
        case 2: addskill(TACTICS, 1); break;
        case 3: bumpsoc(); break;
        case 4: techl(1); break;
        case 5: interp(1); break;
        case 6: inbrn(1); break;
      }
    }
    skills--;
  }
}


void varraider_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: addskill(ATV, 1); break;
        case 2: addskill(VACCSUIT, 1); break;
        case 3: bc(1); break;
        case 4: gc(1); break;
        case 5: mc(1); break;
        case 6: special(1); break;
      }
}

