/* VARBELTR.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void varbelter();
void varbeltermot(int term);
void varbelterbene();
void varbelterskills(int skills);
void varbelter_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int var_success();
extern int basic_cash();
extern int var_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int varpicktable();
extern void bumpdex();
extern void bumpintl();
extern void bumpend();
extern void physicl(int skl_val);
extern void spac(int skl_val);
extern void techl(int skl_val);
extern void mc(int skl_val);
extern void explore(int skl_val);
extern void spacetech(int skl_val);
extern void inbrn(int skl_val);
extern void vc(int skl_val);
extern void gc(int skl_val);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_ship();
extern void mot_lopsg();
extern void mot_hipsg();

#include "chargen.h"

void varbelter()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(7);
    newterm = basic_surv(9, (terms + 1), 0);
    if (newterm == 0) {
      skills += 2;
      if (terms == 3) addskill(NOGRAV, 1);
      printf("skills=%d\n", skills);
      newterm = var_success(intl, 10, end, 9, &skills);
      printf("skills=%d\n", skills);
    }
    if (skills != 0) varbelterskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  terms = terms - anagathics;
  varbeltermot(terms);
}


void varbeltermot(int term)
{

  int  cash, roll, amt;
  char choice;
  
  cash = 3;
  term = var_mot(term);
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: break;
        case 2: break;
        case 3: amt = 1000; break;
        case 4: amt = 10000; break;
        case 5: amt = 100000; break;
        case 6: amt = 100000; break;
        case 7: amt = 100000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        varbelterbene();
        term--;
    }
  }
  while (term > 0)
  {
    varbelterbene();
    term--;
  }
}


void varbelterbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpintl(); break;
    case 3: mot_weapon(); break;
    case 4: mot_weapon(); break;
    case 5: mot_hipsg(); break;
    default: mot_ship(); break;
  }
}


void varbelterskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = varpicktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: physicl(1); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: mc(1); break;
        case 5: vc(1); break;
        case 6: addskill(VACCSUIT, 1); break;
      }
    }
    if (table == 2) {
      varbelter_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: spac(1); break;
        case 2: explore(1); break;
        case 3: addskill(SHIPBOAT, 1); break;
        case 4: addskill(MECHANICAL, 1); break;
        case 5: addskill(ELECTRONICS, 1); break;
        case 6: addskill(PROSPECTING, 1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: addskill(MEDICAL, 1); break;
        case 2: spacetech(1); break;
        case 3: spac(1); break;
        case 4: spacetech(1); break;
        case 5: inbrn(1); break;
        case 6: techl(1); break;
      }
    }
    skills--;
  }
}


void varbelter_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: spac(1); break;
        case 2: addskill(PROSPECTING, 1); break;
        case 3: spac(1); break;
        case 4: gc(1); break;
        case 5: addskill(NOGRAV, 1); break;
        case 6: addskill(PROSPECTING, 1); break;
      }
}

