/* VARDOC.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void vardoc();
void vardocmot(int term);
void vardocbene();
void vardocskills(int skills);
void vardoc_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int var_success();
extern int basic_cash();
extern int var_mot();
extern int basic_bene();
extern int d6();
extern int d12();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int varpicktable();
extern void bumpdex();
extern void bumpstr();
extern void bumpsoc();
extern void bumpedu();
extern void bumpend();
extern void mentl(int skl_val);
extern void techl(int skl_val);
extern void sci(int skl_val);
extern void interp(int skl_val);
extern void acad(int skl_val);
extern void vc(int skl_val);
extern void bc(int skl_val);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_lopsg();
extern void mot_midpsg();
extern void mot_medkit();

#include "chargen.h"

void vardoc()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(6);
    newterm = basic_surv(5, intl, 8);
    if (newterm == 0) {
      skills += 2;
      printf("skills=%d\n", skills);
      newterm = var_success(edu, 10, soc, 7, &skills);
      printf("skills=%d\n", skills);
    }
    if (skills != 0) vardocskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(4);
  }
  terms = terms - anagathics;
  vardocmot(terms);
}


void vardocmot(int term)
{

  int  cash, roll, amt;
  char choice;
  
  cash = 3;
  term = var_mot(term);
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 2000; break;
        case 2: amt = 5000; break;
        case 3: amt = 5000; break;
        case 4: amt = 10000; break;
        case 5: amt = 20000; break;
        case 6: amt = 30000; break;
        case 7: amt = 40000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        vardocbene();
        term--;
    }
  }
  while (term > 0)
  {
    vardocbene();
    term--;
  }
}


void vardocbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 3: bumpedu(); break;
    case 2: bumpedu(); bumpedu(); break;
    case 4: mot_weapon(); break;
    case 5: mot_medkit(); break;
    default: mot_midpsg(); break;
  }
}


void vardocskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = varpicktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: bumpstr(); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: bumpedu(); break;
        case 5: bumpsoc(); break;
        case 6: mentl(1); break;
      }
    }
    if (table == 2) {
      vardoc_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: addskill(MECHANICAL, 1); break;
        case 2: acad(1); break;
        case 3: addskill(MEDICAL, 1); break;
        case 4: addskill(MEDICAL, 1); break;
        case 5: techl(1); break;
        case 6: sci(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: acad(1); break;
        case 2: addskill(MEDICAL, 1); break;
        case 3: sci(1); break;
        case 4: mentl(1); break;
        case 5: interp(1); break;
        case 6: techl(1); break;
      }
    }
    skills--;
  }
}


void vardoc_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: bumpdex(); break;
        case 2: addskill(MEDICAL, 1); break;
        case 3: techl(1); break;
        case 4: vc(1); break;
        case 5: bc(1); break;
        case 6: addskill(MEDICAL, 1); break;
      }
}

