/* VARSCI.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void varscient();
void varscientmot(int term);
void varscientbene();
void varscientskills(int skills);
void varscient_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int var_success();
extern int basic_cash();
extern int var_mot();
extern int basic_bene();
extern int d6();
extern int d12();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int varpicktable();
extern void bumpdex();
extern void bumpsoc();
extern void bumpstr();
extern void mentl(int skl_val);
extern void bumpend();
extern void interp(int skl_val);
extern void vhcl(int skl_val);
extern void techl(int skl_val);
extern void mc(int skl_val);
extern void env(int skl_val);
extern void spacetech(int skl_val);
extern void inbrn(int skl_val);
extern void acad(int skl_val);
extern void sci(int skl_val);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_ship();
extern void mot_lopsg();
extern void mot_hipsg();
extern void mot_midpsg();
extern void mot_equipment();

#include "chargen.h"

void varscient()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(6);
    newterm = basic_surv(5, edu, 9);
    if (newterm == 0) {
      skills += 2;
      printf("skills=%d\n", skills);
      newterm = var_success(edu, 9, soc, 9, &skills);
      printf("skills=%d\n", skills);
    }
    if (skills != 0) varscientskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(5);
  }
  terms = terms - anagathics;
  varscientmot(terms);
}


void varscientmot(int term)
{

  int  cash, roll, amt;
  char choice;
  
  cash = 3;
  term = var_mot(term);
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 1000; break;
        case 2: amt = 2000; break;
        case 3: amt = 5000; break;
        case 4: amt = 10000; break;
        case 5: amt = 20000; break;
        case 6: amt = 30000; break;
        case 7: amt = 40000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        varscientbene();
        term--;
    }
  }
  while (term > 0)
  {
    varscientbene();
    term--;
  }
}


void varscientbene()
{
  int roll;

  roll = basic_bene();
  switch (roll) {
    case 1: mot_lopsg(); break;
    case 2: mot_midpsg(); break;
    case 3: mot_hipsg(); break;
    case 4: mot_equipment(); break;
    case 5: mot_weapon(); break;
    case 6: bumpsoc(); break;
    default: mot_ship(); break;
  }
}


void varscientskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = varpicktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: bumpstr(); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: mentl(1); break;
        case 5: interp(1); break;
        case 6: inbrn(1); break;
      }
    }
    if (table == 2) {
      varscient_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: addskill(MECHANICAL, 1); break;
        case 2: addskill(ELECTRONICS, 1); break;
        case 3: techl(1); break;
        case 4: sci(1); break;
        case 5: sci(1); break;
        case 6: acad(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: sci(1); break;
        case 2: acad(1); break;
        case 3: inbrn(1); break;
        case 4: mentl(1); break;
        case 5: acad(1); break;
        case 6: acad(1); break;
      }
    }
    skills--;
  }
}


void varscient_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
  switch (roll) {
    case 1: techl(1); break;
    case 2: mc(1); break;
    case 3: vhcl(1); break;
    case 4: inbrn(1); break;
    case 5: env(1); break;
    case 6: spacetech(1); break;
  }
}

